#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1323
#define LARGE_STATE_COUNT 355
#define SYMBOL_COUNT 306
#define ALIAS_COUNT 1
#define TOKEN_COUNT 135
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 37
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 238

enum {
  sym_identifier = 1,
  sym_decimal_integer_literal = 2,
  sym_hex_integer_literal = 3,
  sym_octal_integer_literal = 4,
  sym_binary_integer_literal = 5,
  sym_decimal_floating_point_literal = 6,
  sym_hex_floating_point_literal = 7,
  sym_true = 8,
  sym_false = 9,
  sym_character_literal = 10,
  anon_sym_DQUOTE = 11,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 12,
  sym_string_fragment = 13,
  aux_sym__multiline_string_fragment_token1 = 14,
  aux_sym__multiline_string_fragment_token2 = 15,
  aux_sym__escape_sequence_token1 = 16,
  sym_escape_sequence = 17,
  sym_null_literal = 18,
  anon_sym_LPAREN = 19,
  anon_sym_RPAREN = 20,
  anon_sym_AMP = 21,
  anon_sym_EQ = 22,
  anon_sym_PLUS_EQ = 23,
  anon_sym_DASH_EQ = 24,
  anon_sym_STAR_EQ = 25,
  anon_sym_SLASH_EQ = 26,
  anon_sym_AMP_EQ = 27,
  anon_sym_PIPE_EQ = 28,
  anon_sym_CARET_EQ = 29,
  anon_sym_PERCENT_EQ = 30,
  anon_sym_LT_LT_EQ = 31,
  anon_sym_GT_GT_EQ = 32,
  anon_sym_GT_GT_GT_EQ = 33,
  anon_sym_GT = 34,
  anon_sym_LT = 35,
  anon_sym_GT_EQ = 36,
  anon_sym_LT_EQ = 37,
  anon_sym_EQ_EQ = 38,
  anon_sym_BANG_EQ = 39,
  anon_sym_AMP_AMP = 40,
  anon_sym_PIPE_PIPE = 41,
  anon_sym_PLUS = 42,
  anon_sym_DASH = 43,
  anon_sym_STAR = 44,
  anon_sym_SLASH = 45,
  anon_sym_PIPE = 46,
  anon_sym_CARET = 47,
  anon_sym_PERCENT = 48,
  anon_sym_LT_LT = 49,
  anon_sym_GT_GT = 50,
  anon_sym_GT_GT_GT = 51,
  anon_sym_instanceof = 52,
  anon_sym_final = 53,
  anon_sym_DASH_GT = 54,
  anon_sym_COMMA = 55,
  anon_sym_QMARK = 56,
  anon_sym_COLON = 57,
  anon_sym_BANG = 58,
  anon_sym_TILDE = 59,
  anon_sym_PLUS_PLUS = 60,
  anon_sym_DASH_DASH = 61,
  anon_sym_new = 62,
  anon_sym_LBRACK = 63,
  anon_sym_RBRACK = 64,
  anon_sym_DOT = 65,
  anon_sym_class = 66,
  anon_sym_COLON_COLON = 67,
  anon_sym_extends = 68,
  anon_sym_switch = 69,
  anon_sym_LBRACE = 70,
  anon_sym_RBRACE = 71,
  anon_sym_case = 72,
  anon_sym_default = 73,
  anon_sym_SEMI = 74,
  anon_sym_assert = 75,
  anon_sym_do = 76,
  anon_sym_while = 77,
  anon_sym_break = 78,
  anon_sym_continue = 79,
  anon_sym_return = 80,
  anon_sym_yield = 81,
  anon_sym_synchronized = 82,
  anon_sym_throw = 83,
  anon_sym_try = 84,
  anon_sym_catch = 85,
  anon_sym_finally = 86,
  anon_sym_if = 87,
  anon_sym_else = 88,
  anon_sym_for = 89,
  anon_sym_AT = 90,
  anon_sym_open = 91,
  anon_sym_module = 92,
  anon_sym_requires = 93,
  anon_sym_transitive = 94,
  anon_sym_static = 95,
  anon_sym_exports = 96,
  anon_sym_to = 97,
  anon_sym_opens = 98,
  anon_sym_uses = 99,
  anon_sym_provides = 100,
  anon_sym_with = 101,
  anon_sym_package = 102,
  anon_sym_import = 103,
  anon_sym_enum = 104,
  anon_sym_public = 105,
  anon_sym_protected = 106,
  anon_sym_private = 107,
  anon_sym_abstract = 108,
  anon_sym_strictfp = 109,
  anon_sym_native = 110,
  anon_sym_transient = 111,
  anon_sym_volatile = 112,
  anon_sym_sealed = 113,
  anon_sym_non_DASHsealed = 114,
  anon_sym_implements = 115,
  anon_sym_permits = 116,
  anon_sym_record = 117,
  anon_sym_ATinterface = 118,
  anon_sym_interface = 119,
  anon_sym_byte = 120,
  anon_sym_short = 121,
  anon_sym_int = 122,
  anon_sym_long = 123,
  anon_sym_char = 124,
  anon_sym_float = 125,
  anon_sym_double = 126,
  sym_boolean_type = 127,
  sym_void_type = 128,
  anon_sym_DOT_DOT_DOT = 129,
  anon_sym_throws = 130,
  sym_this = 131,
  sym_super = 132,
  sym_line_comment = 133,
  sym_block_comment = 134,
  sym_program = 135,
  sym__literal = 136,
  sym_string_literal = 137,
  sym__string_literal = 138,
  sym__multiline_string_literal = 139,
  sym__multiline_string_fragment = 140,
  sym__escape_sequence = 141,
  sym_expression = 142,
  sym_cast_expression = 143,
  sym_assignment_expression = 144,
  sym_binary_expression = 145,
  sym_instanceof_expression = 146,
  sym_lambda_expression = 147,
  sym_inferred_parameters = 148,
  sym_ternary_expression = 149,
  sym_unary_expression = 150,
  sym_update_expression = 151,
  sym_primary_expression = 152,
  sym_array_creation_expression = 153,
  sym_dimensions_expr = 154,
  sym_parenthesized_expression = 155,
  sym_condition = 156,
  sym_class_literal = 157,
  sym_object_creation_expression = 158,
  sym__unqualified_object_creation_expression = 159,
  sym_field_access = 160,
  sym_array_access = 161,
  sym_method_invocation = 162,
  sym_argument_list = 163,
  sym_method_reference = 164,
  sym_type_arguments = 165,
  sym_wildcard = 166,
  sym__wildcard_bounds = 167,
  sym_dimensions = 168,
  sym_switch_expression = 169,
  sym_switch_block = 170,
  sym_switch_block_statement_group = 171,
  sym_switch_rule = 172,
  sym_switch_label = 173,
  sym_statement = 174,
  sym_block = 175,
  sym_expression_statement = 176,
  sym_labeled_statement = 177,
  sym_assert_statement = 178,
  sym_do_statement = 179,
  sym_break_statement = 180,
  sym_continue_statement = 181,
  sym_return_statement = 182,
  sym_yield_statement = 183,
  sym_synchronized_statement = 184,
  sym_throw_statement = 185,
  sym_try_statement = 186,
  sym_catch_clause = 187,
  sym_catch_formal_parameter = 188,
  sym_catch_type = 189,
  sym_finally_clause = 190,
  sym_try_with_resources_statement = 191,
  sym_resource_specification = 192,
  sym_resource = 193,
  sym_if_statement = 194,
  sym_while_statement = 195,
  sym_for_statement = 196,
  sym_enhanced_for_statement = 197,
  sym__annotation = 198,
  sym_marker_annotation = 199,
  sym_annotation = 200,
  sym_annotation_argument_list = 201,
  sym_element_value_pair = 202,
  sym__element_value = 203,
  sym_element_value_array_initializer = 204,
  sym_declaration = 205,
  sym_module_declaration = 206,
  sym_module_body = 207,
  sym_module_directive = 208,
  sym_requires_module_directive = 209,
  sym_requires_modifier = 210,
  sym_exports_module_directive = 211,
  sym_opens_module_directive = 212,
  sym_uses_module_directive = 213,
  sym_provides_module_directive = 214,
  sym_package_declaration = 215,
  sym_import_declaration = 216,
  sym_asterisk = 217,
  sym_enum_declaration = 218,
  sym_enum_body = 219,
  sym_enum_body_declarations = 220,
  sym_enum_constant = 221,
  sym_class_declaration = 222,
  sym_modifiers = 223,
  sym_type_parameters = 224,
  sym_type_parameter = 225,
  sym_type_bound = 226,
  sym_superclass = 227,
  sym_super_interfaces = 228,
  sym_type_list = 229,
  sym_permits = 230,
  sym_class_body = 231,
  sym_static_initializer = 232,
  sym_constructor_declaration = 233,
  sym__constructor_declarator = 234,
  sym_constructor_body = 235,
  sym_explicit_constructor_invocation = 236,
  sym_scoped_identifier = 237,
  sym_field_declaration = 238,
  sym_record_declaration = 239,
  sym_annotation_type_declaration = 240,
  sym_annotation_type_body = 241,
  sym_annotation_type_element_declaration = 242,
  sym__default_value = 243,
  sym_interface_declaration = 244,
  sym_extends_interfaces = 245,
  sym_interface_body = 246,
  sym_constant_declaration = 247,
  sym__variable_declarator_list = 248,
  sym_variable_declarator = 249,
  sym__variable_declarator_id = 250,
  sym_array_initializer = 251,
  sym__type = 252,
  sym__unannotated_type = 253,
  sym_annotated_type = 254,
  sym_scoped_type_identifier = 255,
  sym_generic_type = 256,
  sym_array_type = 257,
  sym_integral_type = 258,
  sym_floating_point_type = 259,
  sym__method_header = 260,
  sym__method_declarator = 261,
  sym_formal_parameters = 262,
  sym_formal_parameter = 263,
  sym_receiver_parameter = 264,
  sym_spread_parameter = 265,
  sym_throws = 266,
  sym_local_variable_declaration = 267,
  sym_method_declaration = 268,
  sym_compact_constructor_declaration = 269,
  aux_sym_program_repeat1 = 270,
  aux_sym__string_literal_repeat1 = 271,
  aux_sym__multiline_string_literal_repeat1 = 272,
  aux_sym__multiline_string_fragment_repeat1 = 273,
  aux_sym_cast_expression_repeat1 = 274,
  aux_sym_inferred_parameters_repeat1 = 275,
  aux_sym_array_creation_expression_repeat1 = 276,
  aux_sym_array_creation_expression_repeat2 = 277,
  aux_sym_argument_list_repeat1 = 278,
  aux_sym_type_arguments_repeat1 = 279,
  aux_sym_dimensions_repeat1 = 280,
  aux_sym_switch_block_repeat1 = 281,
  aux_sym_switch_block_repeat2 = 282,
  aux_sym_switch_block_statement_group_repeat1 = 283,
  aux_sym_try_statement_repeat1 = 284,
  aux_sym_catch_type_repeat1 = 285,
  aux_sym_resource_specification_repeat1 = 286,
  aux_sym_for_statement_repeat1 = 287,
  aux_sym_for_statement_repeat2 = 288,
  aux_sym_annotation_argument_list_repeat1 = 289,
  aux_sym_element_value_array_initializer_repeat1 = 290,
  aux_sym_module_body_repeat1 = 291,
  aux_sym_requires_module_directive_repeat1 = 292,
  aux_sym_exports_module_directive_repeat1 = 293,
  aux_sym_provides_module_directive_repeat1 = 294,
  aux_sym_enum_body_repeat1 = 295,
  aux_sym_enum_body_declarations_repeat1 = 296,
  aux_sym_modifiers_repeat1 = 297,
  aux_sym_type_parameters_repeat1 = 298,
  aux_sym_type_bound_repeat1 = 299,
  aux_sym_type_list_repeat1 = 300,
  aux_sym_annotation_type_body_repeat1 = 301,
  aux_sym_interface_body_repeat1 = 302,
  aux_sym__variable_declarator_list_repeat1 = 303,
  aux_sym_array_initializer_repeat1 = 304,
  aux_sym_formal_parameters_repeat1 = 305,
  alias_sym_type_identifier = 306,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_decimal_integer_literal] = "decimal_integer_literal",
  [sym_hex_integer_literal] = "hex_integer_literal",
  [sym_octal_integer_literal] = "octal_integer_literal",
  [sym_binary_integer_literal] = "binary_integer_literal",
  [sym_decimal_floating_point_literal] = "decimal_floating_point_literal",
  [sym_hex_floating_point_literal] = "hex_floating_point_literal",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_character_literal] = "character_literal",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [sym_string_fragment] = "string_fragment",
  [aux_sym__multiline_string_fragment_token1] = "_multiline_string_fragment_token1",
  [aux_sym__multiline_string_fragment_token2] = "_multiline_string_fragment_token2",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_null_literal] = "null_literal",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_final] = "final",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_COMMA] = ",",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON] = ":",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_new] = "new",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_extends] = "extends",
  [anon_sym_switch] = "switch",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_SEMI] = ";",
  [anon_sym_assert] = "assert",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_synchronized] = "synchronized",
  [anon_sym_throw] = "throw",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_AT] = "@",
  [anon_sym_open] = "open",
  [anon_sym_module] = "module",
  [anon_sym_requires] = "requires",
  [anon_sym_transitive] = "transitive",
  [anon_sym_static] = "static",
  [anon_sym_exports] = "exports",
  [anon_sym_to] = "to",
  [anon_sym_opens] = "opens",
  [anon_sym_uses] = "uses",
  [anon_sym_provides] = "provides",
  [anon_sym_with] = "with",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_enum] = "enum",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_private] = "private",
  [anon_sym_abstract] = "abstract",
  [anon_sym_strictfp] = "strictfp",
  [anon_sym_native] = "native",
  [anon_sym_transient] = "transient",
  [anon_sym_volatile] = "volatile",
  [anon_sym_sealed] = "sealed",
  [anon_sym_non_DASHsealed] = "non-sealed",
  [anon_sym_implements] = "implements",
  [anon_sym_permits] = "permits",
  [anon_sym_record] = "record",
  [anon_sym_ATinterface] = "@interface",
  [anon_sym_interface] = "interface",
  [anon_sym_byte] = "byte",
  [anon_sym_short] = "short",
  [anon_sym_int] = "int",
  [anon_sym_long] = "long",
  [anon_sym_char] = "char",
  [anon_sym_float] = "float",
  [anon_sym_double] = "double",
  [sym_boolean_type] = "boolean_type",
  [sym_void_type] = "void_type",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_throws] = "throws",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym_program] = "program",
  [sym__literal] = "_literal",
  [sym_string_literal] = "string_literal",
  [sym__string_literal] = "_string_literal",
  [sym__multiline_string_literal] = "_multiline_string_literal",
  [sym__multiline_string_fragment] = "multiline_string_fragment",
  [sym__escape_sequence] = "_escape_sequence",
  [sym_expression] = "expression",
  [sym_cast_expression] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_instanceof_expression] = "instanceof_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_inferred_parameters] = "inferred_parameters",
  [sym_ternary_expression] = "ternary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_primary_expression] = "primary_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_dimensions_expr] = "dimensions_expr",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_condition] = "condition",
  [sym_class_literal] = "class_literal",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym__unqualified_object_creation_expression] = "_unqualified_object_creation_expression",
  [sym_field_access] = "field_access",
  [sym_array_access] = "array_access",
  [sym_method_invocation] = "method_invocation",
  [sym_argument_list] = "argument_list",
  [sym_method_reference] = "method_reference",
  [sym_type_arguments] = "type_arguments",
  [sym_wildcard] = "wildcard",
  [sym__wildcard_bounds] = "_wildcard_bounds",
  [sym_dimensions] = "dimensions",
  [sym_switch_expression] = "switch_expression",
  [sym_switch_block] = "switch_block",
  [sym_switch_block_statement_group] = "switch_block_statement_group",
  [sym_switch_rule] = "switch_rule",
  [sym_switch_label] = "switch_label",
  [sym_statement] = "statement",
  [sym_block] = "block",
  [sym_expression_statement] = "expression_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_assert_statement] = "assert_statement",
  [sym_do_statement] = "do_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_return_statement] = "return_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_synchronized_statement] = "synchronized_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_formal_parameter] = "catch_formal_parameter",
  [sym_catch_type] = "catch_type",
  [sym_finally_clause] = "finally_clause",
  [sym_try_with_resources_statement] = "try_with_resources_statement",
  [sym_resource_specification] = "resource_specification",
  [sym_resource] = "resource",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_for_statement] = "for_statement",
  [sym_enhanced_for_statement] = "enhanced_for_statement",
  [sym__annotation] = "_annotation",
  [sym_marker_annotation] = "marker_annotation",
  [sym_annotation] = "annotation",
  [sym_annotation_argument_list] = "annotation_argument_list",
  [sym_element_value_pair] = "element_value_pair",
  [sym__element_value] = "_element_value",
  [sym_element_value_array_initializer] = "element_value_array_initializer",
  [sym_declaration] = "declaration",
  [sym_module_declaration] = "module_declaration",
  [sym_module_body] = "module_body",
  [sym_module_directive] = "module_directive",
  [sym_requires_module_directive] = "requires_module_directive",
  [sym_requires_modifier] = "requires_modifier",
  [sym_exports_module_directive] = "exports_module_directive",
  [sym_opens_module_directive] = "opens_module_directive",
  [sym_uses_module_directive] = "uses_module_directive",
  [sym_provides_module_directive] = "provides_module_directive",
  [sym_package_declaration] = "package_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_asterisk] = "asterisk",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_body_declarations] = "enum_body_declarations",
  [sym_enum_constant] = "enum_constant",
  [sym_class_declaration] = "class_declaration",
  [sym_modifiers] = "modifiers",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_type_bound] = "type_bound",
  [sym_superclass] = "superclass",
  [sym_super_interfaces] = "super_interfaces",
  [sym_type_list] = "type_list",
  [sym_permits] = "permits",
  [sym_class_body] = "class_body",
  [sym_static_initializer] = "static_initializer",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym__constructor_declarator] = "_constructor_declarator",
  [sym_constructor_body] = "constructor_body",
  [sym_explicit_constructor_invocation] = "explicit_constructor_invocation",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_field_declaration] = "field_declaration",
  [sym_record_declaration] = "record_declaration",
  [sym_annotation_type_declaration] = "annotation_type_declaration",
  [sym_annotation_type_body] = "annotation_type_body",
  [sym_annotation_type_element_declaration] = "annotation_type_element_declaration",
  [sym__default_value] = "_default_value",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_interfaces] = "extends_interfaces",
  [sym_interface_body] = "interface_body",
  [sym_constant_declaration] = "constant_declaration",
  [sym__variable_declarator_list] = "_variable_declarator_list",
  [sym_variable_declarator] = "variable_declarator",
  [sym__variable_declarator_id] = "_variable_declarator_id",
  [sym_array_initializer] = "array_initializer",
  [sym__type] = "_type",
  [sym__unannotated_type] = "_unannotated_type",
  [sym_annotated_type] = "annotated_type",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_generic_type] = "generic_type",
  [sym_array_type] = "array_type",
  [sym_integral_type] = "integral_type",
  [sym_floating_point_type] = "floating_point_type",
  [sym__method_header] = "_method_header",
  [sym__method_declarator] = "_method_declarator",
  [sym_formal_parameters] = "formal_parameters",
  [sym_formal_parameter] = "formal_parameter",
  [sym_receiver_parameter] = "receiver_parameter",
  [sym_spread_parameter] = "spread_parameter",
  [sym_throws] = "throws",
  [sym_local_variable_declaration] = "local_variable_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_compact_constructor_declaration] = "compact_constructor_declaration",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym__string_literal_repeat1] = "_string_literal_repeat1",
  [aux_sym__multiline_string_literal_repeat1] = "_multiline_string_literal_repeat1",
  [aux_sym__multiline_string_fragment_repeat1] = "_multiline_string_fragment_repeat1",
  [aux_sym_cast_expression_repeat1] = "cast_expression_repeat1",
  [aux_sym_inferred_parameters_repeat1] = "inferred_parameters_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [aux_sym_array_creation_expression_repeat2] = "array_creation_expression_repeat2",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_dimensions_repeat1] = "dimensions_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_switch_block_repeat2] = "switch_block_repeat2",
  [aux_sym_switch_block_statement_group_repeat1] = "switch_block_statement_group_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_catch_type_repeat1] = "catch_type_repeat1",
  [aux_sym_resource_specification_repeat1] = "resource_specification_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_for_statement_repeat2] = "for_statement_repeat2",
  [aux_sym_annotation_argument_list_repeat1] = "annotation_argument_list_repeat1",
  [aux_sym_element_value_array_initializer_repeat1] = "element_value_array_initializer_repeat1",
  [aux_sym_module_body_repeat1] = "module_body_repeat1",
  [aux_sym_requires_module_directive_repeat1] = "requires_module_directive_repeat1",
  [aux_sym_exports_module_directive_repeat1] = "exports_module_directive_repeat1",
  [aux_sym_provides_module_directive_repeat1] = "provides_module_directive_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_enum_body_declarations_repeat1] = "enum_body_declarations_repeat1",
  [aux_sym_modifiers_repeat1] = "modifiers_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_type_bound_repeat1] = "type_bound_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym_annotation_type_body_repeat1] = "annotation_type_body_repeat1",
  [aux_sym_interface_body_repeat1] = "interface_body_repeat1",
  [aux_sym__variable_declarator_list_repeat1] = "_variable_declarator_list_repeat1",
  [aux_sym_array_initializer_repeat1] = "array_initializer_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_decimal_integer_literal] = sym_decimal_integer_literal,
  [sym_hex_integer_literal] = sym_hex_integer_literal,
  [sym_octal_integer_literal] = sym_octal_integer_literal,
  [sym_binary_integer_literal] = sym_binary_integer_literal,
  [sym_decimal_floating_point_literal] = sym_decimal_floating_point_literal,
  [sym_hex_floating_point_literal] = sym_hex_floating_point_literal,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_character_literal] = sym_character_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [sym_string_fragment] = sym_string_fragment,
  [aux_sym__multiline_string_fragment_token1] = aux_sym__multiline_string_fragment_token1,
  [aux_sym__multiline_string_fragment_token2] = aux_sym__multiline_string_fragment_token2,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_null_literal] = sym_null_literal,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_synchronized] = anon_sym_synchronized,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_open] = anon_sym_open,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_transitive] = anon_sym_transitive,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_exports] = anon_sym_exports,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_opens] = anon_sym_opens,
  [anon_sym_uses] = anon_sym_uses,
  [anon_sym_provides] = anon_sym_provides,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_strictfp] = anon_sym_strictfp,
  [anon_sym_native] = anon_sym_native,
  [anon_sym_transient] = anon_sym_transient,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_sealed] = anon_sym_sealed,
  [anon_sym_non_DASHsealed] = anon_sym_non_DASHsealed,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_permits] = anon_sym_permits,
  [anon_sym_record] = anon_sym_record,
  [anon_sym_ATinterface] = anon_sym_ATinterface,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_char] = anon_sym_char,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_double] = anon_sym_double,
  [sym_boolean_type] = sym_boolean_type,
  [sym_void_type] = sym_void_type,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_throws] = anon_sym_throws,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym_program] = sym_program,
  [sym__literal] = sym__literal,
  [sym_string_literal] = sym_string_literal,
  [sym__string_literal] = sym__string_literal,
  [sym__multiline_string_literal] = sym__multiline_string_literal,
  [sym__multiline_string_fragment] = sym__multiline_string_fragment,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym_expression] = sym_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_instanceof_expression] = sym_instanceof_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_inferred_parameters] = sym_inferred_parameters,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_dimensions_expr] = sym_dimensions_expr,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_condition] = sym_condition,
  [sym_class_literal] = sym_class_literal,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym__unqualified_object_creation_expression] = sym__unqualified_object_creation_expression,
  [sym_field_access] = sym_field_access,
  [sym_array_access] = sym_array_access,
  [sym_method_invocation] = sym_method_invocation,
  [sym_argument_list] = sym_argument_list,
  [sym_method_reference] = sym_method_reference,
  [sym_type_arguments] = sym_type_arguments,
  [sym_wildcard] = sym_wildcard,
  [sym__wildcard_bounds] = sym__wildcard_bounds,
  [sym_dimensions] = sym_dimensions,
  [sym_switch_expression] = sym_switch_expression,
  [sym_switch_block] = sym_switch_block,
  [sym_switch_block_statement_group] = sym_switch_block_statement_group,
  [sym_switch_rule] = sym_switch_rule,
  [sym_switch_label] = sym_switch_label,
  [sym_statement] = sym_statement,
  [sym_block] = sym_block,
  [sym_expression_statement] = sym_expression_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_assert_statement] = sym_assert_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_synchronized_statement] = sym_synchronized_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_formal_parameter] = sym_catch_formal_parameter,
  [sym_catch_type] = sym_catch_type,
  [sym_finally_clause] = sym_finally_clause,
  [sym_try_with_resources_statement] = sym_try_with_resources_statement,
  [sym_resource_specification] = sym_resource_specification,
  [sym_resource] = sym_resource,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_enhanced_for_statement] = sym_enhanced_for_statement,
  [sym__annotation] = sym__annotation,
  [sym_marker_annotation] = sym_marker_annotation,
  [sym_annotation] = sym_annotation,
  [sym_annotation_argument_list] = sym_annotation_argument_list,
  [sym_element_value_pair] = sym_element_value_pair,
  [sym__element_value] = sym__element_value,
  [sym_element_value_array_initializer] = sym_element_value_array_initializer,
  [sym_declaration] = sym_declaration,
  [sym_module_declaration] = sym_module_declaration,
  [sym_module_body] = sym_module_body,
  [sym_module_directive] = sym_module_directive,
  [sym_requires_module_directive] = sym_requires_module_directive,
  [sym_requires_modifier] = sym_requires_modifier,
  [sym_exports_module_directive] = sym_exports_module_directive,
  [sym_opens_module_directive] = sym_opens_module_directive,
  [sym_uses_module_directive] = sym_uses_module_directive,
  [sym_provides_module_directive] = sym_provides_module_directive,
  [sym_package_declaration] = sym_package_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_asterisk] = sym_asterisk,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_body_declarations] = sym_enum_body_declarations,
  [sym_enum_constant] = sym_enum_constant,
  [sym_class_declaration] = sym_class_declaration,
  [sym_modifiers] = sym_modifiers,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_type_bound] = sym_type_bound,
  [sym_superclass] = sym_superclass,
  [sym_super_interfaces] = sym_super_interfaces,
  [sym_type_list] = sym_type_list,
  [sym_permits] = sym_permits,
  [sym_class_body] = sym_class_body,
  [sym_static_initializer] = sym_static_initializer,
  [sym_constructor_declaration] = sym_constructor_declaration,
  [sym__constructor_declarator] = sym__constructor_declarator,
  [sym_constructor_body] = sym_constructor_body,
  [sym_explicit_constructor_invocation] = sym_explicit_constructor_invocation,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_field_declaration] = sym_field_declaration,
  [sym_record_declaration] = sym_record_declaration,
  [sym_annotation_type_declaration] = sym_annotation_type_declaration,
  [sym_annotation_type_body] = sym_annotation_type_body,
  [sym_annotation_type_element_declaration] = sym_annotation_type_element_declaration,
  [sym__default_value] = sym__default_value,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_interfaces] = sym_extends_interfaces,
  [sym_interface_body] = sym_interface_body,
  [sym_constant_declaration] = sym_constant_declaration,
  [sym__variable_declarator_list] = sym__variable_declarator_list,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym__variable_declarator_id] = sym__variable_declarator_id,
  [sym_array_initializer] = sym_array_initializer,
  [sym__type] = sym__type,
  [sym__unannotated_type] = sym__unannotated_type,
  [sym_annotated_type] = sym_annotated_type,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_generic_type] = sym_generic_type,
  [sym_array_type] = sym_array_type,
  [sym_integral_type] = sym_integral_type,
  [sym_floating_point_type] = sym_floating_point_type,
  [sym__method_header] = sym__method_header,
  [sym__method_declarator] = sym__method_declarator,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_formal_parameter] = sym_formal_parameter,
  [sym_receiver_parameter] = sym_receiver_parameter,
  [sym_spread_parameter] = sym_spread_parameter,
  [sym_throws] = sym_throws,
  [sym_local_variable_declaration] = sym_local_variable_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_compact_constructor_declaration] = sym_compact_constructor_declaration,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym__string_literal_repeat1] = aux_sym__string_literal_repeat1,
  [aux_sym__multiline_string_literal_repeat1] = aux_sym__multiline_string_literal_repeat1,
  [aux_sym__multiline_string_fragment_repeat1] = aux_sym__multiline_string_fragment_repeat1,
  [aux_sym_cast_expression_repeat1] = aux_sym_cast_expression_repeat1,
  [aux_sym_inferred_parameters_repeat1] = aux_sym_inferred_parameters_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [aux_sym_array_creation_expression_repeat2] = aux_sym_array_creation_expression_repeat2,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_dimensions_repeat1] = aux_sym_dimensions_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_switch_block_repeat2] = aux_sym_switch_block_repeat2,
  [aux_sym_switch_block_statement_group_repeat1] = aux_sym_switch_block_statement_group_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_catch_type_repeat1] = aux_sym_catch_type_repeat1,
  [aux_sym_resource_specification_repeat1] = aux_sym_resource_specification_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_for_statement_repeat2] = aux_sym_for_statement_repeat2,
  [aux_sym_annotation_argument_list_repeat1] = aux_sym_annotation_argument_list_repeat1,
  [aux_sym_element_value_array_initializer_repeat1] = aux_sym_element_value_array_initializer_repeat1,
  [aux_sym_module_body_repeat1] = aux_sym_module_body_repeat1,
  [aux_sym_requires_module_directive_repeat1] = aux_sym_requires_module_directive_repeat1,
  [aux_sym_exports_module_directive_repeat1] = aux_sym_exports_module_directive_repeat1,
  [aux_sym_provides_module_directive_repeat1] = aux_sym_provides_module_directive_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_enum_body_declarations_repeat1] = aux_sym_enum_body_declarations_repeat1,
  [aux_sym_modifiers_repeat1] = aux_sym_modifiers_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_type_bound_repeat1] = aux_sym_type_bound_repeat1,
  [aux_sym_type_list_repeat1] = aux_sym_type_list_repeat1,
  [aux_sym_annotation_type_body_repeat1] = aux_sym_annotation_type_body_repeat1,
  [aux_sym_interface_body_repeat1] = aux_sym_interface_body_repeat1,
  [aux_sym__variable_declarator_list_repeat1] = aux_sym__variable_declarator_list_repeat1,
  [aux_sym_array_initializer_repeat1] = aux_sym_array_initializer_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_octal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__multiline_string_fragment_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__multiline_string_fragment_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_synchronized] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_open] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exports] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_opens] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uses] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_provides] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictfp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_native] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transient] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_non_DASHsealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_permits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_record] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATinterface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [sym_boolean_type] = {
    .visible = true,
    .named = true,
  },
  [sym_void_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throws] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__multiline_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__multiline_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_instanceof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_inferred_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dimensions_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_class_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__unqualified_object_creation_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym_array_access] = {
    .visible = true,
    .named = true,
  },
  [sym_method_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_method_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym__wildcard_bounds] = {
    .visible = false,
    .named = true,
  },
  [sym_dimensions] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block_statement_group] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_synchronized_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_type] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_try_with_resources_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_resource_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_resource] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_enhanced_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_marker_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_element_value_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__element_value] = {
    .visible = false,
    .named = true,
  },
  [sym_element_value_array_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module_body] = {
    .visible = true,
    .named = true,
  },
  [sym_module_directive] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_requires_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_exports_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_opens_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_uses_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_provides_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_package_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_asterisk] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body_declarations] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_super_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_permits] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_static_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_body] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_constructor_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_body] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_element_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__default_value] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_body] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator_list] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator_id] = {
    .visible = false,
    .named = true,
  },
  [sym_array_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unannotated_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_annotated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_integral_type] = {
    .visible = true,
    .named = true,
  },
  [sym_floating_point_type] = {
    .visible = true,
    .named = true,
  },
  [sym__method_header] = {
    .visible = false,
    .named = true,
  },
  [sym__method_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_receiver_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_throws] = {
    .visible = true,
    .named = true,
  },
  [sym_local_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_compact_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__multiline_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__multiline_string_fragment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inferred_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimensions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_statement_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_catch_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_resource_specification_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_element_value_array_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exports_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_provides_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_declarations_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_bound_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_declarator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_array = 3,
  field_body = 4,
  field_condition = 5,
  field_consequence = 6,
  field_constructor = 7,
  field_declarator = 8,
  field_dimensions = 9,
  field_element = 10,
  field_field = 11,
  field_index = 12,
  field_init = 13,
  field_interfaces = 14,
  field_key = 15,
  field_left = 16,
  field_modifiers = 17,
  field_module = 18,
  field_modules = 19,
  field_name = 20,
  field_object = 21,
  field_operand = 22,
  field_operator = 23,
  field_package = 24,
  field_parameters = 25,
  field_permits = 26,
  field_provided = 27,
  field_provider = 28,
  field_resources = 29,
  field_right = 30,
  field_scope = 31,
  field_superclass = 32,
  field_type = 33,
  field_type_arguments = 34,
  field_type_parameters = 35,
  field_update = 36,
  field_value = 37,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_array] = "array",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declarator] = "declarator",
  [field_dimensions] = "dimensions",
  [field_element] = "element",
  [field_field] = "field",
  [field_index] = "index",
  [field_init] = "init",
  [field_interfaces] = "interfaces",
  [field_key] = "key",
  [field_left] = "left",
  [field_modifiers] = "modifiers",
  [field_module] = "module",
  [field_modules] = "modules",
  [field_name] = "name",
  [field_object] = "object",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameters] = "parameters",
  [field_permits] = "permits",
  [field_provided] = "provided",
  [field_provider] = "provider",
  [field_resources] = "resources",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_superclass] = "superclass",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 3},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 8, .length = 1},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 1},
  [13] = {.index = 12, .length = 2},
  [15] = {.index = 14, .length = 3},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 17, .length = 2},
  [19] = {.index = 19, .length = 2},
  [20] = {.index = 21, .length = 2},
  [21] = {.index = 23, .length = 2},
  [22] = {.index = 25, .length = 1},
  [23] = {.index = 26, .length = 1},
  [24] = {.index = 27, .length = 2},
  [25] = {.index = 29, .length = 2},
  [26] = {.index = 31, .length = 2},
  [27] = {.index = 31, .length = 2},
  [28] = {.index = 33, .length = 3},
  [29] = {.index = 36, .length = 2},
  [30] = {.index = 21, .length = 2},
  [31] = {.index = 38, .length = 2},
  [32] = {.index = 38, .length = 2},
  [33] = {.index = 33, .length = 3},
  [34] = {.index = 36, .length = 2},
  [36] = {.index = 40, .length = 2},
  [37] = {.index = 42, .length = 3},
  [38] = {.index = 45, .length = 2},
  [39] = {.index = 45, .length = 2},
  [40] = {.index = 47, .length = 2},
  [41] = {.index = 49, .length = 2},
  [43] = {.index = 51, .length = 3},
  [44] = {.index = 54, .length = 2},
  [45] = {.index = 56, .length = 1},
  [46] = {.index = 57, .length = 2},
  [47] = {.index = 59, .length = 3},
  [48] = {.index = 62, .length = 3},
  [49] = {.index = 59, .length = 3},
  [50] = {.index = 62, .length = 3},
  [51] = {.index = 65, .length = 3},
  [52] = {.index = 65, .length = 3},
  [53] = {.index = 68, .length = 2},
  [54] = {.index = 68, .length = 2},
  [55] = {.index = 70, .length = 3},
  [56] = {.index = 73, .length = 3},
  [57] = {.index = 76, .length = 3},
  [58] = {.index = 79, .length = 3},
  [59] = {.index = 82, .length = 2},
  [60] = {.index = 82, .length = 2},
  [61] = {.index = 84, .length = 2},
  [62] = {.index = 84, .length = 2},
  [64] = {.index = 86, .length = 3},
  [65] = {.index = 89, .length = 2},
  [66] = {.index = 91, .length = 3},
  [67] = {.index = 91, .length = 3},
  [69] = {.index = 94, .length = 2},
  [70] = {.index = 96, .length = 3},
  [71] = {.index = 96, .length = 3},
  [72] = {.index = 99, .length = 2},
  [73] = {.index = 101, .length = 2},
  [74] = {.index = 103, .length = 1},
  [75] = {.index = 104, .length = 2},
  [76] = {.index = 106, .length = 3},
  [78] = {.index = 109, .length = 3},
  [79] = {.index = 112, .length = 3},
  [80] = {.index = 115, .length = 3},
  [81] = {.index = 112, .length = 3},
  [82] = {.index = 115, .length = 3},
  [84] = {.index = 118, .length = 2},
  [85] = {.index = 120, .length = 2},
  [86] = {.index = 122, .length = 4},
  [87] = {.index = 126, .length = 4},
  [88] = {.index = 130, .length = 5},
  [89] = {.index = 135, .length = 6},
  [90] = {.index = 141, .length = 4},
  [91] = {.index = 145, .length = 4},
  [92] = {.index = 149, .length = 4},
  [93] = {.index = 153, .length = 4},
  [94] = {.index = 157, .length = 4},
  [95] = {.index = 161, .length = 4},
  [96] = {.index = 165, .length = 2},
  [97] = {.index = 167, .length = 3},
  [98] = {.index = 170, .length = 1},
  [99] = {.index = 171, .length = 2},
  [100] = {.index = 173, .length = 1},
  [101] = {.index = 174, .length = 4},
  [102] = {.index = 178, .length = 4},
  [103] = {.index = 182, .length = 3},
  [104] = {.index = 185, .length = 3},
  [105] = {.index = 188, .length = 2},
  [106] = {.index = 188, .length = 2},
  [107] = {.index = 190, .length = 4},
  [108] = {.index = 190, .length = 4},
  [109] = {.index = 194, .length = 3},
  [110] = {.index = 194, .length = 3},
  [111] = {.index = 197, .length = 3},
  [112] = {.index = 200, .length = 3},
  [113] = {.index = 203, .length = 3},
  [114] = {.index = 206, .length = 3},
  [115] = {.index = 209, .length = 3},
  [116] = {.index = 212, .length = 3},
  [117] = {.index = 215, .length = 2},
  [118] = {.index = 217, .length = 2},
  [119] = {.index = 217, .length = 2},
  [120] = {.index = 219, .length = 4},
  [121] = {.index = 223, .length = 5},
  [122] = {.index = 228, .length = 6},
  [123] = {.index = 234, .length = 3},
  [124] = {.index = 237, .length = 5},
  [125] = {.index = 242, .length = 4},
  [126] = {.index = 120, .length = 2},
  [127] = {.index = 246, .length = 5},
  [128] = {.index = 251, .length = 5},
  [129] = {.index = 256, .length = 5},
  [130] = {.index = 261, .length = 5},
  [131] = {.index = 266, .length = 4},
  [132] = {.index = 270, .length = 2},
  [133] = {.index = 272, .length = 1},
  [134] = {.index = 273, .length = 2},
  [135] = {.index = 275, .length = 2},
  [136] = {.index = 277, .length = 1},
  [137] = {.index = 277, .length = 1},
  [138] = {.index = 278, .length = 2},
  [139] = {.index = 280, .length = 1},
  [140] = {.index = 280, .length = 1},
  [141] = {.index = 56, .length = 1},
  [142] = {.index = 281, .length = 3},
  [143] = {.index = 284, .length = 5},
  [144] = {.index = 289, .length = 4},
  [145] = {.index = 293, .length = 3},
  [146] = {.index = 293, .length = 3},
  [147] = {.index = 296, .length = 4},
  [148] = {.index = 300, .length = 4},
  [149] = {.index = 304, .length = 4},
  [150] = {.index = 308, .length = 4},
  [151] = {.index = 312, .length = 4},
  [152] = {.index = 316, .length = 4},
  [153] = {.index = 320, .length = 4},
  [154] = {.index = 324, .length = 4},
  [155] = {.index = 328, .length = 3},
  [156] = {.index = 331, .length = 3},
  [157] = {.index = 334, .length = 4},
  [158] = {.index = 338, .length = 5},
  [159] = {.index = 343, .length = 3},
  [160] = {.index = 343, .length = 3},
  [161] = {.index = 346, .length = 6},
  [162] = {.index = 352, .length = 4},
  [163] = {.index = 356, .length = 1},
  [164] = {.index = 357, .length = 2},
  [165] = {.index = 359, .length = 2},
  [166] = {.index = 361, .length = 1},
  [167] = {.index = 362, .length = 2},
  [168] = {.index = 364, .length = 2},
  [169] = {.index = 366, .length = 2},
  [170] = {.index = 368, .length = 3},
  [171] = {.index = 371, .length = 3},
  [172] = {.index = 374, .length = 2},
  [173] = {.index = 374, .length = 2},
  [174] = {.index = 376, .length = 3},
  [175] = {.index = 379, .length = 4},
  [176] = {.index = 379, .length = 4},
  [177] = {.index = 383, .length = 5},
  [178] = {.index = 388, .length = 5},
  [179] = {.index = 393, .length = 5},
  [180] = {.index = 398, .length = 5},
  [181] = {.index = 403, .length = 5},
  [182] = {.index = 408, .length = 4},
  [183] = {.index = 412, .length = 2},
  [184] = {.index = 414, .length = 3},
  [185] = {.index = 417, .length = 3},
  [186] = {.index = 420, .length = 3},
  [187] = {.index = 423, .length = 3},
  [188] = {.index = 426, .length = 3},
  [189] = {.index = 429, .length = 5},
  [190] = {.index = 434, .length = 4},
  [191] = {.index = 438, .length = 4},
  [192] = {.index = 442, .length = 2},
  [193] = {.index = 442, .length = 2},
  [194] = {.index = 442, .length = 2},
  [195] = {.index = 442, .length = 2},
  [196] = {.index = 444, .length = 1},
  [197] = {.index = 444, .length = 1},
  [198] = {.index = 444, .length = 1},
  [199] = {.index = 444, .length = 1},
  [200] = {.index = 445, .length = 2},
  [201] = {.index = 447, .length = 6},
  [202] = {.index = 453, .length = 3},
  [203] = {.index = 456, .length = 4},
  [204] = {.index = 460, .length = 4},
  [205] = {.index = 464, .length = 4},
  [206] = {.index = 468, .length = 4},
  [207] = {.index = 472, .length = 4},
  [208] = {.index = 476, .length = 5},
  [209] = {.index = 481, .length = 5},
  [210] = {.index = 486, .length = 1},
  [211] = {.index = 486, .length = 1},
  [212] = {.index = 487, .length = 3},
  [213] = {.index = 490, .length = 2},
  [214] = {.index = 487, .length = 3},
  [215] = {.index = 487, .length = 3},
  [216] = {.index = 487, .length = 3},
  [217] = {.index = 492, .length = 1},
  [218] = {.index = 492, .length = 1},
  [219] = {.index = 493, .length = 2},
  [220] = {.index = 495, .length = 2},
  [221] = {.index = 493, .length = 2},
  [222] = {.index = 493, .length = 2},
  [223] = {.index = 493, .length = 2},
  [224] = {.index = 497, .length = 2},
  [225] = {.index = 499, .length = 1},
  [226] = {.index = 500, .length = 3},
  [227] = {.index = 503, .length = 3},
  [228] = {.index = 506, .length = 3},
  [229] = {.index = 509, .length = 5},
  [230] = {.index = 514, .length = 5},
  [231] = {.index = 519, .length = 5},
  [232] = {.index = 524, .length = 3},
  [233] = {.index = 527, .length = 3},
  [234] = {.index = 530, .length = 4},
  [235] = {.index = 534, .length = 4},
  [236] = {.index = 538, .length = 6},
  [237] = {.index = 544, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_arguments, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_arguments, 0, .inherited = true},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_name, 1},
  [6] =
    {field_arguments, 1},
    {field_name, 0},
  [8] =
    {field_name, 0},
  [9] =
    {field_dimensions, 1},
    {field_element, 0},
  [11] =
    {field_declarator, 0},
  [12] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [14] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0},
  [17] =
    {field_arguments, 2},
    {field_type, 1},
  [19] =
    {field_dimensions, 2},
    {field_type, 1},
  [21] =
    {field_body, 2},
    {field_name, 1},
  [23] =
    {field_body, 2},
    {field_condition, 1},
  [25] =
    {field_body, 2},
  [26] =
    {field_body, 1},
  [27] =
    {field_body, 2},
    {field_resources, 1},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_arguments, 2},
    {field_name, 1},
  [33] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [36] =
    {field_body, 2},
    {field_parameters, 0},
  [38] =
    {field_field, 2},
    {field_object, 0},
  [40] =
    {field_left, 0},
    {field_right, 2},
  [42] =
    {field_arguments, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_type_arguments, 2, .inherited = true},
  [45] =
    {field_dimensions, 1},
    {field_name, 0},
  [47] =
    {field_declarator, 1, .inherited = true},
    {field_type, 0},
  [49] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [51] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1},
  [54] =
    {field_type, 1},
    {field_value, 3},
  [56] =
    {field_type, 1},
  [57] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [59] =
    {field_dimensions, 2},
    {field_type, 1},
    {field_value, 3},
  [62] =
    {field_dimensions, 2},
    {field_dimensions, 3},
    {field_type, 1},
  [65] =
    {field_arguments, 3},
    {field_type, 2},
    {field_type_arguments, 1},
  [68] =
    {field_dimensions, 3},
    {field_type, 2},
  [70] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [73] =
    {field_body, 3},
    {field_name, 1},
    {field_superclass, 2},
  [76] =
    {field_body, 3},
    {field_interfaces, 2},
    {field_name, 1},
  [79] =
    {field_body, 3},
    {field_name, 1},
    {field_permits, 2},
  [82] =
    {field_name, 2},
    {field_scope, 0},
  [84] =
    {field_body, 3},
    {field_name, 2},
  [86] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [89] =
    {field_body, 3},
    {field_name, 1},
  [91] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [94] =
    {field_left, 0},
    {field_right, 3},
  [96] =
    {field_left, 0},
    {field_name, 3},
    {field_right, 2},
  [99] =
    {field_array, 0},
    {field_index, 2},
  [101] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1},
  [103] =
    {field_declarator, 1},
  [104] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [106] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_value, 2},
  [109] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
    {field_value, 4},
  [112] =
    {field_dimensions, 3},
    {field_type, 2},
    {field_value, 4},
  [115] =
    {field_dimensions, 3},
    {field_dimensions, 4},
    {field_type, 2},
  [118] =
    {field_body, 1},
    {field_name, 0},
  [120] =
    {field_name, 0},
    {field_parameters, 1},
  [122] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [126] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0},
  [130] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [135] =
    {field_body, 1},
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [141] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [145] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [149] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
    {field_type_parameters, 2},
  [153] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_superclass, 2},
  [157] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
    {field_superclass, 2},
  [161] =
    {field_body, 4},
    {field_interfaces, 2},
    {field_name, 1},
    {field_permits, 3},
  [165] =
    {field_body, 1},
    {field_condition, 3},
  [167] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [170] =
    {field_init, 1},
  [171] =
    {field_init, 0, .inherited = true},
    {field_init, 1, .inherited = true},
  [173] =
    {field_modifiers, 0},
  [174] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [178] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_parameters, 2},
  [182] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [185] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
  [188] =
    {field_field, 4},
    {field_object, 0},
  [190] =
    {field_arguments, 4},
    {field_name, 3},
    {field_object, 0},
    {field_type_arguments, 2},
  [194] =
    {field_left, 0},
    {field_name, 4},
    {field_right, 3},
  [197] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [200] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [203] =
    {field_body, 4},
    {field_name, 2},
    {field_superclass, 3},
  [206] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 2},
  [209] =
    {field_body, 4},
    {field_name, 2},
    {field_permits, 3},
  [212] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [215] =
    {field_body, 4},
    {field_name, 2},
  [217] =
    {field_body, 4},
    {field_name, 3},
  [219] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [223] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [228] =
    {field_body, 2},
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [234] =
    {field_name, 1},
    {field_parameters, 2},
    {field_type_parameters, 0},
  [237] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1},
    {field_type_parameters, 0},
  [242] =
    {field_body, 2},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [246] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [251] =
    {field_body, 5},
    {field_name, 1},
    {field_permits, 4},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [256] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 1},
    {field_permits, 4},
    {field_type_parameters, 2},
  [261] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 1},
    {field_permits, 4},
    {field_superclass, 2},
  [266] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0},
    {field_value, 3},
  [270] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [272] =
    {field_body, 5},
  [273] =
    {field_body, 5},
    {field_init, 2},
  [275] =
    {field_key, 0},
    {field_value, 2},
  [277] =
    {field_module, 1},
  [278] =
    {field_modifiers, 0, .inherited = true},
    {field_modifiers, 1, .inherited = true},
  [280] =
    {field_package, 1},
  [281] =
    {field_arguments, 1},
    {field_body, 2},
    {field_name, 0},
  [284] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [289] =
    {field_body, 5},
    {field_name, 1},
    {field_permits, 4},
    {field_type_parameters, 2},
  [293] =
    {field_arguments, 5},
    {field_name, 4},
    {field_object, 0},
  [296] =
    {field_body, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [300] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [304] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
    {field_type_parameters, 3},
  [308] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_superclass, 3},
  [312] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
    {field_superclass, 3},
  [316] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 2},
    {field_permits, 4},
  [320] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [324] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_parameters, 3},
  [328] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [331] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
  [334] =
    {field_body, 3},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [338] =
    {field_dimensions, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_parameters, 3, .inherited = true},
    {field_type, 2},
    {field_type_parameters, 0},
  [343] =
    {field_dimensions, 2},
    {field_name, 0},
    {field_parameters, 1},
  [346] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 1},
    {field_permits, 5},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [352] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1},
    {field_value, 4},
  [356] =
    {field_body, 4},
  [357] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [359] =
    {field_body, 6},
    {field_update, 4},
  [361] =
    {field_update, 1},
  [362] =
    {field_update, 0, .inherited = true},
    {field_update, 1, .inherited = true},
  [364] =
    {field_body, 6},
    {field_condition, 3},
  [366] =
    {field_body, 6},
    {field_init, 2},
  [368] =
    {field_body, 6},
    {field_init, 2},
    {field_update, 4},
  [371] =
    {field_body, 6},
    {field_condition, 3},
    {field_init, 2},
  [374] =
    {field_modifiers, 1, .inherited = true},
    {field_module, 2},
  [376] =
    {field_arguments, 2},
    {field_body, 3},
    {field_name, 1},
  [379] =
    {field_arguments, 6},
    {field_name, 5},
    {field_object, 0},
    {field_type_arguments, 4},
  [383] =
    {field_body, 6},
    {field_interfaces, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [388] =
    {field_body, 6},
    {field_name, 2},
    {field_permits, 5},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [393] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 2},
    {field_permits, 5},
    {field_type_parameters, 3},
  [398] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 2},
    {field_permits, 5},
    {field_superclass, 3},
  [403] =
    {field_body, 6},
    {field_interfaces, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [408] =
    {field_body, 6},
    {field_name, 2},
    {field_permits, 5},
    {field_type_parameters, 3},
  [412] =
    {field_arguments, 1},
    {field_constructor, 0},
  [414] =
    {field_body, 7},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [417] =
    {field_body, 7},
    {field_condition, 3},
    {field_update, 5},
  [420] =
    {field_body, 7},
    {field_init, 2},
    {field_update, 5},
  [423] =
    {field_body, 7},
    {field_condition, 4},
    {field_init, 2},
  [426] =
    {field_body, 7},
    {field_init, 2},
    {field_init, 3, .inherited = true},
  [429] =
    {field_body, 7},
    {field_dimensions, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_type, 2},
    {field_value, 5},
  [434] =
    {field_body, 7},
    {field_init, 2},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [438] =
    {field_body, 7},
    {field_condition, 3},
    {field_init, 2},
    {field_update, 5},
  [442] =
    {field_modules, 3},
    {field_package, 1},
  [444] =
    {field_provided, 1},
  [445] =
    {field_name, 1},
    {field_type, 0},
  [447] =
    {field_body, 7},
    {field_interfaces, 5},
    {field_name, 2},
    {field_permits, 6},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [453] =
    {field_arguments, 2},
    {field_constructor, 1},
    {field_type_arguments, 0},
  [456] =
    {field_body, 8},
    {field_condition, 3},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [460] =
    {field_body, 8},
    {field_init, 2},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [464] =
    {field_body, 8},
    {field_condition, 4},
    {field_init, 2},
    {field_update, 6},
  [468] =
    {field_body, 8},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 6},
  [472] =
    {field_body, 8},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
  [476] =
    {field_body, 8},
    {field_dimensions, 4, .inherited = true},
    {field_name, 4, .inherited = true},
    {field_type, 3},
    {field_value, 6},
  [481] =
    {field_body, 8},
    {field_condition, 3},
    {field_init, 2},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [486] =
    {field_modules, 1},
  [487] =
    {field_modules, 3},
    {field_modules, 4, .inherited = true},
    {field_package, 1},
  [490] =
    {field_modules, 0, .inherited = true},
    {field_modules, 1, .inherited = true},
  [492] =
    {field_provider, 1},
  [493] =
    {field_provided, 1},
    {field_provider, 4, .inherited = true},
  [495] =
    {field_provider, 0, .inherited = true},
    {field_provider, 1, .inherited = true},
  [497] =
    {field_name, 2},
    {field_type, 1},
  [499] =
    {field_value, 1},
  [500] =
    {field_dimensions, 4},
    {field_name, 1},
    {field_type, 0},
  [503] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 4, .inherited = true},
  [506] =
    {field_arguments, 3},
    {field_constructor, 2},
    {field_object, 0},
  [509] =
    {field_body, 9},
    {field_condition, 4},
    {field_init, 2},
    {field_update, 6},
    {field_update, 7, .inherited = true},
  [514] =
    {field_body, 9},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 6},
    {field_update, 7, .inherited = true},
  [519] =
    {field_body, 9},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 7},
  [524] =
    {field_dimensions, 5},
    {field_name, 2},
    {field_type, 1},
  [527] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 5, .inherited = true},
  [530] =
    {field_dimensions, 4},
    {field_name, 1},
    {field_type, 0},
    {field_value, 5, .inherited = true},
  [534] =
    {field_arguments, 4},
    {field_constructor, 3},
    {field_object, 0},
    {field_type_arguments, 2},
  [538] =
    {field_body, 10},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 7},
    {field_update, 8, .inherited = true},
  [544] =
    {field_dimensions, 5},
    {field_name, 2},
    {field_type, 1},
    {field_value, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = alias_sym_type_identifier,
  },
  [5] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = sym_identifier,
  },
  [9] = {
    [0] = sym_identifier,
  },
  [14] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = alias_sym_type_identifier,
  },
  [19] = {
    [1] = alias_sym_type_identifier,
  },
  [26] = {
    [1] = sym_identifier,
  },
  [28] = {
    [0] = sym_identifier,
  },
  [29] = {
    [0] = sym_identifier,
  },
  [30] = {
    [1] = sym_identifier,
  },
  [31] = {
    [2] = sym_identifier,
  },
  [35] = {
    [0] = alias_sym_type_identifier,
    [2] = alias_sym_type_identifier,
  },
  [38] = {
    [0] = sym_identifier,
  },
  [42] = {
    [2] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [50] = {
    [1] = alias_sym_type_identifier,
  },
  [52] = {
    [2] = alias_sym_type_identifier,
  },
  [54] = {
    [2] = alias_sym_type_identifier,
  },
  [59] = {
    [0] = sym_identifier,
  },
  [61] = {
    [2] = sym_identifier,
  },
  [63] = {
    [2] = sym_identifier,
  },
  [66] = {
    [2] = sym_identifier,
  },
  [68] = {
    [0] = alias_sym_type_identifier,
    [3] = alias_sym_type_identifier,
  },
  [70] = {
    [3] = sym_identifier,
  },
  [77] = {
    [3] = alias_sym_type_identifier,
  },
  [81] = {
    [2] = alias_sym_type_identifier,
  },
  [82] = {
    [2] = alias_sym_type_identifier,
  },
  [83] = {
    [1] = alias_sym_type_identifier,
  },
  [105] = {
    [4] = sym_identifier,
  },
  [107] = {
    [3] = sym_identifier,
  },
  [109] = {
    [4] = sym_identifier,
  },
  [118] = {
    [3] = sym_identifier,
  },
  [126] = {
    [0] = sym_identifier,
  },
  [136] = {
    [1] = sym_identifier,
  },
  [139] = {
    [1] = sym_identifier,
  },
  [141] = {
    [1] = sym_identifier,
  },
  [145] = {
    [4] = sym_identifier,
  },
  [159] = {
    [0] = sym_identifier,
  },
  [172] = {
    [2] = sym_identifier,
  },
  [175] = {
    [5] = sym_identifier,
  },
  [192] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [193] = {
    [1] = sym_identifier,
  },
  [194] = {
    [3] = sym_identifier,
  },
  [196] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [197] = {
    [1] = sym_identifier,
  },
  [198] = {
    [3] = sym_identifier,
  },
  [210] = {
    [1] = sym_identifier,
  },
  [212] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [214] = {
    [1] = sym_identifier,
  },
  [215] = {
    [3] = sym_identifier,
  },
  [217] = {
    [1] = sym_identifier,
  },
  [219] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [221] = {
    [1] = sym_identifier,
  },
  [222] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 8,
  [13] = 10,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 14,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 35,
  [38] = 38,
  [39] = 18,
  [40] = 40,
  [41] = 41,
  [42] = 15,
  [43] = 22,
  [44] = 24,
  [45] = 32,
  [46] = 28,
  [47] = 47,
  [48] = 48,
  [49] = 41,
  [50] = 50,
  [51] = 51,
  [52] = 36,
  [53] = 34,
  [54] = 21,
  [55] = 20,
  [56] = 38,
  [57] = 31,
  [58] = 27,
  [59] = 59,
  [60] = 19,
  [61] = 26,
  [62] = 40,
  [63] = 25,
  [64] = 29,
  [65] = 30,
  [66] = 33,
  [67] = 67,
  [68] = 59,
  [69] = 47,
  [70] = 48,
  [71] = 50,
  [72] = 51,
  [73] = 67,
  [74] = 17,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 83,
  [85] = 85,
  [86] = 85,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 88,
  [92] = 88,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 108,
  [110] = 110,
  [111] = 107,
  [112] = 77,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 79,
  [119] = 116,
  [120] = 115,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 124,
  [128] = 128,
  [129] = 125,
  [130] = 130,
  [131] = 128,
  [132] = 132,
  [133] = 126,
  [134] = 132,
  [135] = 135,
  [136] = 117,
  [137] = 137,
  [138] = 113,
  [139] = 121,
  [140] = 137,
  [141] = 123,
  [142] = 122,
  [143] = 143,
  [144] = 135,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 163,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 167,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 161,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 191,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 147,
  [218] = 146,
  [219] = 157,
  [220] = 155,
  [221] = 153,
  [222] = 160,
  [223] = 164,
  [224] = 165,
  [225] = 166,
  [226] = 172,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 178,
  [231] = 231,
  [232] = 204,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 149,
  [248] = 152,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 253,
  [267] = 267,
  [268] = 162,
  [269] = 196,
  [270] = 194,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 360,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 366,
  [368] = 368,
  [369] = 368,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 365,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 377,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 384,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 343,
  [408] = 408,
  [409] = 344,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 378,
  [431] = 431,
  [432] = 375,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 374,
  [438] = 373,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 381,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 417,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 379,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 382,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 416,
  [520] = 423,
  [521] = 435,
  [522] = 412,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 433,
  [550] = 550,
  [551] = 419,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 411,
  [561] = 561,
  [562] = 562,
  [563] = 428,
  [564] = 387,
  [565] = 399,
  [566] = 398,
  [567] = 388,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 545,
  [573] = 557,
  [574] = 574,
  [575] = 440,
  [576] = 459,
  [577] = 460,
  [578] = 578,
  [579] = 555,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 439,
  [584] = 584,
  [585] = 585,
  [586] = 562,
  [587] = 587,
  [588] = 559,
  [589] = 554,
  [590] = 578,
  [591] = 591,
  [592] = 87,
  [593] = 593,
  [594] = 550,
  [595] = 595,
  [596] = 558,
  [597] = 547,
  [598] = 584,
  [599] = 552,
  [600] = 553,
  [601] = 556,
  [602] = 548,
  [603] = 546,
  [604] = 604,
  [605] = 582,
  [606] = 606,
  [607] = 607,
  [608] = 568,
  [609] = 593,
  [610] = 610,
  [611] = 611,
  [612] = 604,
  [613] = 580,
  [614] = 610,
  [615] = 615,
  [616] = 606,
  [617] = 456,
  [618] = 611,
  [619] = 615,
  [620] = 620,
  [621] = 571,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 471,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 637,
  [642] = 642,
  [643] = 634,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 636,
  [652] = 642,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 640,
  [660] = 647,
  [661] = 646,
  [662] = 662,
  [663] = 663,
  [664] = 650,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 404,
  [672] = 408,
  [673] = 673,
  [674] = 674,
  [675] = 411,
  [676] = 419,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 422,
  [683] = 683,
  [684] = 398,
  [685] = 410,
  [686] = 399,
  [687] = 683,
  [688] = 688,
  [689] = 689,
  [690] = 421,
  [691] = 415,
  [692] = 692,
  [693] = 693,
  [694] = 414,
  [695] = 403,
  [696] = 680,
  [697] = 427,
  [698] = 418,
  [699] = 420,
  [700] = 700,
  [701] = 425,
  [702] = 424,
  [703] = 426,
  [704] = 704,
  [705] = 705,
  [706] = 704,
  [707] = 707,
  [708] = 460,
  [709] = 439,
  [710] = 459,
  [711] = 413,
  [712] = 456,
  [713] = 440,
  [714] = 714,
  [715] = 715,
  [716] = 394,
  [717] = 715,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 392,
  [726] = 724,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 733,
  [739] = 739,
  [740] = 740,
  [741] = 735,
  [742] = 742,
  [743] = 734,
  [744] = 744,
  [745] = 410,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 751,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 758,
  [761] = 761,
  [762] = 762,
  [763] = 754,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 413,
  [772] = 396,
  [773] = 773,
  [774] = 393,
  [775] = 391,
  [776] = 773,
  [777] = 777,
  [778] = 395,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 780,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 787,
  [794] = 789,
  [795] = 795,
  [796] = 796,
  [797] = 466,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 801,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 818,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 833,
  [839] = 705,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 857,
  [865] = 865,
  [866] = 840,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 865,
  [872] = 872,
  [873] = 870,
  [874] = 874,
  [875] = 837,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 907,
  [930] = 930,
  [931] = 907,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 951,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 950,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 958,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 937,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1027,
  [1038] = 1027,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1005,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1014,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1056,
  [1085] = 1018,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1029,
  [1089] = 1089,
  [1090] = 1050,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1065,
  [1097] = 1097,
  [1098] = 1005,
  [1099] = 1052,
  [1100] = 1100,
  [1101] = 1040,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 1093,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 967,
  [1108] = 1108,
  [1109] = 1071,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1082,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1049,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 301,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1177,
  [1206] = 1153,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1139,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1247,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1252,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1257,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1256,
  [1273] = 1259,
  [1274] = 1274,
  [1275] = 1239,
  [1276] = 1276,
  [1277] = 1251,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1251,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1296,
  [1297] = 1297,
  [1298] = 1298,
  [1299] = 1252,
  [1300] = 1263,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1261,
  [1305] = 1305,
  [1306] = 1247,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1295,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
};

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < 'a'
    ? (c < '?'
      ? (c < '\''
        ? c == '"'
        : c <= '\'')
      : (c <= '?' || c == '\\'))
    : (c <= 'b' || (c < 'r'
      ? (c < 'n'
        ? c == 'f'
        : c <= 'n')
      : (c <= 'r' || (c >= 't' && c <= 'v')))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6688
    ? (c < 2984
      ? (c < 2365
        ? (c < 1488
          ? (c < 886
            ? (c < 216
              ? (c < 181
                ? (c < 'a'
                  ? (c >= '$' && c <= '_')
                  : (c <= 'z' || c == 170))
                : (c <= 181 || (c < 192
                  ? c == 186
                  : c <= 214)))
              : (c <= 246 || (c < 748
                ? (c < 710
                  ? (c >= 248 && c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))
                : (c <= 748 || (c < 880
                  ? c == 750
                  : c <= 884)))))
            : (c <= 887 || (c < 931
              ? (c < 904
                ? (c < 895
                  ? (c >= 890 && c <= 893)
                  : (c <= 895 || c == 902))
                : (c <= 906 || (c < 910
                  ? c == 908
                  : c <= 929)))
              : (c <= 1013 || (c < 1329
                ? (c < 1162
                  ? (c >= 1015 && c <= 1153)
                  : c <= 1327)
                : (c <= 1366 || (c < 1376
                  ? c == 1369
                  : c <= 1416)))))))
          : (c <= 1514 || (c < 1994
            ? (c < 1774
              ? (c < 1649
                ? (c < 1568
                  ? (c >= 1519 && c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1765
                  ? c == 1749
                  : c <= 1766)))
              : (c <= 1775 || (c < 1810
                ? (c < 1791
                  ? (c >= 1786 && c <= 1788)
                  : (c <= 1791 || c == 1808))
                : (c <= 1839 || (c < 1969
                  ? (c >= 1869 && c <= 1957)
                  : c <= 1969)))))
            : (c <= 2026 || (c < 2112
              ? (c < 2074
                ? (c < 2042
                  ? (c >= 2036 && c <= 2037)
                  : (c <= 2042 || (c >= 2048 && c <= 2069)))
                : (c <= 2074 || (c < 2088
                  ? c == 2084
                  : c <= 2088)))
              : (c <= 2136 || (c < 2185
                ? (c < 2160
                  ? (c >= 2144 && c <= 2154)
                  : c <= 2183)
                : (c <= 2190 || (c < 2308
                  ? (c >= 2208 && c <= 2249)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2544
            ? (c < 2474
              ? (c < 2437
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2451
                  ? (c >= 2447 && c <= 2448)
                  : c <= 2472)))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2654
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : c <= 2652)
                : (c <= 2654 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2869
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2835
                ? (c < 2821
                  ? c == 2809
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))
                : (c <= 2856 || (c < 2866
                  ? (c >= 2858 && c <= 2864)
                  : c <= 2867)))))
            : (c <= 2873 || (c < 2958
              ? (c < 2929
                ? (c < 2908
                  ? c == 2877
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2949
                  ? c == 2947
                  : c <= 2954)))
              : (c <= 2960 || (c < 2972
                ? (c < 2969
                  ? (c >= 2962 && c <= 2965)
                  : c <= 2970)
                : (c <= 2972 || (c < 2979
                  ? (c >= 2974 && c <= 2975)
                  : c <= 2980)))))))))))
      : (c <= 2986 || (c < 4176
        ? (c < 3423
          ? (c < 3218
            ? (c < 3133
              ? (c < 3086
                ? (c < 3024
                  ? (c >= 2990 && c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))
                : (c <= 3088 || (c < 3114
                  ? (c >= 3090 && c <= 3112)
                  : c <= 3129)))
              : (c <= 3133 || (c < 3200
                ? (c < 3165
                  ? (c >= 3160 && c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : c <= 3216)))))
            : (c <= 3240 || (c < 3332
              ? (c < 3293
                ? (c < 3253
                  ? (c >= 3242 && c <= 3251)
                  : (c <= 3257 || c == 3261))
                : (c <= 3294 || (c < 3313
                  ? (c >= 3296 && c <= 3297)
                  : c <= 3314)))
              : (c <= 3340 || (c < 3389
                ? (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : c <= 3386)
                : (c <= 3389 || (c < 3412
                  ? c == 3406
                  : c <= 3414)))))))
          : (c <= 3425 || (c < 3749
            ? (c < 3585
              ? (c < 3507
                ? (c < 3461
                  ? (c >= 3450 && c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3520
                  ? c == 3517
                  : c <= 3526)))
              : (c <= 3632 || (c < 3716
                ? (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))
                : (c <= 3716 || (c < 3724
                  ? (c >= 3718 && c <= 3722)
                  : c <= 3747)))))
            : (c <= 3749 || (c < 3840
              ? (c < 3776
                ? (c < 3762
                  ? (c >= 3751 && c <= 3760)
                  : (c <= 3763 || c == 3773))
                : (c <= 3780 || (c < 3804
                  ? c == 3782
                  : c <= 3807)))
              : (c <= 3840 || (c < 3976
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : c <= 3948)
                : (c <= 3980 || (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : c <= 4159)))))))))
        : (c <= 4181 || (c < 4992
          ? (c < 4696
            ? (c < 4256
              ? (c < 4206
                ? (c < 4193
                  ? (c >= 4186 && c <= 4189)
                  : (c <= 4193 || (c >= 4197 && c <= 4198)))
                : (c <= 4208 || (c < 4238
                  ? (c >= 4213 && c <= 4225)
                  : c <= 4238)))
              : (c <= 4293 || (c < 4348
                ? (c < 4301
                  ? c == 4295
                  : (c <= 4301 || (c >= 4304 && c <= 4346)))
                : (c <= 4680 || (c < 4688
                  ? (c >= 4682 && c <= 4685)
                  : c <= 4694)))))
            : (c <= 4696 || (c < 4800
              ? (c < 4752
                ? (c < 4704
                  ? (c >= 4698 && c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4792
                  ? (c >= 4786 && c <= 4789)
                  : c <= 4798)))
              : (c <= 4800 || (c < 4824
                ? (c < 4808
                  ? (c >= 4802 && c <= 4805)
                  : c <= 4822)
                : (c <= 4880 || (c < 4888
                  ? (c >= 4882 && c <= 4885)
                  : c <= 4954)))))))
          : (c <= 5007 || (c < 6103
            ? (c < 5873
              ? (c < 5743
                ? (c < 5112
                  ? (c >= 5024 && c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))
                : (c <= 5759 || (c < 5792
                  ? (c >= 5761 && c <= 5786)
                  : c <= 5866)))
              : (c <= 5880 || (c < 5984
                ? (c < 5919
                  ? (c >= 5888 && c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6016
                  ? (c >= 5998 && c <= 6000)
                  : c <= 6067)))))
            : (c <= 6103 || (c < 6400
              ? (c < 6279
                ? (c < 6176
                  ? c == 6108
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))
              : (c <= 6430 || (c < 6528
                ? (c < 6512
                  ? (c >= 6480 && c <= 6509)
                  : c <= 6516)
                : (c <= 6571 || (c < 6656
                  ? (c >= 6576 && c <= 6601)
                  : c <= 6678)))))))))))))
    : (c <= 6740 || (c < 43261
      ? (c < 11264
        ? (c < 8064
          ? (c < 7406
            ? (c < 7168
              ? (c < 7043
                ? (c < 6917
                  ? c == 6823
                  : (c <= 6963 || (c >= 6981 && c <= 6988)))
                : (c <= 7072 || (c < 7098
                  ? (c >= 7086 && c <= 7087)
                  : c <= 7141)))
              : (c <= 7203 || (c < 7312
                ? (c < 7258
                  ? (c >= 7245 && c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))
                : (c <= 7354 || (c < 7401
                  ? (c >= 7357 && c <= 7359)
                  : c <= 7404)))))
            : (c <= 7411 || (c < 8008
              ? (c < 7680
                ? (c < 7418
                  ? (c >= 7413 && c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))
                : (c <= 7957 || (c < 7968
                  ? (c >= 7960 && c <= 7965)
                  : c <= 8005)))
              : (c <= 8013 || (c < 8027
                ? (c < 8025
                  ? (c >= 8016 && c <= 8023)
                  : c <= 8025)
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))))))
          : (c <= 8116 || (c < 8455
            ? (c < 8160
              ? (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))
              : (c <= 8172 || (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))))
            : (c <= 8455 || (c < 8490
              ? (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))
              : (c <= 8493 || (c < 8517
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : c <= 8511)
                : (c <= 8521 || (c < 8579
                  ? c == 8526
                  : c <= 8580)))))))))
        : (c <= 11492 || (c < 12704
          ? (c < 11720
            ? (c < 11631
              ? (c < 11559
                ? (c < 11506
                  ? (c >= 11499 && c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11568
                  ? c == 11565
                  : c <= 11623)))
              : (c <= 11631 || (c < 11696
                ? (c < 11680
                  ? (c >= 11648 && c <= 11670)
                  : (c <= 11686 || (c >= 11688 && c <= 11694)))
                : (c <= 11702 || (c < 11712
                  ? (c >= 11704 && c <= 11710)
                  : c <= 11718)))))
            : (c <= 11726 || (c < 12353
              ? (c < 12293
                ? (c < 11736
                  ? (c >= 11728 && c <= 11734)
                  : (c <= 11742 || c == 11823))
                : (c <= 12294 || (c < 12347
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)))
              : (c <= 12438 || (c < 12540
                ? (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)
                : (c <= 12543 || (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : c <= 12686)))))))
          : (c <= 12735 || (c < 42786
            ? (c < 42240
              ? (c < 19968
                ? (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : (c <= 13312 || c == 19903))
                : (c <= 19968 || (c < 42192
                  ? (c >= 40959 && c <= 42124)
                  : c <= 42237)))
              : (c <= 42508 || (c < 42623
                ? (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : c <= 42783)))))
            : (c <= 42888 || (c < 43015
              ? (c < 42965
                ? (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : c <= 43013)))
              : (c <= 43018 || (c < 43138
                ? (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)
                : (c <= 43187 || (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : c <= 43259)))))))))))
      : (c <= 43262 || (c < 65345
        ? (c < 43816
          ? (c < 43646
            ? (c < 43494
              ? (c < 43396
                ? (c < 43312
                  ? (c >= 43274 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43488
                  ? c == 43471
                  : c <= 43492)))
              : (c <= 43503 || (c < 43588
                ? (c < 43520
                  ? (c >= 43514 && c <= 43518)
                  : (c <= 43560 || (c >= 43584 && c <= 43586)))
                : (c <= 43595 || (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : c <= 43642)))))
            : (c <= 43695 || (c < 43744
              ? (c < 43712
                ? (c < 43701
                  ? c == 43697
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))
                : (c <= 43712 || (c < 43739
                  ? c == 43714
                  : c <= 43741)))
              : (c <= 43754 || (c < 43785
                ? (c < 43777
                  ? (c >= 43762 && c <= 43764)
                  : c <= 43782)
                : (c <= 43790 || (c < 43808
                  ? (c >= 43793 && c <= 43798)
                  : c <= 43814)))))))
          : (c <= 43822 || (c < 64298
            ? (c < 55243
              ? (c < 44032
                ? (c < 43868
                  ? (c >= 43824 && c <= 43866)
                  : (c <= 43881 || (c >= 43888 && c <= 44002)))
                : (c <= 44032 || (c < 55216
                  ? c == 55203
                  : c <= 55238)))
              : (c <= 55291 || (c < 64275
                ? (c < 64112
                  ? (c >= 63744 && c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))
                : (c <= 64279 || (c < 64287
                  ? c == 64285
                  : c <= 64296)))))
            : (c <= 64310 || (c < 64848
              ? (c < 64323
                ? (c < 64318
                  ? (c >= 64312 && c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : c <= 64829)))
              : (c <= 64911 || (c < 65136
                ? (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : c <= 65019)
                : (c <= 65140 || (c < 65313
                  ? (c >= 65142 && c <= 65276)
                  : c <= 65338)))))))))
        : (c <= 65370 || (c < 66928
          ? (c < 66208
            ? (c < 65549
              ? (c < 65490
                ? (c < 65474
                  ? (c >= 65382 && c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65536
                  ? (c >= 65498 && c <= 65500)
                  : c <= 65547)))
              : (c <= 65574 || (c < 65616
                ? (c < 65596
                  ? (c >= 65576 && c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))
                : (c <= 65629 || (c < 66176
                  ? (c >= 65664 && c <= 65786)
                  : c <= 66204)))))
            : (c <= 66256 || (c < 66504
              ? (c < 66384
                ? (c < 66349
                  ? (c >= 66304 && c <= 66335)
                  : (c <= 66368 || (c >= 66370 && c <= 66377)))
                : (c <= 66421 || (c < 66464
                  ? (c >= 66432 && c <= 66461)
                  : c <= 66499)))
              : (c <= 66511 || (c < 66776
                ? (c < 66736
                  ? (c >= 66560 && c <= 66717)
                  : c <= 66771)
                : (c <= 66811 || (c < 66864
                  ? (c >= 66816 && c <= 66855)
                  : c <= 66915)))))))
          : (c <= 66938 || (c < 67506
            ? (c < 67003
              ? (c < 66967
                ? (c < 66956
                  ? (c >= 66940 && c <= 66954)
                  : (c <= 66962 || (c >= 66964 && c <= 66965)))
                : (c <= 66977 || (c < 66995
                  ? (c >= 66979 && c <= 66993)
                  : c <= 67001)))
              : (c <= 67004 || (c < 67424
                ? (c < 67392
                  ? (c >= 67072 && c <= 67382)
                  : c <= 67413)
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67880)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= '$' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67880)))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < 'a'
                ? (c < 'A'
                  ? c == '$'
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67880)))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 6400
    ? (c < 2979
      ? (c < 2365
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < '_'
                ? (c < '0'
                  ? c == '$'
                  : (c <= '9' || (c >= 'A' && c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c >= 'a' && c <= 'z')
                  : (c <= 170 || c == 181))))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1749
              ? (c < 1632
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1641 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1808
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1984 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2185
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : (c <= 2154 || (c >= 2160 && c <= 2183)))
                : (c <= 2190 || (c < 2308
                  ? (c >= 2208 && c <= 2249)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2534
            ? (c < 2474
              ? (c < 2417
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2406 && c <= 2415)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2662
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : (c <= 2652 || c == 2654))
                : (c <= 2671 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2866
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2831
                ? (c < 2809
                  ? (c >= 2790 && c <= 2799)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2947
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2929
                  ? (c >= 2918 && c <= 2927)
                  : c <= 2929)))
              : (c <= 2947 || (c < 2969
                ? (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : (c <= 2960 || (c >= 2962 && c <= 2965)))
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 3872
        ? (c < 3406
          ? (c < 3205
            ? (c < 3114
              ? (c < 3046
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3055 || (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3200
                  ? (c >= 3174 && c <= 3183)
                  : c <= 3200)))))
            : (c <= 3212 || (c < 3296
              ? (c < 3253
                ? (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))
                : (c <= 3257 || (c < 3293
                  ? c == 3261
                  : c <= 3294)))
              : (c <= 3297 || (c < 3342
                ? (c < 3313
                  ? (c >= 3302 && c <= 3311)
                  : (c <= 3314 || (c >= 3332 && c <= 3340)))
                : (c <= 3344 || (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)))))))
          : (c <= 3406 || (c < 3664
            ? (c < 3507
              ? (c < 3450
                ? (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : (c <= 3425 || (c >= 3430 && c <= 3439)))
                : (c <= 3455 || (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : c <= 3505)))
              : (c <= 3515 || (c < 3585
                ? (c < 3520
                  ? c == 3517
                  : (c <= 3526 || (c >= 3558 && c <= 3567)))
                : (c <= 3632 || (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : c <= 3654)))))
            : (c <= 3673 || (c < 3762
              ? (c < 3724
                ? (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3751
                  ? c == 3749
                  : c <= 3760)))
              : (c <= 3763 || (c < 3792
                ? (c < 3776
                  ? c == 3773
                  : (c <= 3780 || c == 3782))
                : (c <= 3801 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))))))))
        : (c <= 3881 || (c < 4802
          ? (c < 4295
            ? (c < 4193
              ? (c < 4096
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))
                : (c <= 4138 || (c < 4176
                  ? (c >= 4159 && c <= 4169)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))
              : (c <= 4193 || (c < 4238
                ? (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : (c <= 4208 || (c >= 4213 && c <= 4225)))
                : (c <= 4238 || (c < 4256
                  ? (c >= 4240 && c <= 4249)
                  : c <= 4293)))))
            : (c <= 4295 || (c < 4698
              ? (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))
              : (c <= 4701 || (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))))))
          : (c <= 4805 || (c < 5919
            ? (c < 5112
              ? (c < 4888
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : (c <= 4880 || (c >= 4882 && c <= 4885)))
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))
              : (c <= 5117 || (c < 5792
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : c <= 5905)))))
            : (c <= 5937 || (c < 6112
              ? (c < 6016
                ? (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))
                : (c <= 6067 || (c < 6108
                  ? c == 6103
                  : c <= 6108)))
              : (c <= 6121 || (c < 6279
                ? (c < 6176
                  ? (c >= 6160 && c <= 6169)
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))))))))))))
    : (c <= 6430 || (c < 43216
      ? (c < 8490
        ? (c < 7968
          ? (c < 7086
            ? (c < 6784
              ? (c < 6576
                ? (c < 6512
                  ? (c >= 6470 && c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))
                : (c <= 6601 || (c < 6656
                  ? (c >= 6608 && c <= 6617)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6793 || (c < 6981
                ? (c < 6823
                  ? (c >= 6800 && c <= 6809)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7043
                  ? (c >= 6992 && c <= 7001)
                  : c <= 7072)))))
            : (c <= 7141 || (c < 7401
              ? (c < 7296
                ? (c < 7232
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7241 || (c >= 7245 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))
              : (c <= 7404 || (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))))))
          : (c <= 8005 || (c < 8160
            ? (c < 8064
              ? (c < 8027
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : (c <= 8023 || c == 8025))
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))
              : (c <= 8116 || (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))))
            : (c <= 8172 || (c < 8455
              ? (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))
              : (c <= 8455 || (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))))))))
        : (c <= 8493 || (c < 12449
          ? (c < 11680
            ? (c < 11506
              ? (c < 8526
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))
                : (c <= 8526 || (c < 11264
                  ? (c >= 8579 && c <= 8580)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))))
              : (c <= 11507 || (c < 11568
                ? (c < 11559
                  ? (c >= 11520 && c <= 11557)
                  : (c <= 11559 || c == 11565))
                : (c <= 11623 || (c < 11648
                  ? c == 11631
                  : c <= 11670)))))
            : (c <= 11686 || (c < 11736
              ? (c < 11712
                ? (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))
                : (c <= 11718 || (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : c <= 11734)))
              : (c <= 11742 || (c < 12347
                ? (c < 12293
                  ? c == 11823
                  : (c <= 12294 || (c >= 12337 && c <= 12341)))
                : (c <= 12348 || (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)))))))
          : (c <= 12538 || (c < 42623
            ? (c < 19903
              ? (c < 12704
                ? (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : (c <= 12591 || (c >= 12593 && c <= 12686)))
                : (c <= 12735 || (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : c <= 13312)))
              : (c <= 19903 || (c < 42240
                ? (c < 40959
                  ? c == 19968
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42560
                  ? (c >= 42512 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 42965
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42954 || (c < 42963
                  ? (c >= 42960 && c <= 42961)
                  : c <= 42963)))
              : (c <= 42969 || (c < 43020
                ? (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : (c <= 43013 || (c >= 43015 && c <= 43018)))
                : (c <= 43042 || (c < 43138
                  ? (c >= 43072 && c <= 43123)
                  : c <= 43187)))))))))))
      : (c <= 43225 || (c < 65296
        ? (c < 43808
          ? (c < 43616
            ? (c < 43471
              ? (c < 43264
                ? (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : (c <= 43259 || (c >= 43261 && c <= 43262)))
                : (c <= 43301 || (c < 43360
                  ? (c >= 43312 && c <= 43334)
                  : (c <= 43388 || (c >= 43396 && c <= 43442)))))
              : (c <= 43481 || (c < 43584
                ? (c < 43494
                  ? (c >= 43488 && c <= 43492)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43600
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43609)))))
            : (c <= 43638 || (c < 43714
              ? (c < 43701
                ? (c < 43646
                  ? c == 43642
                  : (c <= 43695 || c == 43697))
                : (c <= 43702 || (c < 43712
                  ? (c >= 43705 && c <= 43709)
                  : c <= 43712)))
              : (c <= 43714 || (c < 43777
                ? (c < 43744
                  ? (c >= 43739 && c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64285
            ? (c < 55203
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 44032
                  ? (c >= 44016 && c <= 44025)
                  : c <= 44032)))
              : (c <= 55203 || (c < 64112
                ? (c < 55243
                  ? (c >= 55216 && c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64275
                  ? (c >= 64256 && c <= 64262)
                  : c <= 64279)))))
            : (c <= 64285 || (c < 64326
              ? (c < 64318
                ? (c < 64298
                  ? (c >= 64287 && c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64323
                  ? (c >= 64320 && c <= 64321)
                  : c <= 64324)))
              : (c <= 64433 || (c < 65008
                ? (c < 64848
                  ? (c >= 64467 && c <= 64829)
                  : (c <= 64911 || (c >= 64914 && c <= 64967)))
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65305 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65474
                ? (c < 65345
                  ? (c >= 65313 && c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65470)))
                : (c <= 65479 || (c < 65490
                  ? (c >= 65482 && c <= 65487)
                  : c <= 65495)))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66720
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : (c <= 66511 || (c >= 66560 && c <= 66717)))
                : (c <= 66729 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67463
            ? (c < 66979
              ? (c < 66956
                ? (c < 66928
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))
                : (c <= 66962 || (c < 66967
                  ? (c >= 66964 && c <= 66965)
                  : c <= 66977)))
              : (c <= 66993 || (c < 67392
                ? (c < 67003
                  ? (c >= 66995 && c <= 67001)
                  : (c <= 67004 || (c >= 67072 && c <= 67382)))
                : (c <= 67413 || (c < 67456
                  ? (c >= 67424 && c <= 67431)
                  : c <= 67461)))))
            : (c <= 67504 || (c < 67647
              ? (c < 67594
                ? (c < 67584
                  ? (c >= 67506 && c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : c <= 67644)))
              : (c <= 67669 || (c < 67828
                ? (c < 67712
                  ? (c >= 67680 && c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67880)))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(193);
      if (lookahead == '"') ADVANCE(103);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '\'') ADVANCE(23);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == '+') ADVANCE(166);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '-') ADVANCE(168);
      if (lookahead == '.') ADVANCE(201);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '0') ADVANCE(72);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(154);
      if (lookahead == '?') ADVANCE(189);
      if (lookahead == '@') ADVANCE(208);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == '\\') ADVANCE(44);
      if (lookahead == ']') ADVANCE(198);
      if (lookahead == '^') ADVANCE(178);
      if (lookahead == 'n') ADVANCE(214);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '|') ADVANCE(175);
      if (lookahead == '}') ADVANCE(205);
      if (lookahead == '~') ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(215);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(193);
      if (lookahead == '"') ADVANCE(103);
      if (lookahead == '%') ADVANCE(179);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '\'') ADVANCE(23);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '+') ADVANCE(165);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(15);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '0') ADVANCE(72);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(158);
      if (lookahead == '=') ADVANCE(22);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(189);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == ']') ADVANCE(198);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '|') ADVANCE(176);
      if (lookahead == '}') ADVANCE(205);
      if (lookahead == '~') ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(215);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(192);
      if (lookahead == '"') ADVANCE(103);
      if (lookahead == '&') ADVANCE(137);
      if (lookahead == '\'') ADVANCE(23);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == '+') ADVANCE(165);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '-') ADVANCE(167);
      if (lookahead == '.') ADVANCE(53);
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == '0') ADVANCE(72);
      if (lookahead == ':') ADVANCE(190);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '>') ADVANCE(153);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == 'n') ADVANCE(214);
      if (lookahead == '}') ADVANCE(205);
      if (lookahead == '~') ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(215);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == '+') ADVANCE(166);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '-') ADVANCE(168);
      if (lookahead == '.') ADVANCE(200);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(154);
      if (lookahead == '?') ADVANCE(189);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == ']') ADVANCE(198);
      if (lookahead == '^') ADVANCE(178);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '|') ADVANCE(175);
      if (lookahead == '}') ADVANCE(205);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(215);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '%') ADVANCE(179);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '+') ADVANCE(165);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(158);
      if (lookahead == '=') ADVANCE(22);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(189);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == ']') ADVANCE(198);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '|') ADVANCE(176);
      if (lookahead == '}') ADVANCE(205);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(215);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(104);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(124);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '\\') ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(116);
      if (lookahead != 0) ADVANCE(123);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(102);
      if (lookahead == '/') ADVANCE(106);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(109);
      if (lookahead != 0) ADVANCE(110);
      END_STATE();
    case 8:
      if (lookahead == '&') ADVANCE(137);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '.') ADVANCE(200);
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '>') ADVANCE(153);
      if (lookahead == '?') ADVANCE(189);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '|') ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(215);
      END_STATE();
    case 9:
      if (lookahead == '\'') ADVANCE(101);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '@') ADVANCE(208);
      if (lookahead == 'n') ADVANCE(214);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(215);
      END_STATE();
    case 11:
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == 'n') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(215);
      END_STATE();
    case 12:
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(216);
      END_STATE();
    case 13:
      if (lookahead == '*') ADVANCE(13);
      if (lookahead == '/') ADVANCE(217);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 14:
      if (lookahead == '*') ADVANCE(13);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 16:
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '_') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(16);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(211);
      END_STATE();
    case 18:
      if (lookahead == '.') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 19:
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '@') ADVANCE(38);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(215);
      END_STATE();
    case 20:
      if (lookahead == '0') ADVANCE(100);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(97);
      END_STATE();
    case 21:
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 22:
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 23:
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(9);
      END_STATE();
    case 24:
      if (lookahead == '_') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 25:
      if (lookahead == '_') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 26:
      if (lookahead == '_') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 28:
      if (lookahead == '_') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(39);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'c') ADVANCE(36);
      END_STATE();
    case 32:
      if (lookahead == 'd') ADVANCE(209);
      END_STATE();
    case 33:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 34:
      if (lookahead == 'e') ADVANCE(29);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 37:
      if (lookahead == 'f') ADVANCE(30);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(40);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(35);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(43);
      END_STATE();
    case 41:
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(34);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(33);
      END_STATE();
    case 44:
      if (lookahead == 'u') ADVANCE(46);
      if (lookahead == 'x') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(127);
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(130);
      if (lookahead != 0) ADVANCE(126);
      END_STATE();
    case 45:
      if (lookahead == 'u') ADVANCE(46);
      if (lookahead == 'x') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(132);
      if (lookahead != 0) ADVANCE(130);
      END_STATE();
    case 46:
      if (lookahead == '{') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 47:
      if (lookahead == '}') ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 48:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(20);
      if (lookahead == '0') ADVANCE(100);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(97);
      END_STATE();
    case 49:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(89);
      END_STATE();
    case 50:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(86);
      END_STATE();
    case 51:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(83);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(84);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(16);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(89);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(130);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 66:
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 67:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(193);
      if (lookahead == '"') ADVANCE(103);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '\'') ADVANCE(23);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == '+') ADVANCE(166);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '-') ADVANCE(168);
      if (lookahead == '.') ADVANCE(201);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '0') ADVANCE(72);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(154);
      if (lookahead == '?') ADVANCE(189);
      if (lookahead == '@') ADVANCE(208);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == ']') ADVANCE(198);
      if (lookahead == '^') ADVANCE(178);
      if (lookahead == 'n') ADVANCE(214);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '|') ADVANCE(175);
      if (lookahead == '}') ADVANCE(205);
      if (lookahead == '~') ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(215);
      END_STATE();
    case 68:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(193);
      if (lookahead == '"') ADVANCE(103);
      if (lookahead == '%') ADVANCE(179);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '\'') ADVANCE(23);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '+') ADVANCE(165);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(202);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '0') ADVANCE(72);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(158);
      if (lookahead == '=') ADVANCE(22);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(189);
      if (lookahead == '@') ADVANCE(208);
      if (lookahead == '[') ADVANCE(197);
      if (lookahead == ']') ADVANCE(198);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == 'n') ADVANCE(214);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '|') ADVANCE(176);
      if (lookahead == '}') ADVANCE(205);
      if (lookahead == '~') ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(68)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(215);
      END_STATE();
    case 69:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(193);
      if (lookahead == '"') ADVANCE(103);
      if (lookahead == '%') ADVANCE(179);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '\'') ADVANCE(23);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(136);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '+') ADVANCE(165);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(53);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '0') ADVANCE(72);
      if (lookahead == ':') ADVANCE(190);
      if (lookahead == ';') ADVANCE(206);
      if (lookahead == '<') ADVANCE(158);
      if (lookahead == '=') ADVANCE(22);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(189);
      if (lookahead == '@') ADVANCE(208);
      if (lookahead == ']') ADVANCE(198);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == 'n') ADVANCE(214);
      if (lookahead == '{') ADVANCE(204);
      if (lookahead == '|') ADVANCE(176);
      if (lookahead == '}') ADVANCE(205);
      if (lookahead == '~') ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(215);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(50);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(71);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(52);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(18);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(49);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(49);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(16);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(83);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(71);
      if (lookahead == '_') ADVANCE(25);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(49);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(49);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(71);
      if (lookahead == '_') ADVANCE(56);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(49);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(49);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(71);
      if (lookahead == '_') ADVANCE(24);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(49);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(49);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(76);
      if (lookahead == '_') ADVANCE(57);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(76);
      if (lookahead == '_') ADVANCE(26);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(76);
      if (lookahead == '_') ADVANCE(62);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(80);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(76);
      if (lookahead == '_') ADVANCE(62);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(20);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '0') ADVANCE(79);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(76);
      if (lookahead == '_') ADVANCE(62);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(77);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(82);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(82);
      if (lookahead == '_') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_binary_integer_literal);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_binary_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(85);
      if (lookahead == '_') ADVANCE(50);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(53);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(49);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(55);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(49);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(63);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(98);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(93);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(63);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(98);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(59);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(98);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(98);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(27);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(58);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(20);
      if (lookahead == '0') ADVANCE(92);
      if (lookahead == '_') ADVANCE(63);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(98);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(94);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(98);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(91);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_character_literal);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(5);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_string_fragment);
      if (lookahead == '\n') ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(105);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_string_fragment);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '/') ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(110);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_string_fragment);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_string_fragment);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_string_fragment);
      if (lookahead == '/') ADVANCE(106);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(109);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(110);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(110);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead == '\n') ADVANCE(123);
      if (lookahead == '"') ADVANCE(216);
      if (lookahead != 0) ADVANCE(111);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead == '"') ADVANCE(14);
      if (lookahead == '*') ADVANCE(112);
      if (lookahead == '/') ADVANCE(123);
      if (lookahead != 0) ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead == '"') ADVANCE(14);
      if (lookahead == '*') ADVANCE(112);
      if (lookahead != 0) ADVANCE(113);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead == '"') ADVANCE(130);
      if (lookahead == 'u') ADVANCE(117);
      if (lookahead == 'x') ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(128);
      if (lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(134);
      if (lookahead != 0) ADVANCE(129);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead == '*') ADVANCE(113);
      if (lookahead == '/') ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(116);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead == '{') ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(119);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead == '}') ADVANCE(134);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(122);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(134);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token1);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token2);
      if (lookahead == '"') ADVANCE(5);
      if (lookahead != 0) ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym__multiline_string_fragment_token2);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(131);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(130);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(131);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(134);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(123);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(163);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(183);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(184);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(182);
      if (lookahead == '=') ADVANCE(160);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(181);
      if (lookahead == '=') ADVANCE(160);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(195);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(195);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(196);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(196);
      if (lookahead == '=') ADVANCE(143);
      if (lookahead == '>') ADVANCE(187);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(196);
      if (lookahead == '>') ADVANCE(187);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(216);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(216);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(147);
      if (lookahead == '|') ADVANCE(164);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(164);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '>') ADVANCE(186);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(185);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(203);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(17);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == 'i') ADVANCE(40);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_non_DASHsealed);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_ATinterface);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(42);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(215);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(212);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(215);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(213);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(215);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(215);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(216);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'p') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'v') ADVANCE(17);
      if (lookahead == 'w') ADVANCE(18);
      if (lookahead == 'y') ADVANCE(19);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      if (lookahead == 'y') ADVANCE(24);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'h') ADVANCE(26);
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'o') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'n') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(35);
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(38);
      if (lookahead == 'm') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(40);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(43);
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      END_STATE();
    case 11:
      if (lookahead == 'p') ADVANCE(46);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'e') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      if (lookahead == 'u') ADVANCE(50);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(52);
      if (lookahead == 'h') ADVANCE(53);
      if (lookahead == 't') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      if (lookahead == 'w') ADVANCE(56);
      if (lookahead == 'y') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(58);
      if (lookahead == 'o') ADVANCE(59);
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 's') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(62);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'i') ADVANCE(64);
      END_STATE();
    case 19:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 20:
      if (lookahead == 's') ADVANCE(66);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(71);
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(74);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == 'f') ADVANCE(76);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(78);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(79);
      END_STATE();
    case 33:
      if (lookahead == 'p') ADVANCE(80);
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(82);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(83);
      END_STATE();
    case 36:
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(85);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 39:
      if (lookahead == 'p') ADVANCE(86);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(87);
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(89);
      END_STATE();
    case 42:
      if (lookahead == 'd') ADVANCE(90);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 44:
      if (lookahead == 'w') ADVANCE(92);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 47:
      if (lookahead == 'c') ADVANCE(95);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(97);
      if (lookahead == 'o') ADVANCE(98);
      END_STATE();
    case 50:
      if (lookahead == 'b') ADVANCE(99);
      END_STATE();
    case 51:
      if (lookahead == 'c') ADVANCE(100);
      if (lookahead == 'q') ADVANCE(101);
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(103);
      END_STATE();
    case 53:
      if (lookahead == 'o') ADVANCE(104);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(105);
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 55:
      if (lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(110);
      if (lookahead == 'r') ADVANCE(111);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'u') ADVANCE(113);
      if (lookahead == 'y') ADVANCE(114);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(116);
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 66:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(123);
      END_STATE();
    case 69:
      if (lookahead == 'a') ADVANCE(124);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(127);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 74:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(130);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(132);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 79:
      if (lookahead == 'm') ADVANCE(134);
      END_STATE();
    case 80:
      if (lookahead == 'o') ADVANCE(135);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(139);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(140);
      if (lookahead == 'o') ADVANCE(141);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 89:
      if (lookahead == 'g') ADVANCE(144);
      END_STATE();
    case 90:
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 91:
      if (lookahead == 'i') ADVANCE(146);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(147);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 95:
      if (lookahead == 'k') ADVANCE(149);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(150);
      END_STATE();
    case 97:
      if (lookahead == 'v') ADVANCE(151);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(152);
      if (lookahead == 'v') ADVANCE(153);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(154);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(156);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(157);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(158);
      END_STATE();
    case 104:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 106:
      if (lookahead == 'i') ADVANCE(161);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 109:
      if (lookahead == 'c') ADVANCE(164);
      END_STATE();
    case 110:
      if (lookahead == 's') ADVANCE(165);
      END_STATE();
    case 111:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 112:
      if (lookahead == 'n') ADVANCE(167);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 115:
      if (lookahead == 's') ADVANCE(169);
      END_STATE();
    case 116:
      if (lookahead == 'd') ADVANCE(170);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(171);
      END_STATE();
    case 118:
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 119:
      if (lookahead == 'h') ADVANCE(173);
      END_STATE();
    case 120:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 121:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 122:
      if (lookahead == 'r') ADVANCE(176);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 124:
      if (lookahead == 'k') ADVANCE(178);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 127:
      if (lookahead == 'h') ADVANCE(179);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 129:
      if (lookahead == 's') ADVANCE(180);
      END_STATE();
    case 130:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 131:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 135:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 136:
      if (lookahead == 'n') ADVANCE(185);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(189);
      END_STATE();
    case 141:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(191);
      END_STATE();
    case 143:
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 145:
      if (lookahead == 'l') ADVANCE(193);
      END_STATE();
    case 146:
      if (lookahead == 'v') ADVANCE(194);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_null_literal);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_open);
      if (lookahead == 's') ADVANCE(195);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(196);
      END_STATE();
    case 150:
      if (lookahead == 'i') ADVANCE(197);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(198);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 153:
      if (lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 154:
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 156:
      if (lookahead == 'i') ADVANCE(203);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 159:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 160:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 161:
      if (lookahead == 'c') ADVANCE(208);
      END_STATE();
    case 162:
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(210);
      END_STATE();
    case 164:
      if (lookahead == 'h') ADVANCE(211);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 166:
      if (lookahead == 'w') ADVANCE(212);
      END_STATE();
    case 167:
      if (lookahead == 's') ADVANCE(213);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_uses);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_void_type);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 174:
      if (lookahead == 'd') ADVANCE(216);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 176:
      if (lookahead == 't') ADVANCE(218);
      END_STATE();
    case 177:
      if (lookahead == 'a') ADVANCE(219);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(221);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(223);
      END_STATE();
    case 185:
      if (lookahead == 'd') ADVANCE(224);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_final);
      if (lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 189:
      if (lookahead == 'm') ADVANCE(226);
      END_STATE();
    case 190:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 191:
      if (lookahead == 'n') ADVANCE(228);
      END_STATE();
    case 192:
      if (lookahead == 'f') ADVANCE(229);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 194:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_opens);
      END_STATE();
    case 196:
      if (lookahead == 'g') ADVANCE(232);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 198:
      if (lookahead == 't') ADVANCE(234);
      END_STATE();
    case 199:
      if (lookahead == 'c') ADVANCE(235);
      END_STATE();
    case 200:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 201:
      if (lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 202:
      if (lookahead == 'd') ADVANCE(238);
      END_STATE();
    case 203:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 205:
      if (lookahead == 'd') ADVANCE(241);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(242);
      END_STATE();
    case 208:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 210:
      if (lookahead == 'h') ADVANCE(244);
      END_STATE();
    case 211:
      if (lookahead == 'r') ADVANCE(245);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_throw);
      if (lookahead == 's') ADVANCE(246);
      END_STATE();
    case 213:
      if (lookahead == 'i') ADVANCE(247);
      END_STATE();
    case 214:
      if (lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 220:
      if (lookahead == 'u') ADVANCE(251);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(252);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 223:
      if (lookahead == 's') ADVANCE(253);
      END_STATE();
    case 224:
      if (lookahead == 's') ADVANCE(254);
      END_STATE();
    case 225:
      if (lookahead == 'y') ADVANCE(255);
      END_STATE();
    case 226:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(257);
      END_STATE();
    case 229:
      if (lookahead == 'a') ADVANCE(258);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_native);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(259);
      END_STATE();
    case 233:
      if (lookahead == 's') ADVANCE(260);
      END_STATE();
    case 234:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 235:
      if (lookahead == 't') ADVANCE(262);
      END_STATE();
    case 236:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_record);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 243:
      if (lookahead == 'f') ADVANCE(265);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(266);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_throws);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(267);
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 248:
      if (lookahead == 'l') ADVANCE(269);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(270);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_boolean_type);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_exports);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 256:
      if (lookahead == 'n') ADVANCE(272);
      END_STATE();
    case 257:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 258:
      if (lookahead == 'c') ADVANCE(274);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_permits);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 263:
      if (lookahead == 's') ADVANCE(276);
      END_STATE();
    case 264:
      if (lookahead == 's') ADVANCE(277);
      END_STATE();
    case 265:
      if (lookahead == 'p') ADVANCE(278);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(279);
      END_STATE();
    case 267:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 268:
      if (lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 272:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 273:
      if (lookahead == 'o') ADVANCE(284);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 275:
      if (lookahead == 'd') ADVANCE(286);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_provides);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_strictfp);
      END_STATE();
    case 279:
      if (lookahead == 'i') ADVANCE(287);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 281:
      if (lookahead == 'v') ADVANCE(289);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 283:
      if (lookahead == 's') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'f') ADVANCE(291);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 287:
      if (lookahead == 'z') ADVANCE(292);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_transient);
      END_STATE();
    case 289:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_transitive);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(295);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_synchronized);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 69},
  [2] = {.lex_state = 69},
  [3] = {.lex_state = 69},
  [4] = {.lex_state = 69},
  [5] = {.lex_state = 69},
  [6] = {.lex_state = 69},
  [7] = {.lex_state = 69},
  [8] = {.lex_state = 69},
  [9] = {.lex_state = 69},
  [10] = {.lex_state = 69},
  [11] = {.lex_state = 69},
  [12] = {.lex_state = 69},
  [13] = {.lex_state = 69},
  [14] = {.lex_state = 69},
  [15] = {.lex_state = 69},
  [16] = {.lex_state = 69},
  [17] = {.lex_state = 69},
  [18] = {.lex_state = 69},
  [19] = {.lex_state = 69},
  [20] = {.lex_state = 69},
  [21] = {.lex_state = 69},
  [22] = {.lex_state = 69},
  [23] = {.lex_state = 69},
  [24] = {.lex_state = 69},
  [25] = {.lex_state = 69},
  [26] = {.lex_state = 69},
  [27] = {.lex_state = 69},
  [28] = {.lex_state = 69},
  [29] = {.lex_state = 69},
  [30] = {.lex_state = 69},
  [31] = {.lex_state = 69},
  [32] = {.lex_state = 69},
  [33] = {.lex_state = 69},
  [34] = {.lex_state = 69},
  [35] = {.lex_state = 69},
  [36] = {.lex_state = 69},
  [37] = {.lex_state = 69},
  [38] = {.lex_state = 69},
  [39] = {.lex_state = 69},
  [40] = {.lex_state = 69},
  [41] = {.lex_state = 69},
  [42] = {.lex_state = 69},
  [43] = {.lex_state = 69},
  [44] = {.lex_state = 69},
  [45] = {.lex_state = 69},
  [46] = {.lex_state = 69},
  [47] = {.lex_state = 69},
  [48] = {.lex_state = 69},
  [49] = {.lex_state = 69},
  [50] = {.lex_state = 69},
  [51] = {.lex_state = 69},
  [52] = {.lex_state = 69},
  [53] = {.lex_state = 69},
  [54] = {.lex_state = 69},
  [55] = {.lex_state = 69},
  [56] = {.lex_state = 69},
  [57] = {.lex_state = 69},
  [58] = {.lex_state = 69},
  [59] = {.lex_state = 69},
  [60] = {.lex_state = 69},
  [61] = {.lex_state = 69},
  [62] = {.lex_state = 69},
  [63] = {.lex_state = 69},
  [64] = {.lex_state = 69},
  [65] = {.lex_state = 69},
  [66] = {.lex_state = 69},
  [67] = {.lex_state = 69},
  [68] = {.lex_state = 69},
  [69] = {.lex_state = 69},
  [70] = {.lex_state = 69},
  [71] = {.lex_state = 69},
  [72] = {.lex_state = 69},
  [73] = {.lex_state = 69},
  [74] = {.lex_state = 69},
  [75] = {.lex_state = 68},
  [76] = {.lex_state = 68},
  [77] = {.lex_state = 69},
  [78] = {.lex_state = 69},
  [79] = {.lex_state = 69},
  [80] = {.lex_state = 69},
  [81] = {.lex_state = 69},
  [82] = {.lex_state = 2},
  [83] = {.lex_state = 2},
  [84] = {.lex_state = 2},
  [85] = {.lex_state = 2},
  [86] = {.lex_state = 2},
  [87] = {.lex_state = 69},
  [88] = {.lex_state = 1},
  [89] = {.lex_state = 1},
  [90] = {.lex_state = 1},
  [91] = {.lex_state = 1},
  [92] = {.lex_state = 1},
  [93] = {.lex_state = 1},
  [94] = {.lex_state = 1},
  [95] = {.lex_state = 69},
  [96] = {.lex_state = 69},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 69},
  [99] = {.lex_state = 1},
  [100] = {.lex_state = 1},
  [101] = {.lex_state = 69},
  [102] = {.lex_state = 1},
  [103] = {.lex_state = 1},
  [104] = {.lex_state = 1},
  [105] = {.lex_state = 1},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 1},
  [108] = {.lex_state = 1},
  [109] = {.lex_state = 1},
  [110] = {.lex_state = 1},
  [111] = {.lex_state = 1},
  [112] = {.lex_state = 69},
  [113] = {.lex_state = 1},
  [114] = {.lex_state = 1},
  [115] = {.lex_state = 1},
  [116] = {.lex_state = 1},
  [117] = {.lex_state = 1},
  [118] = {.lex_state = 69},
  [119] = {.lex_state = 1},
  [120] = {.lex_state = 1},
  [121] = {.lex_state = 1},
  [122] = {.lex_state = 1},
  [123] = {.lex_state = 1},
  [124] = {.lex_state = 1},
  [125] = {.lex_state = 1},
  [126] = {.lex_state = 1},
  [127] = {.lex_state = 1},
  [128] = {.lex_state = 1},
  [129] = {.lex_state = 1},
  [130] = {.lex_state = 69},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 1},
  [133] = {.lex_state = 1},
  [134] = {.lex_state = 1},
  [135] = {.lex_state = 1},
  [136] = {.lex_state = 1},
  [137] = {.lex_state = 1},
  [138] = {.lex_state = 1},
  [139] = {.lex_state = 1},
  [140] = {.lex_state = 1},
  [141] = {.lex_state = 1},
  [142] = {.lex_state = 1},
  [143] = {.lex_state = 1},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 69},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 69},
  [151] = {.lex_state = 69},
  [152] = {.lex_state = 1},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 1},
  [155] = {.lex_state = 1},
  [156] = {.lex_state = 69},
  [157] = {.lex_state = 1},
  [158] = {.lex_state = 69},
  [159] = {.lex_state = 69},
  [160] = {.lex_state = 1},
  [161] = {.lex_state = 1},
  [162] = {.lex_state = 1},
  [163] = {.lex_state = 1},
  [164] = {.lex_state = 1},
  [165] = {.lex_state = 1},
  [166] = {.lex_state = 1},
  [167] = {.lex_state = 1},
  [168] = {.lex_state = 69},
  [169] = {.lex_state = 69},
  [170] = {.lex_state = 1},
  [171] = {.lex_state = 69},
  [172] = {.lex_state = 1},
  [173] = {.lex_state = 69},
  [174] = {.lex_state = 69},
  [175] = {.lex_state = 69},
  [176] = {.lex_state = 69},
  [177] = {.lex_state = 69},
  [178] = {.lex_state = 1},
  [179] = {.lex_state = 1},
  [180] = {.lex_state = 69},
  [181] = {.lex_state = 1},
  [182] = {.lex_state = 69},
  [183] = {.lex_state = 69},
  [184] = {.lex_state = 69},
  [185] = {.lex_state = 69},
  [186] = {.lex_state = 69},
  [187] = {.lex_state = 69},
  [188] = {.lex_state = 69},
  [189] = {.lex_state = 69},
  [190] = {.lex_state = 69},
  [191] = {.lex_state = 1},
  [192] = {.lex_state = 69},
  [193] = {.lex_state = 69},
  [194] = {.lex_state = 1},
  [195] = {.lex_state = 1},
  [196] = {.lex_state = 1},
  [197] = {.lex_state = 69},
  [198] = {.lex_state = 69},
  [199] = {.lex_state = 69},
  [200] = {.lex_state = 69},
  [201] = {.lex_state = 1},
  [202] = {.lex_state = 1},
  [203] = {.lex_state = 69},
  [204] = {.lex_state = 1},
  [205] = {.lex_state = 1},
  [206] = {.lex_state = 69},
  [207] = {.lex_state = 69},
  [208] = {.lex_state = 69},
  [209] = {.lex_state = 69},
  [210] = {.lex_state = 69},
  [211] = {.lex_state = 69},
  [212] = {.lex_state = 1},
  [213] = {.lex_state = 69},
  [214] = {.lex_state = 1},
  [215] = {.lex_state = 69},
  [216] = {.lex_state = 69},
  [217] = {.lex_state = 1},
  [218] = {.lex_state = 1},
  [219] = {.lex_state = 1},
  [220] = {.lex_state = 1},
  [221] = {.lex_state = 1},
  [222] = {.lex_state = 1},
  [223] = {.lex_state = 1},
  [224] = {.lex_state = 1},
  [225] = {.lex_state = 1},
  [226] = {.lex_state = 1},
  [227] = {.lex_state = 69},
  [228] = {.lex_state = 69},
  [229] = {.lex_state = 69},
  [230] = {.lex_state = 1},
  [231] = {.lex_state = 69},
  [232] = {.lex_state = 1},
  [233] = {.lex_state = 69},
  [234] = {.lex_state = 69},
  [235] = {.lex_state = 69},
  [236] = {.lex_state = 1},
  [237] = {.lex_state = 69},
  [238] = {.lex_state = 1},
  [239] = {.lex_state = 69},
  [240] = {.lex_state = 69},
  [241] = {.lex_state = 69},
  [242] = {.lex_state = 69},
  [243] = {.lex_state = 69},
  [244] = {.lex_state = 69},
  [245] = {.lex_state = 69},
  [246] = {.lex_state = 69},
  [247] = {.lex_state = 1},
  [248] = {.lex_state = 1},
  [249] = {.lex_state = 69},
  [250] = {.lex_state = 69},
  [251] = {.lex_state = 69},
  [252] = {.lex_state = 69},
  [253] = {.lex_state = 1},
  [254] = {.lex_state = 69},
  [255] = {.lex_state = 69},
  [256] = {.lex_state = 69},
  [257] = {.lex_state = 69},
  [258] = {.lex_state = 69},
  [259] = {.lex_state = 69},
  [260] = {.lex_state = 69},
  [261] = {.lex_state = 1},
  [262] = {.lex_state = 1},
  [263] = {.lex_state = 1},
  [264] = {.lex_state = 69},
  [265] = {.lex_state = 69},
  [266] = {.lex_state = 1},
  [267] = {.lex_state = 69},
  [268] = {.lex_state = 1},
  [269] = {.lex_state = 1},
  [270] = {.lex_state = 1},
  [271] = {.lex_state = 69},
  [272] = {.lex_state = 69},
  [273] = {.lex_state = 69},
  [274] = {.lex_state = 69},
  [275] = {.lex_state = 69},
  [276] = {.lex_state = 69},
  [277] = {.lex_state = 2},
  [278] = {.lex_state = 69},
  [279] = {.lex_state = 69},
  [280] = {.lex_state = 69},
  [281] = {.lex_state = 69},
  [282] = {.lex_state = 69},
  [283] = {.lex_state = 69},
  [284] = {.lex_state = 69},
  [285] = {.lex_state = 69},
  [286] = {.lex_state = 69},
  [287] = {.lex_state = 69},
  [288] = {.lex_state = 69},
  [289] = {.lex_state = 69},
  [290] = {.lex_state = 69},
  [291] = {.lex_state = 69},
  [292] = {.lex_state = 69},
  [293] = {.lex_state = 2},
  [294] = {.lex_state = 69},
  [295] = {.lex_state = 69},
  [296] = {.lex_state = 69},
  [297] = {.lex_state = 69},
  [298] = {.lex_state = 69},
  [299] = {.lex_state = 69},
  [300] = {.lex_state = 69},
  [301] = {.lex_state = 69},
  [302] = {.lex_state = 69},
  [303] = {.lex_state = 69},
  [304] = {.lex_state = 69},
  [305] = {.lex_state = 69},
  [306] = {.lex_state = 69},
  [307] = {.lex_state = 69},
  [308] = {.lex_state = 69},
  [309] = {.lex_state = 69},
  [310] = {.lex_state = 69},
  [311] = {.lex_state = 69},
  [312] = {.lex_state = 69},
  [313] = {.lex_state = 69},
  [314] = {.lex_state = 69},
  [315] = {.lex_state = 69},
  [316] = {.lex_state = 69},
  [317] = {.lex_state = 69},
  [318] = {.lex_state = 69},
  [319] = {.lex_state = 69},
  [320] = {.lex_state = 69},
  [321] = {.lex_state = 69},
  [322] = {.lex_state = 69},
  [323] = {.lex_state = 69},
  [324] = {.lex_state = 69},
  [325] = {.lex_state = 69},
  [326] = {.lex_state = 69},
  [327] = {.lex_state = 69},
  [328] = {.lex_state = 69},
  [329] = {.lex_state = 69},
  [330] = {.lex_state = 69},
  [331] = {.lex_state = 69},
  [332] = {.lex_state = 69},
  [333] = {.lex_state = 69},
  [334] = {.lex_state = 69},
  [335] = {.lex_state = 69},
  [336] = {.lex_state = 69},
  [337] = {.lex_state = 69},
  [338] = {.lex_state = 69},
  [339] = {.lex_state = 69},
  [340] = {.lex_state = 69},
  [341] = {.lex_state = 69},
  [342] = {.lex_state = 69},
  [343] = {.lex_state = 69},
  [344] = {.lex_state = 69},
  [345] = {.lex_state = 69},
  [346] = {.lex_state = 69},
  [347] = {.lex_state = 2},
  [348] = {.lex_state = 2},
  [349] = {.lex_state = 69},
  [350] = {.lex_state = 69},
  [351] = {.lex_state = 69},
  [352] = {.lex_state = 69},
  [353] = {.lex_state = 69},
  [354] = {.lex_state = 69},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 0},
  [357] = {.lex_state = 0},
  [358] = {.lex_state = 0},
  [359] = {.lex_state = 0},
  [360] = {.lex_state = 1},
  [361] = {.lex_state = 1},
  [362] = {.lex_state = 0},
  [363] = {.lex_state = 0},
  [364] = {.lex_state = 0},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 3},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 0},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 3},
  [374] = {.lex_state = 3},
  [375] = {.lex_state = 3},
  [376] = {.lex_state = 3},
  [377] = {.lex_state = 3},
  [378] = {.lex_state = 3},
  [379] = {.lex_state = 3},
  [380] = {.lex_state = 3},
  [381] = {.lex_state = 3},
  [382] = {.lex_state = 3},
  [383] = {.lex_state = 3},
  [384] = {.lex_state = 3},
  [385] = {.lex_state = 3},
  [386] = {.lex_state = 3},
  [387] = {.lex_state = 4},
  [388] = {.lex_state = 4},
  [389] = {.lex_state = 3},
  [390] = {.lex_state = 3},
  [391] = {.lex_state = 4},
  [392] = {.lex_state = 1},
  [393] = {.lex_state = 4},
  [394] = {.lex_state = 1},
  [395] = {.lex_state = 4},
  [396] = {.lex_state = 4},
  [397] = {.lex_state = 2},
  [398] = {.lex_state = 10},
  [399] = {.lex_state = 10},
  [400] = {.lex_state = 3},
  [401] = {.lex_state = 4},
  [402] = {.lex_state = 2},
  [403] = {.lex_state = 4},
  [404] = {.lex_state = 4},
  [405] = {.lex_state = 2},
  [406] = {.lex_state = 2},
  [407] = {.lex_state = 1},
  [408] = {.lex_state = 4},
  [409] = {.lex_state = 1},
  [410] = {.lex_state = 4},
  [411] = {.lex_state = 10},
  [412] = {.lex_state = 4},
  [413] = {.lex_state = 4},
  [414] = {.lex_state = 4},
  [415] = {.lex_state = 4},
  [416] = {.lex_state = 4},
  [417] = {.lex_state = 4},
  [418] = {.lex_state = 4},
  [419] = {.lex_state = 10},
  [420] = {.lex_state = 4},
  [421] = {.lex_state = 4},
  [422] = {.lex_state = 4},
  [423] = {.lex_state = 4},
  [424] = {.lex_state = 1},
  [425] = {.lex_state = 1},
  [426] = {.lex_state = 1},
  [427] = {.lex_state = 1},
  [428] = {.lex_state = 0},
  [429] = {.lex_state = 4},
  [430] = {.lex_state = 4},
  [431] = {.lex_state = 4},
  [432] = {.lex_state = 4},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 4},
  [435] = {.lex_state = 4},
  [436] = {.lex_state = 4},
  [437] = {.lex_state = 4},
  [438] = {.lex_state = 4},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 4},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 4},
  [451] = {.lex_state = 4},
  [452] = {.lex_state = 1},
  [453] = {.lex_state = 0},
  [454] = {.lex_state = 4},
  [455] = {.lex_state = 4},
  [456] = {.lex_state = 0},
  [457] = {.lex_state = 0},
  [458] = {.lex_state = 1},
  [459] = {.lex_state = 0},
  [460] = {.lex_state = 0},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 0},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 4},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 1},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 4},
  [470] = {.lex_state = 4},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 4},
  [473] = {.lex_state = 4},
  [474] = {.lex_state = 4},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 4},
  [477] = {.lex_state = 4},
  [478] = {.lex_state = 4},
  [479] = {.lex_state = 4},
  [480] = {.lex_state = 4},
  [481] = {.lex_state = 0},
  [482] = {.lex_state = 4},
  [483] = {.lex_state = 4},
  [484] = {.lex_state = 4},
  [485] = {.lex_state = 4},
  [486] = {.lex_state = 4},
  [487] = {.lex_state = 4},
  [488] = {.lex_state = 4},
  [489] = {.lex_state = 4},
  [490] = {.lex_state = 4},
  [491] = {.lex_state = 4},
  [492] = {.lex_state = 4},
  [493] = {.lex_state = 4},
  [494] = {.lex_state = 4},
  [495] = {.lex_state = 4},
  [496] = {.lex_state = 4},
  [497] = {.lex_state = 4},
  [498] = {.lex_state = 4},
  [499] = {.lex_state = 4},
  [500] = {.lex_state = 4},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 4},
  [503] = {.lex_state = 4},
  [504] = {.lex_state = 4},
  [505] = {.lex_state = 4},
  [506] = {.lex_state = 4},
  [507] = {.lex_state = 4},
  [508] = {.lex_state = 4},
  [509] = {.lex_state = 4},
  [510] = {.lex_state = 4},
  [511] = {.lex_state = 4},
  [512] = {.lex_state = 4},
  [513] = {.lex_state = 4},
  [514] = {.lex_state = 4},
  [515] = {.lex_state = 4},
  [516] = {.lex_state = 4},
  [517] = {.lex_state = 4},
  [518] = {.lex_state = 0},
  [519] = {.lex_state = 8},
  [520] = {.lex_state = 8},
  [521] = {.lex_state = 4},
  [522] = {.lex_state = 8},
  [523] = {.lex_state = 1},
  [524] = {.lex_state = 1},
  [525] = {.lex_state = 1},
  [526] = {.lex_state = 1},
  [527] = {.lex_state = 1},
  [528] = {.lex_state = 1},
  [529] = {.lex_state = 1},
  [530] = {.lex_state = 0},
  [531] = {.lex_state = 0},
  [532] = {.lex_state = 0},
  [533] = {.lex_state = 1},
  [534] = {.lex_state = 0},
  [535] = {.lex_state = 1},
  [536] = {.lex_state = 0},
  [537] = {.lex_state = 0},
  [538] = {.lex_state = 0},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 1},
  [541] = {.lex_state = 1},
  [542] = {.lex_state = 1},
  [543] = {.lex_state = 1},
  [544] = {.lex_state = 1},
  [545] = {.lex_state = 1},
  [546] = {.lex_state = 1},
  [547] = {.lex_state = 1},
  [548] = {.lex_state = 1},
  [549] = {.lex_state = 2},
  [550] = {.lex_state = 1},
  [551] = {.lex_state = 11},
  [552] = {.lex_state = 1},
  [553] = {.lex_state = 1},
  [554] = {.lex_state = 1},
  [555] = {.lex_state = 1},
  [556] = {.lex_state = 1},
  [557] = {.lex_state = 1},
  [558] = {.lex_state = 1},
  [559] = {.lex_state = 1},
  [560] = {.lex_state = 11},
  [561] = {.lex_state = 4},
  [562] = {.lex_state = 1},
  [563] = {.lex_state = 2},
  [564] = {.lex_state = 8},
  [565] = {.lex_state = 11},
  [566] = {.lex_state = 11},
  [567] = {.lex_state = 8},
  [568] = {.lex_state = 1},
  [569] = {.lex_state = 1},
  [570] = {.lex_state = 4},
  [571] = {.lex_state = 1},
  [572] = {.lex_state = 1},
  [573] = {.lex_state = 1},
  [574] = {.lex_state = 1},
  [575] = {.lex_state = 2},
  [576] = {.lex_state = 2},
  [577] = {.lex_state = 2},
  [578] = {.lex_state = 1},
  [579] = {.lex_state = 1},
  [580] = {.lex_state = 1},
  [581] = {.lex_state = 2},
  [582] = {.lex_state = 8},
  [583] = {.lex_state = 2},
  [584] = {.lex_state = 1},
  [585] = {.lex_state = 2},
  [586] = {.lex_state = 1},
  [587] = {.lex_state = 1},
  [588] = {.lex_state = 1},
  [589] = {.lex_state = 1},
  [590] = {.lex_state = 1},
  [591] = {.lex_state = 2},
  [592] = {.lex_state = 1},
  [593] = {.lex_state = 1},
  [594] = {.lex_state = 1},
  [595] = {.lex_state = 2},
  [596] = {.lex_state = 1},
  [597] = {.lex_state = 1},
  [598] = {.lex_state = 1},
  [599] = {.lex_state = 1},
  [600] = {.lex_state = 1},
  [601] = {.lex_state = 1},
  [602] = {.lex_state = 1},
  [603] = {.lex_state = 1},
  [604] = {.lex_state = 1},
  [605] = {.lex_state = 8},
  [606] = {.lex_state = 1},
  [607] = {.lex_state = 1},
  [608] = {.lex_state = 1},
  [609] = {.lex_state = 1},
  [610] = {.lex_state = 1},
  [611] = {.lex_state = 1},
  [612] = {.lex_state = 1},
  [613] = {.lex_state = 1},
  [614] = {.lex_state = 1},
  [615] = {.lex_state = 1},
  [616] = {.lex_state = 1},
  [617] = {.lex_state = 2},
  [618] = {.lex_state = 1},
  [619] = {.lex_state = 1},
  [620] = {.lex_state = 2},
  [621] = {.lex_state = 1},
  [622] = {.lex_state = 1},
  [623] = {.lex_state = 1},
  [624] = {.lex_state = 2},
  [625] = {.lex_state = 1},
  [626] = {.lex_state = 1},
  [627] = {.lex_state = 2},
  [628] = {.lex_state = 2},
  [629] = {.lex_state = 1},
  [630] = {.lex_state = 1},
  [631] = {.lex_state = 1},
  [632] = {.lex_state = 19},
  [633] = {.lex_state = 1},
  [634] = {.lex_state = 1},
  [635] = {.lex_state = 1},
  [636] = {.lex_state = 1},
  [637] = {.lex_state = 1},
  [638] = {.lex_state = 1},
  [639] = {.lex_state = 1},
  [640] = {.lex_state = 1},
  [641] = {.lex_state = 1},
  [642] = {.lex_state = 1},
  [643] = {.lex_state = 1},
  [644] = {.lex_state = 1},
  [645] = {.lex_state = 1},
  [646] = {.lex_state = 1},
  [647] = {.lex_state = 1},
  [648] = {.lex_state = 1},
  [649] = {.lex_state = 1},
  [650] = {.lex_state = 1},
  [651] = {.lex_state = 1},
  [652] = {.lex_state = 1},
  [653] = {.lex_state = 1},
  [654] = {.lex_state = 1},
  [655] = {.lex_state = 1},
  [656] = {.lex_state = 1},
  [657] = {.lex_state = 1},
  [658] = {.lex_state = 1},
  [659] = {.lex_state = 1},
  [660] = {.lex_state = 1},
  [661] = {.lex_state = 1},
  [662] = {.lex_state = 19},
  [663] = {.lex_state = 1},
  [664] = {.lex_state = 1},
  [665] = {.lex_state = 1},
  [666] = {.lex_state = 1},
  [667] = {.lex_state = 1},
  [668] = {.lex_state = 1},
  [669] = {.lex_state = 1},
  [670] = {.lex_state = 1},
  [671] = {.lex_state = 8},
  [672] = {.lex_state = 8},
  [673] = {.lex_state = 1},
  [674] = {.lex_state = 1},
  [675] = {.lex_state = 3},
  [676] = {.lex_state = 3},
  [677] = {.lex_state = 2},
  [678] = {.lex_state = 1},
  [679] = {.lex_state = 19},
  [680] = {.lex_state = 1},
  [681] = {.lex_state = 1},
  [682] = {.lex_state = 8},
  [683] = {.lex_state = 1},
  [684] = {.lex_state = 3},
  [685] = {.lex_state = 8},
  [686] = {.lex_state = 3},
  [687] = {.lex_state = 1},
  [688] = {.lex_state = 1},
  [689] = {.lex_state = 1},
  [690] = {.lex_state = 8},
  [691] = {.lex_state = 8},
  [692] = {.lex_state = 1},
  [693] = {.lex_state = 1},
  [694] = {.lex_state = 8},
  [695] = {.lex_state = 8},
  [696] = {.lex_state = 1},
  [697] = {.lex_state = 8},
  [698] = {.lex_state = 8},
  [699] = {.lex_state = 8},
  [700] = {.lex_state = 19},
  [701] = {.lex_state = 8},
  [702] = {.lex_state = 8},
  [703] = {.lex_state = 8},
  [704] = {.lex_state = 1},
  [705] = {.lex_state = 1},
  [706] = {.lex_state = 1},
  [707] = {.lex_state = 3},
  [708] = {.lex_state = 1},
  [709] = {.lex_state = 1},
  [710] = {.lex_state = 1},
  [711] = {.lex_state = 8},
  [712] = {.lex_state = 1},
  [713] = {.lex_state = 1},
  [714] = {.lex_state = 1},
  [715] = {.lex_state = 3},
  [716] = {.lex_state = 8},
  [717] = {.lex_state = 3},
  [718] = {.lex_state = 3},
  [719] = {.lex_state = 1},
  [720] = {.lex_state = 1},
  [721] = {.lex_state = 1},
  [722] = {.lex_state = 1},
  [723] = {.lex_state = 1},
  [724] = {.lex_state = 1},
  [725] = {.lex_state = 8},
  [726] = {.lex_state = 1},
  [727] = {.lex_state = 1},
  [728] = {.lex_state = 1},
  [729] = {.lex_state = 1},
  [730] = {.lex_state = 1},
  [731] = {.lex_state = 1},
  [732] = {.lex_state = 1},
  [733] = {.lex_state = 3},
  [734] = {.lex_state = 1},
  [735] = {.lex_state = 3},
  [736] = {.lex_state = 1},
  [737] = {.lex_state = 1},
  [738] = {.lex_state = 3},
  [739] = {.lex_state = 1},
  [740] = {.lex_state = 1},
  [741] = {.lex_state = 3},
  [742] = {.lex_state = 3},
  [743] = {.lex_state = 1},
  [744] = {.lex_state = 3},
  [745] = {.lex_state = 3},
  [746] = {.lex_state = 1},
  [747] = {.lex_state = 1},
  [748] = {.lex_state = 1},
  [749] = {.lex_state = 1},
  [750] = {.lex_state = 1},
  [751] = {.lex_state = 3},
  [752] = {.lex_state = 3},
  [753] = {.lex_state = 1},
  [754] = {.lex_state = 3},
  [755] = {.lex_state = 3},
  [756] = {.lex_state = 2},
  [757] = {.lex_state = 1},
  [758] = {.lex_state = 3},
  [759] = {.lex_state = 3},
  [760] = {.lex_state = 3},
  [761] = {.lex_state = 1},
  [762] = {.lex_state = 1},
  [763] = {.lex_state = 3},
  [764] = {.lex_state = 1},
  [765] = {.lex_state = 1},
  [766] = {.lex_state = 2},
  [767] = {.lex_state = 1},
  [768] = {.lex_state = 2},
  [769] = {.lex_state = 2},
  [770] = {.lex_state = 2},
  [771] = {.lex_state = 3},
  [772] = {.lex_state = 3},
  [773] = {.lex_state = 2},
  [774] = {.lex_state = 3},
  [775] = {.lex_state = 3},
  [776] = {.lex_state = 2},
  [777] = {.lex_state = 2},
  [778] = {.lex_state = 3},
  [779] = {.lex_state = 3},
  [780] = {.lex_state = 3},
  [781] = {.lex_state = 1},
  [782] = {.lex_state = 3},
  [783] = {.lex_state = 1},
  [784] = {.lex_state = 1},
  [785] = {.lex_state = 3},
  [786] = {.lex_state = 1},
  [787] = {.lex_state = 1},
  [788] = {.lex_state = 1},
  [789] = {.lex_state = 2},
  [790] = {.lex_state = 1},
  [791] = {.lex_state = 1},
  [792] = {.lex_state = 1},
  [793] = {.lex_state = 1},
  [794] = {.lex_state = 2},
  [795] = {.lex_state = 3},
  [796] = {.lex_state = 1},
  [797] = {.lex_state = 8},
  [798] = {.lex_state = 1},
  [799] = {.lex_state = 1},
  [800] = {.lex_state = 1},
  [801] = {.lex_state = 1},
  [802] = {.lex_state = 6},
  [803] = {.lex_state = 1},
  [804] = {.lex_state = 6},
  [805] = {.lex_state = 1},
  [806] = {.lex_state = 1},
  [807] = {.lex_state = 6},
  [808] = {.lex_state = 1},
  [809] = {.lex_state = 1},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 1},
  [812] = {.lex_state = 1},
  [813] = {.lex_state = 1},
  [814] = {.lex_state = 1},
  [815] = {.lex_state = 1},
  [816] = {.lex_state = 1},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 1},
  [819] = {.lex_state = 1},
  [820] = {.lex_state = 1},
  [821] = {.lex_state = 1},
  [822] = {.lex_state = 1},
  [823] = {.lex_state = 1},
  [824] = {.lex_state = 1},
  [825] = {.lex_state = 1},
  [826] = {.lex_state = 1},
  [827] = {.lex_state = 1},
  [828] = {.lex_state = 1},
  [829] = {.lex_state = 1},
  [830] = {.lex_state = 6},
  [831] = {.lex_state = 1},
  [832] = {.lex_state = 6},
  [833] = {.lex_state = 1},
  [834] = {.lex_state = 1},
  [835] = {.lex_state = 1},
  [836] = {.lex_state = 1},
  [837] = {.lex_state = 1},
  [838] = {.lex_state = 1},
  [839] = {.lex_state = 2},
  [840] = {.lex_state = 1},
  [841] = {.lex_state = 1},
  [842] = {.lex_state = 1},
  [843] = {.lex_state = 1},
  [844] = {.lex_state = 1},
  [845] = {.lex_state = 1},
  [846] = {.lex_state = 1},
  [847] = {.lex_state = 1},
  [848] = {.lex_state = 1},
  [849] = {.lex_state = 1},
  [850] = {.lex_state = 1},
  [851] = {.lex_state = 1},
  [852] = {.lex_state = 1},
  [853] = {.lex_state = 1},
  [854] = {.lex_state = 1},
  [855] = {.lex_state = 1},
  [856] = {.lex_state = 1},
  [857] = {.lex_state = 1},
  [858] = {.lex_state = 1},
  [859] = {.lex_state = 1},
  [860] = {.lex_state = 1},
  [861] = {.lex_state = 1},
  [862] = {.lex_state = 1},
  [863] = {.lex_state = 1},
  [864] = {.lex_state = 1},
  [865] = {.lex_state = 2},
  [866] = {.lex_state = 1},
  [867] = {.lex_state = 1},
  [868] = {.lex_state = 6},
  [869] = {.lex_state = 1},
  [870] = {.lex_state = 2},
  [871] = {.lex_state = 2},
  [872] = {.lex_state = 1},
  [873] = {.lex_state = 2},
  [874] = {.lex_state = 1},
  [875] = {.lex_state = 1},
  [876] = {.lex_state = 1},
  [877] = {.lex_state = 1},
  [878] = {.lex_state = 1},
  [879] = {.lex_state = 1},
  [880] = {.lex_state = 1},
  [881] = {.lex_state = 1},
  [882] = {.lex_state = 1},
  [883] = {.lex_state = 1},
  [884] = {.lex_state = 2},
  [885] = {.lex_state = 1},
  [886] = {.lex_state = 1},
  [887] = {.lex_state = 1},
  [888] = {.lex_state = 1},
  [889] = {.lex_state = 1},
  [890] = {.lex_state = 1},
  [891] = {.lex_state = 1},
  [892] = {.lex_state = 1},
  [893] = {.lex_state = 1},
  [894] = {.lex_state = 1},
  [895] = {.lex_state = 1},
  [896] = {.lex_state = 3},
  [897] = {.lex_state = 1},
  [898] = {.lex_state = 3},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 3},
  [901] = {.lex_state = 8},
  [902] = {.lex_state = 1},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 1},
  [905] = {.lex_state = 1},
  [906] = {.lex_state = 1},
  [907] = {.lex_state = 1},
  [908] = {.lex_state = 3},
  [909] = {.lex_state = 1},
  [910] = {.lex_state = 1},
  [911] = {.lex_state = 1},
  [912] = {.lex_state = 3},
  [913] = {.lex_state = 1},
  [914] = {.lex_state = 1},
  [915] = {.lex_state = 1},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 1},
  [919] = {.lex_state = 1},
  [920] = {.lex_state = 1},
  [921] = {.lex_state = 1},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 1},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 6},
  [926] = {.lex_state = 8},
  [927] = {.lex_state = 1},
  [928] = {.lex_state = 3},
  [929] = {.lex_state = 1},
  [930] = {.lex_state = 1},
  [931] = {.lex_state = 1},
  [932] = {.lex_state = 1},
  [933] = {.lex_state = 1},
  [934] = {.lex_state = 3},
  [935] = {.lex_state = 1},
  [936] = {.lex_state = 7},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 3},
  [940] = {.lex_state = 3},
  [941] = {.lex_state = 3},
  [942] = {.lex_state = 3},
  [943] = {.lex_state = 3},
  [944] = {.lex_state = 3},
  [945] = {.lex_state = 3},
  [946] = {.lex_state = 3},
  [947] = {.lex_state = 3},
  [948] = {.lex_state = 3},
  [949] = {.lex_state = 3},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 1},
  [953] = {.lex_state = 1},
  [954] = {.lex_state = 1},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 1},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 1},
  [961] = {.lex_state = 1},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 1},
  [964] = {.lex_state = 7},
  [965] = {.lex_state = 1},
  [966] = {.lex_state = 1},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 1},
  [969] = {.lex_state = 2},
  [970] = {.lex_state = 1},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 1},
  [973] = {.lex_state = 1},
  [974] = {.lex_state = 1},
  [975] = {.lex_state = 2},
  [976] = {.lex_state = 1},
  [977] = {.lex_state = 1},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 1},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 1},
  [982] = {.lex_state = 8},
  [983] = {.lex_state = 1},
  [984] = {.lex_state = 2},
  [985] = {.lex_state = 1},
  [986] = {.lex_state = 1},
  [987] = {.lex_state = 1},
  [988] = {.lex_state = 8},
  [989] = {.lex_state = 1},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 1},
  [992] = {.lex_state = 1},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 3},
  [996] = {.lex_state = 1},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 1},
  [1002] = {.lex_state = 1},
  [1003] = {.lex_state = 7},
  [1004] = {.lex_state = 1},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 3},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 3},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 1},
  [1023] = {.lex_state = 3},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 3},
  [1026] = {.lex_state = 1},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 3},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 1},
  [1035] = {.lex_state = 1},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 1},
  [1043] = {.lex_state = 3},
  [1044] = {.lex_state = 3},
  [1045] = {.lex_state = 1},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 2},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 2},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 2},
  [1054] = {.lex_state = 3},
  [1055] = {.lex_state = 3},
  [1056] = {.lex_state = 2},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 1},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 1},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 3},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 1},
  [1067] = {.lex_state = 1},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 3},
  [1070] = {.lex_state = 3},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 3},
  [1074] = {.lex_state = 3},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 2},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 3},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 3},
  [1084] = {.lex_state = 2},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 2},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 3},
  [1103] = {.lex_state = 3},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 2},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 2},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 3},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 1},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 1},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 1},
  [1147] = {.lex_state = 2},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 2},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 2},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 3},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 3},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 3},
  [1175] = {.lex_state = 2},
  [1176] = {.lex_state = 2},
  [1177] = {.lex_state = 3},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 2},
  [1180] = {.lex_state = 1},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 3},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 3},
  [1186] = {.lex_state = 3},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 3},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 1},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 3},
  [1197] = {.lex_state = 3},
  [1198] = {.lex_state = 3},
  [1199] = {.lex_state = 3},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 2},
  [1204] = {.lex_state = 3},
  [1205] = {.lex_state = 3},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 3},
  [1208] = {.lex_state = 3},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 1},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 1},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 1},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 3},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 3},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 3},
  [1230] = {.lex_state = 1},
  [1231] = {.lex_state = 1},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 3},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 1},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 3},
  [1240] = {.lex_state = 1},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 1},
  [1252] = {.lex_state = 1},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 1},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 1},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 3},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 1},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 1},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 1},
  [1285] = {.lex_state = 1},
  [1286] = {.lex_state = 1},
  [1287] = {.lex_state = 1},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 1},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 1},
  [1294] = {.lex_state = 1},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 1},
  [1298] = {.lex_state = 1},
  [1299] = {.lex_state = 1},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 1},
  [1302] = {.lex_state = 1},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 1},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 3},
  [1313] = {.lex_state = 1},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_decimal_integer_literal] = ACTIONS(1),
    [sym_hex_integer_literal] = ACTIONS(1),
    [sym_octal_integer_literal] = ACTIONS(1),
    [sym_binary_integer_literal] = ACTIONS(1),
    [sym_decimal_floating_point_literal] = ACTIONS(1),
    [sym_hex_floating_point_literal] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_character_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [aux_sym__escape_sequence_token1] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_null_literal] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_synchronized] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_open] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_transitive] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_exports] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_opens] = ACTIONS(1),
    [anon_sym_uses] = ACTIONS(1),
    [anon_sym_provides] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_strictfp] = ACTIONS(1),
    [anon_sym_native] = ACTIONS(1),
    [anon_sym_transient] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_non_DASHsealed] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_permits] = ACTIONS(1),
    [anon_sym_record] = ACTIONS(1),
    [anon_sym_ATinterface] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [sym_boolean_type] = ACTIONS(1),
    [sym_void_type] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_throws] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(1235),
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_switch_label] = STATE(1308),
    [sym_statement] = STATE(5),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_switch_block_statement_group_repeat1] = STATE(275),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(93),
    [anon_sym_default] = ACTIONS(93),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(570),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_type_arguments] = STATE(1231),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(7),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_explicit_constructor_invocation] = STATE(9),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LT] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(99),
    [sym_super] = ACTIONS(101),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_decimal_integer_literal] = ACTIONS(108),
    [sym_hex_integer_literal] = ACTIONS(108),
    [sym_octal_integer_literal] = ACTIONS(108),
    [sym_binary_integer_literal] = ACTIONS(111),
    [sym_decimal_floating_point_literal] = ACTIONS(111),
    [sym_hex_floating_point_literal] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_character_literal] = ACTIONS(111),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(117),
    [sym_null_literal] = ACTIONS(108),
    [anon_sym_LPAREN] = ACTIONS(120),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_final] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_PLUS_PLUS] = ACTIONS(132),
    [anon_sym_DASH_DASH] = ACTIONS(132),
    [anon_sym_new] = ACTIONS(135),
    [anon_sym_class] = ACTIONS(138),
    [anon_sym_switch] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_RBRACE] = ACTIONS(103),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(126),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_assert] = ACTIONS(152),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_break] = ACTIONS(161),
    [anon_sym_continue] = ACTIONS(164),
    [anon_sym_return] = ACTIONS(167),
    [anon_sym_yield] = ACTIONS(170),
    [anon_sym_synchronized] = ACTIONS(173),
    [anon_sym_throw] = ACTIONS(176),
    [anon_sym_try] = ACTIONS(179),
    [anon_sym_if] = ACTIONS(182),
    [anon_sym_for] = ACTIONS(185),
    [anon_sym_AT] = ACTIONS(188),
    [anon_sym_open] = ACTIONS(191),
    [anon_sym_module] = ACTIONS(194),
    [anon_sym_static] = ACTIONS(126),
    [anon_sym_package] = ACTIONS(197),
    [anon_sym_import] = ACTIONS(200),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_public] = ACTIONS(126),
    [anon_sym_protected] = ACTIONS(126),
    [anon_sym_private] = ACTIONS(126),
    [anon_sym_abstract] = ACTIONS(126),
    [anon_sym_strictfp] = ACTIONS(126),
    [anon_sym_native] = ACTIONS(126),
    [anon_sym_transient] = ACTIONS(126),
    [anon_sym_volatile] = ACTIONS(126),
    [anon_sym_sealed] = ACTIONS(126),
    [anon_sym_non_DASHsealed] = ACTIONS(206),
    [anon_sym_record] = ACTIONS(209),
    [anon_sym_ATinterface] = ACTIONS(212),
    [anon_sym_interface] = ACTIONS(215),
    [anon_sym_byte] = ACTIONS(218),
    [anon_sym_short] = ACTIONS(218),
    [anon_sym_int] = ACTIONS(218),
    [anon_sym_long] = ACTIONS(218),
    [anon_sym_char] = ACTIONS(218),
    [anon_sym_float] = ACTIONS(221),
    [anon_sym_double] = ACTIONS(221),
    [sym_boolean_type] = ACTIONS(224),
    [sym_void_type] = ACTIONS(224),
    [sym_this] = ACTIONS(227),
    [sym_super] = ACTIONS(230),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_default] = ACTIONS(235),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(239),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(10),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(11),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(239),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(245),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(13),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(314),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(323),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(1240),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(290),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(341),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(291),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(292),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(295),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(320),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(314),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(279),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(287),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(286),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(284),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(319),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(298),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(300),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(297),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(328),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(302),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(306),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(1180),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(329),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(301),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(288),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(341),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(333),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(317),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(323),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(320),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(279),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(328),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [46] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(319),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [47] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(308),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [48] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(315),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [49] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(317),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [50] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(316),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(327),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(329),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [53] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(306),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(295),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(292),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(288),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(297),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(284),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(339),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(291),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(286),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(333),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(287),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(298),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(300),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(302),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(87),
    [sym_statement] = STATE(338),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(339),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(308),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [70] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(315),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [71] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(316),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(327),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(338),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [74] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(592),
    [sym_statement] = STATE(290),
    [sym_block] = STATE(276),
    [sym_expression_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_assert_statement] = STATE(276),
    [sym_do_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_continue_statement] = STATE(276),
    [sym_return_statement] = STATE(276),
    [sym_yield_statement] = STATE(276),
    [sym_synchronized_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_try_statement] = STATE(276),
    [sym_try_with_resources_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_for_statement] = STATE(276),
    [sym_enhanced_for_statement] = STATE(276),
    [sym__annotation] = STATE(471),
    [sym_marker_annotation] = STATE(471),
    [sym_annotation] = STATE(471),
    [sym_declaration] = STATE(276),
    [sym_module_declaration] = STATE(332),
    [sym_package_declaration] = STATE(332),
    [sym_import_declaration] = STATE(332),
    [sym_enum_declaration] = STATE(332),
    [sym_class_declaration] = STATE(332),
    [sym_modifiers] = STATE(679),
    [sym_record_declaration] = STATE(332),
    [sym_annotation_type_declaration] = STATE(332),
    [sym_interface_declaration] = STATE(332),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(718),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(276),
    [aux_sym_array_creation_expression_repeat1] = STATE(658),
    [aux_sym_modifiers_repeat1] = STATE(428),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_default] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(35),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_synchronized] = ACTIONS(51),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_open] = ACTIONS(63),
    [anon_sym_module] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_package] = ACTIONS(67),
    [anon_sym_import] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_abstract] = ACTIONS(21),
    [anon_sym_strictfp] = ACTIONS(21),
    [anon_sym_native] = ACTIONS(21),
    [anon_sym_transient] = ACTIONS(21),
    [anon_sym_volatile] = ACTIONS(21),
    [anon_sym_sealed] = ACTIONS(21),
    [anon_sym_non_DASHsealed] = ACTIONS(73),
    [anon_sym_record] = ACTIONS(75),
    [anon_sym_ATinterface] = ACTIONS(77),
    [anon_sym_interface] = ACTIONS(79),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(259),
    [sym_identifier] = ACTIONS(261),
    [sym_decimal_integer_literal] = ACTIONS(261),
    [sym_hex_integer_literal] = ACTIONS(261),
    [sym_octal_integer_literal] = ACTIONS(261),
    [sym_binary_integer_literal] = ACTIONS(259),
    [sym_decimal_floating_point_literal] = ACTIONS(259),
    [sym_hex_floating_point_literal] = ACTIONS(261),
    [sym_true] = ACTIONS(261),
    [sym_false] = ACTIONS(261),
    [sym_character_literal] = ACTIONS(259),
    [anon_sym_DQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(259),
    [sym_null_literal] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(261),
    [anon_sym_GT_EQ] = ACTIONS(259),
    [anon_sym_LT_EQ] = ACTIONS(259),
    [anon_sym_EQ_EQ] = ACTIONS(259),
    [anon_sym_BANG_EQ] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_PLUS] = ACTIONS(261),
    [anon_sym_DASH] = ACTIONS(261),
    [anon_sym_STAR] = ACTIONS(259),
    [anon_sym_SLASH] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(259),
    [anon_sym_PERCENT] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(259),
    [anon_sym_GT_GT] = ACTIONS(261),
    [anon_sym_GT_GT_GT] = ACTIONS(259),
    [anon_sym_instanceof] = ACTIONS(261),
    [anon_sym_final] = ACTIONS(261),
    [anon_sym_DASH_GT] = ACTIONS(259),
    [anon_sym_COMMA] = ACTIONS(259),
    [anon_sym_QMARK] = ACTIONS(259),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(261),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_PLUS_PLUS] = ACTIONS(259),
    [anon_sym_DASH_DASH] = ACTIONS(259),
    [anon_sym_new] = ACTIONS(261),
    [anon_sym_LBRACK] = ACTIONS(259),
    [anon_sym_RBRACK] = ACTIONS(259),
    [anon_sym_DOT] = ACTIONS(261),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(259),
    [anon_sym_switch] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_case] = ACTIONS(261),
    [anon_sym_default] = ACTIONS(261),
    [anon_sym_SEMI] = ACTIONS(259),
    [anon_sym_assert] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(261),
    [anon_sym_while] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(261),
    [anon_sym_continue] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_yield] = ACTIONS(261),
    [anon_sym_synchronized] = ACTIONS(261),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_try] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(261),
    [anon_sym_else] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [anon_sym_open] = ACTIONS(261),
    [anon_sym_module] = ACTIONS(261),
    [anon_sym_static] = ACTIONS(261),
    [anon_sym_package] = ACTIONS(261),
    [anon_sym_import] = ACTIONS(261),
    [anon_sym_enum] = ACTIONS(261),
    [anon_sym_public] = ACTIONS(261),
    [anon_sym_protected] = ACTIONS(261),
    [anon_sym_private] = ACTIONS(261),
    [anon_sym_abstract] = ACTIONS(261),
    [anon_sym_strictfp] = ACTIONS(261),
    [anon_sym_native] = ACTIONS(261),
    [anon_sym_transient] = ACTIONS(261),
    [anon_sym_volatile] = ACTIONS(261),
    [anon_sym_sealed] = ACTIONS(261),
    [anon_sym_non_DASHsealed] = ACTIONS(259),
    [anon_sym_record] = ACTIONS(261),
    [anon_sym_ATinterface] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(261),
    [anon_sym_byte] = ACTIONS(261),
    [anon_sym_short] = ACTIONS(261),
    [anon_sym_int] = ACTIONS(261),
    [anon_sym_long] = ACTIONS(261),
    [anon_sym_char] = ACTIONS(261),
    [anon_sym_float] = ACTIONS(261),
    [anon_sym_double] = ACTIONS(261),
    [sym_boolean_type] = ACTIONS(261),
    [sym_void_type] = ACTIONS(261),
    [sym_this] = ACTIONS(261),
    [sym_super] = ACTIONS(261),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(265),
    [sym_decimal_integer_literal] = ACTIONS(265),
    [sym_hex_integer_literal] = ACTIONS(265),
    [sym_octal_integer_literal] = ACTIONS(265),
    [sym_binary_integer_literal] = ACTIONS(263),
    [sym_decimal_floating_point_literal] = ACTIONS(263),
    [sym_hex_floating_point_literal] = ACTIONS(265),
    [sym_true] = ACTIONS(265),
    [sym_false] = ACTIONS(265),
    [sym_character_literal] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(263),
    [sym_null_literal] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_SLASH] = ACTIONS(265),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(265),
    [anon_sym_GT_GT_GT] = ACTIONS(263),
    [anon_sym_instanceof] = ACTIONS(265),
    [anon_sym_final] = ACTIONS(265),
    [anon_sym_DASH_GT] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_QMARK] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(263),
    [anon_sym_PLUS_PLUS] = ACTIONS(263),
    [anon_sym_DASH_DASH] = ACTIONS(263),
    [anon_sym_new] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(265),
    [anon_sym_class] = ACTIONS(265),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(265),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_break] = ACTIONS(265),
    [anon_sym_continue] = ACTIONS(265),
    [anon_sym_return] = ACTIONS(265),
    [anon_sym_yield] = ACTIONS(265),
    [anon_sym_synchronized] = ACTIONS(265),
    [anon_sym_throw] = ACTIONS(265),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_else] = ACTIONS(265),
    [anon_sym_for] = ACTIONS(265),
    [anon_sym_AT] = ACTIONS(265),
    [anon_sym_open] = ACTIONS(265),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_static] = ACTIONS(265),
    [anon_sym_package] = ACTIONS(265),
    [anon_sym_import] = ACTIONS(265),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_public] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_abstract] = ACTIONS(265),
    [anon_sym_strictfp] = ACTIONS(265),
    [anon_sym_native] = ACTIONS(265),
    [anon_sym_transient] = ACTIONS(265),
    [anon_sym_volatile] = ACTIONS(265),
    [anon_sym_sealed] = ACTIONS(265),
    [anon_sym_non_DASHsealed] = ACTIONS(263),
    [anon_sym_record] = ACTIONS(265),
    [anon_sym_ATinterface] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(265),
    [anon_sym_byte] = ACTIONS(265),
    [anon_sym_short] = ACTIONS(265),
    [anon_sym_int] = ACTIONS(265),
    [anon_sym_long] = ACTIONS(265),
    [anon_sym_char] = ACTIONS(265),
    [anon_sym_float] = ACTIONS(265),
    [anon_sym_double] = ACTIONS(265),
    [sym_boolean_type] = ACTIONS(265),
    [sym_void_type] = ACTIONS(265),
    [sym_this] = ACTIONS(265),
    [sym_super] = ACTIONS(265),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(267),
    [sym_identifier] = ACTIONS(269),
    [sym_decimal_integer_literal] = ACTIONS(269),
    [sym_hex_integer_literal] = ACTIONS(269),
    [sym_octal_integer_literal] = ACTIONS(269),
    [sym_binary_integer_literal] = ACTIONS(267),
    [sym_decimal_floating_point_literal] = ACTIONS(267),
    [sym_hex_floating_point_literal] = ACTIONS(269),
    [sym_true] = ACTIONS(269),
    [sym_false] = ACTIONS(269),
    [sym_character_literal] = ACTIONS(267),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(267),
    [sym_null_literal] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(267),
    [anon_sym_RPAREN] = ACTIONS(267),
    [anon_sym_AMP] = ACTIONS(269),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(269),
    [anon_sym_GT_EQ] = ACTIONS(267),
    [anon_sym_LT_EQ] = ACTIONS(267),
    [anon_sym_EQ_EQ] = ACTIONS(267),
    [anon_sym_BANG_EQ] = ACTIONS(267),
    [anon_sym_AMP_AMP] = ACTIONS(267),
    [anon_sym_PIPE_PIPE] = ACTIONS(267),
    [anon_sym_PLUS] = ACTIONS(269),
    [anon_sym_DASH] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(267),
    [anon_sym_SLASH] = ACTIONS(269),
    [anon_sym_PIPE] = ACTIONS(269),
    [anon_sym_CARET] = ACTIONS(267),
    [anon_sym_PERCENT] = ACTIONS(267),
    [anon_sym_LT_LT] = ACTIONS(267),
    [anon_sym_GT_GT] = ACTIONS(269),
    [anon_sym_GT_GT_GT] = ACTIONS(267),
    [anon_sym_instanceof] = ACTIONS(269),
    [anon_sym_final] = ACTIONS(269),
    [anon_sym_DASH_GT] = ACTIONS(267),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_QMARK] = ACTIONS(267),
    [anon_sym_COLON] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(267),
    [anon_sym_DASH_DASH] = ACTIONS(267),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_RBRACK] = ACTIONS(267),
    [anon_sym_class] = ACTIONS(269),
    [anon_sym_switch] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(267),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_SEMI] = ACTIONS(267),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(269),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_break] = ACTIONS(269),
    [anon_sym_continue] = ACTIONS(269),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_synchronized] = ACTIONS(269),
    [anon_sym_throw] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(269),
    [anon_sym_open] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_package] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(269),
    [anon_sym_enum] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_abstract] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_native] = ACTIONS(269),
    [anon_sym_transient] = ACTIONS(269),
    [anon_sym_volatile] = ACTIONS(269),
    [anon_sym_sealed] = ACTIONS(269),
    [anon_sym_non_DASHsealed] = ACTIONS(267),
    [anon_sym_record] = ACTIONS(269),
    [anon_sym_ATinterface] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(269),
    [anon_sym_byte] = ACTIONS(269),
    [anon_sym_short] = ACTIONS(269),
    [anon_sym_int] = ACTIONS(269),
    [anon_sym_long] = ACTIONS(269),
    [anon_sym_char] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [sym_boolean_type] = ACTIONS(269),
    [sym_void_type] = ACTIONS(269),
    [sym_this] = ACTIONS(269),
    [sym_super] = ACTIONS(269),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(271),
    [sym_identifier] = ACTIONS(273),
    [sym_decimal_integer_literal] = ACTIONS(273),
    [sym_hex_integer_literal] = ACTIONS(273),
    [sym_octal_integer_literal] = ACTIONS(273),
    [sym_binary_integer_literal] = ACTIONS(271),
    [sym_decimal_floating_point_literal] = ACTIONS(271),
    [sym_hex_floating_point_literal] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_character_literal] = ACTIONS(271),
    [anon_sym_DQUOTE] = ACTIONS(273),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(271),
    [sym_null_literal] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_AMP] = ACTIONS(273),
    [anon_sym_GT] = ACTIONS(273),
    [anon_sym_LT] = ACTIONS(273),
    [anon_sym_GT_EQ] = ACTIONS(271),
    [anon_sym_LT_EQ] = ACTIONS(271),
    [anon_sym_EQ_EQ] = ACTIONS(271),
    [anon_sym_BANG_EQ] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(271),
    [anon_sym_PIPE_PIPE] = ACTIONS(271),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_SLASH] = ACTIONS(273),
    [anon_sym_PIPE] = ACTIONS(273),
    [anon_sym_CARET] = ACTIONS(271),
    [anon_sym_PERCENT] = ACTIONS(271),
    [anon_sym_LT_LT] = ACTIONS(271),
    [anon_sym_GT_GT] = ACTIONS(273),
    [anon_sym_GT_GT_GT] = ACTIONS(271),
    [anon_sym_instanceof] = ACTIONS(273),
    [anon_sym_final] = ACTIONS(273),
    [anon_sym_DASH_GT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_QMARK] = ACTIONS(271),
    [anon_sym_COLON] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_PLUS_PLUS] = ACTIONS(271),
    [anon_sym_DASH_DASH] = ACTIONS(271),
    [anon_sym_new] = ACTIONS(273),
    [anon_sym_RBRACK] = ACTIONS(271),
    [anon_sym_class] = ACTIONS(273),
    [anon_sym_switch] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(273),
    [anon_sym_default] = ACTIONS(273),
    [anon_sym_SEMI] = ACTIONS(271),
    [anon_sym_assert] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(273),
    [anon_sym_break] = ACTIONS(273),
    [anon_sym_continue] = ACTIONS(273),
    [anon_sym_return] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(273),
    [anon_sym_synchronized] = ACTIONS(273),
    [anon_sym_throw] = ACTIONS(273),
    [anon_sym_try] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(273),
    [anon_sym_else] = ACTIONS(273),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_AT] = ACTIONS(273),
    [anon_sym_open] = ACTIONS(273),
    [anon_sym_module] = ACTIONS(273),
    [anon_sym_static] = ACTIONS(273),
    [anon_sym_package] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(273),
    [anon_sym_enum] = ACTIONS(273),
    [anon_sym_public] = ACTIONS(273),
    [anon_sym_protected] = ACTIONS(273),
    [anon_sym_private] = ACTIONS(273),
    [anon_sym_abstract] = ACTIONS(273),
    [anon_sym_strictfp] = ACTIONS(273),
    [anon_sym_native] = ACTIONS(273),
    [anon_sym_transient] = ACTIONS(273),
    [anon_sym_volatile] = ACTIONS(273),
    [anon_sym_sealed] = ACTIONS(273),
    [anon_sym_non_DASHsealed] = ACTIONS(271),
    [anon_sym_record] = ACTIONS(273),
    [anon_sym_ATinterface] = ACTIONS(271),
    [anon_sym_interface] = ACTIONS(273),
    [anon_sym_byte] = ACTIONS(273),
    [anon_sym_short] = ACTIONS(273),
    [anon_sym_int] = ACTIONS(273),
    [anon_sym_long] = ACTIONS(273),
    [anon_sym_char] = ACTIONS(273),
    [anon_sym_float] = ACTIONS(273),
    [anon_sym_double] = ACTIONS(273),
    [sym_boolean_type] = ACTIONS(273),
    [sym_void_type] = ACTIONS(273),
    [sym_this] = ACTIONS(273),
    [sym_super] = ACTIONS(273),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(275),
    [sym_identifier] = ACTIONS(277),
    [sym_decimal_integer_literal] = ACTIONS(277),
    [sym_hex_integer_literal] = ACTIONS(277),
    [sym_octal_integer_literal] = ACTIONS(277),
    [sym_binary_integer_literal] = ACTIONS(275),
    [sym_decimal_floating_point_literal] = ACTIONS(275),
    [sym_hex_floating_point_literal] = ACTIONS(277),
    [sym_true] = ACTIONS(277),
    [sym_false] = ACTIONS(277),
    [sym_character_literal] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(277),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(275),
    [sym_null_literal] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(275),
    [anon_sym_LT_EQ] = ACTIONS(275),
    [anon_sym_EQ_EQ] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_SLASH] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(275),
    [anon_sym_PERCENT] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(275),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_GT_GT_GT] = ACTIONS(275),
    [anon_sym_instanceof] = ACTIONS(277),
    [anon_sym_final] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(275),
    [anon_sym_COMMA] = ACTIONS(275),
    [anon_sym_QMARK] = ACTIONS(275),
    [anon_sym_COLON] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_PLUS_PLUS] = ACTIONS(275),
    [anon_sym_DASH_DASH] = ACTIONS(275),
    [anon_sym_new] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(275),
    [anon_sym_class] = ACTIONS(277),
    [anon_sym_switch] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(275),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_default] = ACTIONS(277),
    [anon_sym_SEMI] = ACTIONS(275),
    [anon_sym_assert] = ACTIONS(277),
    [anon_sym_do] = ACTIONS(277),
    [anon_sym_while] = ACTIONS(277),
    [anon_sym_break] = ACTIONS(277),
    [anon_sym_continue] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_yield] = ACTIONS(277),
    [anon_sym_synchronized] = ACTIONS(277),
    [anon_sym_throw] = ACTIONS(277),
    [anon_sym_try] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_else] = ACTIONS(277),
    [anon_sym_for] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_open] = ACTIONS(277),
    [anon_sym_module] = ACTIONS(277),
    [anon_sym_static] = ACTIONS(277),
    [anon_sym_package] = ACTIONS(277),
    [anon_sym_import] = ACTIONS(277),
    [anon_sym_enum] = ACTIONS(277),
    [anon_sym_public] = ACTIONS(277),
    [anon_sym_protected] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(277),
    [anon_sym_abstract] = ACTIONS(277),
    [anon_sym_strictfp] = ACTIONS(277),
    [anon_sym_native] = ACTIONS(277),
    [anon_sym_transient] = ACTIONS(277),
    [anon_sym_volatile] = ACTIONS(277),
    [anon_sym_sealed] = ACTIONS(277),
    [anon_sym_non_DASHsealed] = ACTIONS(275),
    [anon_sym_record] = ACTIONS(277),
    [anon_sym_ATinterface] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_byte] = ACTIONS(277),
    [anon_sym_short] = ACTIONS(277),
    [anon_sym_int] = ACTIONS(277),
    [anon_sym_long] = ACTIONS(277),
    [anon_sym_char] = ACTIONS(277),
    [anon_sym_float] = ACTIONS(277),
    [anon_sym_double] = ACTIONS(277),
    [sym_boolean_type] = ACTIONS(277),
    [sym_void_type] = ACTIONS(277),
    [sym_this] = ACTIONS(277),
    [sym_super] = ACTIONS(277),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym_identifier] = ACTIONS(281),
    [sym_decimal_integer_literal] = ACTIONS(281),
    [sym_hex_integer_literal] = ACTIONS(281),
    [sym_octal_integer_literal] = ACTIONS(281),
    [sym_binary_integer_literal] = ACTIONS(279),
    [sym_decimal_floating_point_literal] = ACTIONS(279),
    [sym_hex_floating_point_literal] = ACTIONS(281),
    [sym_true] = ACTIONS(281),
    [sym_false] = ACTIONS(281),
    [sym_character_literal] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(281),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(279),
    [sym_null_literal] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT_EQ] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(279),
    [anon_sym_EQ_EQ] = ACTIONS(279),
    [anon_sym_BANG_EQ] = ACTIONS(279),
    [anon_sym_AMP_AMP] = ACTIONS(279),
    [anon_sym_PIPE_PIPE] = ACTIONS(279),
    [anon_sym_PLUS] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(281),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(281),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_GT_GT] = ACTIONS(281),
    [anon_sym_GT_GT_GT] = ACTIONS(279),
    [anon_sym_instanceof] = ACTIONS(281),
    [anon_sym_final] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_TILDE] = ACTIONS(279),
    [anon_sym_PLUS_PLUS] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(279),
    [anon_sym_new] = ACTIONS(281),
    [anon_sym_RBRACK] = ACTIONS(279),
    [anon_sym_class] = ACTIONS(281),
    [anon_sym_switch] = ACTIONS(281),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_case] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(281),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(281),
    [anon_sym_break] = ACTIONS(281),
    [anon_sym_continue] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(281),
    [anon_sym_yield] = ACTIONS(281),
    [anon_sym_synchronized] = ACTIONS(281),
    [anon_sym_throw] = ACTIONS(281),
    [anon_sym_try] = ACTIONS(281),
    [anon_sym_if] = ACTIONS(281),
    [anon_sym_else] = ACTIONS(281),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_AT] = ACTIONS(281),
    [anon_sym_open] = ACTIONS(281),
    [anon_sym_module] = ACTIONS(281),
    [anon_sym_static] = ACTIONS(281),
    [anon_sym_package] = ACTIONS(281),
    [anon_sym_import] = ACTIONS(281),
    [anon_sym_enum] = ACTIONS(281),
    [anon_sym_public] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_abstract] = ACTIONS(281),
    [anon_sym_strictfp] = ACTIONS(281),
    [anon_sym_native] = ACTIONS(281),
    [anon_sym_transient] = ACTIONS(281),
    [anon_sym_volatile] = ACTIONS(281),
    [anon_sym_sealed] = ACTIONS(281),
    [anon_sym_non_DASHsealed] = ACTIONS(279),
    [anon_sym_record] = ACTIONS(281),
    [anon_sym_ATinterface] = ACTIONS(279),
    [anon_sym_interface] = ACTIONS(281),
    [anon_sym_byte] = ACTIONS(281),
    [anon_sym_short] = ACTIONS(281),
    [anon_sym_int] = ACTIONS(281),
    [anon_sym_long] = ACTIONS(281),
    [anon_sym_char] = ACTIONS(281),
    [anon_sym_float] = ACTIONS(281),
    [anon_sym_double] = ACTIONS(281),
    [sym_boolean_type] = ACTIONS(281),
    [sym_void_type] = ACTIONS(281),
    [sym_this] = ACTIONS(281),
    [sym_super] = ACTIONS(281),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(283),
    [sym_identifier] = ACTIONS(285),
    [sym_decimal_integer_literal] = ACTIONS(285),
    [sym_hex_integer_literal] = ACTIONS(285),
    [sym_octal_integer_literal] = ACTIONS(285),
    [sym_binary_integer_literal] = ACTIONS(283),
    [sym_decimal_floating_point_literal] = ACTIONS(283),
    [sym_hex_floating_point_literal] = ACTIONS(285),
    [sym_true] = ACTIONS(285),
    [sym_false] = ACTIONS(285),
    [sym_character_literal] = ACTIONS(283),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(283),
    [sym_null_literal] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(283),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_GT] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_GT_EQ] = ACTIONS(283),
    [anon_sym_LT_EQ] = ACTIONS(283),
    [anon_sym_EQ_EQ] = ACTIONS(283),
    [anon_sym_BANG_EQ] = ACTIONS(283),
    [anon_sym_AMP_AMP] = ACTIONS(283),
    [anon_sym_PIPE_PIPE] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(285),
    [anon_sym_DASH] = ACTIONS(285),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_SLASH] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(285),
    [anon_sym_CARET] = ACTIONS(283),
    [anon_sym_PERCENT] = ACTIONS(283),
    [anon_sym_LT_LT] = ACTIONS(283),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_GT_GT_GT] = ACTIONS(283),
    [anon_sym_instanceof] = ACTIONS(285),
    [anon_sym_final] = ACTIONS(285),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_COMMA] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(283),
    [anon_sym_COLON] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(283),
    [anon_sym_PLUS_PLUS] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(283),
    [anon_sym_new] = ACTIONS(285),
    [anon_sym_RBRACK] = ACTIONS(283),
    [anon_sym_class] = ACTIONS(285),
    [anon_sym_switch] = ACTIONS(285),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_case] = ACTIONS(285),
    [anon_sym_default] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(285),
    [anon_sym_do] = ACTIONS(285),
    [anon_sym_while] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(285),
    [anon_sym_continue] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(285),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_synchronized] = ACTIONS(285),
    [anon_sym_throw] = ACTIONS(285),
    [anon_sym_try] = ACTIONS(285),
    [anon_sym_if] = ACTIONS(285),
    [anon_sym_else] = ACTIONS(285),
    [anon_sym_for] = ACTIONS(285),
    [anon_sym_AT] = ACTIONS(285),
    [anon_sym_open] = ACTIONS(285),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_static] = ACTIONS(285),
    [anon_sym_package] = ACTIONS(285),
    [anon_sym_import] = ACTIONS(285),
    [anon_sym_enum] = ACTIONS(285),
    [anon_sym_public] = ACTIONS(285),
    [anon_sym_protected] = ACTIONS(285),
    [anon_sym_private] = ACTIONS(285),
    [anon_sym_abstract] = ACTIONS(285),
    [anon_sym_strictfp] = ACTIONS(285),
    [anon_sym_native] = ACTIONS(285),
    [anon_sym_transient] = ACTIONS(285),
    [anon_sym_volatile] = ACTIONS(285),
    [anon_sym_sealed] = ACTIONS(285),
    [anon_sym_non_DASHsealed] = ACTIONS(283),
    [anon_sym_record] = ACTIONS(285),
    [anon_sym_ATinterface] = ACTIONS(283),
    [anon_sym_interface] = ACTIONS(285),
    [anon_sym_byte] = ACTIONS(285),
    [anon_sym_short] = ACTIONS(285),
    [anon_sym_int] = ACTIONS(285),
    [anon_sym_long] = ACTIONS(285),
    [anon_sym_char] = ACTIONS(285),
    [anon_sym_float] = ACTIONS(285),
    [anon_sym_double] = ACTIONS(285),
    [sym_boolean_type] = ACTIONS(285),
    [sym_void_type] = ACTIONS(285),
    [sym_this] = ACTIONS(285),
    [sym_super] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [82] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(656),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(719),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(707),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_formal_parameter] = STATE(1030),
    [sym_receiver_parameter] = STATE(402),
    [sym_spread_parameter] = STATE(1030),
    [aux_sym_array_creation_expression_repeat1] = STATE(681),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(287),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(295),
    [anon_sym_module] = ACTIONS(295),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(295),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [83] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(656),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(719),
    [sym__type] = STATE(937),
    [sym__unannotated_type] = STATE(707),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_formal_parameter] = STATE(1030),
    [sym_receiver_parameter] = STATE(402),
    [sym_spread_parameter] = STATE(1030),
    [aux_sym_array_creation_expression_repeat1] = STATE(681),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(299),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(295),
    [anon_sym_module] = ACTIONS(295),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(295),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [84] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(656),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(719),
    [sym__type] = STATE(997),
    [sym__unannotated_type] = STATE(707),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_formal_parameter] = STATE(1030),
    [sym_receiver_parameter] = STATE(402),
    [sym_spread_parameter] = STATE(1030),
    [aux_sym_array_creation_expression_repeat1] = STATE(681),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(299),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(295),
    [anon_sym_module] = ACTIONS(295),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(295),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [85] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(590),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(726),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(715),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(140),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [86] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(578),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(724),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(717),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [sym_local_variable_declaration] = STATE(137),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(309),
    [sym_identifier] = ACTIONS(311),
    [sym_decimal_integer_literal] = ACTIONS(311),
    [sym_hex_integer_literal] = ACTIONS(311),
    [sym_octal_integer_literal] = ACTIONS(311),
    [sym_binary_integer_literal] = ACTIONS(309),
    [sym_decimal_floating_point_literal] = ACTIONS(309),
    [sym_hex_floating_point_literal] = ACTIONS(311),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_character_literal] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(309),
    [sym_null_literal] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_GT] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(313),
    [anon_sym_GT_EQ] = ACTIONS(315),
    [anon_sym_LT_EQ] = ACTIONS(315),
    [anon_sym_EQ_EQ] = ACTIONS(315),
    [anon_sym_BANG_EQ] = ACTIONS(315),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_STAR] = ACTIONS(315),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_PIPE] = ACTIONS(313),
    [anon_sym_CARET] = ACTIONS(315),
    [anon_sym_PERCENT] = ACTIONS(315),
    [anon_sym_LT_LT] = ACTIONS(315),
    [anon_sym_GT_GT] = ACTIONS(313),
    [anon_sym_GT_GT_GT] = ACTIONS(315),
    [anon_sym_instanceof] = ACTIONS(313),
    [anon_sym_final] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_PLUS_PLUS] = ACTIONS(320),
    [anon_sym_DASH_DASH] = ACTIONS(320),
    [anon_sym_new] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(311),
    [anon_sym_switch] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_RBRACE] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_assert] = ACTIONS(311),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_synchronized] = ACTIONS(311),
    [anon_sym_throw] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(311),
    [anon_sym_if] = ACTIONS(311),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(311),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_static] = ACTIONS(311),
    [anon_sym_package] = ACTIONS(311),
    [anon_sym_import] = ACTIONS(311),
    [anon_sym_enum] = ACTIONS(311),
    [anon_sym_public] = ACTIONS(311),
    [anon_sym_protected] = ACTIONS(311),
    [anon_sym_private] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(311),
    [anon_sym_strictfp] = ACTIONS(311),
    [anon_sym_native] = ACTIONS(311),
    [anon_sym_transient] = ACTIONS(311),
    [anon_sym_volatile] = ACTIONS(311),
    [anon_sym_sealed] = ACTIONS(311),
    [anon_sym_non_DASHsealed] = ACTIONS(309),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_ATinterface] = ACTIONS(309),
    [anon_sym_interface] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(311),
    [anon_sym_short] = ACTIONS(311),
    [anon_sym_int] = ACTIONS(311),
    [anon_sym_long] = ACTIONS(311),
    [anon_sym_char] = ACTIONS(311),
    [anon_sym_float] = ACTIONS(311),
    [anon_sym_double] = ACTIONS(311),
    [sym_boolean_type] = ACTIONS(311),
    [sym_void_type] = ACTIONS(311),
    [sym_this] = ACTIONS(311),
    [sym_super] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [88] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym_element_value_pair] = STATE(1041),
    [sym__element_value] = STATE(1247),
    [sym_element_value_array_initializer] = STATE(1247),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(323),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [89] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(657),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym_block] = STATE(1059),
    [sym_expression_statement] = STATE(1059),
    [sym_throw_statement] = STATE(1059),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_throw] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [90] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym__element_value] = STATE(1068),
    [sym_element_value_array_initializer] = STATE(1068),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_RBRACE] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [91] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym_element_value_pair] = STATE(1005),
    [sym__element_value] = STATE(1254),
    [sym_element_value_array_initializer] = STATE(1254),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(323),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [92] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym_element_value_pair] = STATE(1098),
    [sym__element_value] = STATE(1306),
    [sym_element_value_array_initializer] = STATE(1306),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(323),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [93] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym__element_value] = STATE(1129),
    [sym_element_value_array_initializer] = STATE(1129),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_RBRACE] = ACTIONS(339),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [94] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(574),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym_array_initializer] = STATE(1063),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(345),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_catch_clause] = STATE(96),
    [sym_finally_clause] = STATE(299),
    [aux_sym_try_statement_repeat1] = STATE(96),
    [ts_builtin_sym_end] = ACTIONS(347),
    [sym_identifier] = ACTIONS(349),
    [sym_decimal_integer_literal] = ACTIONS(349),
    [sym_hex_integer_literal] = ACTIONS(349),
    [sym_octal_integer_literal] = ACTIONS(349),
    [sym_binary_integer_literal] = ACTIONS(347),
    [sym_decimal_floating_point_literal] = ACTIONS(347),
    [sym_hex_floating_point_literal] = ACTIONS(349),
    [sym_true] = ACTIONS(349),
    [sym_false] = ACTIONS(349),
    [sym_character_literal] = ACTIONS(347),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(347),
    [sym_null_literal] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(347),
    [anon_sym_PLUS] = ACTIONS(349),
    [anon_sym_DASH] = ACTIONS(349),
    [anon_sym_final] = ACTIONS(349),
    [anon_sym_BANG] = ACTIONS(347),
    [anon_sym_TILDE] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(347),
    [anon_sym_DASH_DASH] = ACTIONS(347),
    [anon_sym_new] = ACTIONS(349),
    [anon_sym_class] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_RBRACE] = ACTIONS(347),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_default] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(347),
    [anon_sym_assert] = ACTIONS(349),
    [anon_sym_do] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_continue] = ACTIONS(349),
    [anon_sym_return] = ACTIONS(349),
    [anon_sym_yield] = ACTIONS(349),
    [anon_sym_synchronized] = ACTIONS(349),
    [anon_sym_throw] = ACTIONS(349),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_catch] = ACTIONS(351),
    [anon_sym_finally] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_else] = ACTIONS(349),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_AT] = ACTIONS(349),
    [anon_sym_open] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_static] = ACTIONS(349),
    [anon_sym_package] = ACTIONS(349),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(349),
    [anon_sym_protected] = ACTIONS(349),
    [anon_sym_private] = ACTIONS(349),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_strictfp] = ACTIONS(349),
    [anon_sym_native] = ACTIONS(349),
    [anon_sym_transient] = ACTIONS(349),
    [anon_sym_volatile] = ACTIONS(349),
    [anon_sym_sealed] = ACTIONS(349),
    [anon_sym_non_DASHsealed] = ACTIONS(347),
    [anon_sym_record] = ACTIONS(349),
    [anon_sym_ATinterface] = ACTIONS(347),
    [anon_sym_interface] = ACTIONS(349),
    [anon_sym_byte] = ACTIONS(349),
    [anon_sym_short] = ACTIONS(349),
    [anon_sym_int] = ACTIONS(349),
    [anon_sym_long] = ACTIONS(349),
    [anon_sym_char] = ACTIONS(349),
    [anon_sym_float] = ACTIONS(349),
    [anon_sym_double] = ACTIONS(349),
    [sym_boolean_type] = ACTIONS(349),
    [sym_void_type] = ACTIONS(349),
    [sym_this] = ACTIONS(349),
    [sym_super] = ACTIONS(349),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_catch_clause] = STATE(101),
    [sym_finally_clause] = STATE(278),
    [aux_sym_try_statement_repeat1] = STATE(101),
    [ts_builtin_sym_end] = ACTIONS(355),
    [sym_identifier] = ACTIONS(357),
    [sym_decimal_integer_literal] = ACTIONS(357),
    [sym_hex_integer_literal] = ACTIONS(357),
    [sym_octal_integer_literal] = ACTIONS(357),
    [sym_binary_integer_literal] = ACTIONS(355),
    [sym_decimal_floating_point_literal] = ACTIONS(355),
    [sym_hex_floating_point_literal] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_character_literal] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(355),
    [sym_null_literal] = ACTIONS(357),
    [anon_sym_LPAREN] = ACTIONS(355),
    [anon_sym_PLUS] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(357),
    [anon_sym_final] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(355),
    [anon_sym_DASH_DASH] = ACTIONS(355),
    [anon_sym_new] = ACTIONS(357),
    [anon_sym_class] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_RBRACE] = ACTIONS(355),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_assert] = ACTIONS(357),
    [anon_sym_do] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_break] = ACTIONS(357),
    [anon_sym_continue] = ACTIONS(357),
    [anon_sym_return] = ACTIONS(357),
    [anon_sym_yield] = ACTIONS(357),
    [anon_sym_synchronized] = ACTIONS(357),
    [anon_sym_throw] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(357),
    [anon_sym_catch] = ACTIONS(351),
    [anon_sym_finally] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_else] = ACTIONS(357),
    [anon_sym_for] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(357),
    [anon_sym_open] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(357),
    [anon_sym_package] = ACTIONS(357),
    [anon_sym_import] = ACTIONS(357),
    [anon_sym_enum] = ACTIONS(357),
    [anon_sym_public] = ACTIONS(357),
    [anon_sym_protected] = ACTIONS(357),
    [anon_sym_private] = ACTIONS(357),
    [anon_sym_abstract] = ACTIONS(357),
    [anon_sym_strictfp] = ACTIONS(357),
    [anon_sym_native] = ACTIONS(357),
    [anon_sym_transient] = ACTIONS(357),
    [anon_sym_volatile] = ACTIONS(357),
    [anon_sym_sealed] = ACTIONS(357),
    [anon_sym_non_DASHsealed] = ACTIONS(355),
    [anon_sym_record] = ACTIONS(357),
    [anon_sym_ATinterface] = ACTIONS(355),
    [anon_sym_interface] = ACTIONS(357),
    [anon_sym_byte] = ACTIONS(357),
    [anon_sym_short] = ACTIONS(357),
    [anon_sym_int] = ACTIONS(357),
    [anon_sym_long] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_float] = ACTIONS(357),
    [anon_sym_double] = ACTIONS(357),
    [sym_boolean_type] = ACTIONS(357),
    [sym_void_type] = ACTIONS(357),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(357),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [97] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym__element_value] = STATE(1129),
    [sym_element_value_array_initializer] = STATE(1129),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_catch_clause] = STATE(101),
    [sym_finally_clause] = STATE(296),
    [aux_sym_try_statement_repeat1] = STATE(101),
    [ts_builtin_sym_end] = ACTIONS(361),
    [sym_identifier] = ACTIONS(363),
    [sym_decimal_integer_literal] = ACTIONS(363),
    [sym_hex_integer_literal] = ACTIONS(363),
    [sym_octal_integer_literal] = ACTIONS(363),
    [sym_binary_integer_literal] = ACTIONS(361),
    [sym_decimal_floating_point_literal] = ACTIONS(361),
    [sym_hex_floating_point_literal] = ACTIONS(363),
    [sym_true] = ACTIONS(363),
    [sym_false] = ACTIONS(363),
    [sym_character_literal] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(361),
    [sym_null_literal] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_final] = ACTIONS(363),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(361),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_new] = ACTIONS(363),
    [anon_sym_class] = ACTIONS(363),
    [anon_sym_switch] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(363),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_assert] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(363),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_break] = ACTIONS(363),
    [anon_sym_continue] = ACTIONS(363),
    [anon_sym_return] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(363),
    [anon_sym_synchronized] = ACTIONS(363),
    [anon_sym_throw] = ACTIONS(363),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_catch] = ACTIONS(351),
    [anon_sym_finally] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_else] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_open] = ACTIONS(363),
    [anon_sym_module] = ACTIONS(363),
    [anon_sym_static] = ACTIONS(363),
    [anon_sym_package] = ACTIONS(363),
    [anon_sym_import] = ACTIONS(363),
    [anon_sym_enum] = ACTIONS(363),
    [anon_sym_public] = ACTIONS(363),
    [anon_sym_protected] = ACTIONS(363),
    [anon_sym_private] = ACTIONS(363),
    [anon_sym_abstract] = ACTIONS(363),
    [anon_sym_strictfp] = ACTIONS(363),
    [anon_sym_native] = ACTIONS(363),
    [anon_sym_transient] = ACTIONS(363),
    [anon_sym_volatile] = ACTIONS(363),
    [anon_sym_sealed] = ACTIONS(363),
    [anon_sym_non_DASHsealed] = ACTIONS(361),
    [anon_sym_record] = ACTIONS(363),
    [anon_sym_ATinterface] = ACTIONS(361),
    [anon_sym_interface] = ACTIONS(363),
    [anon_sym_byte] = ACTIONS(363),
    [anon_sym_short] = ACTIONS(363),
    [anon_sym_int] = ACTIONS(363),
    [anon_sym_long] = ACTIONS(363),
    [anon_sym_char] = ACTIONS(363),
    [anon_sym_float] = ACTIONS(363),
    [anon_sym_double] = ACTIONS(363),
    [sym_boolean_type] = ACTIONS(363),
    [sym_void_type] = ACTIONS(363),
    [sym_this] = ACTIONS(363),
    [sym_super] = ACTIONS(363),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [99] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym__element_value] = STATE(1267),
    [sym_element_value_array_initializer] = STATE(1267),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [100] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym__element_value] = STATE(1228),
    [sym_element_value_array_initializer] = STATE(1228),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_catch_clause] = STATE(101),
    [aux_sym_try_statement_repeat1] = STATE(101),
    [ts_builtin_sym_end] = ACTIONS(365),
    [sym_identifier] = ACTIONS(367),
    [sym_decimal_integer_literal] = ACTIONS(367),
    [sym_hex_integer_literal] = ACTIONS(367),
    [sym_octal_integer_literal] = ACTIONS(367),
    [sym_binary_integer_literal] = ACTIONS(365),
    [sym_decimal_floating_point_literal] = ACTIONS(365),
    [sym_hex_floating_point_literal] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_character_literal] = ACTIONS(365),
    [anon_sym_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(365),
    [sym_null_literal] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(367),
    [anon_sym_DASH] = ACTIONS(367),
    [anon_sym_final] = ACTIONS(367),
    [anon_sym_BANG] = ACTIONS(365),
    [anon_sym_TILDE] = ACTIONS(365),
    [anon_sym_PLUS_PLUS] = ACTIONS(365),
    [anon_sym_DASH_DASH] = ACTIONS(365),
    [anon_sym_new] = ACTIONS(367),
    [anon_sym_class] = ACTIONS(367),
    [anon_sym_switch] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_case] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_assert] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(367),
    [anon_sym_continue] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(367),
    [anon_sym_yield] = ACTIONS(367),
    [anon_sym_synchronized] = ACTIONS(367),
    [anon_sym_throw] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_catch] = ACTIONS(369),
    [anon_sym_finally] = ACTIONS(367),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_else] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_AT] = ACTIONS(367),
    [anon_sym_open] = ACTIONS(367),
    [anon_sym_module] = ACTIONS(367),
    [anon_sym_static] = ACTIONS(367),
    [anon_sym_package] = ACTIONS(367),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_enum] = ACTIONS(367),
    [anon_sym_public] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_abstract] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_native] = ACTIONS(367),
    [anon_sym_transient] = ACTIONS(367),
    [anon_sym_volatile] = ACTIONS(367),
    [anon_sym_sealed] = ACTIONS(367),
    [anon_sym_non_DASHsealed] = ACTIONS(365),
    [anon_sym_record] = ACTIONS(367),
    [anon_sym_ATinterface] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(367),
    [anon_sym_byte] = ACTIONS(367),
    [anon_sym_short] = ACTIONS(367),
    [anon_sym_int] = ACTIONS(367),
    [anon_sym_long] = ACTIONS(367),
    [anon_sym_char] = ACTIONS(367),
    [anon_sym_float] = ACTIONS(367),
    [anon_sym_double] = ACTIONS(367),
    [sym_boolean_type] = ACTIONS(367),
    [sym_void_type] = ACTIONS(367),
    [sym_this] = ACTIONS(367),
    [sym_super] = ACTIONS(367),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [102] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym__element_value] = STATE(1129),
    [sym_element_value_array_initializer] = STATE(1129),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [103] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(629),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym_array_initializer] = STATE(1126),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [104] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(623),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(739),
    [sym_marker_annotation] = STATE(739),
    [sym_annotation] = STATE(739),
    [sym__element_value] = STATE(1228),
    [sym_element_value_array_initializer] = STATE(1228),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [105] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(629),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym_array_initializer] = STATE(1126),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(374),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [106] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(629),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym_array_initializer] = STATE(1126),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [107] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(602),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym_block] = STATE(527),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [108] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(588),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym_block] = STATE(542),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [109] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(559),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym_block] = STATE(542),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [110] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(607),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym_array_initializer] = STATE(1097),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [111] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(548),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym_block] = STATE(527),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(267),
    [sym_identifier] = ACTIONS(269),
    [sym_decimal_integer_literal] = ACTIONS(269),
    [sym_hex_integer_literal] = ACTIONS(269),
    [sym_octal_integer_literal] = ACTIONS(269),
    [sym_binary_integer_literal] = ACTIONS(267),
    [sym_decimal_floating_point_literal] = ACTIONS(267),
    [sym_hex_floating_point_literal] = ACTIONS(269),
    [sym_true] = ACTIONS(269),
    [sym_false] = ACTIONS(269),
    [sym_character_literal] = ACTIONS(267),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(267),
    [sym_null_literal] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(267),
    [anon_sym_PLUS] = ACTIONS(269),
    [anon_sym_DASH] = ACTIONS(269),
    [anon_sym_final] = ACTIONS(269),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_PLUS_PLUS] = ACTIONS(267),
    [anon_sym_DASH_DASH] = ACTIONS(267),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(269),
    [anon_sym_switch] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(267),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_SEMI] = ACTIONS(267),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(269),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_break] = ACTIONS(269),
    [anon_sym_continue] = ACTIONS(269),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_synchronized] = ACTIONS(269),
    [anon_sym_throw] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_finally] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(269),
    [anon_sym_open] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_package] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(269),
    [anon_sym_enum] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_abstract] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_native] = ACTIONS(269),
    [anon_sym_transient] = ACTIONS(269),
    [anon_sym_volatile] = ACTIONS(269),
    [anon_sym_sealed] = ACTIONS(269),
    [anon_sym_non_DASHsealed] = ACTIONS(267),
    [anon_sym_record] = ACTIONS(269),
    [anon_sym_ATinterface] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(269),
    [anon_sym_byte] = ACTIONS(269),
    [anon_sym_short] = ACTIONS(269),
    [anon_sym_int] = ACTIONS(269),
    [anon_sym_long] = ACTIONS(269),
    [anon_sym_char] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [sym_boolean_type] = ACTIONS(269),
    [sym_void_type] = ACTIONS(269),
    [sym_this] = ACTIONS(269),
    [sym_super] = ACTIONS(269),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [113] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(609),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [114] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(587),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [115] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(637),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(392),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [116] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(615),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [117] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(618),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(275),
    [sym_identifier] = ACTIONS(277),
    [sym_decimal_integer_literal] = ACTIONS(277),
    [sym_hex_integer_literal] = ACTIONS(277),
    [sym_octal_integer_literal] = ACTIONS(277),
    [sym_binary_integer_literal] = ACTIONS(275),
    [sym_decimal_floating_point_literal] = ACTIONS(275),
    [sym_hex_floating_point_literal] = ACTIONS(277),
    [sym_true] = ACTIONS(277),
    [sym_false] = ACTIONS(277),
    [sym_character_literal] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(277),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(275),
    [sym_null_literal] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_final] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_PLUS_PLUS] = ACTIONS(275),
    [anon_sym_DASH_DASH] = ACTIONS(275),
    [anon_sym_new] = ACTIONS(277),
    [anon_sym_class] = ACTIONS(277),
    [anon_sym_switch] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(275),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_default] = ACTIONS(277),
    [anon_sym_SEMI] = ACTIONS(275),
    [anon_sym_assert] = ACTIONS(277),
    [anon_sym_do] = ACTIONS(277),
    [anon_sym_while] = ACTIONS(277),
    [anon_sym_break] = ACTIONS(277),
    [anon_sym_continue] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_yield] = ACTIONS(277),
    [anon_sym_synchronized] = ACTIONS(277),
    [anon_sym_throw] = ACTIONS(277),
    [anon_sym_try] = ACTIONS(277),
    [anon_sym_catch] = ACTIONS(277),
    [anon_sym_finally] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_else] = ACTIONS(277),
    [anon_sym_for] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_open] = ACTIONS(277),
    [anon_sym_module] = ACTIONS(277),
    [anon_sym_static] = ACTIONS(277),
    [anon_sym_package] = ACTIONS(277),
    [anon_sym_import] = ACTIONS(277),
    [anon_sym_enum] = ACTIONS(277),
    [anon_sym_public] = ACTIONS(277),
    [anon_sym_protected] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(277),
    [anon_sym_abstract] = ACTIONS(277),
    [anon_sym_strictfp] = ACTIONS(277),
    [anon_sym_native] = ACTIONS(277),
    [anon_sym_transient] = ACTIONS(277),
    [anon_sym_volatile] = ACTIONS(277),
    [anon_sym_sealed] = ACTIONS(277),
    [anon_sym_non_DASHsealed] = ACTIONS(275),
    [anon_sym_record] = ACTIONS(277),
    [anon_sym_ATinterface] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_byte] = ACTIONS(277),
    [anon_sym_short] = ACTIONS(277),
    [anon_sym_int] = ACTIONS(277),
    [anon_sym_long] = ACTIONS(277),
    [anon_sym_char] = ACTIONS(277),
    [anon_sym_float] = ACTIONS(277),
    [anon_sym_double] = ACTIONS(277),
    [sym_boolean_type] = ACTIONS(277),
    [sym_void_type] = ACTIONS(277),
    [sym_this] = ACTIONS(277),
    [sym_super] = ACTIONS(277),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [119] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(619),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(398),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [120] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(641),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(400),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [121] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(610),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [122] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(621),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [123] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(613),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(406),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [124] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(638),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_RBRACK] = ACTIONS(408),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [125] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(606),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [126] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(635),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_RBRACK] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [127] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(638),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_RBRACK] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [128] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(642),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [129] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(420),
    [sym_identifier] = ACTIONS(422),
    [sym_decimal_integer_literal] = ACTIONS(422),
    [sym_hex_integer_literal] = ACTIONS(422),
    [sym_octal_integer_literal] = ACTIONS(422),
    [sym_binary_integer_literal] = ACTIONS(420),
    [sym_decimal_floating_point_literal] = ACTIONS(420),
    [sym_hex_floating_point_literal] = ACTIONS(422),
    [sym_true] = ACTIONS(422),
    [sym_false] = ACTIONS(422),
    [sym_character_literal] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(420),
    [sym_null_literal] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(420),
    [anon_sym_PLUS] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_final] = ACTIONS(422),
    [anon_sym_BANG] = ACTIONS(420),
    [anon_sym_TILDE] = ACTIONS(420),
    [anon_sym_PLUS_PLUS] = ACTIONS(420),
    [anon_sym_DASH_DASH] = ACTIONS(420),
    [anon_sym_new] = ACTIONS(422),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_switch] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(420),
    [anon_sym_RBRACE] = ACTIONS(420),
    [anon_sym_case] = ACTIONS(422),
    [anon_sym_default] = ACTIONS(422),
    [anon_sym_SEMI] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_do] = ACTIONS(422),
    [anon_sym_while] = ACTIONS(422),
    [anon_sym_break] = ACTIONS(422),
    [anon_sym_continue] = ACTIONS(422),
    [anon_sym_return] = ACTIONS(422),
    [anon_sym_yield] = ACTIONS(422),
    [anon_sym_synchronized] = ACTIONS(422),
    [anon_sym_throw] = ACTIONS(422),
    [anon_sym_try] = ACTIONS(422),
    [anon_sym_catch] = ACTIONS(422),
    [anon_sym_finally] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_else] = ACTIONS(422),
    [anon_sym_for] = ACTIONS(422),
    [anon_sym_AT] = ACTIONS(422),
    [anon_sym_open] = ACTIONS(422),
    [anon_sym_module] = ACTIONS(422),
    [anon_sym_static] = ACTIONS(422),
    [anon_sym_package] = ACTIONS(422),
    [anon_sym_import] = ACTIONS(422),
    [anon_sym_enum] = ACTIONS(422),
    [anon_sym_public] = ACTIONS(422),
    [anon_sym_protected] = ACTIONS(422),
    [anon_sym_private] = ACTIONS(422),
    [anon_sym_abstract] = ACTIONS(422),
    [anon_sym_strictfp] = ACTIONS(422),
    [anon_sym_native] = ACTIONS(422),
    [anon_sym_transient] = ACTIONS(422),
    [anon_sym_volatile] = ACTIONS(422),
    [anon_sym_sealed] = ACTIONS(422),
    [anon_sym_non_DASHsealed] = ACTIONS(420),
    [anon_sym_record] = ACTIONS(422),
    [anon_sym_ATinterface] = ACTIONS(420),
    [anon_sym_interface] = ACTIONS(422),
    [anon_sym_byte] = ACTIONS(422),
    [anon_sym_short] = ACTIONS(422),
    [anon_sym_int] = ACTIONS(422),
    [anon_sym_long] = ACTIONS(422),
    [anon_sym_char] = ACTIONS(422),
    [anon_sym_float] = ACTIONS(422),
    [anon_sym_double] = ACTIONS(422),
    [sym_boolean_type] = ACTIONS(422),
    [sym_void_type] = ACTIONS(422),
    [sym_this] = ACTIONS(422),
    [sym_super] = ACTIONS(422),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [131] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(652),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(424),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [132] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(604),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [133] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(635),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_RBRACK] = ACTIONS(428),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [134] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(612),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(430),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [135] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(660),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [136] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(611),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(434),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [137] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(646),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [138] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(593),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [139] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(614),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [140] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(661),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [141] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(580),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [142] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(571),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [143] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(649),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(448),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [144] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(647),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(452),
    [sym_identifier] = ACTIONS(454),
    [sym_decimal_integer_literal] = ACTIONS(454),
    [sym_hex_integer_literal] = ACTIONS(454),
    [sym_octal_integer_literal] = ACTIONS(454),
    [sym_binary_integer_literal] = ACTIONS(452),
    [sym_decimal_floating_point_literal] = ACTIONS(452),
    [sym_hex_floating_point_literal] = ACTIONS(454),
    [sym_true] = ACTIONS(454),
    [sym_false] = ACTIONS(454),
    [sym_character_literal] = ACTIONS(452),
    [anon_sym_DQUOTE] = ACTIONS(454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(452),
    [sym_null_literal] = ACTIONS(454),
    [anon_sym_LPAREN] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(452),
    [anon_sym_PLUS] = ACTIONS(454),
    [anon_sym_DASH] = ACTIONS(454),
    [anon_sym_final] = ACTIONS(454),
    [anon_sym_BANG] = ACTIONS(452),
    [anon_sym_TILDE] = ACTIONS(452),
    [anon_sym_PLUS_PLUS] = ACTIONS(452),
    [anon_sym_DASH_DASH] = ACTIONS(452),
    [anon_sym_new] = ACTIONS(454),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_switch] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(452),
    [anon_sym_RBRACE] = ACTIONS(452),
    [anon_sym_case] = ACTIONS(454),
    [anon_sym_default] = ACTIONS(454),
    [anon_sym_SEMI] = ACTIONS(452),
    [anon_sym_assert] = ACTIONS(454),
    [anon_sym_do] = ACTIONS(454),
    [anon_sym_while] = ACTIONS(454),
    [anon_sym_break] = ACTIONS(454),
    [anon_sym_continue] = ACTIONS(454),
    [anon_sym_return] = ACTIONS(454),
    [anon_sym_yield] = ACTIONS(454),
    [anon_sym_synchronized] = ACTIONS(454),
    [anon_sym_throw] = ACTIONS(454),
    [anon_sym_try] = ACTIONS(454),
    [anon_sym_if] = ACTIONS(454),
    [anon_sym_else] = ACTIONS(454),
    [anon_sym_for] = ACTIONS(454),
    [anon_sym_AT] = ACTIONS(454),
    [anon_sym_open] = ACTIONS(454),
    [anon_sym_module] = ACTIONS(454),
    [anon_sym_static] = ACTIONS(454),
    [anon_sym_package] = ACTIONS(454),
    [anon_sym_import] = ACTIONS(454),
    [anon_sym_enum] = ACTIONS(454),
    [anon_sym_public] = ACTIONS(454),
    [anon_sym_protected] = ACTIONS(454),
    [anon_sym_private] = ACTIONS(454),
    [anon_sym_abstract] = ACTIONS(454),
    [anon_sym_strictfp] = ACTIONS(454),
    [anon_sym_native] = ACTIONS(454),
    [anon_sym_transient] = ACTIONS(454),
    [anon_sym_volatile] = ACTIONS(454),
    [anon_sym_sealed] = ACTIONS(454),
    [anon_sym_non_DASHsealed] = ACTIONS(452),
    [anon_sym_record] = ACTIONS(454),
    [anon_sym_ATinterface] = ACTIONS(452),
    [anon_sym_interface] = ACTIONS(454),
    [anon_sym_byte] = ACTIONS(454),
    [anon_sym_short] = ACTIONS(454),
    [anon_sym_int] = ACTIONS(454),
    [anon_sym_long] = ACTIONS(454),
    [anon_sym_char] = ACTIONS(454),
    [anon_sym_float] = ACTIONS(454),
    [anon_sym_double] = ACTIONS(454),
    [sym_boolean_type] = ACTIONS(454),
    [sym_void_type] = ACTIONS(454),
    [sym_this] = ACTIONS(454),
    [sym_super] = ACTIONS(454),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [146] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(545),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [147] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(546),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [148] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(633),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [149] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(659),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(456),
    [sym_identifier] = ACTIONS(458),
    [sym_decimal_integer_literal] = ACTIONS(458),
    [sym_hex_integer_literal] = ACTIONS(458),
    [sym_octal_integer_literal] = ACTIONS(458),
    [sym_binary_integer_literal] = ACTIONS(456),
    [sym_decimal_floating_point_literal] = ACTIONS(456),
    [sym_hex_floating_point_literal] = ACTIONS(458),
    [sym_true] = ACTIONS(458),
    [sym_false] = ACTIONS(458),
    [sym_character_literal] = ACTIONS(456),
    [anon_sym_DQUOTE] = ACTIONS(458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(456),
    [sym_null_literal] = ACTIONS(458),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LT] = ACTIONS(456),
    [anon_sym_PLUS] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(458),
    [anon_sym_final] = ACTIONS(458),
    [anon_sym_BANG] = ACTIONS(456),
    [anon_sym_TILDE] = ACTIONS(456),
    [anon_sym_PLUS_PLUS] = ACTIONS(456),
    [anon_sym_DASH_DASH] = ACTIONS(456),
    [anon_sym_new] = ACTIONS(458),
    [anon_sym_class] = ACTIONS(458),
    [anon_sym_switch] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(456),
    [anon_sym_RBRACE] = ACTIONS(456),
    [anon_sym_case] = ACTIONS(458),
    [anon_sym_default] = ACTIONS(458),
    [anon_sym_SEMI] = ACTIONS(456),
    [anon_sym_assert] = ACTIONS(458),
    [anon_sym_do] = ACTIONS(458),
    [anon_sym_while] = ACTIONS(458),
    [anon_sym_break] = ACTIONS(458),
    [anon_sym_continue] = ACTIONS(458),
    [anon_sym_return] = ACTIONS(458),
    [anon_sym_yield] = ACTIONS(458),
    [anon_sym_synchronized] = ACTIONS(458),
    [anon_sym_throw] = ACTIONS(458),
    [anon_sym_try] = ACTIONS(458),
    [anon_sym_if] = ACTIONS(458),
    [anon_sym_else] = ACTIONS(458),
    [anon_sym_for] = ACTIONS(458),
    [anon_sym_AT] = ACTIONS(458),
    [anon_sym_open] = ACTIONS(458),
    [anon_sym_module] = ACTIONS(458),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_package] = ACTIONS(458),
    [anon_sym_import] = ACTIONS(458),
    [anon_sym_enum] = ACTIONS(458),
    [anon_sym_public] = ACTIONS(458),
    [anon_sym_protected] = ACTIONS(458),
    [anon_sym_private] = ACTIONS(458),
    [anon_sym_abstract] = ACTIONS(458),
    [anon_sym_strictfp] = ACTIONS(458),
    [anon_sym_native] = ACTIONS(458),
    [anon_sym_transient] = ACTIONS(458),
    [anon_sym_volatile] = ACTIONS(458),
    [anon_sym_sealed] = ACTIONS(458),
    [anon_sym_non_DASHsealed] = ACTIONS(456),
    [anon_sym_record] = ACTIONS(458),
    [anon_sym_ATinterface] = ACTIONS(456),
    [anon_sym_interface] = ACTIONS(458),
    [anon_sym_byte] = ACTIONS(458),
    [anon_sym_short] = ACTIONS(458),
    [anon_sym_int] = ACTIONS(458),
    [anon_sym_long] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_float] = ACTIONS(458),
    [anon_sym_double] = ACTIONS(458),
    [sym_boolean_type] = ACTIONS(458),
    [sym_void_type] = ACTIONS(458),
    [sym_this] = ACTIONS(458),
    [sym_super] = ACTIONS(458),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(460),
    [sym_identifier] = ACTIONS(462),
    [sym_decimal_integer_literal] = ACTIONS(462),
    [sym_hex_integer_literal] = ACTIONS(462),
    [sym_octal_integer_literal] = ACTIONS(462),
    [sym_binary_integer_literal] = ACTIONS(460),
    [sym_decimal_floating_point_literal] = ACTIONS(460),
    [sym_hex_floating_point_literal] = ACTIONS(462),
    [sym_true] = ACTIONS(462),
    [sym_false] = ACTIONS(462),
    [sym_character_literal] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(460),
    [sym_null_literal] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(460),
    [anon_sym_LT] = ACTIONS(460),
    [anon_sym_PLUS] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(462),
    [anon_sym_final] = ACTIONS(462),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_TILDE] = ACTIONS(460),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_class] = ACTIONS(462),
    [anon_sym_switch] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_RBRACE] = ACTIONS(460),
    [anon_sym_case] = ACTIONS(462),
    [anon_sym_default] = ACTIONS(462),
    [anon_sym_SEMI] = ACTIONS(460),
    [anon_sym_assert] = ACTIONS(462),
    [anon_sym_do] = ACTIONS(462),
    [anon_sym_while] = ACTIONS(462),
    [anon_sym_break] = ACTIONS(462),
    [anon_sym_continue] = ACTIONS(462),
    [anon_sym_return] = ACTIONS(462),
    [anon_sym_yield] = ACTIONS(462),
    [anon_sym_synchronized] = ACTIONS(462),
    [anon_sym_throw] = ACTIONS(462),
    [anon_sym_try] = ACTIONS(462),
    [anon_sym_if] = ACTIONS(462),
    [anon_sym_else] = ACTIONS(462),
    [anon_sym_for] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_open] = ACTIONS(462),
    [anon_sym_module] = ACTIONS(462),
    [anon_sym_static] = ACTIONS(462),
    [anon_sym_package] = ACTIONS(462),
    [anon_sym_import] = ACTIONS(462),
    [anon_sym_enum] = ACTIONS(462),
    [anon_sym_public] = ACTIONS(462),
    [anon_sym_protected] = ACTIONS(462),
    [anon_sym_private] = ACTIONS(462),
    [anon_sym_abstract] = ACTIONS(462),
    [anon_sym_strictfp] = ACTIONS(462),
    [anon_sym_native] = ACTIONS(462),
    [anon_sym_transient] = ACTIONS(462),
    [anon_sym_volatile] = ACTIONS(462),
    [anon_sym_sealed] = ACTIONS(462),
    [anon_sym_non_DASHsealed] = ACTIONS(460),
    [anon_sym_record] = ACTIONS(462),
    [anon_sym_ATinterface] = ACTIONS(460),
    [anon_sym_interface] = ACTIONS(462),
    [anon_sym_byte] = ACTIONS(462),
    [anon_sym_short] = ACTIONS(462),
    [anon_sym_int] = ACTIONS(462),
    [anon_sym_long] = ACTIONS(462),
    [anon_sym_char] = ACTIONS(462),
    [anon_sym_float] = ACTIONS(462),
    [anon_sym_double] = ACTIONS(462),
    [sym_boolean_type] = ACTIONS(462),
    [sym_void_type] = ACTIONS(462),
    [sym_this] = ACTIONS(462),
    [sym_super] = ACTIONS(462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [152] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(634),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [153] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(553),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [154] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(631),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [155] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(541),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(464),
    [sym_identifier] = ACTIONS(466),
    [sym_decimal_integer_literal] = ACTIONS(466),
    [sym_hex_integer_literal] = ACTIONS(466),
    [sym_octal_integer_literal] = ACTIONS(466),
    [sym_binary_integer_literal] = ACTIONS(464),
    [sym_decimal_floating_point_literal] = ACTIONS(464),
    [sym_hex_floating_point_literal] = ACTIONS(466),
    [sym_true] = ACTIONS(466),
    [sym_false] = ACTIONS(466),
    [sym_character_literal] = ACTIONS(464),
    [anon_sym_DQUOTE] = ACTIONS(466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(464),
    [sym_null_literal] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(466),
    [anon_sym_final] = ACTIONS(466),
    [anon_sym_BANG] = ACTIONS(464),
    [anon_sym_TILDE] = ACTIONS(464),
    [anon_sym_PLUS_PLUS] = ACTIONS(464),
    [anon_sym_DASH_DASH] = ACTIONS(464),
    [anon_sym_new] = ACTIONS(466),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_switch] = ACTIONS(466),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_case] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(466),
    [anon_sym_SEMI] = ACTIONS(464),
    [anon_sym_assert] = ACTIONS(466),
    [anon_sym_do] = ACTIONS(466),
    [anon_sym_while] = ACTIONS(466),
    [anon_sym_break] = ACTIONS(466),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_return] = ACTIONS(466),
    [anon_sym_yield] = ACTIONS(466),
    [anon_sym_synchronized] = ACTIONS(466),
    [anon_sym_throw] = ACTIONS(466),
    [anon_sym_try] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(466),
    [anon_sym_else] = ACTIONS(466),
    [anon_sym_for] = ACTIONS(466),
    [anon_sym_AT] = ACTIONS(466),
    [anon_sym_open] = ACTIONS(466),
    [anon_sym_module] = ACTIONS(466),
    [anon_sym_static] = ACTIONS(466),
    [anon_sym_package] = ACTIONS(466),
    [anon_sym_import] = ACTIONS(466),
    [anon_sym_enum] = ACTIONS(466),
    [anon_sym_public] = ACTIONS(466),
    [anon_sym_protected] = ACTIONS(466),
    [anon_sym_private] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(466),
    [anon_sym_strictfp] = ACTIONS(466),
    [anon_sym_native] = ACTIONS(466),
    [anon_sym_transient] = ACTIONS(466),
    [anon_sym_volatile] = ACTIONS(466),
    [anon_sym_sealed] = ACTIONS(466),
    [anon_sym_non_DASHsealed] = ACTIONS(464),
    [anon_sym_record] = ACTIONS(466),
    [anon_sym_ATinterface] = ACTIONS(464),
    [anon_sym_interface] = ACTIONS(466),
    [anon_sym_byte] = ACTIONS(466),
    [anon_sym_short] = ACTIONS(466),
    [anon_sym_int] = ACTIONS(466),
    [anon_sym_long] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_float] = ACTIONS(466),
    [anon_sym_double] = ACTIONS(466),
    [sym_boolean_type] = ACTIONS(466),
    [sym_void_type] = ACTIONS(466),
    [sym_this] = ACTIONS(466),
    [sym_super] = ACTIONS(466),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [157] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(556),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(468),
    [sym_identifier] = ACTIONS(470),
    [sym_decimal_integer_literal] = ACTIONS(470),
    [sym_hex_integer_literal] = ACTIONS(470),
    [sym_octal_integer_literal] = ACTIONS(470),
    [sym_binary_integer_literal] = ACTIONS(468),
    [sym_decimal_floating_point_literal] = ACTIONS(468),
    [sym_hex_floating_point_literal] = ACTIONS(470),
    [sym_true] = ACTIONS(470),
    [sym_false] = ACTIONS(470),
    [sym_character_literal] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(468),
    [sym_null_literal] = ACTIONS(470),
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(470),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_final] = ACTIONS(470),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_TILDE] = ACTIONS(468),
    [anon_sym_PLUS_PLUS] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(468),
    [anon_sym_new] = ACTIONS(470),
    [anon_sym_class] = ACTIONS(470),
    [anon_sym_switch] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(468),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_case] = ACTIONS(470),
    [anon_sym_default] = ACTIONS(470),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_assert] = ACTIONS(470),
    [anon_sym_do] = ACTIONS(470),
    [anon_sym_while] = ACTIONS(470),
    [anon_sym_break] = ACTIONS(470),
    [anon_sym_continue] = ACTIONS(470),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_yield] = ACTIONS(470),
    [anon_sym_synchronized] = ACTIONS(470),
    [anon_sym_throw] = ACTIONS(470),
    [anon_sym_try] = ACTIONS(470),
    [anon_sym_if] = ACTIONS(470),
    [anon_sym_else] = ACTIONS(470),
    [anon_sym_for] = ACTIONS(470),
    [anon_sym_AT] = ACTIONS(470),
    [anon_sym_open] = ACTIONS(470),
    [anon_sym_module] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(470),
    [anon_sym_package] = ACTIONS(470),
    [anon_sym_import] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(470),
    [anon_sym_public] = ACTIONS(470),
    [anon_sym_protected] = ACTIONS(470),
    [anon_sym_private] = ACTIONS(470),
    [anon_sym_abstract] = ACTIONS(470),
    [anon_sym_strictfp] = ACTIONS(470),
    [anon_sym_native] = ACTIONS(470),
    [anon_sym_transient] = ACTIONS(470),
    [anon_sym_volatile] = ACTIONS(470),
    [anon_sym_sealed] = ACTIONS(470),
    [anon_sym_non_DASHsealed] = ACTIONS(468),
    [anon_sym_record] = ACTIONS(470),
    [anon_sym_ATinterface] = ACTIONS(468),
    [anon_sym_interface] = ACTIONS(470),
    [anon_sym_byte] = ACTIONS(470),
    [anon_sym_short] = ACTIONS(470),
    [anon_sym_int] = ACTIONS(470),
    [anon_sym_long] = ACTIONS(470),
    [anon_sym_char] = ACTIONS(470),
    [anon_sym_float] = ACTIONS(470),
    [anon_sym_double] = ACTIONS(470),
    [sym_boolean_type] = ACTIONS(470),
    [sym_void_type] = ACTIONS(470),
    [sym_this] = ACTIONS(470),
    [sym_super] = ACTIONS(470),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(472),
    [sym_identifier] = ACTIONS(474),
    [sym_decimal_integer_literal] = ACTIONS(474),
    [sym_hex_integer_literal] = ACTIONS(474),
    [sym_octal_integer_literal] = ACTIONS(474),
    [sym_binary_integer_literal] = ACTIONS(472),
    [sym_decimal_floating_point_literal] = ACTIONS(472),
    [sym_hex_floating_point_literal] = ACTIONS(474),
    [sym_true] = ACTIONS(474),
    [sym_false] = ACTIONS(474),
    [sym_character_literal] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(472),
    [sym_null_literal] = ACTIONS(474),
    [anon_sym_LPAREN] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(474),
    [anon_sym_final] = ACTIONS(474),
    [anon_sym_BANG] = ACTIONS(472),
    [anon_sym_TILDE] = ACTIONS(472),
    [anon_sym_PLUS_PLUS] = ACTIONS(472),
    [anon_sym_DASH_DASH] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(474),
    [anon_sym_class] = ACTIONS(474),
    [anon_sym_switch] = ACTIONS(474),
    [anon_sym_LBRACE] = ACTIONS(472),
    [anon_sym_RBRACE] = ACTIONS(472),
    [anon_sym_case] = ACTIONS(474),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_SEMI] = ACTIONS(472),
    [anon_sym_assert] = ACTIONS(474),
    [anon_sym_do] = ACTIONS(474),
    [anon_sym_while] = ACTIONS(474),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_continue] = ACTIONS(474),
    [anon_sym_return] = ACTIONS(474),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_synchronized] = ACTIONS(474),
    [anon_sym_throw] = ACTIONS(474),
    [anon_sym_try] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(474),
    [anon_sym_else] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(474),
    [anon_sym_AT] = ACTIONS(474),
    [anon_sym_open] = ACTIONS(474),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(474),
    [anon_sym_package] = ACTIONS(474),
    [anon_sym_import] = ACTIONS(474),
    [anon_sym_enum] = ACTIONS(474),
    [anon_sym_public] = ACTIONS(474),
    [anon_sym_protected] = ACTIONS(474),
    [anon_sym_private] = ACTIONS(474),
    [anon_sym_abstract] = ACTIONS(474),
    [anon_sym_strictfp] = ACTIONS(474),
    [anon_sym_native] = ACTIONS(474),
    [anon_sym_transient] = ACTIONS(474),
    [anon_sym_volatile] = ACTIONS(474),
    [anon_sym_sealed] = ACTIONS(474),
    [anon_sym_non_DASHsealed] = ACTIONS(472),
    [anon_sym_record] = ACTIONS(474),
    [anon_sym_ATinterface] = ACTIONS(472),
    [anon_sym_interface] = ACTIONS(474),
    [anon_sym_byte] = ACTIONS(474),
    [anon_sym_short] = ACTIONS(474),
    [anon_sym_int] = ACTIONS(474),
    [anon_sym_long] = ACTIONS(474),
    [anon_sym_char] = ACTIONS(474),
    [anon_sym_float] = ACTIONS(474),
    [anon_sym_double] = ACTIONS(474),
    [sym_boolean_type] = ACTIONS(474),
    [sym_void_type] = ACTIONS(474),
    [sym_this] = ACTIONS(474),
    [sym_super] = ACTIONS(474),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [160] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(552),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [161] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(579),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [162] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(664),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [163] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(584),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [164] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(547),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [165] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(558),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [166] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(550),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [167] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(608),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(476),
    [sym_identifier] = ACTIONS(478),
    [sym_decimal_integer_literal] = ACTIONS(478),
    [sym_hex_integer_literal] = ACTIONS(478),
    [sym_octal_integer_literal] = ACTIONS(478),
    [sym_binary_integer_literal] = ACTIONS(476),
    [sym_decimal_floating_point_literal] = ACTIONS(476),
    [sym_hex_floating_point_literal] = ACTIONS(478),
    [sym_true] = ACTIONS(478),
    [sym_false] = ACTIONS(478),
    [sym_character_literal] = ACTIONS(476),
    [anon_sym_DQUOTE] = ACTIONS(478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(476),
    [sym_null_literal] = ACTIONS(478),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_final] = ACTIONS(478),
    [anon_sym_BANG] = ACTIONS(476),
    [anon_sym_TILDE] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(476),
    [anon_sym_DASH_DASH] = ACTIONS(476),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_class] = ACTIONS(478),
    [anon_sym_switch] = ACTIONS(478),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_RBRACE] = ACTIONS(476),
    [anon_sym_case] = ACTIONS(478),
    [anon_sym_default] = ACTIONS(478),
    [anon_sym_SEMI] = ACTIONS(476),
    [anon_sym_assert] = ACTIONS(478),
    [anon_sym_do] = ACTIONS(478),
    [anon_sym_while] = ACTIONS(478),
    [anon_sym_break] = ACTIONS(478),
    [anon_sym_continue] = ACTIONS(478),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_yield] = ACTIONS(478),
    [anon_sym_synchronized] = ACTIONS(478),
    [anon_sym_throw] = ACTIONS(478),
    [anon_sym_try] = ACTIONS(478),
    [anon_sym_if] = ACTIONS(478),
    [anon_sym_else] = ACTIONS(478),
    [anon_sym_for] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(478),
    [anon_sym_open] = ACTIONS(478),
    [anon_sym_module] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_package] = ACTIONS(478),
    [anon_sym_import] = ACTIONS(478),
    [anon_sym_enum] = ACTIONS(478),
    [anon_sym_public] = ACTIONS(478),
    [anon_sym_protected] = ACTIONS(478),
    [anon_sym_private] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(478),
    [anon_sym_strictfp] = ACTIONS(478),
    [anon_sym_native] = ACTIONS(478),
    [anon_sym_transient] = ACTIONS(478),
    [anon_sym_volatile] = ACTIONS(478),
    [anon_sym_sealed] = ACTIONS(478),
    [anon_sym_non_DASHsealed] = ACTIONS(476),
    [anon_sym_record] = ACTIONS(478),
    [anon_sym_ATinterface] = ACTIONS(476),
    [anon_sym_interface] = ACTIONS(478),
    [anon_sym_byte] = ACTIONS(478),
    [anon_sym_short] = ACTIONS(478),
    [anon_sym_int] = ACTIONS(478),
    [anon_sym_long] = ACTIONS(478),
    [anon_sym_char] = ACTIONS(478),
    [anon_sym_float] = ACTIONS(478),
    [anon_sym_double] = ACTIONS(478),
    [sym_boolean_type] = ACTIONS(478),
    [sym_void_type] = ACTIONS(478),
    [sym_this] = ACTIONS(478),
    [sym_super] = ACTIONS(478),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(480),
    [sym_identifier] = ACTIONS(482),
    [sym_decimal_integer_literal] = ACTIONS(482),
    [sym_hex_integer_literal] = ACTIONS(482),
    [sym_octal_integer_literal] = ACTIONS(482),
    [sym_binary_integer_literal] = ACTIONS(480),
    [sym_decimal_floating_point_literal] = ACTIONS(480),
    [sym_hex_floating_point_literal] = ACTIONS(482),
    [sym_true] = ACTIONS(482),
    [sym_false] = ACTIONS(482),
    [sym_character_literal] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(480),
    [sym_null_literal] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(480),
    [anon_sym_PLUS] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(482),
    [anon_sym_final] = ACTIONS(482),
    [anon_sym_BANG] = ACTIONS(480),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_new] = ACTIONS(482),
    [anon_sym_class] = ACTIONS(482),
    [anon_sym_switch] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(480),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_case] = ACTIONS(482),
    [anon_sym_default] = ACTIONS(482),
    [anon_sym_SEMI] = ACTIONS(480),
    [anon_sym_assert] = ACTIONS(482),
    [anon_sym_do] = ACTIONS(482),
    [anon_sym_while] = ACTIONS(482),
    [anon_sym_break] = ACTIONS(482),
    [anon_sym_continue] = ACTIONS(482),
    [anon_sym_return] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_synchronized] = ACTIONS(482),
    [anon_sym_throw] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(482),
    [anon_sym_else] = ACTIONS(482),
    [anon_sym_for] = ACTIONS(482),
    [anon_sym_AT] = ACTIONS(482),
    [anon_sym_open] = ACTIONS(482),
    [anon_sym_module] = ACTIONS(482),
    [anon_sym_static] = ACTIONS(482),
    [anon_sym_package] = ACTIONS(482),
    [anon_sym_import] = ACTIONS(482),
    [anon_sym_enum] = ACTIONS(482),
    [anon_sym_public] = ACTIONS(482),
    [anon_sym_protected] = ACTIONS(482),
    [anon_sym_private] = ACTIONS(482),
    [anon_sym_abstract] = ACTIONS(482),
    [anon_sym_strictfp] = ACTIONS(482),
    [anon_sym_native] = ACTIONS(482),
    [anon_sym_transient] = ACTIONS(482),
    [anon_sym_volatile] = ACTIONS(482),
    [anon_sym_sealed] = ACTIONS(482),
    [anon_sym_non_DASHsealed] = ACTIONS(480),
    [anon_sym_record] = ACTIONS(482),
    [anon_sym_ATinterface] = ACTIONS(480),
    [anon_sym_interface] = ACTIONS(482),
    [anon_sym_byte] = ACTIONS(482),
    [anon_sym_short] = ACTIONS(482),
    [anon_sym_int] = ACTIONS(482),
    [anon_sym_long] = ACTIONS(482),
    [anon_sym_char] = ACTIONS(482),
    [anon_sym_float] = ACTIONS(482),
    [anon_sym_double] = ACTIONS(482),
    [sym_boolean_type] = ACTIONS(482),
    [sym_void_type] = ACTIONS(482),
    [sym_this] = ACTIONS(482),
    [sym_super] = ACTIONS(482),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [170] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(598),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(484),
    [sym_identifier] = ACTIONS(486),
    [sym_decimal_integer_literal] = ACTIONS(486),
    [sym_hex_integer_literal] = ACTIONS(486),
    [sym_octal_integer_literal] = ACTIONS(486),
    [sym_binary_integer_literal] = ACTIONS(484),
    [sym_decimal_floating_point_literal] = ACTIONS(484),
    [sym_hex_floating_point_literal] = ACTIONS(486),
    [sym_true] = ACTIONS(486),
    [sym_false] = ACTIONS(486),
    [sym_character_literal] = ACTIONS(484),
    [anon_sym_DQUOTE] = ACTIONS(486),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(484),
    [sym_null_literal] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_LT] = ACTIONS(484),
    [anon_sym_PLUS] = ACTIONS(486),
    [anon_sym_DASH] = ACTIONS(486),
    [anon_sym_final] = ACTIONS(486),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(484),
    [anon_sym_DASH_DASH] = ACTIONS(484),
    [anon_sym_new] = ACTIONS(486),
    [anon_sym_class] = ACTIONS(486),
    [anon_sym_switch] = ACTIONS(486),
    [anon_sym_LBRACE] = ACTIONS(484),
    [anon_sym_RBRACE] = ACTIONS(484),
    [anon_sym_case] = ACTIONS(486),
    [anon_sym_default] = ACTIONS(486),
    [anon_sym_SEMI] = ACTIONS(484),
    [anon_sym_assert] = ACTIONS(486),
    [anon_sym_do] = ACTIONS(486),
    [anon_sym_while] = ACTIONS(486),
    [anon_sym_break] = ACTIONS(486),
    [anon_sym_continue] = ACTIONS(486),
    [anon_sym_return] = ACTIONS(486),
    [anon_sym_yield] = ACTIONS(486),
    [anon_sym_synchronized] = ACTIONS(486),
    [anon_sym_throw] = ACTIONS(486),
    [anon_sym_try] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(486),
    [anon_sym_else] = ACTIONS(486),
    [anon_sym_for] = ACTIONS(486),
    [anon_sym_AT] = ACTIONS(486),
    [anon_sym_open] = ACTIONS(486),
    [anon_sym_module] = ACTIONS(486),
    [anon_sym_static] = ACTIONS(486),
    [anon_sym_package] = ACTIONS(486),
    [anon_sym_import] = ACTIONS(486),
    [anon_sym_enum] = ACTIONS(486),
    [anon_sym_public] = ACTIONS(486),
    [anon_sym_protected] = ACTIONS(486),
    [anon_sym_private] = ACTIONS(486),
    [anon_sym_abstract] = ACTIONS(486),
    [anon_sym_strictfp] = ACTIONS(486),
    [anon_sym_native] = ACTIONS(486),
    [anon_sym_transient] = ACTIONS(486),
    [anon_sym_volatile] = ACTIONS(486),
    [anon_sym_sealed] = ACTIONS(486),
    [anon_sym_non_DASHsealed] = ACTIONS(484),
    [anon_sym_record] = ACTIONS(486),
    [anon_sym_ATinterface] = ACTIONS(484),
    [anon_sym_interface] = ACTIONS(486),
    [anon_sym_byte] = ACTIONS(486),
    [anon_sym_short] = ACTIONS(486),
    [anon_sym_int] = ACTIONS(486),
    [anon_sym_long] = ACTIONS(486),
    [anon_sym_char] = ACTIONS(486),
    [anon_sym_float] = ACTIONS(486),
    [anon_sym_double] = ACTIONS(486),
    [sym_boolean_type] = ACTIONS(486),
    [sym_void_type] = ACTIONS(486),
    [sym_this] = ACTIONS(486),
    [sym_super] = ACTIONS(486),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [172] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(554),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(488),
    [sym_identifier] = ACTIONS(490),
    [sym_decimal_integer_literal] = ACTIONS(490),
    [sym_hex_integer_literal] = ACTIONS(490),
    [sym_octal_integer_literal] = ACTIONS(490),
    [sym_binary_integer_literal] = ACTIONS(488),
    [sym_decimal_floating_point_literal] = ACTIONS(488),
    [sym_hex_floating_point_literal] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_character_literal] = ACTIONS(488),
    [anon_sym_DQUOTE] = ACTIONS(490),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(488),
    [sym_null_literal] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_final] = ACTIONS(490),
    [anon_sym_BANG] = ACTIONS(488),
    [anon_sym_TILDE] = ACTIONS(488),
    [anon_sym_PLUS_PLUS] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(488),
    [anon_sym_new] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(490),
    [anon_sym_switch] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [anon_sym_case] = ACTIONS(490),
    [anon_sym_default] = ACTIONS(490),
    [anon_sym_SEMI] = ACTIONS(488),
    [anon_sym_assert] = ACTIONS(490),
    [anon_sym_do] = ACTIONS(490),
    [anon_sym_while] = ACTIONS(490),
    [anon_sym_break] = ACTIONS(490),
    [anon_sym_continue] = ACTIONS(490),
    [anon_sym_return] = ACTIONS(490),
    [anon_sym_yield] = ACTIONS(490),
    [anon_sym_synchronized] = ACTIONS(490),
    [anon_sym_throw] = ACTIONS(490),
    [anon_sym_try] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(490),
    [anon_sym_else] = ACTIONS(490),
    [anon_sym_for] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(490),
    [anon_sym_open] = ACTIONS(490),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_static] = ACTIONS(490),
    [anon_sym_package] = ACTIONS(490),
    [anon_sym_import] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(490),
    [anon_sym_public] = ACTIONS(490),
    [anon_sym_protected] = ACTIONS(490),
    [anon_sym_private] = ACTIONS(490),
    [anon_sym_abstract] = ACTIONS(490),
    [anon_sym_strictfp] = ACTIONS(490),
    [anon_sym_native] = ACTIONS(490),
    [anon_sym_transient] = ACTIONS(490),
    [anon_sym_volatile] = ACTIONS(490),
    [anon_sym_sealed] = ACTIONS(490),
    [anon_sym_non_DASHsealed] = ACTIONS(488),
    [anon_sym_record] = ACTIONS(490),
    [anon_sym_ATinterface] = ACTIONS(488),
    [anon_sym_interface] = ACTIONS(490),
    [anon_sym_byte] = ACTIONS(490),
    [anon_sym_short] = ACTIONS(490),
    [anon_sym_int] = ACTIONS(490),
    [anon_sym_long] = ACTIONS(490),
    [anon_sym_char] = ACTIONS(490),
    [anon_sym_float] = ACTIONS(490),
    [anon_sym_double] = ACTIONS(490),
    [sym_boolean_type] = ACTIONS(490),
    [sym_void_type] = ACTIONS(490),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(492),
    [sym_identifier] = ACTIONS(494),
    [sym_decimal_integer_literal] = ACTIONS(494),
    [sym_hex_integer_literal] = ACTIONS(494),
    [sym_octal_integer_literal] = ACTIONS(494),
    [sym_binary_integer_literal] = ACTIONS(492),
    [sym_decimal_floating_point_literal] = ACTIONS(492),
    [sym_hex_floating_point_literal] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_character_literal] = ACTIONS(492),
    [anon_sym_DQUOTE] = ACTIONS(494),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(492),
    [sym_null_literal] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_final] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_TILDE] = ACTIONS(492),
    [anon_sym_PLUS_PLUS] = ACTIONS(492),
    [anon_sym_DASH_DASH] = ACTIONS(492),
    [anon_sym_new] = ACTIONS(494),
    [anon_sym_class] = ACTIONS(494),
    [anon_sym_switch] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(492),
    [anon_sym_RBRACE] = ACTIONS(492),
    [anon_sym_case] = ACTIONS(494),
    [anon_sym_default] = ACTIONS(494),
    [anon_sym_SEMI] = ACTIONS(492),
    [anon_sym_assert] = ACTIONS(494),
    [anon_sym_do] = ACTIONS(494),
    [anon_sym_while] = ACTIONS(494),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_continue] = ACTIONS(494),
    [anon_sym_return] = ACTIONS(494),
    [anon_sym_yield] = ACTIONS(494),
    [anon_sym_synchronized] = ACTIONS(494),
    [anon_sym_throw] = ACTIONS(494),
    [anon_sym_try] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(494),
    [anon_sym_open] = ACTIONS(494),
    [anon_sym_module] = ACTIONS(494),
    [anon_sym_static] = ACTIONS(494),
    [anon_sym_package] = ACTIONS(494),
    [anon_sym_import] = ACTIONS(494),
    [anon_sym_enum] = ACTIONS(494),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_abstract] = ACTIONS(494),
    [anon_sym_strictfp] = ACTIONS(494),
    [anon_sym_native] = ACTIONS(494),
    [anon_sym_transient] = ACTIONS(494),
    [anon_sym_volatile] = ACTIONS(494),
    [anon_sym_sealed] = ACTIONS(494),
    [anon_sym_non_DASHsealed] = ACTIONS(492),
    [anon_sym_record] = ACTIONS(494),
    [anon_sym_ATinterface] = ACTIONS(492),
    [anon_sym_interface] = ACTIONS(494),
    [anon_sym_byte] = ACTIONS(494),
    [anon_sym_short] = ACTIONS(494),
    [anon_sym_int] = ACTIONS(494),
    [anon_sym_long] = ACTIONS(494),
    [anon_sym_char] = ACTIONS(494),
    [anon_sym_float] = ACTIONS(494),
    [anon_sym_double] = ACTIONS(494),
    [sym_boolean_type] = ACTIONS(494),
    [sym_void_type] = ACTIONS(494),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(496),
    [sym_identifier] = ACTIONS(498),
    [sym_decimal_integer_literal] = ACTIONS(498),
    [sym_hex_integer_literal] = ACTIONS(498),
    [sym_octal_integer_literal] = ACTIONS(498),
    [sym_binary_integer_literal] = ACTIONS(496),
    [sym_decimal_floating_point_literal] = ACTIONS(496),
    [sym_hex_floating_point_literal] = ACTIONS(498),
    [sym_true] = ACTIONS(498),
    [sym_false] = ACTIONS(498),
    [sym_character_literal] = ACTIONS(496),
    [anon_sym_DQUOTE] = ACTIONS(498),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(496),
    [sym_null_literal] = ACTIONS(498),
    [anon_sym_LPAREN] = ACTIONS(496),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_final] = ACTIONS(498),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_PLUS_PLUS] = ACTIONS(496),
    [anon_sym_DASH_DASH] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(498),
    [anon_sym_class] = ACTIONS(498),
    [anon_sym_switch] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(496),
    [anon_sym_case] = ACTIONS(498),
    [anon_sym_default] = ACTIONS(498),
    [anon_sym_SEMI] = ACTIONS(496),
    [anon_sym_assert] = ACTIONS(498),
    [anon_sym_do] = ACTIONS(498),
    [anon_sym_while] = ACTIONS(498),
    [anon_sym_break] = ACTIONS(498),
    [anon_sym_continue] = ACTIONS(498),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_yield] = ACTIONS(498),
    [anon_sym_synchronized] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(498),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_else] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(498),
    [anon_sym_AT] = ACTIONS(498),
    [anon_sym_open] = ACTIONS(498),
    [anon_sym_module] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(498),
    [anon_sym_package] = ACTIONS(498),
    [anon_sym_import] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(498),
    [anon_sym_public] = ACTIONS(498),
    [anon_sym_protected] = ACTIONS(498),
    [anon_sym_private] = ACTIONS(498),
    [anon_sym_abstract] = ACTIONS(498),
    [anon_sym_strictfp] = ACTIONS(498),
    [anon_sym_native] = ACTIONS(498),
    [anon_sym_transient] = ACTIONS(498),
    [anon_sym_volatile] = ACTIONS(498),
    [anon_sym_sealed] = ACTIONS(498),
    [anon_sym_non_DASHsealed] = ACTIONS(496),
    [anon_sym_record] = ACTIONS(498),
    [anon_sym_ATinterface] = ACTIONS(496),
    [anon_sym_interface] = ACTIONS(498),
    [anon_sym_byte] = ACTIONS(498),
    [anon_sym_short] = ACTIONS(498),
    [anon_sym_int] = ACTIONS(498),
    [anon_sym_long] = ACTIONS(498),
    [anon_sym_char] = ACTIONS(498),
    [anon_sym_float] = ACTIONS(498),
    [anon_sym_double] = ACTIONS(498),
    [sym_boolean_type] = ACTIONS(498),
    [sym_void_type] = ACTIONS(498),
    [sym_this] = ACTIONS(498),
    [sym_super] = ACTIONS(498),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(500),
    [sym_identifier] = ACTIONS(502),
    [sym_decimal_integer_literal] = ACTIONS(502),
    [sym_hex_integer_literal] = ACTIONS(502),
    [sym_octal_integer_literal] = ACTIONS(502),
    [sym_binary_integer_literal] = ACTIONS(500),
    [sym_decimal_floating_point_literal] = ACTIONS(500),
    [sym_hex_floating_point_literal] = ACTIONS(502),
    [sym_true] = ACTIONS(502),
    [sym_false] = ACTIONS(502),
    [sym_character_literal] = ACTIONS(500),
    [anon_sym_DQUOTE] = ACTIONS(502),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(500),
    [sym_null_literal] = ACTIONS(502),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(502),
    [anon_sym_final] = ACTIONS(502),
    [anon_sym_BANG] = ACTIONS(500),
    [anon_sym_TILDE] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(500),
    [anon_sym_DASH_DASH] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_class] = ACTIONS(502),
    [anon_sym_switch] = ACTIONS(502),
    [anon_sym_LBRACE] = ACTIONS(500),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_case] = ACTIONS(502),
    [anon_sym_default] = ACTIONS(502),
    [anon_sym_SEMI] = ACTIONS(500),
    [anon_sym_assert] = ACTIONS(502),
    [anon_sym_do] = ACTIONS(502),
    [anon_sym_while] = ACTIONS(502),
    [anon_sym_break] = ACTIONS(502),
    [anon_sym_continue] = ACTIONS(502),
    [anon_sym_return] = ACTIONS(502),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_synchronized] = ACTIONS(502),
    [anon_sym_throw] = ACTIONS(502),
    [anon_sym_try] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_else] = ACTIONS(502),
    [anon_sym_for] = ACTIONS(502),
    [anon_sym_AT] = ACTIONS(502),
    [anon_sym_open] = ACTIONS(502),
    [anon_sym_module] = ACTIONS(502),
    [anon_sym_static] = ACTIONS(502),
    [anon_sym_package] = ACTIONS(502),
    [anon_sym_import] = ACTIONS(502),
    [anon_sym_enum] = ACTIONS(502),
    [anon_sym_public] = ACTIONS(502),
    [anon_sym_protected] = ACTIONS(502),
    [anon_sym_private] = ACTIONS(502),
    [anon_sym_abstract] = ACTIONS(502),
    [anon_sym_strictfp] = ACTIONS(502),
    [anon_sym_native] = ACTIONS(502),
    [anon_sym_transient] = ACTIONS(502),
    [anon_sym_volatile] = ACTIONS(502),
    [anon_sym_sealed] = ACTIONS(502),
    [anon_sym_non_DASHsealed] = ACTIONS(500),
    [anon_sym_record] = ACTIONS(502),
    [anon_sym_ATinterface] = ACTIONS(500),
    [anon_sym_interface] = ACTIONS(502),
    [anon_sym_byte] = ACTIONS(502),
    [anon_sym_short] = ACTIONS(502),
    [anon_sym_int] = ACTIONS(502),
    [anon_sym_long] = ACTIONS(502),
    [anon_sym_char] = ACTIONS(502),
    [anon_sym_float] = ACTIONS(502),
    [anon_sym_double] = ACTIONS(502),
    [sym_boolean_type] = ACTIONS(502),
    [sym_void_type] = ACTIONS(502),
    [sym_this] = ACTIONS(502),
    [sym_super] = ACTIONS(502),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(504),
    [sym_identifier] = ACTIONS(506),
    [sym_decimal_integer_literal] = ACTIONS(506),
    [sym_hex_integer_literal] = ACTIONS(506),
    [sym_octal_integer_literal] = ACTIONS(506),
    [sym_binary_integer_literal] = ACTIONS(504),
    [sym_decimal_floating_point_literal] = ACTIONS(504),
    [sym_hex_floating_point_literal] = ACTIONS(506),
    [sym_true] = ACTIONS(506),
    [sym_false] = ACTIONS(506),
    [sym_character_literal] = ACTIONS(504),
    [anon_sym_DQUOTE] = ACTIONS(506),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(504),
    [sym_null_literal] = ACTIONS(506),
    [anon_sym_LPAREN] = ACTIONS(504),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_PLUS] = ACTIONS(506),
    [anon_sym_DASH] = ACTIONS(506),
    [anon_sym_final] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(504),
    [anon_sym_TILDE] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_new] = ACTIONS(506),
    [anon_sym_class] = ACTIONS(506),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_LBRACE] = ACTIONS(504),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_case] = ACTIONS(506),
    [anon_sym_default] = ACTIONS(506),
    [anon_sym_SEMI] = ACTIONS(504),
    [anon_sym_assert] = ACTIONS(506),
    [anon_sym_do] = ACTIONS(506),
    [anon_sym_while] = ACTIONS(506),
    [anon_sym_break] = ACTIONS(506),
    [anon_sym_continue] = ACTIONS(506),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_yield] = ACTIONS(506),
    [anon_sym_synchronized] = ACTIONS(506),
    [anon_sym_throw] = ACTIONS(506),
    [anon_sym_try] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(506),
    [anon_sym_else] = ACTIONS(506),
    [anon_sym_for] = ACTIONS(506),
    [anon_sym_AT] = ACTIONS(506),
    [anon_sym_open] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(506),
    [anon_sym_enum] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_abstract] = ACTIONS(506),
    [anon_sym_strictfp] = ACTIONS(506),
    [anon_sym_native] = ACTIONS(506),
    [anon_sym_transient] = ACTIONS(506),
    [anon_sym_volatile] = ACTIONS(506),
    [anon_sym_sealed] = ACTIONS(506),
    [anon_sym_non_DASHsealed] = ACTIONS(504),
    [anon_sym_record] = ACTIONS(506),
    [anon_sym_ATinterface] = ACTIONS(504),
    [anon_sym_interface] = ACTIONS(506),
    [anon_sym_byte] = ACTIONS(506),
    [anon_sym_short] = ACTIONS(506),
    [anon_sym_int] = ACTIONS(506),
    [anon_sym_long] = ACTIONS(506),
    [anon_sym_char] = ACTIONS(506),
    [anon_sym_float] = ACTIONS(506),
    [anon_sym_double] = ACTIONS(506),
    [sym_boolean_type] = ACTIONS(506),
    [sym_void_type] = ACTIONS(506),
    [sym_this] = ACTIONS(506),
    [sym_super] = ACTIONS(506),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [178] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(562),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [179] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(622),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(508),
    [sym_identifier] = ACTIONS(510),
    [sym_decimal_integer_literal] = ACTIONS(510),
    [sym_hex_integer_literal] = ACTIONS(510),
    [sym_octal_integer_literal] = ACTIONS(510),
    [sym_binary_integer_literal] = ACTIONS(508),
    [sym_decimal_floating_point_literal] = ACTIONS(508),
    [sym_hex_floating_point_literal] = ACTIONS(510),
    [sym_true] = ACTIONS(510),
    [sym_false] = ACTIONS(510),
    [sym_character_literal] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(508),
    [sym_null_literal] = ACTIONS(510),
    [anon_sym_LPAREN] = ACTIONS(508),
    [anon_sym_LT] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(510),
    [anon_sym_DASH] = ACTIONS(510),
    [anon_sym_final] = ACTIONS(510),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(508),
    [anon_sym_DASH_DASH] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(510),
    [anon_sym_class] = ACTIONS(510),
    [anon_sym_switch] = ACTIONS(510),
    [anon_sym_LBRACE] = ACTIONS(508),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_case] = ACTIONS(510),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_SEMI] = ACTIONS(508),
    [anon_sym_assert] = ACTIONS(510),
    [anon_sym_do] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(510),
    [anon_sym_break] = ACTIONS(510),
    [anon_sym_continue] = ACTIONS(510),
    [anon_sym_return] = ACTIONS(510),
    [anon_sym_yield] = ACTIONS(510),
    [anon_sym_synchronized] = ACTIONS(510),
    [anon_sym_throw] = ACTIONS(510),
    [anon_sym_try] = ACTIONS(510),
    [anon_sym_if] = ACTIONS(510),
    [anon_sym_else] = ACTIONS(510),
    [anon_sym_for] = ACTIONS(510),
    [anon_sym_AT] = ACTIONS(510),
    [anon_sym_open] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_package] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(510),
    [anon_sym_enum] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_abstract] = ACTIONS(510),
    [anon_sym_strictfp] = ACTIONS(510),
    [anon_sym_native] = ACTIONS(510),
    [anon_sym_transient] = ACTIONS(510),
    [anon_sym_volatile] = ACTIONS(510),
    [anon_sym_sealed] = ACTIONS(510),
    [anon_sym_non_DASHsealed] = ACTIONS(508),
    [anon_sym_record] = ACTIONS(510),
    [anon_sym_ATinterface] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(510),
    [anon_sym_byte] = ACTIONS(510),
    [anon_sym_short] = ACTIONS(510),
    [anon_sym_int] = ACTIONS(510),
    [anon_sym_long] = ACTIONS(510),
    [anon_sym_char] = ACTIONS(510),
    [anon_sym_float] = ACTIONS(510),
    [anon_sym_double] = ACTIONS(510),
    [sym_boolean_type] = ACTIONS(510),
    [sym_void_type] = ACTIONS(510),
    [sym_this] = ACTIONS(510),
    [sym_super] = ACTIONS(510),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [181] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(626),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(512),
    [sym_identifier] = ACTIONS(514),
    [sym_decimal_integer_literal] = ACTIONS(514),
    [sym_hex_integer_literal] = ACTIONS(514),
    [sym_octal_integer_literal] = ACTIONS(514),
    [sym_binary_integer_literal] = ACTIONS(512),
    [sym_decimal_floating_point_literal] = ACTIONS(512),
    [sym_hex_floating_point_literal] = ACTIONS(514),
    [sym_true] = ACTIONS(514),
    [sym_false] = ACTIONS(514),
    [sym_character_literal] = ACTIONS(512),
    [anon_sym_DQUOTE] = ACTIONS(514),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(512),
    [sym_null_literal] = ACTIONS(514),
    [anon_sym_LPAREN] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_PLUS] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(514),
    [anon_sym_final] = ACTIONS(514),
    [anon_sym_BANG] = ACTIONS(512),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_PLUS_PLUS] = ACTIONS(512),
    [anon_sym_DASH_DASH] = ACTIONS(512),
    [anon_sym_new] = ACTIONS(514),
    [anon_sym_class] = ACTIONS(514),
    [anon_sym_switch] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_case] = ACTIONS(514),
    [anon_sym_default] = ACTIONS(514),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_assert] = ACTIONS(514),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_while] = ACTIONS(514),
    [anon_sym_break] = ACTIONS(514),
    [anon_sym_continue] = ACTIONS(514),
    [anon_sym_return] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(514),
    [anon_sym_synchronized] = ACTIONS(514),
    [anon_sym_throw] = ACTIONS(514),
    [anon_sym_try] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_else] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(514),
    [anon_sym_open] = ACTIONS(514),
    [anon_sym_module] = ACTIONS(514),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_package] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_enum] = ACTIONS(514),
    [anon_sym_public] = ACTIONS(514),
    [anon_sym_protected] = ACTIONS(514),
    [anon_sym_private] = ACTIONS(514),
    [anon_sym_abstract] = ACTIONS(514),
    [anon_sym_strictfp] = ACTIONS(514),
    [anon_sym_native] = ACTIONS(514),
    [anon_sym_transient] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym_sealed] = ACTIONS(514),
    [anon_sym_non_DASHsealed] = ACTIONS(512),
    [anon_sym_record] = ACTIONS(514),
    [anon_sym_ATinterface] = ACTIONS(512),
    [anon_sym_interface] = ACTIONS(514),
    [anon_sym_byte] = ACTIONS(514),
    [anon_sym_short] = ACTIONS(514),
    [anon_sym_int] = ACTIONS(514),
    [anon_sym_long] = ACTIONS(514),
    [anon_sym_char] = ACTIONS(514),
    [anon_sym_float] = ACTIONS(514),
    [anon_sym_double] = ACTIONS(514),
    [sym_boolean_type] = ACTIONS(514),
    [sym_void_type] = ACTIONS(514),
    [sym_this] = ACTIONS(514),
    [sym_super] = ACTIONS(514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(516),
    [sym_identifier] = ACTIONS(518),
    [sym_decimal_integer_literal] = ACTIONS(518),
    [sym_hex_integer_literal] = ACTIONS(518),
    [sym_octal_integer_literal] = ACTIONS(518),
    [sym_binary_integer_literal] = ACTIONS(516),
    [sym_decimal_floating_point_literal] = ACTIONS(516),
    [sym_hex_floating_point_literal] = ACTIONS(518),
    [sym_true] = ACTIONS(518),
    [sym_false] = ACTIONS(518),
    [sym_character_literal] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(518),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(516),
    [sym_null_literal] = ACTIONS(518),
    [anon_sym_LPAREN] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_PLUS] = ACTIONS(518),
    [anon_sym_DASH] = ACTIONS(518),
    [anon_sym_final] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(516),
    [anon_sym_PLUS_PLUS] = ACTIONS(516),
    [anon_sym_DASH_DASH] = ACTIONS(516),
    [anon_sym_new] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(518),
    [anon_sym_switch] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(516),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_case] = ACTIONS(518),
    [anon_sym_default] = ACTIONS(518),
    [anon_sym_SEMI] = ACTIONS(516),
    [anon_sym_assert] = ACTIONS(518),
    [anon_sym_do] = ACTIONS(518),
    [anon_sym_while] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(518),
    [anon_sym_continue] = ACTIONS(518),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_yield] = ACTIONS(518),
    [anon_sym_synchronized] = ACTIONS(518),
    [anon_sym_throw] = ACTIONS(518),
    [anon_sym_try] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(518),
    [anon_sym_else] = ACTIONS(518),
    [anon_sym_for] = ACTIONS(518),
    [anon_sym_AT] = ACTIONS(518),
    [anon_sym_open] = ACTIONS(518),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_static] = ACTIONS(518),
    [anon_sym_package] = ACTIONS(518),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_enum] = ACTIONS(518),
    [anon_sym_public] = ACTIONS(518),
    [anon_sym_protected] = ACTIONS(518),
    [anon_sym_private] = ACTIONS(518),
    [anon_sym_abstract] = ACTIONS(518),
    [anon_sym_strictfp] = ACTIONS(518),
    [anon_sym_native] = ACTIONS(518),
    [anon_sym_transient] = ACTIONS(518),
    [anon_sym_volatile] = ACTIONS(518),
    [anon_sym_sealed] = ACTIONS(518),
    [anon_sym_non_DASHsealed] = ACTIONS(516),
    [anon_sym_record] = ACTIONS(518),
    [anon_sym_ATinterface] = ACTIONS(516),
    [anon_sym_interface] = ACTIONS(518),
    [anon_sym_byte] = ACTIONS(518),
    [anon_sym_short] = ACTIONS(518),
    [anon_sym_int] = ACTIONS(518),
    [anon_sym_long] = ACTIONS(518),
    [anon_sym_char] = ACTIONS(518),
    [anon_sym_float] = ACTIONS(518),
    [anon_sym_double] = ACTIONS(518),
    [sym_boolean_type] = ACTIONS(518),
    [sym_void_type] = ACTIONS(518),
    [sym_this] = ACTIONS(518),
    [sym_super] = ACTIONS(518),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(520),
    [sym_identifier] = ACTIONS(522),
    [sym_decimal_integer_literal] = ACTIONS(522),
    [sym_hex_integer_literal] = ACTIONS(522),
    [sym_octal_integer_literal] = ACTIONS(522),
    [sym_binary_integer_literal] = ACTIONS(520),
    [sym_decimal_floating_point_literal] = ACTIONS(520),
    [sym_hex_floating_point_literal] = ACTIONS(522),
    [sym_true] = ACTIONS(522),
    [sym_false] = ACTIONS(522),
    [sym_character_literal] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(520),
    [sym_null_literal] = ACTIONS(522),
    [anon_sym_LPAREN] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(522),
    [anon_sym_DASH] = ACTIONS(522),
    [anon_sym_final] = ACTIONS(522),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_PLUS_PLUS] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(520),
    [anon_sym_new] = ACTIONS(522),
    [anon_sym_class] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(522),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_case] = ACTIONS(522),
    [anon_sym_default] = ACTIONS(522),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_assert] = ACTIONS(522),
    [anon_sym_do] = ACTIONS(522),
    [anon_sym_while] = ACTIONS(522),
    [anon_sym_break] = ACTIONS(522),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_return] = ACTIONS(522),
    [anon_sym_yield] = ACTIONS(522),
    [anon_sym_synchronized] = ACTIONS(522),
    [anon_sym_throw] = ACTIONS(522),
    [anon_sym_try] = ACTIONS(522),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(522),
    [anon_sym_for] = ACTIONS(522),
    [anon_sym_AT] = ACTIONS(522),
    [anon_sym_open] = ACTIONS(522),
    [anon_sym_module] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(522),
    [anon_sym_package] = ACTIONS(522),
    [anon_sym_import] = ACTIONS(522),
    [anon_sym_enum] = ACTIONS(522),
    [anon_sym_public] = ACTIONS(522),
    [anon_sym_protected] = ACTIONS(522),
    [anon_sym_private] = ACTIONS(522),
    [anon_sym_abstract] = ACTIONS(522),
    [anon_sym_strictfp] = ACTIONS(522),
    [anon_sym_native] = ACTIONS(522),
    [anon_sym_transient] = ACTIONS(522),
    [anon_sym_volatile] = ACTIONS(522),
    [anon_sym_sealed] = ACTIONS(522),
    [anon_sym_non_DASHsealed] = ACTIONS(520),
    [anon_sym_record] = ACTIONS(522),
    [anon_sym_ATinterface] = ACTIONS(520),
    [anon_sym_interface] = ACTIONS(522),
    [anon_sym_byte] = ACTIONS(522),
    [anon_sym_short] = ACTIONS(522),
    [anon_sym_int] = ACTIONS(522),
    [anon_sym_long] = ACTIONS(522),
    [anon_sym_char] = ACTIONS(522),
    [anon_sym_float] = ACTIONS(522),
    [anon_sym_double] = ACTIONS(522),
    [sym_boolean_type] = ACTIONS(522),
    [sym_void_type] = ACTIONS(522),
    [sym_this] = ACTIONS(522),
    [sym_super] = ACTIONS(522),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(524),
    [sym_identifier] = ACTIONS(526),
    [sym_decimal_integer_literal] = ACTIONS(526),
    [sym_hex_integer_literal] = ACTIONS(526),
    [sym_octal_integer_literal] = ACTIONS(526),
    [sym_binary_integer_literal] = ACTIONS(524),
    [sym_decimal_floating_point_literal] = ACTIONS(524),
    [sym_hex_floating_point_literal] = ACTIONS(526),
    [sym_true] = ACTIONS(526),
    [sym_false] = ACTIONS(526),
    [sym_character_literal] = ACTIONS(524),
    [anon_sym_DQUOTE] = ACTIONS(526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(524),
    [sym_null_literal] = ACTIONS(526),
    [anon_sym_LPAREN] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_PLUS] = ACTIONS(526),
    [anon_sym_DASH] = ACTIONS(526),
    [anon_sym_final] = ACTIONS(526),
    [anon_sym_BANG] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_new] = ACTIONS(526),
    [anon_sym_class] = ACTIONS(526),
    [anon_sym_switch] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(524),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(526),
    [anon_sym_SEMI] = ACTIONS(524),
    [anon_sym_assert] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(526),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_break] = ACTIONS(526),
    [anon_sym_continue] = ACTIONS(526),
    [anon_sym_return] = ACTIONS(526),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_synchronized] = ACTIONS(526),
    [anon_sym_throw] = ACTIONS(526),
    [anon_sym_try] = ACTIONS(526),
    [anon_sym_if] = ACTIONS(526),
    [anon_sym_else] = ACTIONS(526),
    [anon_sym_for] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(526),
    [anon_sym_open] = ACTIONS(526),
    [anon_sym_module] = ACTIONS(526),
    [anon_sym_static] = ACTIONS(526),
    [anon_sym_package] = ACTIONS(526),
    [anon_sym_import] = ACTIONS(526),
    [anon_sym_enum] = ACTIONS(526),
    [anon_sym_public] = ACTIONS(526),
    [anon_sym_protected] = ACTIONS(526),
    [anon_sym_private] = ACTIONS(526),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_strictfp] = ACTIONS(526),
    [anon_sym_native] = ACTIONS(526),
    [anon_sym_transient] = ACTIONS(526),
    [anon_sym_volatile] = ACTIONS(526),
    [anon_sym_sealed] = ACTIONS(526),
    [anon_sym_non_DASHsealed] = ACTIONS(524),
    [anon_sym_record] = ACTIONS(526),
    [anon_sym_ATinterface] = ACTIONS(524),
    [anon_sym_interface] = ACTIONS(526),
    [anon_sym_byte] = ACTIONS(526),
    [anon_sym_short] = ACTIONS(526),
    [anon_sym_int] = ACTIONS(526),
    [anon_sym_long] = ACTIONS(526),
    [anon_sym_char] = ACTIONS(526),
    [anon_sym_float] = ACTIONS(526),
    [anon_sym_double] = ACTIONS(526),
    [sym_boolean_type] = ACTIONS(526),
    [sym_void_type] = ACTIONS(526),
    [sym_this] = ACTIONS(526),
    [sym_super] = ACTIONS(526),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(528),
    [sym_identifier] = ACTIONS(530),
    [sym_decimal_integer_literal] = ACTIONS(530),
    [sym_hex_integer_literal] = ACTIONS(530),
    [sym_octal_integer_literal] = ACTIONS(530),
    [sym_binary_integer_literal] = ACTIONS(528),
    [sym_decimal_floating_point_literal] = ACTIONS(528),
    [sym_hex_floating_point_literal] = ACTIONS(530),
    [sym_true] = ACTIONS(530),
    [sym_false] = ACTIONS(530),
    [sym_character_literal] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(528),
    [sym_null_literal] = ACTIONS(530),
    [anon_sym_LPAREN] = ACTIONS(528),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(530),
    [anon_sym_DASH] = ACTIONS(530),
    [anon_sym_final] = ACTIONS(530),
    [anon_sym_BANG] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(528),
    [anon_sym_PLUS_PLUS] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(528),
    [anon_sym_new] = ACTIONS(530),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_RBRACE] = ACTIONS(528),
    [anon_sym_case] = ACTIONS(530),
    [anon_sym_default] = ACTIONS(530),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_assert] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(530),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_break] = ACTIONS(530),
    [anon_sym_continue] = ACTIONS(530),
    [anon_sym_return] = ACTIONS(530),
    [anon_sym_yield] = ACTIONS(530),
    [anon_sym_synchronized] = ACTIONS(530),
    [anon_sym_throw] = ACTIONS(530),
    [anon_sym_try] = ACTIONS(530),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_else] = ACTIONS(530),
    [anon_sym_for] = ACTIONS(530),
    [anon_sym_AT] = ACTIONS(530),
    [anon_sym_open] = ACTIONS(530),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_package] = ACTIONS(530),
    [anon_sym_import] = ACTIONS(530),
    [anon_sym_enum] = ACTIONS(530),
    [anon_sym_public] = ACTIONS(530),
    [anon_sym_protected] = ACTIONS(530),
    [anon_sym_private] = ACTIONS(530),
    [anon_sym_abstract] = ACTIONS(530),
    [anon_sym_strictfp] = ACTIONS(530),
    [anon_sym_native] = ACTIONS(530),
    [anon_sym_transient] = ACTIONS(530),
    [anon_sym_volatile] = ACTIONS(530),
    [anon_sym_sealed] = ACTIONS(530),
    [anon_sym_non_DASHsealed] = ACTIONS(528),
    [anon_sym_record] = ACTIONS(530),
    [anon_sym_ATinterface] = ACTIONS(528),
    [anon_sym_interface] = ACTIONS(530),
    [anon_sym_byte] = ACTIONS(530),
    [anon_sym_short] = ACTIONS(530),
    [anon_sym_int] = ACTIONS(530),
    [anon_sym_long] = ACTIONS(530),
    [anon_sym_char] = ACTIONS(530),
    [anon_sym_float] = ACTIONS(530),
    [anon_sym_double] = ACTIONS(530),
    [sym_boolean_type] = ACTIONS(530),
    [sym_void_type] = ACTIONS(530),
    [sym_this] = ACTIONS(530),
    [sym_super] = ACTIONS(530),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(532),
    [sym_identifier] = ACTIONS(534),
    [sym_decimal_integer_literal] = ACTIONS(534),
    [sym_hex_integer_literal] = ACTIONS(534),
    [sym_octal_integer_literal] = ACTIONS(534),
    [sym_binary_integer_literal] = ACTIONS(532),
    [sym_decimal_floating_point_literal] = ACTIONS(532),
    [sym_hex_floating_point_literal] = ACTIONS(534),
    [sym_true] = ACTIONS(534),
    [sym_false] = ACTIONS(534),
    [sym_character_literal] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(532),
    [sym_null_literal] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_PLUS] = ACTIONS(534),
    [anon_sym_DASH] = ACTIONS(534),
    [anon_sym_final] = ACTIONS(534),
    [anon_sym_BANG] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(532),
    [anon_sym_PLUS_PLUS] = ACTIONS(532),
    [anon_sym_DASH_DASH] = ACTIONS(532),
    [anon_sym_new] = ACTIONS(534),
    [anon_sym_class] = ACTIONS(534),
    [anon_sym_switch] = ACTIONS(534),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_RBRACE] = ACTIONS(532),
    [anon_sym_case] = ACTIONS(534),
    [anon_sym_default] = ACTIONS(534),
    [anon_sym_SEMI] = ACTIONS(532),
    [anon_sym_assert] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(534),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_break] = ACTIONS(534),
    [anon_sym_continue] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(534),
    [anon_sym_yield] = ACTIONS(534),
    [anon_sym_synchronized] = ACTIONS(534),
    [anon_sym_throw] = ACTIONS(534),
    [anon_sym_try] = ACTIONS(534),
    [anon_sym_if] = ACTIONS(534),
    [anon_sym_else] = ACTIONS(534),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_AT] = ACTIONS(534),
    [anon_sym_open] = ACTIONS(534),
    [anon_sym_module] = ACTIONS(534),
    [anon_sym_static] = ACTIONS(534),
    [anon_sym_package] = ACTIONS(534),
    [anon_sym_import] = ACTIONS(534),
    [anon_sym_enum] = ACTIONS(534),
    [anon_sym_public] = ACTIONS(534),
    [anon_sym_protected] = ACTIONS(534),
    [anon_sym_private] = ACTIONS(534),
    [anon_sym_abstract] = ACTIONS(534),
    [anon_sym_strictfp] = ACTIONS(534),
    [anon_sym_native] = ACTIONS(534),
    [anon_sym_transient] = ACTIONS(534),
    [anon_sym_volatile] = ACTIONS(534),
    [anon_sym_sealed] = ACTIONS(534),
    [anon_sym_non_DASHsealed] = ACTIONS(532),
    [anon_sym_record] = ACTIONS(534),
    [anon_sym_ATinterface] = ACTIONS(532),
    [anon_sym_interface] = ACTIONS(534),
    [anon_sym_byte] = ACTIONS(534),
    [anon_sym_short] = ACTIONS(534),
    [anon_sym_int] = ACTIONS(534),
    [anon_sym_long] = ACTIONS(534),
    [anon_sym_char] = ACTIONS(534),
    [anon_sym_float] = ACTIONS(534),
    [anon_sym_double] = ACTIONS(534),
    [sym_boolean_type] = ACTIONS(534),
    [sym_void_type] = ACTIONS(534),
    [sym_this] = ACTIONS(534),
    [sym_super] = ACTIONS(534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(536),
    [sym_identifier] = ACTIONS(538),
    [sym_decimal_integer_literal] = ACTIONS(538),
    [sym_hex_integer_literal] = ACTIONS(538),
    [sym_octal_integer_literal] = ACTIONS(538),
    [sym_binary_integer_literal] = ACTIONS(536),
    [sym_decimal_floating_point_literal] = ACTIONS(536),
    [sym_hex_floating_point_literal] = ACTIONS(538),
    [sym_true] = ACTIONS(538),
    [sym_false] = ACTIONS(538),
    [sym_character_literal] = ACTIONS(536),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(536),
    [sym_null_literal] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_final] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(536),
    [anon_sym_TILDE] = ACTIONS(536),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_DASH_DASH] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(538),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_case] = ACTIONS(538),
    [anon_sym_default] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(536),
    [anon_sym_assert] = ACTIONS(538),
    [anon_sym_do] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(538),
    [anon_sym_return] = ACTIONS(538),
    [anon_sym_yield] = ACTIONS(538),
    [anon_sym_synchronized] = ACTIONS(538),
    [anon_sym_throw] = ACTIONS(538),
    [anon_sym_try] = ACTIONS(538),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_else] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(538),
    [anon_sym_open] = ACTIONS(538),
    [anon_sym_module] = ACTIONS(538),
    [anon_sym_static] = ACTIONS(538),
    [anon_sym_package] = ACTIONS(538),
    [anon_sym_import] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(538),
    [anon_sym_protected] = ACTIONS(538),
    [anon_sym_private] = ACTIONS(538),
    [anon_sym_abstract] = ACTIONS(538),
    [anon_sym_strictfp] = ACTIONS(538),
    [anon_sym_native] = ACTIONS(538),
    [anon_sym_transient] = ACTIONS(538),
    [anon_sym_volatile] = ACTIONS(538),
    [anon_sym_sealed] = ACTIONS(538),
    [anon_sym_non_DASHsealed] = ACTIONS(536),
    [anon_sym_record] = ACTIONS(538),
    [anon_sym_ATinterface] = ACTIONS(536),
    [anon_sym_interface] = ACTIONS(538),
    [anon_sym_byte] = ACTIONS(538),
    [anon_sym_short] = ACTIONS(538),
    [anon_sym_int] = ACTIONS(538),
    [anon_sym_long] = ACTIONS(538),
    [anon_sym_char] = ACTIONS(538),
    [anon_sym_float] = ACTIONS(538),
    [anon_sym_double] = ACTIONS(538),
    [sym_boolean_type] = ACTIONS(538),
    [sym_void_type] = ACTIONS(538),
    [sym_this] = ACTIONS(538),
    [sym_super] = ACTIONS(538),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_decimal_integer_literal] = ACTIONS(542),
    [sym_hex_integer_literal] = ACTIONS(542),
    [sym_octal_integer_literal] = ACTIONS(542),
    [sym_binary_integer_literal] = ACTIONS(540),
    [sym_decimal_floating_point_literal] = ACTIONS(540),
    [sym_hex_floating_point_literal] = ACTIONS(542),
    [sym_true] = ACTIONS(542),
    [sym_false] = ACTIONS(542),
    [sym_character_literal] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(540),
    [sym_null_literal] = ACTIONS(542),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_PLUS] = ACTIONS(542),
    [anon_sym_DASH] = ACTIONS(542),
    [anon_sym_final] = ACTIONS(542),
    [anon_sym_BANG] = ACTIONS(540),
    [anon_sym_TILDE] = ACTIONS(540),
    [anon_sym_PLUS_PLUS] = ACTIONS(540),
    [anon_sym_DASH_DASH] = ACTIONS(540),
    [anon_sym_new] = ACTIONS(542),
    [anon_sym_class] = ACTIONS(542),
    [anon_sym_switch] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(540),
    [anon_sym_RBRACE] = ACTIONS(540),
    [anon_sym_case] = ACTIONS(542),
    [anon_sym_default] = ACTIONS(542),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_assert] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(542),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_break] = ACTIONS(542),
    [anon_sym_continue] = ACTIONS(542),
    [anon_sym_return] = ACTIONS(542),
    [anon_sym_yield] = ACTIONS(542),
    [anon_sym_synchronized] = ACTIONS(542),
    [anon_sym_throw] = ACTIONS(542),
    [anon_sym_try] = ACTIONS(542),
    [anon_sym_if] = ACTIONS(542),
    [anon_sym_else] = ACTIONS(542),
    [anon_sym_for] = ACTIONS(542),
    [anon_sym_AT] = ACTIONS(542),
    [anon_sym_open] = ACTIONS(542),
    [anon_sym_module] = ACTIONS(542),
    [anon_sym_static] = ACTIONS(542),
    [anon_sym_package] = ACTIONS(542),
    [anon_sym_import] = ACTIONS(542),
    [anon_sym_enum] = ACTIONS(542),
    [anon_sym_public] = ACTIONS(542),
    [anon_sym_protected] = ACTIONS(542),
    [anon_sym_private] = ACTIONS(542),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_strictfp] = ACTIONS(542),
    [anon_sym_native] = ACTIONS(542),
    [anon_sym_transient] = ACTIONS(542),
    [anon_sym_volatile] = ACTIONS(542),
    [anon_sym_sealed] = ACTIONS(542),
    [anon_sym_non_DASHsealed] = ACTIONS(540),
    [anon_sym_record] = ACTIONS(542),
    [anon_sym_ATinterface] = ACTIONS(540),
    [anon_sym_interface] = ACTIONS(542),
    [anon_sym_byte] = ACTIONS(542),
    [anon_sym_short] = ACTIONS(542),
    [anon_sym_int] = ACTIONS(542),
    [anon_sym_long] = ACTIONS(542),
    [anon_sym_char] = ACTIONS(542),
    [anon_sym_float] = ACTIONS(542),
    [anon_sym_double] = ACTIONS(542),
    [sym_boolean_type] = ACTIONS(542),
    [sym_void_type] = ACTIONS(542),
    [sym_this] = ACTIONS(542),
    [sym_super] = ACTIONS(542),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(544),
    [sym_identifier] = ACTIONS(546),
    [sym_decimal_integer_literal] = ACTIONS(546),
    [sym_hex_integer_literal] = ACTIONS(546),
    [sym_octal_integer_literal] = ACTIONS(546),
    [sym_binary_integer_literal] = ACTIONS(544),
    [sym_decimal_floating_point_literal] = ACTIONS(544),
    [sym_hex_floating_point_literal] = ACTIONS(546),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [sym_character_literal] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(544),
    [sym_null_literal] = ACTIONS(546),
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(546),
    [anon_sym_DASH] = ACTIONS(546),
    [anon_sym_final] = ACTIONS(546),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_new] = ACTIONS(546),
    [anon_sym_class] = ACTIONS(546),
    [anon_sym_switch] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_RBRACE] = ACTIONS(544),
    [anon_sym_case] = ACTIONS(546),
    [anon_sym_default] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_assert] = ACTIONS(546),
    [anon_sym_do] = ACTIONS(546),
    [anon_sym_while] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(546),
    [anon_sym_continue] = ACTIONS(546),
    [anon_sym_return] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_synchronized] = ACTIONS(546),
    [anon_sym_throw] = ACTIONS(546),
    [anon_sym_try] = ACTIONS(546),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_else] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(546),
    [anon_sym_AT] = ACTIONS(546),
    [anon_sym_open] = ACTIONS(546),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_package] = ACTIONS(546),
    [anon_sym_import] = ACTIONS(546),
    [anon_sym_enum] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(546),
    [anon_sym_protected] = ACTIONS(546),
    [anon_sym_private] = ACTIONS(546),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_strictfp] = ACTIONS(546),
    [anon_sym_native] = ACTIONS(546),
    [anon_sym_transient] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym_sealed] = ACTIONS(546),
    [anon_sym_non_DASHsealed] = ACTIONS(544),
    [anon_sym_record] = ACTIONS(546),
    [anon_sym_ATinterface] = ACTIONS(544),
    [anon_sym_interface] = ACTIONS(546),
    [anon_sym_byte] = ACTIONS(546),
    [anon_sym_short] = ACTIONS(546),
    [anon_sym_int] = ACTIONS(546),
    [anon_sym_long] = ACTIONS(546),
    [anon_sym_char] = ACTIONS(546),
    [anon_sym_float] = ACTIONS(546),
    [anon_sym_double] = ACTIONS(546),
    [sym_boolean_type] = ACTIONS(546),
    [sym_void_type] = ACTIONS(546),
    [sym_this] = ACTIONS(546),
    [sym_super] = ACTIONS(546),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [191] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(523),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(525),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(474),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(548),
    [sym_identifier] = ACTIONS(550),
    [sym_decimal_integer_literal] = ACTIONS(550),
    [sym_hex_integer_literal] = ACTIONS(550),
    [sym_octal_integer_literal] = ACTIONS(550),
    [sym_binary_integer_literal] = ACTIONS(548),
    [sym_decimal_floating_point_literal] = ACTIONS(548),
    [sym_hex_floating_point_literal] = ACTIONS(550),
    [sym_true] = ACTIONS(550),
    [sym_false] = ACTIONS(550),
    [sym_character_literal] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(550),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(548),
    [sym_null_literal] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_PLUS] = ACTIONS(550),
    [anon_sym_DASH] = ACTIONS(550),
    [anon_sym_final] = ACTIONS(550),
    [anon_sym_BANG] = ACTIONS(548),
    [anon_sym_TILDE] = ACTIONS(548),
    [anon_sym_PLUS_PLUS] = ACTIONS(548),
    [anon_sym_DASH_DASH] = ACTIONS(548),
    [anon_sym_new] = ACTIONS(550),
    [anon_sym_class] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(550),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(550),
    [anon_sym_default] = ACTIONS(550),
    [anon_sym_SEMI] = ACTIONS(548),
    [anon_sym_assert] = ACTIONS(550),
    [anon_sym_do] = ACTIONS(550),
    [anon_sym_while] = ACTIONS(550),
    [anon_sym_break] = ACTIONS(550),
    [anon_sym_continue] = ACTIONS(550),
    [anon_sym_return] = ACTIONS(550),
    [anon_sym_yield] = ACTIONS(550),
    [anon_sym_synchronized] = ACTIONS(550),
    [anon_sym_throw] = ACTIONS(550),
    [anon_sym_try] = ACTIONS(550),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_else] = ACTIONS(550),
    [anon_sym_for] = ACTIONS(550),
    [anon_sym_AT] = ACTIONS(550),
    [anon_sym_open] = ACTIONS(550),
    [anon_sym_module] = ACTIONS(550),
    [anon_sym_static] = ACTIONS(550),
    [anon_sym_package] = ACTIONS(550),
    [anon_sym_import] = ACTIONS(550),
    [anon_sym_enum] = ACTIONS(550),
    [anon_sym_public] = ACTIONS(550),
    [anon_sym_protected] = ACTIONS(550),
    [anon_sym_private] = ACTIONS(550),
    [anon_sym_abstract] = ACTIONS(550),
    [anon_sym_strictfp] = ACTIONS(550),
    [anon_sym_native] = ACTIONS(550),
    [anon_sym_transient] = ACTIONS(550),
    [anon_sym_volatile] = ACTIONS(550),
    [anon_sym_sealed] = ACTIONS(550),
    [anon_sym_non_DASHsealed] = ACTIONS(548),
    [anon_sym_record] = ACTIONS(550),
    [anon_sym_ATinterface] = ACTIONS(548),
    [anon_sym_interface] = ACTIONS(550),
    [anon_sym_byte] = ACTIONS(550),
    [anon_sym_short] = ACTIONS(550),
    [anon_sym_int] = ACTIONS(550),
    [anon_sym_long] = ACTIONS(550),
    [anon_sym_char] = ACTIONS(550),
    [anon_sym_float] = ACTIONS(550),
    [anon_sym_double] = ACTIONS(550),
    [sym_boolean_type] = ACTIONS(550),
    [sym_void_type] = ACTIONS(550),
    [sym_this] = ACTIONS(550),
    [sym_super] = ACTIONS(550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(552),
    [sym_identifier] = ACTIONS(554),
    [sym_decimal_integer_literal] = ACTIONS(554),
    [sym_hex_integer_literal] = ACTIONS(554),
    [sym_octal_integer_literal] = ACTIONS(554),
    [sym_binary_integer_literal] = ACTIONS(552),
    [sym_decimal_floating_point_literal] = ACTIONS(552),
    [sym_hex_floating_point_literal] = ACTIONS(554),
    [sym_true] = ACTIONS(554),
    [sym_false] = ACTIONS(554),
    [sym_character_literal] = ACTIONS(552),
    [anon_sym_DQUOTE] = ACTIONS(554),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(552),
    [sym_null_literal] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_final] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_DASH_DASH] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(554),
    [anon_sym_class] = ACTIONS(554),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_case] = ACTIONS(554),
    [anon_sym_default] = ACTIONS(554),
    [anon_sym_SEMI] = ACTIONS(552),
    [anon_sym_assert] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_break] = ACTIONS(554),
    [anon_sym_continue] = ACTIONS(554),
    [anon_sym_return] = ACTIONS(554),
    [anon_sym_yield] = ACTIONS(554),
    [anon_sym_synchronized] = ACTIONS(554),
    [anon_sym_throw] = ACTIONS(554),
    [anon_sym_try] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_else] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym_open] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(554),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_package] = ACTIONS(554),
    [anon_sym_import] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(554),
    [anon_sym_strictfp] = ACTIONS(554),
    [anon_sym_native] = ACTIONS(554),
    [anon_sym_transient] = ACTIONS(554),
    [anon_sym_volatile] = ACTIONS(554),
    [anon_sym_sealed] = ACTIONS(554),
    [anon_sym_non_DASHsealed] = ACTIONS(552),
    [anon_sym_record] = ACTIONS(554),
    [anon_sym_ATinterface] = ACTIONS(552),
    [anon_sym_interface] = ACTIONS(554),
    [anon_sym_byte] = ACTIONS(554),
    [anon_sym_short] = ACTIONS(554),
    [anon_sym_int] = ACTIONS(554),
    [anon_sym_long] = ACTIONS(554),
    [anon_sym_char] = ACTIONS(554),
    [anon_sym_float] = ACTIONS(554),
    [anon_sym_double] = ACTIONS(554),
    [sym_boolean_type] = ACTIONS(554),
    [sym_void_type] = ACTIONS(554),
    [sym_this] = ACTIONS(554),
    [sym_super] = ACTIONS(554),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [194] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(543),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [195] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(568),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [196] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(556),
    [sym_identifier] = ACTIONS(558),
    [sym_decimal_integer_literal] = ACTIONS(558),
    [sym_hex_integer_literal] = ACTIONS(558),
    [sym_octal_integer_literal] = ACTIONS(558),
    [sym_binary_integer_literal] = ACTIONS(556),
    [sym_decimal_floating_point_literal] = ACTIONS(556),
    [sym_hex_floating_point_literal] = ACTIONS(558),
    [sym_true] = ACTIONS(558),
    [sym_false] = ACTIONS(558),
    [sym_character_literal] = ACTIONS(556),
    [anon_sym_DQUOTE] = ACTIONS(558),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(556),
    [sym_null_literal] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_final] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(556),
    [anon_sym_TILDE] = ACTIONS(556),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_DASH_DASH] = ACTIONS(556),
    [anon_sym_new] = ACTIONS(558),
    [anon_sym_class] = ACTIONS(558),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_case] = ACTIONS(558),
    [anon_sym_default] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(556),
    [anon_sym_assert] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_break] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(558),
    [anon_sym_return] = ACTIONS(558),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_synchronized] = ACTIONS(558),
    [anon_sym_throw] = ACTIONS(558),
    [anon_sym_try] = ACTIONS(558),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_open] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_package] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_abstract] = ACTIONS(558),
    [anon_sym_strictfp] = ACTIONS(558),
    [anon_sym_native] = ACTIONS(558),
    [anon_sym_transient] = ACTIONS(558),
    [anon_sym_volatile] = ACTIONS(558),
    [anon_sym_sealed] = ACTIONS(558),
    [anon_sym_non_DASHsealed] = ACTIONS(556),
    [anon_sym_record] = ACTIONS(558),
    [anon_sym_ATinterface] = ACTIONS(556),
    [anon_sym_interface] = ACTIONS(558),
    [anon_sym_byte] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [anon_sym_int] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_char] = ACTIONS(558),
    [anon_sym_float] = ACTIONS(558),
    [anon_sym_double] = ACTIONS(558),
    [sym_boolean_type] = ACTIONS(558),
    [sym_void_type] = ACTIONS(558),
    [sym_this] = ACTIONS(558),
    [sym_super] = ACTIONS(558),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(560),
    [sym_identifier] = ACTIONS(562),
    [sym_decimal_integer_literal] = ACTIONS(562),
    [sym_hex_integer_literal] = ACTIONS(562),
    [sym_octal_integer_literal] = ACTIONS(562),
    [sym_binary_integer_literal] = ACTIONS(560),
    [sym_decimal_floating_point_literal] = ACTIONS(560),
    [sym_hex_floating_point_literal] = ACTIONS(562),
    [sym_true] = ACTIONS(562),
    [sym_false] = ACTIONS(562),
    [sym_character_literal] = ACTIONS(560),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(560),
    [sym_null_literal] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_final] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(560),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_DASH_DASH] = ACTIONS(560),
    [anon_sym_new] = ACTIONS(562),
    [anon_sym_class] = ACTIONS(562),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_case] = ACTIONS(562),
    [anon_sym_default] = ACTIONS(562),
    [anon_sym_SEMI] = ACTIONS(560),
    [anon_sym_assert] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_break] = ACTIONS(562),
    [anon_sym_continue] = ACTIONS(562),
    [anon_sym_return] = ACTIONS(562),
    [anon_sym_yield] = ACTIONS(562),
    [anon_sym_synchronized] = ACTIONS(562),
    [anon_sym_throw] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_else] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(562),
    [anon_sym_open] = ACTIONS(562),
    [anon_sym_module] = ACTIONS(562),
    [anon_sym_static] = ACTIONS(562),
    [anon_sym_package] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(562),
    [anon_sym_protected] = ACTIONS(562),
    [anon_sym_private] = ACTIONS(562),
    [anon_sym_abstract] = ACTIONS(562),
    [anon_sym_strictfp] = ACTIONS(562),
    [anon_sym_native] = ACTIONS(562),
    [anon_sym_transient] = ACTIONS(562),
    [anon_sym_volatile] = ACTIONS(562),
    [anon_sym_sealed] = ACTIONS(562),
    [anon_sym_non_DASHsealed] = ACTIONS(560),
    [anon_sym_record] = ACTIONS(562),
    [anon_sym_ATinterface] = ACTIONS(560),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_byte] = ACTIONS(562),
    [anon_sym_short] = ACTIONS(562),
    [anon_sym_int] = ACTIONS(562),
    [anon_sym_long] = ACTIONS(562),
    [anon_sym_char] = ACTIONS(562),
    [anon_sym_float] = ACTIONS(562),
    [anon_sym_double] = ACTIONS(562),
    [sym_boolean_type] = ACTIONS(562),
    [sym_void_type] = ACTIONS(562),
    [sym_this] = ACTIONS(562),
    [sym_super] = ACTIONS(562),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(564),
    [sym_identifier] = ACTIONS(566),
    [sym_decimal_integer_literal] = ACTIONS(566),
    [sym_hex_integer_literal] = ACTIONS(566),
    [sym_octal_integer_literal] = ACTIONS(566),
    [sym_binary_integer_literal] = ACTIONS(564),
    [sym_decimal_floating_point_literal] = ACTIONS(564),
    [sym_hex_floating_point_literal] = ACTIONS(566),
    [sym_true] = ACTIONS(566),
    [sym_false] = ACTIONS(566),
    [sym_character_literal] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(566),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(564),
    [sym_null_literal] = ACTIONS(566),
    [anon_sym_LPAREN] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_final] = ACTIONS(566),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_new] = ACTIONS(566),
    [anon_sym_class] = ACTIONS(566),
    [anon_sym_switch] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(564),
    [anon_sym_RBRACE] = ACTIONS(564),
    [anon_sym_case] = ACTIONS(566),
    [anon_sym_default] = ACTIONS(566),
    [anon_sym_SEMI] = ACTIONS(564),
    [anon_sym_assert] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_break] = ACTIONS(566),
    [anon_sym_continue] = ACTIONS(566),
    [anon_sym_return] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(566),
    [anon_sym_synchronized] = ACTIONS(566),
    [anon_sym_throw] = ACTIONS(566),
    [anon_sym_try] = ACTIONS(566),
    [anon_sym_if] = ACTIONS(566),
    [anon_sym_else] = ACTIONS(566),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_AT] = ACTIONS(566),
    [anon_sym_open] = ACTIONS(566),
    [anon_sym_module] = ACTIONS(566),
    [anon_sym_static] = ACTIONS(566),
    [anon_sym_package] = ACTIONS(566),
    [anon_sym_import] = ACTIONS(566),
    [anon_sym_enum] = ACTIONS(566),
    [anon_sym_public] = ACTIONS(566),
    [anon_sym_protected] = ACTIONS(566),
    [anon_sym_private] = ACTIONS(566),
    [anon_sym_abstract] = ACTIONS(566),
    [anon_sym_strictfp] = ACTIONS(566),
    [anon_sym_native] = ACTIONS(566),
    [anon_sym_transient] = ACTIONS(566),
    [anon_sym_volatile] = ACTIONS(566),
    [anon_sym_sealed] = ACTIONS(566),
    [anon_sym_non_DASHsealed] = ACTIONS(564),
    [anon_sym_record] = ACTIONS(566),
    [anon_sym_ATinterface] = ACTIONS(564),
    [anon_sym_interface] = ACTIONS(566),
    [anon_sym_byte] = ACTIONS(566),
    [anon_sym_short] = ACTIONS(566),
    [anon_sym_int] = ACTIONS(566),
    [anon_sym_long] = ACTIONS(566),
    [anon_sym_char] = ACTIONS(566),
    [anon_sym_float] = ACTIONS(566),
    [anon_sym_double] = ACTIONS(566),
    [sym_boolean_type] = ACTIONS(566),
    [sym_void_type] = ACTIONS(566),
    [sym_this] = ACTIONS(566),
    [sym_super] = ACTIONS(566),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(568),
    [sym_identifier] = ACTIONS(570),
    [sym_decimal_integer_literal] = ACTIONS(570),
    [sym_hex_integer_literal] = ACTIONS(570),
    [sym_octal_integer_literal] = ACTIONS(570),
    [sym_binary_integer_literal] = ACTIONS(568),
    [sym_decimal_floating_point_literal] = ACTIONS(568),
    [sym_hex_floating_point_literal] = ACTIONS(570),
    [sym_true] = ACTIONS(570),
    [sym_false] = ACTIONS(570),
    [sym_character_literal] = ACTIONS(568),
    [anon_sym_DQUOTE] = ACTIONS(570),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(568),
    [sym_null_literal] = ACTIONS(570),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(570),
    [anon_sym_final] = ACTIONS(570),
    [anon_sym_BANG] = ACTIONS(568),
    [anon_sym_TILDE] = ACTIONS(568),
    [anon_sym_PLUS_PLUS] = ACTIONS(568),
    [anon_sym_DASH_DASH] = ACTIONS(568),
    [anon_sym_new] = ACTIONS(570),
    [anon_sym_class] = ACTIONS(570),
    [anon_sym_switch] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_RBRACE] = ACTIONS(568),
    [anon_sym_case] = ACTIONS(570),
    [anon_sym_default] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(568),
    [anon_sym_assert] = ACTIONS(570),
    [anon_sym_do] = ACTIONS(570),
    [anon_sym_while] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(570),
    [anon_sym_continue] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(570),
    [anon_sym_yield] = ACTIONS(570),
    [anon_sym_synchronized] = ACTIONS(570),
    [anon_sym_throw] = ACTIONS(570),
    [anon_sym_try] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(570),
    [anon_sym_else] = ACTIONS(570),
    [anon_sym_for] = ACTIONS(570),
    [anon_sym_AT] = ACTIONS(570),
    [anon_sym_open] = ACTIONS(570),
    [anon_sym_module] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(570),
    [anon_sym_package] = ACTIONS(570),
    [anon_sym_import] = ACTIONS(570),
    [anon_sym_enum] = ACTIONS(570),
    [anon_sym_public] = ACTIONS(570),
    [anon_sym_protected] = ACTIONS(570),
    [anon_sym_private] = ACTIONS(570),
    [anon_sym_abstract] = ACTIONS(570),
    [anon_sym_strictfp] = ACTIONS(570),
    [anon_sym_native] = ACTIONS(570),
    [anon_sym_transient] = ACTIONS(570),
    [anon_sym_volatile] = ACTIONS(570),
    [anon_sym_sealed] = ACTIONS(570),
    [anon_sym_non_DASHsealed] = ACTIONS(568),
    [anon_sym_record] = ACTIONS(570),
    [anon_sym_ATinterface] = ACTIONS(568),
    [anon_sym_interface] = ACTIONS(570),
    [anon_sym_byte] = ACTIONS(570),
    [anon_sym_short] = ACTIONS(570),
    [anon_sym_int] = ACTIONS(570),
    [anon_sym_long] = ACTIONS(570),
    [anon_sym_char] = ACTIONS(570),
    [anon_sym_float] = ACTIONS(570),
    [anon_sym_double] = ACTIONS(570),
    [sym_boolean_type] = ACTIONS(570),
    [sym_void_type] = ACTIONS(570),
    [sym_this] = ACTIONS(570),
    [sym_super] = ACTIONS(570),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [201] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(555),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [202] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(638),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(572),
    [sym_identifier] = ACTIONS(574),
    [sym_decimal_integer_literal] = ACTIONS(574),
    [sym_hex_integer_literal] = ACTIONS(574),
    [sym_octal_integer_literal] = ACTIONS(574),
    [sym_binary_integer_literal] = ACTIONS(572),
    [sym_decimal_floating_point_literal] = ACTIONS(572),
    [sym_hex_floating_point_literal] = ACTIONS(574),
    [sym_true] = ACTIONS(574),
    [sym_false] = ACTIONS(574),
    [sym_character_literal] = ACTIONS(572),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(572),
    [sym_null_literal] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(574),
    [anon_sym_DASH] = ACTIONS(574),
    [anon_sym_final] = ACTIONS(574),
    [anon_sym_BANG] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(572),
    [anon_sym_PLUS_PLUS] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(572),
    [anon_sym_new] = ACTIONS(574),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(574),
    [anon_sym_LBRACE] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(572),
    [anon_sym_case] = ACTIONS(574),
    [anon_sym_default] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_assert] = ACTIONS(574),
    [anon_sym_do] = ACTIONS(574),
    [anon_sym_while] = ACTIONS(574),
    [anon_sym_break] = ACTIONS(574),
    [anon_sym_continue] = ACTIONS(574),
    [anon_sym_return] = ACTIONS(574),
    [anon_sym_yield] = ACTIONS(574),
    [anon_sym_synchronized] = ACTIONS(574),
    [anon_sym_throw] = ACTIONS(574),
    [anon_sym_try] = ACTIONS(574),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_else] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(574),
    [anon_sym_AT] = ACTIONS(574),
    [anon_sym_open] = ACTIONS(574),
    [anon_sym_module] = ACTIONS(574),
    [anon_sym_static] = ACTIONS(574),
    [anon_sym_package] = ACTIONS(574),
    [anon_sym_import] = ACTIONS(574),
    [anon_sym_enum] = ACTIONS(574),
    [anon_sym_public] = ACTIONS(574),
    [anon_sym_protected] = ACTIONS(574),
    [anon_sym_private] = ACTIONS(574),
    [anon_sym_abstract] = ACTIONS(574),
    [anon_sym_strictfp] = ACTIONS(574),
    [anon_sym_native] = ACTIONS(574),
    [anon_sym_transient] = ACTIONS(574),
    [anon_sym_volatile] = ACTIONS(574),
    [anon_sym_sealed] = ACTIONS(574),
    [anon_sym_non_DASHsealed] = ACTIONS(572),
    [anon_sym_record] = ACTIONS(574),
    [anon_sym_ATinterface] = ACTIONS(572),
    [anon_sym_interface] = ACTIONS(574),
    [anon_sym_byte] = ACTIONS(574),
    [anon_sym_short] = ACTIONS(574),
    [anon_sym_int] = ACTIONS(574),
    [anon_sym_long] = ACTIONS(574),
    [anon_sym_char] = ACTIONS(574),
    [anon_sym_float] = ACTIONS(574),
    [anon_sym_double] = ACTIONS(574),
    [sym_boolean_type] = ACTIONS(574),
    [sym_void_type] = ACTIONS(574),
    [sym_this] = ACTIONS(574),
    [sym_super] = ACTIONS(574),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [204] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(557),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [205] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(523),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(525),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(474),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [sym_identifier] = ACTIONS(578),
    [sym_decimal_integer_literal] = ACTIONS(578),
    [sym_hex_integer_literal] = ACTIONS(578),
    [sym_octal_integer_literal] = ACTIONS(578),
    [sym_binary_integer_literal] = ACTIONS(576),
    [sym_decimal_floating_point_literal] = ACTIONS(576),
    [sym_hex_floating_point_literal] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_character_literal] = ACTIONS(576),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(576),
    [sym_null_literal] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_final] = ACTIONS(578),
    [anon_sym_BANG] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_new] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(578),
    [anon_sym_default] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_break] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_synchronized] = ACTIONS(578),
    [anon_sym_throw] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(578),
    [anon_sym_open] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_package] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_abstract] = ACTIONS(578),
    [anon_sym_strictfp] = ACTIONS(578),
    [anon_sym_native] = ACTIONS(578),
    [anon_sym_transient] = ACTIONS(578),
    [anon_sym_volatile] = ACTIONS(578),
    [anon_sym_sealed] = ACTIONS(578),
    [anon_sym_non_DASHsealed] = ACTIONS(576),
    [anon_sym_record] = ACTIONS(578),
    [anon_sym_ATinterface] = ACTIONS(576),
    [anon_sym_interface] = ACTIONS(578),
    [anon_sym_byte] = ACTIONS(578),
    [anon_sym_short] = ACTIONS(578),
    [anon_sym_int] = ACTIONS(578),
    [anon_sym_long] = ACTIONS(578),
    [anon_sym_char] = ACTIONS(578),
    [anon_sym_float] = ACTIONS(578),
    [anon_sym_double] = ACTIONS(578),
    [sym_boolean_type] = ACTIONS(578),
    [sym_void_type] = ACTIONS(578),
    [sym_this] = ACTIONS(578),
    [sym_super] = ACTIONS(578),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(580),
    [sym_identifier] = ACTIONS(582),
    [sym_decimal_integer_literal] = ACTIONS(582),
    [sym_hex_integer_literal] = ACTIONS(582),
    [sym_octal_integer_literal] = ACTIONS(582),
    [sym_binary_integer_literal] = ACTIONS(580),
    [sym_decimal_floating_point_literal] = ACTIONS(580),
    [sym_hex_floating_point_literal] = ACTIONS(582),
    [sym_true] = ACTIONS(582),
    [sym_false] = ACTIONS(582),
    [sym_character_literal] = ACTIONS(580),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(580),
    [sym_null_literal] = ACTIONS(582),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(582),
    [anon_sym_DASH] = ACTIONS(582),
    [anon_sym_final] = ACTIONS(582),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_PLUS_PLUS] = ACTIONS(580),
    [anon_sym_DASH_DASH] = ACTIONS(580),
    [anon_sym_new] = ACTIONS(582),
    [anon_sym_class] = ACTIONS(582),
    [anon_sym_switch] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(580),
    [anon_sym_case] = ACTIONS(582),
    [anon_sym_default] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(580),
    [anon_sym_assert] = ACTIONS(582),
    [anon_sym_do] = ACTIONS(582),
    [anon_sym_while] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(582),
    [anon_sym_continue] = ACTIONS(582),
    [anon_sym_return] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(582),
    [anon_sym_synchronized] = ACTIONS(582),
    [anon_sym_throw] = ACTIONS(582),
    [anon_sym_try] = ACTIONS(582),
    [anon_sym_if] = ACTIONS(582),
    [anon_sym_else] = ACTIONS(582),
    [anon_sym_for] = ACTIONS(582),
    [anon_sym_AT] = ACTIONS(582),
    [anon_sym_open] = ACTIONS(582),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_static] = ACTIONS(582),
    [anon_sym_package] = ACTIONS(582),
    [anon_sym_import] = ACTIONS(582),
    [anon_sym_enum] = ACTIONS(582),
    [anon_sym_public] = ACTIONS(582),
    [anon_sym_protected] = ACTIONS(582),
    [anon_sym_private] = ACTIONS(582),
    [anon_sym_abstract] = ACTIONS(582),
    [anon_sym_strictfp] = ACTIONS(582),
    [anon_sym_native] = ACTIONS(582),
    [anon_sym_transient] = ACTIONS(582),
    [anon_sym_volatile] = ACTIONS(582),
    [anon_sym_sealed] = ACTIONS(582),
    [anon_sym_non_DASHsealed] = ACTIONS(580),
    [anon_sym_record] = ACTIONS(582),
    [anon_sym_ATinterface] = ACTIONS(580),
    [anon_sym_interface] = ACTIONS(582),
    [anon_sym_byte] = ACTIONS(582),
    [anon_sym_short] = ACTIONS(582),
    [anon_sym_int] = ACTIONS(582),
    [anon_sym_long] = ACTIONS(582),
    [anon_sym_char] = ACTIONS(582),
    [anon_sym_float] = ACTIONS(582),
    [anon_sym_double] = ACTIONS(582),
    [sym_boolean_type] = ACTIONS(582),
    [sym_void_type] = ACTIONS(582),
    [sym_this] = ACTIONS(582),
    [sym_super] = ACTIONS(582),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [208] = {
    [ts_builtin_sym_end] = ACTIONS(584),
    [sym_identifier] = ACTIONS(586),
    [sym_decimal_integer_literal] = ACTIONS(586),
    [sym_hex_integer_literal] = ACTIONS(586),
    [sym_octal_integer_literal] = ACTIONS(586),
    [sym_binary_integer_literal] = ACTIONS(584),
    [sym_decimal_floating_point_literal] = ACTIONS(584),
    [sym_hex_floating_point_literal] = ACTIONS(586),
    [sym_true] = ACTIONS(586),
    [sym_false] = ACTIONS(586),
    [sym_character_literal] = ACTIONS(584),
    [anon_sym_DQUOTE] = ACTIONS(586),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(584),
    [sym_null_literal] = ACTIONS(586),
    [anon_sym_LPAREN] = ACTIONS(584),
    [anon_sym_LT] = ACTIONS(584),
    [anon_sym_PLUS] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(586),
    [anon_sym_final] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(584),
    [anon_sym_PLUS_PLUS] = ACTIONS(584),
    [anon_sym_DASH_DASH] = ACTIONS(584),
    [anon_sym_new] = ACTIONS(586),
    [anon_sym_class] = ACTIONS(586),
    [anon_sym_switch] = ACTIONS(586),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_RBRACE] = ACTIONS(584),
    [anon_sym_case] = ACTIONS(586),
    [anon_sym_default] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(584),
    [anon_sym_assert] = ACTIONS(586),
    [anon_sym_do] = ACTIONS(586),
    [anon_sym_while] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(586),
    [anon_sym_continue] = ACTIONS(586),
    [anon_sym_return] = ACTIONS(586),
    [anon_sym_yield] = ACTIONS(586),
    [anon_sym_synchronized] = ACTIONS(586),
    [anon_sym_throw] = ACTIONS(586),
    [anon_sym_try] = ACTIONS(586),
    [anon_sym_if] = ACTIONS(586),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_for] = ACTIONS(586),
    [anon_sym_AT] = ACTIONS(586),
    [anon_sym_open] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_package] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_enum] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_abstract] = ACTIONS(586),
    [anon_sym_strictfp] = ACTIONS(586),
    [anon_sym_native] = ACTIONS(586),
    [anon_sym_transient] = ACTIONS(586),
    [anon_sym_volatile] = ACTIONS(586),
    [anon_sym_sealed] = ACTIONS(586),
    [anon_sym_non_DASHsealed] = ACTIONS(584),
    [anon_sym_record] = ACTIONS(586),
    [anon_sym_ATinterface] = ACTIONS(584),
    [anon_sym_interface] = ACTIONS(586),
    [anon_sym_byte] = ACTIONS(586),
    [anon_sym_short] = ACTIONS(586),
    [anon_sym_int] = ACTIONS(586),
    [anon_sym_long] = ACTIONS(586),
    [anon_sym_char] = ACTIONS(586),
    [anon_sym_float] = ACTIONS(586),
    [anon_sym_double] = ACTIONS(586),
    [sym_boolean_type] = ACTIONS(586),
    [sym_void_type] = ACTIONS(586),
    [sym_this] = ACTIONS(586),
    [sym_super] = ACTIONS(586),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [209] = {
    [ts_builtin_sym_end] = ACTIONS(588),
    [sym_identifier] = ACTIONS(590),
    [sym_decimal_integer_literal] = ACTIONS(590),
    [sym_hex_integer_literal] = ACTIONS(590),
    [sym_octal_integer_literal] = ACTIONS(590),
    [sym_binary_integer_literal] = ACTIONS(588),
    [sym_decimal_floating_point_literal] = ACTIONS(588),
    [sym_hex_floating_point_literal] = ACTIONS(590),
    [sym_true] = ACTIONS(590),
    [sym_false] = ACTIONS(590),
    [sym_character_literal] = ACTIONS(588),
    [anon_sym_DQUOTE] = ACTIONS(590),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(588),
    [sym_null_literal] = ACTIONS(590),
    [anon_sym_LPAREN] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_final] = ACTIONS(590),
    [anon_sym_BANG] = ACTIONS(588),
    [anon_sym_TILDE] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(590),
    [anon_sym_switch] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(588),
    [anon_sym_RBRACE] = ACTIONS(588),
    [anon_sym_case] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_assert] = ACTIONS(590),
    [anon_sym_do] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_yield] = ACTIONS(590),
    [anon_sym_synchronized] = ACTIONS(590),
    [anon_sym_throw] = ACTIONS(590),
    [anon_sym_try] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_AT] = ACTIONS(590),
    [anon_sym_open] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_package] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(590),
    [anon_sym_strictfp] = ACTIONS(590),
    [anon_sym_native] = ACTIONS(590),
    [anon_sym_transient] = ACTIONS(590),
    [anon_sym_volatile] = ACTIONS(590),
    [anon_sym_sealed] = ACTIONS(590),
    [anon_sym_non_DASHsealed] = ACTIONS(588),
    [anon_sym_record] = ACTIONS(590),
    [anon_sym_ATinterface] = ACTIONS(588),
    [anon_sym_interface] = ACTIONS(590),
    [anon_sym_byte] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [anon_sym_int] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_float] = ACTIONS(590),
    [anon_sym_double] = ACTIONS(590),
    [sym_boolean_type] = ACTIONS(590),
    [sym_void_type] = ACTIONS(590),
    [sym_this] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(592),
    [sym_identifier] = ACTIONS(594),
    [sym_decimal_integer_literal] = ACTIONS(594),
    [sym_hex_integer_literal] = ACTIONS(594),
    [sym_octal_integer_literal] = ACTIONS(594),
    [sym_binary_integer_literal] = ACTIONS(592),
    [sym_decimal_floating_point_literal] = ACTIONS(592),
    [sym_hex_floating_point_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(594),
    [sym_false] = ACTIONS(594),
    [sym_character_literal] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(592),
    [sym_null_literal] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(592),
    [anon_sym_PLUS] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(594),
    [anon_sym_final] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(592),
    [anon_sym_TILDE] = ACTIONS(592),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(592),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_class] = ACTIONS(594),
    [anon_sym_switch] = ACTIONS(594),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_RBRACE] = ACTIONS(592),
    [anon_sym_case] = ACTIONS(594),
    [anon_sym_default] = ACTIONS(594),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_assert] = ACTIONS(594),
    [anon_sym_do] = ACTIONS(594),
    [anon_sym_while] = ACTIONS(594),
    [anon_sym_break] = ACTIONS(594),
    [anon_sym_continue] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(594),
    [anon_sym_yield] = ACTIONS(594),
    [anon_sym_synchronized] = ACTIONS(594),
    [anon_sym_throw] = ACTIONS(594),
    [anon_sym_try] = ACTIONS(594),
    [anon_sym_if] = ACTIONS(594),
    [anon_sym_else] = ACTIONS(594),
    [anon_sym_for] = ACTIONS(594),
    [anon_sym_AT] = ACTIONS(594),
    [anon_sym_open] = ACTIONS(594),
    [anon_sym_module] = ACTIONS(594),
    [anon_sym_static] = ACTIONS(594),
    [anon_sym_package] = ACTIONS(594),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_enum] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(594),
    [anon_sym_protected] = ACTIONS(594),
    [anon_sym_private] = ACTIONS(594),
    [anon_sym_abstract] = ACTIONS(594),
    [anon_sym_strictfp] = ACTIONS(594),
    [anon_sym_native] = ACTIONS(594),
    [anon_sym_transient] = ACTIONS(594),
    [anon_sym_volatile] = ACTIONS(594),
    [anon_sym_sealed] = ACTIONS(594),
    [anon_sym_non_DASHsealed] = ACTIONS(592),
    [anon_sym_record] = ACTIONS(594),
    [anon_sym_ATinterface] = ACTIONS(592),
    [anon_sym_interface] = ACTIONS(594),
    [anon_sym_byte] = ACTIONS(594),
    [anon_sym_short] = ACTIONS(594),
    [anon_sym_int] = ACTIONS(594),
    [anon_sym_long] = ACTIONS(594),
    [anon_sym_char] = ACTIONS(594),
    [anon_sym_float] = ACTIONS(594),
    [anon_sym_double] = ACTIONS(594),
    [sym_boolean_type] = ACTIONS(594),
    [sym_void_type] = ACTIONS(594),
    [sym_this] = ACTIONS(594),
    [sym_super] = ACTIONS(594),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(596),
    [sym_identifier] = ACTIONS(598),
    [sym_decimal_integer_literal] = ACTIONS(598),
    [sym_hex_integer_literal] = ACTIONS(598),
    [sym_octal_integer_literal] = ACTIONS(598),
    [sym_binary_integer_literal] = ACTIONS(596),
    [sym_decimal_floating_point_literal] = ACTIONS(596),
    [sym_hex_floating_point_literal] = ACTIONS(598),
    [sym_true] = ACTIONS(598),
    [sym_false] = ACTIONS(598),
    [sym_character_literal] = ACTIONS(596),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(596),
    [sym_null_literal] = ACTIONS(598),
    [anon_sym_LPAREN] = ACTIONS(596),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_PLUS] = ACTIONS(598),
    [anon_sym_DASH] = ACTIONS(598),
    [anon_sym_final] = ACTIONS(598),
    [anon_sym_BANG] = ACTIONS(596),
    [anon_sym_TILDE] = ACTIONS(596),
    [anon_sym_PLUS_PLUS] = ACTIONS(596),
    [anon_sym_DASH_DASH] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_class] = ACTIONS(598),
    [anon_sym_switch] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(596),
    [anon_sym_RBRACE] = ACTIONS(596),
    [anon_sym_case] = ACTIONS(598),
    [anon_sym_default] = ACTIONS(598),
    [anon_sym_SEMI] = ACTIONS(596),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(598),
    [anon_sym_while] = ACTIONS(598),
    [anon_sym_break] = ACTIONS(598),
    [anon_sym_continue] = ACTIONS(598),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_synchronized] = ACTIONS(598),
    [anon_sym_throw] = ACTIONS(598),
    [anon_sym_try] = ACTIONS(598),
    [anon_sym_if] = ACTIONS(598),
    [anon_sym_else] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(598),
    [anon_sym_open] = ACTIONS(598),
    [anon_sym_module] = ACTIONS(598),
    [anon_sym_static] = ACTIONS(598),
    [anon_sym_package] = ACTIONS(598),
    [anon_sym_import] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(598),
    [anon_sym_public] = ACTIONS(598),
    [anon_sym_protected] = ACTIONS(598),
    [anon_sym_private] = ACTIONS(598),
    [anon_sym_abstract] = ACTIONS(598),
    [anon_sym_strictfp] = ACTIONS(598),
    [anon_sym_native] = ACTIONS(598),
    [anon_sym_transient] = ACTIONS(598),
    [anon_sym_volatile] = ACTIONS(598),
    [anon_sym_sealed] = ACTIONS(598),
    [anon_sym_non_DASHsealed] = ACTIONS(596),
    [anon_sym_record] = ACTIONS(598),
    [anon_sym_ATinterface] = ACTIONS(596),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_byte] = ACTIONS(598),
    [anon_sym_short] = ACTIONS(598),
    [anon_sym_int] = ACTIONS(598),
    [anon_sym_long] = ACTIONS(598),
    [anon_sym_char] = ACTIONS(598),
    [anon_sym_float] = ACTIONS(598),
    [anon_sym_double] = ACTIONS(598),
    [sym_boolean_type] = ACTIONS(598),
    [sym_void_type] = ACTIONS(598),
    [sym_this] = ACTIONS(598),
    [sym_super] = ACTIONS(598),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [212] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(655),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(600),
    [sym_identifier] = ACTIONS(602),
    [sym_decimal_integer_literal] = ACTIONS(602),
    [sym_hex_integer_literal] = ACTIONS(602),
    [sym_octal_integer_literal] = ACTIONS(602),
    [sym_binary_integer_literal] = ACTIONS(600),
    [sym_decimal_floating_point_literal] = ACTIONS(600),
    [sym_hex_floating_point_literal] = ACTIONS(602),
    [sym_true] = ACTIONS(602),
    [sym_false] = ACTIONS(602),
    [sym_character_literal] = ACTIONS(600),
    [anon_sym_DQUOTE] = ACTIONS(602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(600),
    [sym_null_literal] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_final] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_TILDE] = ACTIONS(600),
    [anon_sym_PLUS_PLUS] = ACTIONS(600),
    [anon_sym_DASH_DASH] = ACTIONS(600),
    [anon_sym_new] = ACTIONS(602),
    [anon_sym_class] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(602),
    [anon_sym_LBRACE] = ACTIONS(600),
    [anon_sym_RBRACE] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(602),
    [anon_sym_default] = ACTIONS(602),
    [anon_sym_SEMI] = ACTIONS(600),
    [anon_sym_assert] = ACTIONS(602),
    [anon_sym_do] = ACTIONS(602),
    [anon_sym_while] = ACTIONS(602),
    [anon_sym_break] = ACTIONS(602),
    [anon_sym_continue] = ACTIONS(602),
    [anon_sym_return] = ACTIONS(602),
    [anon_sym_yield] = ACTIONS(602),
    [anon_sym_synchronized] = ACTIONS(602),
    [anon_sym_throw] = ACTIONS(602),
    [anon_sym_try] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_else] = ACTIONS(602),
    [anon_sym_for] = ACTIONS(602),
    [anon_sym_AT] = ACTIONS(602),
    [anon_sym_open] = ACTIONS(602),
    [anon_sym_module] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(602),
    [anon_sym_package] = ACTIONS(602),
    [anon_sym_import] = ACTIONS(602),
    [anon_sym_enum] = ACTIONS(602),
    [anon_sym_public] = ACTIONS(602),
    [anon_sym_protected] = ACTIONS(602),
    [anon_sym_private] = ACTIONS(602),
    [anon_sym_abstract] = ACTIONS(602),
    [anon_sym_strictfp] = ACTIONS(602),
    [anon_sym_native] = ACTIONS(602),
    [anon_sym_transient] = ACTIONS(602),
    [anon_sym_volatile] = ACTIONS(602),
    [anon_sym_sealed] = ACTIONS(602),
    [anon_sym_non_DASHsealed] = ACTIONS(600),
    [anon_sym_record] = ACTIONS(602),
    [anon_sym_ATinterface] = ACTIONS(600),
    [anon_sym_interface] = ACTIONS(602),
    [anon_sym_byte] = ACTIONS(602),
    [anon_sym_short] = ACTIONS(602),
    [anon_sym_int] = ACTIONS(602),
    [anon_sym_long] = ACTIONS(602),
    [anon_sym_char] = ACTIONS(602),
    [anon_sym_float] = ACTIONS(602),
    [anon_sym_double] = ACTIONS(602),
    [sym_boolean_type] = ACTIONS(602),
    [sym_void_type] = ACTIONS(602),
    [sym_this] = ACTIONS(602),
    [sym_super] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [214] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(656),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(604),
    [sym_identifier] = ACTIONS(606),
    [sym_decimal_integer_literal] = ACTIONS(606),
    [sym_hex_integer_literal] = ACTIONS(606),
    [sym_octal_integer_literal] = ACTIONS(606),
    [sym_binary_integer_literal] = ACTIONS(604),
    [sym_decimal_floating_point_literal] = ACTIONS(604),
    [sym_hex_floating_point_literal] = ACTIONS(606),
    [sym_true] = ACTIONS(606),
    [sym_false] = ACTIONS(606),
    [sym_character_literal] = ACTIONS(604),
    [anon_sym_DQUOTE] = ACTIONS(606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(604),
    [sym_null_literal] = ACTIONS(606),
    [anon_sym_LPAREN] = ACTIONS(604),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_final] = ACTIONS(606),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_TILDE] = ACTIONS(604),
    [anon_sym_PLUS_PLUS] = ACTIONS(604),
    [anon_sym_DASH_DASH] = ACTIONS(604),
    [anon_sym_new] = ACTIONS(606),
    [anon_sym_class] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(606),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_RBRACE] = ACTIONS(604),
    [anon_sym_case] = ACTIONS(606),
    [anon_sym_default] = ACTIONS(606),
    [anon_sym_SEMI] = ACTIONS(604),
    [anon_sym_assert] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(606),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_break] = ACTIONS(606),
    [anon_sym_continue] = ACTIONS(606),
    [anon_sym_return] = ACTIONS(606),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_synchronized] = ACTIONS(606),
    [anon_sym_throw] = ACTIONS(606),
    [anon_sym_try] = ACTIONS(606),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_else] = ACTIONS(606),
    [anon_sym_for] = ACTIONS(606),
    [anon_sym_AT] = ACTIONS(606),
    [anon_sym_open] = ACTIONS(606),
    [anon_sym_module] = ACTIONS(606),
    [anon_sym_static] = ACTIONS(606),
    [anon_sym_package] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(606),
    [anon_sym_enum] = ACTIONS(606),
    [anon_sym_public] = ACTIONS(606),
    [anon_sym_protected] = ACTIONS(606),
    [anon_sym_private] = ACTIONS(606),
    [anon_sym_abstract] = ACTIONS(606),
    [anon_sym_strictfp] = ACTIONS(606),
    [anon_sym_native] = ACTIONS(606),
    [anon_sym_transient] = ACTIONS(606),
    [anon_sym_volatile] = ACTIONS(606),
    [anon_sym_sealed] = ACTIONS(606),
    [anon_sym_non_DASHsealed] = ACTIONS(604),
    [anon_sym_record] = ACTIONS(606),
    [anon_sym_ATinterface] = ACTIONS(604),
    [anon_sym_interface] = ACTIONS(606),
    [anon_sym_byte] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [anon_sym_int] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_char] = ACTIONS(606),
    [anon_sym_float] = ACTIONS(606),
    [anon_sym_double] = ACTIONS(606),
    [sym_boolean_type] = ACTIONS(606),
    [sym_void_type] = ACTIONS(606),
    [sym_this] = ACTIONS(606),
    [sym_super] = ACTIONS(606),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [216] = {
    [ts_builtin_sym_end] = ACTIONS(608),
    [sym_identifier] = ACTIONS(610),
    [sym_decimal_integer_literal] = ACTIONS(610),
    [sym_hex_integer_literal] = ACTIONS(610),
    [sym_octal_integer_literal] = ACTIONS(610),
    [sym_binary_integer_literal] = ACTIONS(608),
    [sym_decimal_floating_point_literal] = ACTIONS(608),
    [sym_hex_floating_point_literal] = ACTIONS(610),
    [sym_true] = ACTIONS(610),
    [sym_false] = ACTIONS(610),
    [sym_character_literal] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(608),
    [sym_null_literal] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(608),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_final] = ACTIONS(610),
    [anon_sym_BANG] = ACTIONS(608),
    [anon_sym_TILDE] = ACTIONS(608),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_new] = ACTIONS(610),
    [anon_sym_class] = ACTIONS(610),
    [anon_sym_switch] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(608),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_default] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_assert] = ACTIONS(610),
    [anon_sym_do] = ACTIONS(610),
    [anon_sym_while] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(610),
    [anon_sym_continue] = ACTIONS(610),
    [anon_sym_return] = ACTIONS(610),
    [anon_sym_yield] = ACTIONS(610),
    [anon_sym_synchronized] = ACTIONS(610),
    [anon_sym_throw] = ACTIONS(610),
    [anon_sym_try] = ACTIONS(610),
    [anon_sym_if] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(610),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_open] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_package] = ACTIONS(610),
    [anon_sym_import] = ACTIONS(610),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_abstract] = ACTIONS(610),
    [anon_sym_strictfp] = ACTIONS(610),
    [anon_sym_native] = ACTIONS(610),
    [anon_sym_transient] = ACTIONS(610),
    [anon_sym_volatile] = ACTIONS(610),
    [anon_sym_sealed] = ACTIONS(610),
    [anon_sym_non_DASHsealed] = ACTIONS(608),
    [anon_sym_record] = ACTIONS(610),
    [anon_sym_ATinterface] = ACTIONS(608),
    [anon_sym_interface] = ACTIONS(610),
    [anon_sym_byte] = ACTIONS(610),
    [anon_sym_short] = ACTIONS(610),
    [anon_sym_int] = ACTIONS(610),
    [anon_sym_long] = ACTIONS(610),
    [anon_sym_char] = ACTIONS(610),
    [anon_sym_float] = ACTIONS(610),
    [anon_sym_double] = ACTIONS(610),
    [sym_boolean_type] = ACTIONS(610),
    [sym_void_type] = ACTIONS(610),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(610),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [217] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(603),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(572),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [219] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(601),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [220] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(541),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(600),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(599),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [223] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(597),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [224] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(596),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [225] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(594),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [226] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(589),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [227] = {
    [ts_builtin_sym_end] = ACTIONS(612),
    [sym_identifier] = ACTIONS(614),
    [sym_decimal_integer_literal] = ACTIONS(614),
    [sym_hex_integer_literal] = ACTIONS(614),
    [sym_octal_integer_literal] = ACTIONS(614),
    [sym_binary_integer_literal] = ACTIONS(612),
    [sym_decimal_floating_point_literal] = ACTIONS(612),
    [sym_hex_floating_point_literal] = ACTIONS(614),
    [sym_true] = ACTIONS(614),
    [sym_false] = ACTIONS(614),
    [sym_character_literal] = ACTIONS(612),
    [anon_sym_DQUOTE] = ACTIONS(614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(612),
    [sym_null_literal] = ACTIONS(614),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_PLUS] = ACTIONS(614),
    [anon_sym_DASH] = ACTIONS(614),
    [anon_sym_final] = ACTIONS(614),
    [anon_sym_BANG] = ACTIONS(612),
    [anon_sym_TILDE] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(612),
    [anon_sym_DASH_DASH] = ACTIONS(612),
    [anon_sym_new] = ACTIONS(614),
    [anon_sym_class] = ACTIONS(614),
    [anon_sym_switch] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_RBRACE] = ACTIONS(612),
    [anon_sym_case] = ACTIONS(614),
    [anon_sym_default] = ACTIONS(614),
    [anon_sym_SEMI] = ACTIONS(612),
    [anon_sym_assert] = ACTIONS(614),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_while] = ACTIONS(614),
    [anon_sym_break] = ACTIONS(614),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_return] = ACTIONS(614),
    [anon_sym_yield] = ACTIONS(614),
    [anon_sym_synchronized] = ACTIONS(614),
    [anon_sym_throw] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(614),
    [anon_sym_if] = ACTIONS(614),
    [anon_sym_else] = ACTIONS(614),
    [anon_sym_for] = ACTIONS(614),
    [anon_sym_AT] = ACTIONS(614),
    [anon_sym_open] = ACTIONS(614),
    [anon_sym_module] = ACTIONS(614),
    [anon_sym_static] = ACTIONS(614),
    [anon_sym_package] = ACTIONS(614),
    [anon_sym_import] = ACTIONS(614),
    [anon_sym_enum] = ACTIONS(614),
    [anon_sym_public] = ACTIONS(614),
    [anon_sym_protected] = ACTIONS(614),
    [anon_sym_private] = ACTIONS(614),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_strictfp] = ACTIONS(614),
    [anon_sym_native] = ACTIONS(614),
    [anon_sym_transient] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym_sealed] = ACTIONS(614),
    [anon_sym_non_DASHsealed] = ACTIONS(612),
    [anon_sym_record] = ACTIONS(614),
    [anon_sym_ATinterface] = ACTIONS(612),
    [anon_sym_interface] = ACTIONS(614),
    [anon_sym_byte] = ACTIONS(614),
    [anon_sym_short] = ACTIONS(614),
    [anon_sym_int] = ACTIONS(614),
    [anon_sym_long] = ACTIONS(614),
    [anon_sym_char] = ACTIONS(614),
    [anon_sym_float] = ACTIONS(614),
    [anon_sym_double] = ACTIONS(614),
    [sym_boolean_type] = ACTIONS(614),
    [sym_void_type] = ACTIONS(614),
    [sym_this] = ACTIONS(614),
    [sym_super] = ACTIONS(614),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [228] = {
    [ts_builtin_sym_end] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_decimal_integer_literal] = ACTIONS(618),
    [sym_hex_integer_literal] = ACTIONS(618),
    [sym_octal_integer_literal] = ACTIONS(618),
    [sym_binary_integer_literal] = ACTIONS(616),
    [sym_decimal_floating_point_literal] = ACTIONS(616),
    [sym_hex_floating_point_literal] = ACTIONS(618),
    [sym_true] = ACTIONS(618),
    [sym_false] = ACTIONS(618),
    [sym_character_literal] = ACTIONS(616),
    [anon_sym_DQUOTE] = ACTIONS(618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(616),
    [sym_null_literal] = ACTIONS(618),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_LT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_final] = ACTIONS(618),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(616),
    [anon_sym_DASH_DASH] = ACTIONS(616),
    [anon_sym_new] = ACTIONS(618),
    [anon_sym_class] = ACTIONS(618),
    [anon_sym_switch] = ACTIONS(618),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_case] = ACTIONS(618),
    [anon_sym_default] = ACTIONS(618),
    [anon_sym_SEMI] = ACTIONS(616),
    [anon_sym_assert] = ACTIONS(618),
    [anon_sym_do] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(618),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(618),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(618),
    [anon_sym_synchronized] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(618),
    [anon_sym_try] = ACTIONS(618),
    [anon_sym_if] = ACTIONS(618),
    [anon_sym_else] = ACTIONS(618),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_AT] = ACTIONS(618),
    [anon_sym_open] = ACTIONS(618),
    [anon_sym_module] = ACTIONS(618),
    [anon_sym_static] = ACTIONS(618),
    [anon_sym_package] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(618),
    [anon_sym_enum] = ACTIONS(618),
    [anon_sym_public] = ACTIONS(618),
    [anon_sym_protected] = ACTIONS(618),
    [anon_sym_private] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(618),
    [anon_sym_strictfp] = ACTIONS(618),
    [anon_sym_native] = ACTIONS(618),
    [anon_sym_transient] = ACTIONS(618),
    [anon_sym_volatile] = ACTIONS(618),
    [anon_sym_sealed] = ACTIONS(618),
    [anon_sym_non_DASHsealed] = ACTIONS(616),
    [anon_sym_record] = ACTIONS(618),
    [anon_sym_ATinterface] = ACTIONS(616),
    [anon_sym_interface] = ACTIONS(618),
    [anon_sym_byte] = ACTIONS(618),
    [anon_sym_short] = ACTIONS(618),
    [anon_sym_int] = ACTIONS(618),
    [anon_sym_long] = ACTIONS(618),
    [anon_sym_char] = ACTIONS(618),
    [anon_sym_float] = ACTIONS(618),
    [anon_sym_double] = ACTIONS(618),
    [sym_boolean_type] = ACTIONS(618),
    [sym_void_type] = ACTIONS(618),
    [sym_this] = ACTIONS(618),
    [sym_super] = ACTIONS(618),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [229] = {
    [ts_builtin_sym_end] = ACTIONS(620),
    [sym_identifier] = ACTIONS(622),
    [sym_decimal_integer_literal] = ACTIONS(622),
    [sym_hex_integer_literal] = ACTIONS(622),
    [sym_octal_integer_literal] = ACTIONS(622),
    [sym_binary_integer_literal] = ACTIONS(620),
    [sym_decimal_floating_point_literal] = ACTIONS(620),
    [sym_hex_floating_point_literal] = ACTIONS(622),
    [sym_true] = ACTIONS(622),
    [sym_false] = ACTIONS(622),
    [sym_character_literal] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(620),
    [sym_null_literal] = ACTIONS(622),
    [anon_sym_LPAREN] = ACTIONS(620),
    [anon_sym_LT] = ACTIONS(620),
    [anon_sym_PLUS] = ACTIONS(622),
    [anon_sym_DASH] = ACTIONS(622),
    [anon_sym_final] = ACTIONS(622),
    [anon_sym_BANG] = ACTIONS(620),
    [anon_sym_TILDE] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_switch] = ACTIONS(622),
    [anon_sym_LBRACE] = ACTIONS(620),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_case] = ACTIONS(622),
    [anon_sym_default] = ACTIONS(622),
    [anon_sym_SEMI] = ACTIONS(620),
    [anon_sym_assert] = ACTIONS(622),
    [anon_sym_do] = ACTIONS(622),
    [anon_sym_while] = ACTIONS(622),
    [anon_sym_break] = ACTIONS(622),
    [anon_sym_continue] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(622),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_synchronized] = ACTIONS(622),
    [anon_sym_throw] = ACTIONS(622),
    [anon_sym_try] = ACTIONS(622),
    [anon_sym_if] = ACTIONS(622),
    [anon_sym_else] = ACTIONS(622),
    [anon_sym_for] = ACTIONS(622),
    [anon_sym_AT] = ACTIONS(622),
    [anon_sym_open] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_static] = ACTIONS(622),
    [anon_sym_package] = ACTIONS(622),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_enum] = ACTIONS(622),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_abstract] = ACTIONS(622),
    [anon_sym_strictfp] = ACTIONS(622),
    [anon_sym_native] = ACTIONS(622),
    [anon_sym_transient] = ACTIONS(622),
    [anon_sym_volatile] = ACTIONS(622),
    [anon_sym_sealed] = ACTIONS(622),
    [anon_sym_non_DASHsealed] = ACTIONS(620),
    [anon_sym_record] = ACTIONS(622),
    [anon_sym_ATinterface] = ACTIONS(620),
    [anon_sym_interface] = ACTIONS(622),
    [anon_sym_byte] = ACTIONS(622),
    [anon_sym_short] = ACTIONS(622),
    [anon_sym_int] = ACTIONS(622),
    [anon_sym_long] = ACTIONS(622),
    [anon_sym_char] = ACTIONS(622),
    [anon_sym_float] = ACTIONS(622),
    [anon_sym_double] = ACTIONS(622),
    [sym_boolean_type] = ACTIONS(622),
    [sym_void_type] = ACTIONS(622),
    [sym_this] = ACTIONS(622),
    [sym_super] = ACTIONS(622),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [230] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(586),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_decimal_integer_literal] = ACTIONS(626),
    [sym_hex_integer_literal] = ACTIONS(626),
    [sym_octal_integer_literal] = ACTIONS(626),
    [sym_binary_integer_literal] = ACTIONS(624),
    [sym_decimal_floating_point_literal] = ACTIONS(624),
    [sym_hex_floating_point_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(626),
    [sym_false] = ACTIONS(626),
    [sym_character_literal] = ACTIONS(624),
    [anon_sym_DQUOTE] = ACTIONS(626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(624),
    [sym_null_literal] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_final] = ACTIONS(626),
    [anon_sym_BANG] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [anon_sym_PLUS_PLUS] = ACTIONS(624),
    [anon_sym_DASH_DASH] = ACTIONS(624),
    [anon_sym_new] = ACTIONS(626),
    [anon_sym_class] = ACTIONS(626),
    [anon_sym_switch] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_RBRACE] = ACTIONS(624),
    [anon_sym_case] = ACTIONS(626),
    [anon_sym_default] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_assert] = ACTIONS(626),
    [anon_sym_do] = ACTIONS(626),
    [anon_sym_while] = ACTIONS(626),
    [anon_sym_break] = ACTIONS(626),
    [anon_sym_continue] = ACTIONS(626),
    [anon_sym_return] = ACTIONS(626),
    [anon_sym_yield] = ACTIONS(626),
    [anon_sym_synchronized] = ACTIONS(626),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_try] = ACTIONS(626),
    [anon_sym_if] = ACTIONS(626),
    [anon_sym_else] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(626),
    [anon_sym_open] = ACTIONS(626),
    [anon_sym_module] = ACTIONS(626),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_package] = ACTIONS(626),
    [anon_sym_import] = ACTIONS(626),
    [anon_sym_enum] = ACTIONS(626),
    [anon_sym_public] = ACTIONS(626),
    [anon_sym_protected] = ACTIONS(626),
    [anon_sym_private] = ACTIONS(626),
    [anon_sym_abstract] = ACTIONS(626),
    [anon_sym_strictfp] = ACTIONS(626),
    [anon_sym_native] = ACTIONS(626),
    [anon_sym_transient] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym_sealed] = ACTIONS(626),
    [anon_sym_non_DASHsealed] = ACTIONS(624),
    [anon_sym_record] = ACTIONS(626),
    [anon_sym_ATinterface] = ACTIONS(624),
    [anon_sym_interface] = ACTIONS(626),
    [anon_sym_byte] = ACTIONS(626),
    [anon_sym_short] = ACTIONS(626),
    [anon_sym_int] = ACTIONS(626),
    [anon_sym_long] = ACTIONS(626),
    [anon_sym_char] = ACTIONS(626),
    [anon_sym_float] = ACTIONS(626),
    [anon_sym_double] = ACTIONS(626),
    [sym_boolean_type] = ACTIONS(626),
    [sym_void_type] = ACTIONS(626),
    [sym_this] = ACTIONS(626),
    [sym_super] = ACTIONS(626),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [232] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(573),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1273),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(400),
    [sym_array_access] = STATE(400),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1273),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(376),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [233] = {
    [ts_builtin_sym_end] = ACTIONS(628),
    [sym_identifier] = ACTIONS(630),
    [sym_decimal_integer_literal] = ACTIONS(630),
    [sym_hex_integer_literal] = ACTIONS(630),
    [sym_octal_integer_literal] = ACTIONS(630),
    [sym_binary_integer_literal] = ACTIONS(628),
    [sym_decimal_floating_point_literal] = ACTIONS(628),
    [sym_hex_floating_point_literal] = ACTIONS(630),
    [sym_true] = ACTIONS(630),
    [sym_false] = ACTIONS(630),
    [sym_character_literal] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(628),
    [sym_null_literal] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(630),
    [anon_sym_final] = ACTIONS(630),
    [anon_sym_BANG] = ACTIONS(628),
    [anon_sym_TILDE] = ACTIONS(628),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(630),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_switch] = ACTIONS(630),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_RBRACE] = ACTIONS(628),
    [anon_sym_case] = ACTIONS(630),
    [anon_sym_default] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_assert] = ACTIONS(630),
    [anon_sym_do] = ACTIONS(630),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_break] = ACTIONS(630),
    [anon_sym_continue] = ACTIONS(630),
    [anon_sym_return] = ACTIONS(630),
    [anon_sym_yield] = ACTIONS(630),
    [anon_sym_synchronized] = ACTIONS(630),
    [anon_sym_throw] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_else] = ACTIONS(630),
    [anon_sym_for] = ACTIONS(630),
    [anon_sym_AT] = ACTIONS(630),
    [anon_sym_open] = ACTIONS(630),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_static] = ACTIONS(630),
    [anon_sym_package] = ACTIONS(630),
    [anon_sym_import] = ACTIONS(630),
    [anon_sym_enum] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(630),
    [anon_sym_protected] = ACTIONS(630),
    [anon_sym_private] = ACTIONS(630),
    [anon_sym_abstract] = ACTIONS(630),
    [anon_sym_strictfp] = ACTIONS(630),
    [anon_sym_native] = ACTIONS(630),
    [anon_sym_transient] = ACTIONS(630),
    [anon_sym_volatile] = ACTIONS(630),
    [anon_sym_sealed] = ACTIONS(630),
    [anon_sym_non_DASHsealed] = ACTIONS(628),
    [anon_sym_record] = ACTIONS(630),
    [anon_sym_ATinterface] = ACTIONS(628),
    [anon_sym_interface] = ACTIONS(630),
    [anon_sym_byte] = ACTIONS(630),
    [anon_sym_short] = ACTIONS(630),
    [anon_sym_int] = ACTIONS(630),
    [anon_sym_long] = ACTIONS(630),
    [anon_sym_char] = ACTIONS(630),
    [anon_sym_float] = ACTIONS(630),
    [anon_sym_double] = ACTIONS(630),
    [sym_boolean_type] = ACTIONS(630),
    [sym_void_type] = ACTIONS(630),
    [sym_this] = ACTIONS(630),
    [sym_super] = ACTIONS(630),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(632),
    [sym_identifier] = ACTIONS(634),
    [sym_decimal_integer_literal] = ACTIONS(634),
    [sym_hex_integer_literal] = ACTIONS(634),
    [sym_octal_integer_literal] = ACTIONS(634),
    [sym_binary_integer_literal] = ACTIONS(632),
    [sym_decimal_floating_point_literal] = ACTIONS(632),
    [sym_hex_floating_point_literal] = ACTIONS(634),
    [sym_true] = ACTIONS(634),
    [sym_false] = ACTIONS(634),
    [sym_character_literal] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(634),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(632),
    [sym_null_literal] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_final] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(634),
    [anon_sym_class] = ACTIONS(634),
    [anon_sym_switch] = ACTIONS(634),
    [anon_sym_LBRACE] = ACTIONS(632),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_case] = ACTIONS(634),
    [anon_sym_default] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_assert] = ACTIONS(634),
    [anon_sym_do] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(634),
    [anon_sym_break] = ACTIONS(634),
    [anon_sym_continue] = ACTIONS(634),
    [anon_sym_return] = ACTIONS(634),
    [anon_sym_yield] = ACTIONS(634),
    [anon_sym_synchronized] = ACTIONS(634),
    [anon_sym_throw] = ACTIONS(634),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(634),
    [anon_sym_else] = ACTIONS(634),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(634),
    [anon_sym_open] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_package] = ACTIONS(634),
    [anon_sym_import] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_abstract] = ACTIONS(634),
    [anon_sym_strictfp] = ACTIONS(634),
    [anon_sym_native] = ACTIONS(634),
    [anon_sym_transient] = ACTIONS(634),
    [anon_sym_volatile] = ACTIONS(634),
    [anon_sym_sealed] = ACTIONS(634),
    [anon_sym_non_DASHsealed] = ACTIONS(632),
    [anon_sym_record] = ACTIONS(634),
    [anon_sym_ATinterface] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_byte] = ACTIONS(634),
    [anon_sym_short] = ACTIONS(634),
    [anon_sym_int] = ACTIONS(634),
    [anon_sym_long] = ACTIONS(634),
    [anon_sym_char] = ACTIONS(634),
    [anon_sym_float] = ACTIONS(634),
    [anon_sym_double] = ACTIONS(634),
    [sym_boolean_type] = ACTIONS(634),
    [sym_void_type] = ACTIONS(634),
    [sym_this] = ACTIONS(634),
    [sym_super] = ACTIONS(634),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [235] = {
    [ts_builtin_sym_end] = ACTIONS(636),
    [sym_identifier] = ACTIONS(638),
    [sym_decimal_integer_literal] = ACTIONS(638),
    [sym_hex_integer_literal] = ACTIONS(638),
    [sym_octal_integer_literal] = ACTIONS(638),
    [sym_binary_integer_literal] = ACTIONS(636),
    [sym_decimal_floating_point_literal] = ACTIONS(636),
    [sym_hex_floating_point_literal] = ACTIONS(638),
    [sym_true] = ACTIONS(638),
    [sym_false] = ACTIONS(638),
    [sym_character_literal] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(638),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(636),
    [sym_null_literal] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_final] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_class] = ACTIONS(638),
    [anon_sym_switch] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(636),
    [anon_sym_case] = ACTIONS(638),
    [anon_sym_default] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_assert] = ACTIONS(638),
    [anon_sym_do] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_yield] = ACTIONS(638),
    [anon_sym_synchronized] = ACTIONS(638),
    [anon_sym_throw] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_open] = ACTIONS(638),
    [anon_sym_module] = ACTIONS(638),
    [anon_sym_static] = ACTIONS(638),
    [anon_sym_package] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(638),
    [anon_sym_enum] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(638),
    [anon_sym_protected] = ACTIONS(638),
    [anon_sym_private] = ACTIONS(638),
    [anon_sym_abstract] = ACTIONS(638),
    [anon_sym_strictfp] = ACTIONS(638),
    [anon_sym_native] = ACTIONS(638),
    [anon_sym_transient] = ACTIONS(638),
    [anon_sym_volatile] = ACTIONS(638),
    [anon_sym_sealed] = ACTIONS(638),
    [anon_sym_non_DASHsealed] = ACTIONS(636),
    [anon_sym_record] = ACTIONS(638),
    [anon_sym_ATinterface] = ACTIONS(636),
    [anon_sym_interface] = ACTIONS(638),
    [anon_sym_byte] = ACTIONS(638),
    [anon_sym_short] = ACTIONS(638),
    [anon_sym_int] = ACTIONS(638),
    [anon_sym_long] = ACTIONS(638),
    [anon_sym_char] = ACTIONS(638),
    [anon_sym_float] = ACTIONS(638),
    [anon_sym_double] = ACTIONS(638),
    [sym_boolean_type] = ACTIONS(638),
    [sym_void_type] = ACTIONS(638),
    [sym_this] = ACTIONS(638),
    [sym_super] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [236] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(635),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [237] = {
    [ts_builtin_sym_end] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_decimal_integer_literal] = ACTIONS(642),
    [sym_hex_integer_literal] = ACTIONS(642),
    [sym_octal_integer_literal] = ACTIONS(642),
    [sym_binary_integer_literal] = ACTIONS(640),
    [sym_decimal_floating_point_literal] = ACTIONS(640),
    [sym_hex_floating_point_literal] = ACTIONS(642),
    [sym_true] = ACTIONS(642),
    [sym_false] = ACTIONS(642),
    [sym_character_literal] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(640),
    [sym_null_literal] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(642),
    [anon_sym_final] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_new] = ACTIONS(642),
    [anon_sym_class] = ACTIONS(642),
    [anon_sym_switch] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_default] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(640),
    [anon_sym_assert] = ACTIONS(642),
    [anon_sym_do] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_break] = ACTIONS(642),
    [anon_sym_continue] = ACTIONS(642),
    [anon_sym_return] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(642),
    [anon_sym_synchronized] = ACTIONS(642),
    [anon_sym_throw] = ACTIONS(642),
    [anon_sym_try] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(642),
    [anon_sym_open] = ACTIONS(642),
    [anon_sym_module] = ACTIONS(642),
    [anon_sym_static] = ACTIONS(642),
    [anon_sym_package] = ACTIONS(642),
    [anon_sym_import] = ACTIONS(642),
    [anon_sym_enum] = ACTIONS(642),
    [anon_sym_public] = ACTIONS(642),
    [anon_sym_protected] = ACTIONS(642),
    [anon_sym_private] = ACTIONS(642),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_strictfp] = ACTIONS(642),
    [anon_sym_native] = ACTIONS(642),
    [anon_sym_transient] = ACTIONS(642),
    [anon_sym_volatile] = ACTIONS(642),
    [anon_sym_sealed] = ACTIONS(642),
    [anon_sym_non_DASHsealed] = ACTIONS(640),
    [anon_sym_record] = ACTIONS(642),
    [anon_sym_ATinterface] = ACTIONS(640),
    [anon_sym_interface] = ACTIONS(642),
    [anon_sym_byte] = ACTIONS(642),
    [anon_sym_short] = ACTIONS(642),
    [anon_sym_int] = ACTIONS(642),
    [anon_sym_long] = ACTIONS(642),
    [anon_sym_char] = ACTIONS(642),
    [anon_sym_float] = ACTIONS(642),
    [anon_sym_double] = ACTIONS(642),
    [sym_boolean_type] = ACTIONS(642),
    [sym_void_type] = ACTIONS(642),
    [sym_this] = ACTIONS(642),
    [sym_super] = ACTIONS(642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [238] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(645),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [239] = {
    [ts_builtin_sym_end] = ACTIONS(644),
    [sym_identifier] = ACTIONS(646),
    [sym_decimal_integer_literal] = ACTIONS(646),
    [sym_hex_integer_literal] = ACTIONS(646),
    [sym_octal_integer_literal] = ACTIONS(646),
    [sym_binary_integer_literal] = ACTIONS(644),
    [sym_decimal_floating_point_literal] = ACTIONS(644),
    [sym_hex_floating_point_literal] = ACTIONS(646),
    [sym_true] = ACTIONS(646),
    [sym_false] = ACTIONS(646),
    [sym_character_literal] = ACTIONS(644),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(644),
    [sym_null_literal] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_final] = ACTIONS(646),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_TILDE] = ACTIONS(644),
    [anon_sym_PLUS_PLUS] = ACTIONS(644),
    [anon_sym_DASH_DASH] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_case] = ACTIONS(646),
    [anon_sym_default] = ACTIONS(646),
    [anon_sym_SEMI] = ACTIONS(644),
    [anon_sym_assert] = ACTIONS(646),
    [anon_sym_do] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(646),
    [anon_sym_break] = ACTIONS(646),
    [anon_sym_continue] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(646),
    [anon_sym_yield] = ACTIONS(646),
    [anon_sym_synchronized] = ACTIONS(646),
    [anon_sym_throw] = ACTIONS(646),
    [anon_sym_try] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_for] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_open] = ACTIONS(646),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_static] = ACTIONS(646),
    [anon_sym_package] = ACTIONS(646),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_enum] = ACTIONS(646),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_abstract] = ACTIONS(646),
    [anon_sym_strictfp] = ACTIONS(646),
    [anon_sym_native] = ACTIONS(646),
    [anon_sym_transient] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym_sealed] = ACTIONS(646),
    [anon_sym_non_DASHsealed] = ACTIONS(644),
    [anon_sym_record] = ACTIONS(646),
    [anon_sym_ATinterface] = ACTIONS(644),
    [anon_sym_interface] = ACTIONS(646),
    [anon_sym_byte] = ACTIONS(646),
    [anon_sym_short] = ACTIONS(646),
    [anon_sym_int] = ACTIONS(646),
    [anon_sym_long] = ACTIONS(646),
    [anon_sym_char] = ACTIONS(646),
    [anon_sym_float] = ACTIONS(646),
    [anon_sym_double] = ACTIONS(646),
    [sym_boolean_type] = ACTIONS(646),
    [sym_void_type] = ACTIONS(646),
    [sym_this] = ACTIONS(646),
    [sym_super] = ACTIONS(646),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(648),
    [sym_identifier] = ACTIONS(650),
    [sym_decimal_integer_literal] = ACTIONS(650),
    [sym_hex_integer_literal] = ACTIONS(650),
    [sym_octal_integer_literal] = ACTIONS(650),
    [sym_binary_integer_literal] = ACTIONS(648),
    [sym_decimal_floating_point_literal] = ACTIONS(648),
    [sym_hex_floating_point_literal] = ACTIONS(650),
    [sym_true] = ACTIONS(650),
    [sym_false] = ACTIONS(650),
    [sym_character_literal] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(648),
    [sym_null_literal] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_final] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_TILDE] = ACTIONS(648),
    [anon_sym_PLUS_PLUS] = ACTIONS(648),
    [anon_sym_DASH_DASH] = ACTIONS(648),
    [anon_sym_new] = ACTIONS(650),
    [anon_sym_class] = ACTIONS(650),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_RBRACE] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_assert] = ACTIONS(650),
    [anon_sym_do] = ACTIONS(650),
    [anon_sym_while] = ACTIONS(650),
    [anon_sym_break] = ACTIONS(650),
    [anon_sym_continue] = ACTIONS(650),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_yield] = ACTIONS(650),
    [anon_sym_synchronized] = ACTIONS(650),
    [anon_sym_throw] = ACTIONS(650),
    [anon_sym_try] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(650),
    [anon_sym_for] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_open] = ACTIONS(650),
    [anon_sym_module] = ACTIONS(650),
    [anon_sym_static] = ACTIONS(650),
    [anon_sym_package] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(650),
    [anon_sym_enum] = ACTIONS(650),
    [anon_sym_public] = ACTIONS(650),
    [anon_sym_protected] = ACTIONS(650),
    [anon_sym_private] = ACTIONS(650),
    [anon_sym_abstract] = ACTIONS(650),
    [anon_sym_strictfp] = ACTIONS(650),
    [anon_sym_native] = ACTIONS(650),
    [anon_sym_transient] = ACTIONS(650),
    [anon_sym_volatile] = ACTIONS(650),
    [anon_sym_sealed] = ACTIONS(650),
    [anon_sym_non_DASHsealed] = ACTIONS(648),
    [anon_sym_record] = ACTIONS(650),
    [anon_sym_ATinterface] = ACTIONS(648),
    [anon_sym_interface] = ACTIONS(650),
    [anon_sym_byte] = ACTIONS(650),
    [anon_sym_short] = ACTIONS(650),
    [anon_sym_int] = ACTIONS(650),
    [anon_sym_long] = ACTIONS(650),
    [anon_sym_char] = ACTIONS(650),
    [anon_sym_float] = ACTIONS(650),
    [anon_sym_double] = ACTIONS(650),
    [sym_boolean_type] = ACTIONS(650),
    [sym_void_type] = ACTIONS(650),
    [sym_this] = ACTIONS(650),
    [sym_super] = ACTIONS(650),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(652),
    [sym_identifier] = ACTIONS(654),
    [sym_decimal_integer_literal] = ACTIONS(654),
    [sym_hex_integer_literal] = ACTIONS(654),
    [sym_octal_integer_literal] = ACTIONS(654),
    [sym_binary_integer_literal] = ACTIONS(652),
    [sym_decimal_floating_point_literal] = ACTIONS(652),
    [sym_hex_floating_point_literal] = ACTIONS(654),
    [sym_true] = ACTIONS(654),
    [sym_false] = ACTIONS(654),
    [sym_character_literal] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(652),
    [sym_null_literal] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_final] = ACTIONS(654),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_PLUS_PLUS] = ACTIONS(652),
    [anon_sym_DASH_DASH] = ACTIONS(652),
    [anon_sym_new] = ACTIONS(654),
    [anon_sym_class] = ACTIONS(654),
    [anon_sym_switch] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(652),
    [anon_sym_RBRACE] = ACTIONS(652),
    [anon_sym_case] = ACTIONS(654),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_assert] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_break] = ACTIONS(654),
    [anon_sym_continue] = ACTIONS(654),
    [anon_sym_return] = ACTIONS(654),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_synchronized] = ACTIONS(654),
    [anon_sym_throw] = ACTIONS(654),
    [anon_sym_try] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(654),
    [anon_sym_else] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(654),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_open] = ACTIONS(654),
    [anon_sym_module] = ACTIONS(654),
    [anon_sym_static] = ACTIONS(654),
    [anon_sym_package] = ACTIONS(654),
    [anon_sym_import] = ACTIONS(654),
    [anon_sym_enum] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(654),
    [anon_sym_protected] = ACTIONS(654),
    [anon_sym_private] = ACTIONS(654),
    [anon_sym_abstract] = ACTIONS(654),
    [anon_sym_strictfp] = ACTIONS(654),
    [anon_sym_native] = ACTIONS(654),
    [anon_sym_transient] = ACTIONS(654),
    [anon_sym_volatile] = ACTIONS(654),
    [anon_sym_sealed] = ACTIONS(654),
    [anon_sym_non_DASHsealed] = ACTIONS(652),
    [anon_sym_record] = ACTIONS(654),
    [anon_sym_ATinterface] = ACTIONS(652),
    [anon_sym_interface] = ACTIONS(654),
    [anon_sym_byte] = ACTIONS(654),
    [anon_sym_short] = ACTIONS(654),
    [anon_sym_int] = ACTIONS(654),
    [anon_sym_long] = ACTIONS(654),
    [anon_sym_char] = ACTIONS(654),
    [anon_sym_float] = ACTIONS(654),
    [anon_sym_double] = ACTIONS(654),
    [sym_boolean_type] = ACTIONS(654),
    [sym_void_type] = ACTIONS(654),
    [sym_this] = ACTIONS(654),
    [sym_super] = ACTIONS(654),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(656),
    [sym_identifier] = ACTIONS(658),
    [sym_decimal_integer_literal] = ACTIONS(658),
    [sym_hex_integer_literal] = ACTIONS(658),
    [sym_octal_integer_literal] = ACTIONS(658),
    [sym_binary_integer_literal] = ACTIONS(656),
    [sym_decimal_floating_point_literal] = ACTIONS(656),
    [sym_hex_floating_point_literal] = ACTIONS(658),
    [sym_true] = ACTIONS(658),
    [sym_false] = ACTIONS(658),
    [sym_character_literal] = ACTIONS(656),
    [anon_sym_DQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(656),
    [sym_null_literal] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(656),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(658),
    [anon_sym_DASH] = ACTIONS(658),
    [anon_sym_final] = ACTIONS(658),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_new] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(658),
    [anon_sym_switch] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_RBRACE] = ACTIONS(656),
    [anon_sym_case] = ACTIONS(658),
    [anon_sym_default] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(656),
    [anon_sym_assert] = ACTIONS(658),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(658),
    [anon_sym_break] = ACTIONS(658),
    [anon_sym_continue] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(658),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_synchronized] = ACTIONS(658),
    [anon_sym_throw] = ACTIONS(658),
    [anon_sym_try] = ACTIONS(658),
    [anon_sym_if] = ACTIONS(658),
    [anon_sym_else] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_AT] = ACTIONS(658),
    [anon_sym_open] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(658),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_package] = ACTIONS(658),
    [anon_sym_import] = ACTIONS(658),
    [anon_sym_enum] = ACTIONS(658),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(658),
    [anon_sym_strictfp] = ACTIONS(658),
    [anon_sym_native] = ACTIONS(658),
    [anon_sym_transient] = ACTIONS(658),
    [anon_sym_volatile] = ACTIONS(658),
    [anon_sym_sealed] = ACTIONS(658),
    [anon_sym_non_DASHsealed] = ACTIONS(656),
    [anon_sym_record] = ACTIONS(658),
    [anon_sym_ATinterface] = ACTIONS(656),
    [anon_sym_interface] = ACTIONS(658),
    [anon_sym_byte] = ACTIONS(658),
    [anon_sym_short] = ACTIONS(658),
    [anon_sym_int] = ACTIONS(658),
    [anon_sym_long] = ACTIONS(658),
    [anon_sym_char] = ACTIONS(658),
    [anon_sym_float] = ACTIONS(658),
    [anon_sym_double] = ACTIONS(658),
    [sym_boolean_type] = ACTIONS(658),
    [sym_void_type] = ACTIONS(658),
    [sym_this] = ACTIONS(658),
    [sym_super] = ACTIONS(658),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(660),
    [sym_identifier] = ACTIONS(662),
    [sym_decimal_integer_literal] = ACTIONS(662),
    [sym_hex_integer_literal] = ACTIONS(662),
    [sym_octal_integer_literal] = ACTIONS(662),
    [sym_binary_integer_literal] = ACTIONS(660),
    [sym_decimal_floating_point_literal] = ACTIONS(660),
    [sym_hex_floating_point_literal] = ACTIONS(662),
    [sym_true] = ACTIONS(662),
    [sym_false] = ACTIONS(662),
    [sym_character_literal] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(660),
    [sym_null_literal] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_final] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(660),
    [anon_sym_TILDE] = ACTIONS(660),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(662),
    [anon_sym_switch] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_RBRACE] = ACTIONS(660),
    [anon_sym_case] = ACTIONS(662),
    [anon_sym_default] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(660),
    [anon_sym_assert] = ACTIONS(662),
    [anon_sym_do] = ACTIONS(662),
    [anon_sym_while] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(662),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_yield] = ACTIONS(662),
    [anon_sym_synchronized] = ACTIONS(662),
    [anon_sym_throw] = ACTIONS(662),
    [anon_sym_try] = ACTIONS(662),
    [anon_sym_if] = ACTIONS(662),
    [anon_sym_else] = ACTIONS(662),
    [anon_sym_for] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(662),
    [anon_sym_open] = ACTIONS(662),
    [anon_sym_module] = ACTIONS(662),
    [anon_sym_static] = ACTIONS(662),
    [anon_sym_package] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(662),
    [anon_sym_enum] = ACTIONS(662),
    [anon_sym_public] = ACTIONS(662),
    [anon_sym_protected] = ACTIONS(662),
    [anon_sym_private] = ACTIONS(662),
    [anon_sym_abstract] = ACTIONS(662),
    [anon_sym_strictfp] = ACTIONS(662),
    [anon_sym_native] = ACTIONS(662),
    [anon_sym_transient] = ACTIONS(662),
    [anon_sym_volatile] = ACTIONS(662),
    [anon_sym_sealed] = ACTIONS(662),
    [anon_sym_non_DASHsealed] = ACTIONS(660),
    [anon_sym_record] = ACTIONS(662),
    [anon_sym_ATinterface] = ACTIONS(660),
    [anon_sym_interface] = ACTIONS(662),
    [anon_sym_byte] = ACTIONS(662),
    [anon_sym_short] = ACTIONS(662),
    [anon_sym_int] = ACTIONS(662),
    [anon_sym_long] = ACTIONS(662),
    [anon_sym_char] = ACTIONS(662),
    [anon_sym_float] = ACTIONS(662),
    [anon_sym_double] = ACTIONS(662),
    [sym_boolean_type] = ACTIONS(662),
    [sym_void_type] = ACTIONS(662),
    [sym_this] = ACTIONS(662),
    [sym_super] = ACTIONS(662),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(664),
    [sym_identifier] = ACTIONS(666),
    [sym_decimal_integer_literal] = ACTIONS(666),
    [sym_hex_integer_literal] = ACTIONS(666),
    [sym_octal_integer_literal] = ACTIONS(666),
    [sym_binary_integer_literal] = ACTIONS(664),
    [sym_decimal_floating_point_literal] = ACTIONS(664),
    [sym_hex_floating_point_literal] = ACTIONS(666),
    [sym_true] = ACTIONS(666),
    [sym_false] = ACTIONS(666),
    [sym_character_literal] = ACTIONS(664),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [sym_null_literal] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_final] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_TILDE] = ACTIONS(664),
    [anon_sym_PLUS_PLUS] = ACTIONS(664),
    [anon_sym_DASH_DASH] = ACTIONS(664),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(664),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_assert] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_yield] = ACTIONS(666),
    [anon_sym_synchronized] = ACTIONS(666),
    [anon_sym_throw] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_open] = ACTIONS(666),
    [anon_sym_module] = ACTIONS(666),
    [anon_sym_static] = ACTIONS(666),
    [anon_sym_package] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(666),
    [anon_sym_enum] = ACTIONS(666),
    [anon_sym_public] = ACTIONS(666),
    [anon_sym_protected] = ACTIONS(666),
    [anon_sym_private] = ACTIONS(666),
    [anon_sym_abstract] = ACTIONS(666),
    [anon_sym_strictfp] = ACTIONS(666),
    [anon_sym_native] = ACTIONS(666),
    [anon_sym_transient] = ACTIONS(666),
    [anon_sym_volatile] = ACTIONS(666),
    [anon_sym_sealed] = ACTIONS(666),
    [anon_sym_non_DASHsealed] = ACTIONS(664),
    [anon_sym_record] = ACTIONS(666),
    [anon_sym_ATinterface] = ACTIONS(664),
    [anon_sym_interface] = ACTIONS(666),
    [anon_sym_byte] = ACTIONS(666),
    [anon_sym_short] = ACTIONS(666),
    [anon_sym_int] = ACTIONS(666),
    [anon_sym_long] = ACTIONS(666),
    [anon_sym_char] = ACTIONS(666),
    [anon_sym_float] = ACTIONS(666),
    [anon_sym_double] = ACTIONS(666),
    [sym_boolean_type] = ACTIONS(666),
    [sym_void_type] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_super] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(668),
    [sym_identifier] = ACTIONS(670),
    [sym_decimal_integer_literal] = ACTIONS(670),
    [sym_hex_integer_literal] = ACTIONS(670),
    [sym_octal_integer_literal] = ACTIONS(670),
    [sym_binary_integer_literal] = ACTIONS(668),
    [sym_decimal_floating_point_literal] = ACTIONS(668),
    [sym_hex_floating_point_literal] = ACTIONS(670),
    [sym_true] = ACTIONS(670),
    [sym_false] = ACTIONS(670),
    [sym_character_literal] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [sym_null_literal] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_final] = ACTIONS(670),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_switch] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_case] = ACTIONS(670),
    [anon_sym_default] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_assert] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_yield] = ACTIONS(670),
    [anon_sym_synchronized] = ACTIONS(670),
    [anon_sym_throw] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_else] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_open] = ACTIONS(670),
    [anon_sym_module] = ACTIONS(670),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_package] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(670),
    [anon_sym_enum] = ACTIONS(670),
    [anon_sym_public] = ACTIONS(670),
    [anon_sym_protected] = ACTIONS(670),
    [anon_sym_private] = ACTIONS(670),
    [anon_sym_abstract] = ACTIONS(670),
    [anon_sym_strictfp] = ACTIONS(670),
    [anon_sym_native] = ACTIONS(670),
    [anon_sym_transient] = ACTIONS(670),
    [anon_sym_volatile] = ACTIONS(670),
    [anon_sym_sealed] = ACTIONS(670),
    [anon_sym_non_DASHsealed] = ACTIONS(668),
    [anon_sym_record] = ACTIONS(670),
    [anon_sym_ATinterface] = ACTIONS(668),
    [anon_sym_interface] = ACTIONS(670),
    [anon_sym_byte] = ACTIONS(670),
    [anon_sym_short] = ACTIONS(670),
    [anon_sym_int] = ACTIONS(670),
    [anon_sym_long] = ACTIONS(670),
    [anon_sym_char] = ACTIONS(670),
    [anon_sym_float] = ACTIONS(670),
    [anon_sym_double] = ACTIONS(670),
    [sym_boolean_type] = ACTIONS(670),
    [sym_void_type] = ACTIONS(670),
    [sym_this] = ACTIONS(670),
    [sym_super] = ACTIONS(670),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [246] = {
    [ts_builtin_sym_end] = ACTIONS(672),
    [sym_identifier] = ACTIONS(674),
    [sym_decimal_integer_literal] = ACTIONS(674),
    [sym_hex_integer_literal] = ACTIONS(674),
    [sym_octal_integer_literal] = ACTIONS(674),
    [sym_binary_integer_literal] = ACTIONS(672),
    [sym_decimal_floating_point_literal] = ACTIONS(672),
    [sym_hex_floating_point_literal] = ACTIONS(674),
    [sym_true] = ACTIONS(674),
    [sym_false] = ACTIONS(674),
    [sym_character_literal] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(672),
    [sym_null_literal] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_final] = ACTIONS(674),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_new] = ACTIONS(674),
    [anon_sym_class] = ACTIONS(674),
    [anon_sym_switch] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_case] = ACTIONS(674),
    [anon_sym_default] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(672),
    [anon_sym_assert] = ACTIONS(674),
    [anon_sym_do] = ACTIONS(674),
    [anon_sym_while] = ACTIONS(674),
    [anon_sym_break] = ACTIONS(674),
    [anon_sym_continue] = ACTIONS(674),
    [anon_sym_return] = ACTIONS(674),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_synchronized] = ACTIONS(674),
    [anon_sym_throw] = ACTIONS(674),
    [anon_sym_try] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(674),
    [anon_sym_else] = ACTIONS(674),
    [anon_sym_for] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_open] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_package] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(674),
    [anon_sym_enum] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_abstract] = ACTIONS(674),
    [anon_sym_strictfp] = ACTIONS(674),
    [anon_sym_native] = ACTIONS(674),
    [anon_sym_transient] = ACTIONS(674),
    [anon_sym_volatile] = ACTIONS(674),
    [anon_sym_sealed] = ACTIONS(674),
    [anon_sym_non_DASHsealed] = ACTIONS(672),
    [anon_sym_record] = ACTIONS(674),
    [anon_sym_ATinterface] = ACTIONS(672),
    [anon_sym_interface] = ACTIONS(674),
    [anon_sym_byte] = ACTIONS(674),
    [anon_sym_short] = ACTIONS(674),
    [anon_sym_int] = ACTIONS(674),
    [anon_sym_long] = ACTIONS(674),
    [anon_sym_char] = ACTIONS(674),
    [anon_sym_float] = ACTIONS(674),
    [anon_sym_double] = ACTIONS(674),
    [sym_boolean_type] = ACTIONS(674),
    [sym_void_type] = ACTIONS(674),
    [sym_this] = ACTIONS(674),
    [sym_super] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [247] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(640),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [248] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(643),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [249] = {
    [ts_builtin_sym_end] = ACTIONS(676),
    [sym_identifier] = ACTIONS(678),
    [sym_decimal_integer_literal] = ACTIONS(678),
    [sym_hex_integer_literal] = ACTIONS(678),
    [sym_octal_integer_literal] = ACTIONS(678),
    [sym_binary_integer_literal] = ACTIONS(676),
    [sym_decimal_floating_point_literal] = ACTIONS(676),
    [sym_hex_floating_point_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(678),
    [sym_false] = ACTIONS(678),
    [sym_character_literal] = ACTIONS(676),
    [anon_sym_DQUOTE] = ACTIONS(678),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(676),
    [sym_null_literal] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_final] = ACTIONS(678),
    [anon_sym_BANG] = ACTIONS(676),
    [anon_sym_TILDE] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(676),
    [anon_sym_DASH_DASH] = ACTIONS(676),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_class] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(676),
    [anon_sym_case] = ACTIONS(678),
    [anon_sym_default] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(676),
    [anon_sym_assert] = ACTIONS(678),
    [anon_sym_do] = ACTIONS(678),
    [anon_sym_while] = ACTIONS(678),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(678),
    [anon_sym_return] = ACTIONS(678),
    [anon_sym_yield] = ACTIONS(678),
    [anon_sym_synchronized] = ACTIONS(678),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(678),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_open] = ACTIONS(678),
    [anon_sym_module] = ACTIONS(678),
    [anon_sym_static] = ACTIONS(678),
    [anon_sym_package] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_enum] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(678),
    [anon_sym_protected] = ACTIONS(678),
    [anon_sym_private] = ACTIONS(678),
    [anon_sym_abstract] = ACTIONS(678),
    [anon_sym_strictfp] = ACTIONS(678),
    [anon_sym_native] = ACTIONS(678),
    [anon_sym_transient] = ACTIONS(678),
    [anon_sym_volatile] = ACTIONS(678),
    [anon_sym_sealed] = ACTIONS(678),
    [anon_sym_non_DASHsealed] = ACTIONS(676),
    [anon_sym_record] = ACTIONS(678),
    [anon_sym_ATinterface] = ACTIONS(676),
    [anon_sym_interface] = ACTIONS(678),
    [anon_sym_byte] = ACTIONS(678),
    [anon_sym_short] = ACTIONS(678),
    [anon_sym_int] = ACTIONS(678),
    [anon_sym_long] = ACTIONS(678),
    [anon_sym_char] = ACTIONS(678),
    [anon_sym_float] = ACTIONS(678),
    [anon_sym_double] = ACTIONS(678),
    [sym_boolean_type] = ACTIONS(678),
    [sym_void_type] = ACTIONS(678),
    [sym_this] = ACTIONS(678),
    [sym_super] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_decimal_integer_literal] = ACTIONS(682),
    [sym_hex_integer_literal] = ACTIONS(682),
    [sym_octal_integer_literal] = ACTIONS(682),
    [sym_binary_integer_literal] = ACTIONS(680),
    [sym_decimal_floating_point_literal] = ACTIONS(680),
    [sym_hex_floating_point_literal] = ACTIONS(682),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_character_literal] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(680),
    [sym_null_literal] = ACTIONS(682),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_final] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_new] = ACTIONS(682),
    [anon_sym_class] = ACTIONS(682),
    [anon_sym_switch] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(680),
    [anon_sym_assert] = ACTIONS(682),
    [anon_sym_do] = ACTIONS(682),
    [anon_sym_while] = ACTIONS(682),
    [anon_sym_break] = ACTIONS(682),
    [anon_sym_continue] = ACTIONS(682),
    [anon_sym_return] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(682),
    [anon_sym_synchronized] = ACTIONS(682),
    [anon_sym_throw] = ACTIONS(682),
    [anon_sym_try] = ACTIONS(682),
    [anon_sym_if] = ACTIONS(682),
    [anon_sym_else] = ACTIONS(682),
    [anon_sym_for] = ACTIONS(682),
    [anon_sym_AT] = ACTIONS(682),
    [anon_sym_open] = ACTIONS(682),
    [anon_sym_module] = ACTIONS(682),
    [anon_sym_static] = ACTIONS(682),
    [anon_sym_package] = ACTIONS(682),
    [anon_sym_import] = ACTIONS(682),
    [anon_sym_enum] = ACTIONS(682),
    [anon_sym_public] = ACTIONS(682),
    [anon_sym_protected] = ACTIONS(682),
    [anon_sym_private] = ACTIONS(682),
    [anon_sym_abstract] = ACTIONS(682),
    [anon_sym_strictfp] = ACTIONS(682),
    [anon_sym_native] = ACTIONS(682),
    [anon_sym_transient] = ACTIONS(682),
    [anon_sym_volatile] = ACTIONS(682),
    [anon_sym_sealed] = ACTIONS(682),
    [anon_sym_non_DASHsealed] = ACTIONS(680),
    [anon_sym_record] = ACTIONS(682),
    [anon_sym_ATinterface] = ACTIONS(680),
    [anon_sym_interface] = ACTIONS(682),
    [anon_sym_byte] = ACTIONS(682),
    [anon_sym_short] = ACTIONS(682),
    [anon_sym_int] = ACTIONS(682),
    [anon_sym_long] = ACTIONS(682),
    [anon_sym_char] = ACTIONS(682),
    [anon_sym_float] = ACTIONS(682),
    [anon_sym_double] = ACTIONS(682),
    [sym_boolean_type] = ACTIONS(682),
    [sym_void_type] = ACTIONS(682),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(682),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(684),
    [sym_identifier] = ACTIONS(686),
    [sym_decimal_integer_literal] = ACTIONS(686),
    [sym_hex_integer_literal] = ACTIONS(686),
    [sym_octal_integer_literal] = ACTIONS(686),
    [sym_binary_integer_literal] = ACTIONS(684),
    [sym_decimal_floating_point_literal] = ACTIONS(684),
    [sym_hex_floating_point_literal] = ACTIONS(686),
    [sym_true] = ACTIONS(686),
    [sym_false] = ACTIONS(686),
    [sym_character_literal] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(684),
    [sym_null_literal] = ACTIONS(686),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(684),
    [anon_sym_PLUS] = ACTIONS(686),
    [anon_sym_DASH] = ACTIONS(686),
    [anon_sym_final] = ACTIONS(686),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_new] = ACTIONS(686),
    [anon_sym_class] = ACTIONS(686),
    [anon_sym_switch] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(686),
    [anon_sym_default] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_assert] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(686),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_break] = ACTIONS(686),
    [anon_sym_continue] = ACTIONS(686),
    [anon_sym_return] = ACTIONS(686),
    [anon_sym_yield] = ACTIONS(686),
    [anon_sym_synchronized] = ACTIONS(686),
    [anon_sym_throw] = ACTIONS(686),
    [anon_sym_try] = ACTIONS(686),
    [anon_sym_if] = ACTIONS(686),
    [anon_sym_else] = ACTIONS(686),
    [anon_sym_for] = ACTIONS(686),
    [anon_sym_AT] = ACTIONS(686),
    [anon_sym_open] = ACTIONS(686),
    [anon_sym_module] = ACTIONS(686),
    [anon_sym_static] = ACTIONS(686),
    [anon_sym_package] = ACTIONS(686),
    [anon_sym_import] = ACTIONS(686),
    [anon_sym_enum] = ACTIONS(686),
    [anon_sym_public] = ACTIONS(686),
    [anon_sym_protected] = ACTIONS(686),
    [anon_sym_private] = ACTIONS(686),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_strictfp] = ACTIONS(686),
    [anon_sym_native] = ACTIONS(686),
    [anon_sym_transient] = ACTIONS(686),
    [anon_sym_volatile] = ACTIONS(686),
    [anon_sym_sealed] = ACTIONS(686),
    [anon_sym_non_DASHsealed] = ACTIONS(684),
    [anon_sym_record] = ACTIONS(686),
    [anon_sym_ATinterface] = ACTIONS(684),
    [anon_sym_interface] = ACTIONS(686),
    [anon_sym_byte] = ACTIONS(686),
    [anon_sym_short] = ACTIONS(686),
    [anon_sym_int] = ACTIONS(686),
    [anon_sym_long] = ACTIONS(686),
    [anon_sym_char] = ACTIONS(686),
    [anon_sym_float] = ACTIONS(686),
    [anon_sym_double] = ACTIONS(686),
    [sym_boolean_type] = ACTIONS(686),
    [sym_void_type] = ACTIONS(686),
    [sym_this] = ACTIONS(686),
    [sym_super] = ACTIONS(686),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(688),
    [sym_identifier] = ACTIONS(690),
    [sym_decimal_integer_literal] = ACTIONS(690),
    [sym_hex_integer_literal] = ACTIONS(690),
    [sym_octal_integer_literal] = ACTIONS(690),
    [sym_binary_integer_literal] = ACTIONS(688),
    [sym_decimal_floating_point_literal] = ACTIONS(688),
    [sym_hex_floating_point_literal] = ACTIONS(690),
    [sym_true] = ACTIONS(690),
    [sym_false] = ACTIONS(690),
    [sym_character_literal] = ACTIONS(688),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(688),
    [sym_null_literal] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(688),
    [anon_sym_LT] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_final] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(688),
    [anon_sym_TILDE] = ACTIONS(688),
    [anon_sym_PLUS_PLUS] = ACTIONS(688),
    [anon_sym_DASH_DASH] = ACTIONS(688),
    [anon_sym_new] = ACTIONS(690),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_switch] = ACTIONS(690),
    [anon_sym_LBRACE] = ACTIONS(688),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_case] = ACTIONS(690),
    [anon_sym_default] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(690),
    [anon_sym_do] = ACTIONS(690),
    [anon_sym_while] = ACTIONS(690),
    [anon_sym_break] = ACTIONS(690),
    [anon_sym_continue] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(690),
    [anon_sym_yield] = ACTIONS(690),
    [anon_sym_synchronized] = ACTIONS(690),
    [anon_sym_throw] = ACTIONS(690),
    [anon_sym_try] = ACTIONS(690),
    [anon_sym_if] = ACTIONS(690),
    [anon_sym_else] = ACTIONS(690),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(690),
    [anon_sym_open] = ACTIONS(690),
    [anon_sym_module] = ACTIONS(690),
    [anon_sym_static] = ACTIONS(690),
    [anon_sym_package] = ACTIONS(690),
    [anon_sym_import] = ACTIONS(690),
    [anon_sym_enum] = ACTIONS(690),
    [anon_sym_public] = ACTIONS(690),
    [anon_sym_protected] = ACTIONS(690),
    [anon_sym_private] = ACTIONS(690),
    [anon_sym_abstract] = ACTIONS(690),
    [anon_sym_strictfp] = ACTIONS(690),
    [anon_sym_native] = ACTIONS(690),
    [anon_sym_transient] = ACTIONS(690),
    [anon_sym_volatile] = ACTIONS(690),
    [anon_sym_sealed] = ACTIONS(690),
    [anon_sym_non_DASHsealed] = ACTIONS(688),
    [anon_sym_record] = ACTIONS(690),
    [anon_sym_ATinterface] = ACTIONS(688),
    [anon_sym_interface] = ACTIONS(690),
    [anon_sym_byte] = ACTIONS(690),
    [anon_sym_short] = ACTIONS(690),
    [anon_sym_int] = ACTIONS(690),
    [anon_sym_long] = ACTIONS(690),
    [anon_sym_char] = ACTIONS(690),
    [anon_sym_float] = ACTIONS(690),
    [anon_sym_double] = ACTIONS(690),
    [sym_boolean_type] = ACTIONS(690),
    [sym_void_type] = ACTIONS(690),
    [sym_this] = ACTIONS(690),
    [sym_super] = ACTIONS(690),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [253] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(636),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(692),
    [sym_identifier] = ACTIONS(694),
    [sym_decimal_integer_literal] = ACTIONS(694),
    [sym_hex_integer_literal] = ACTIONS(694),
    [sym_octal_integer_literal] = ACTIONS(694),
    [sym_binary_integer_literal] = ACTIONS(692),
    [sym_decimal_floating_point_literal] = ACTIONS(692),
    [sym_hex_floating_point_literal] = ACTIONS(694),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_character_literal] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(692),
    [sym_null_literal] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_final] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_TILDE] = ACTIONS(692),
    [anon_sym_PLUS_PLUS] = ACTIONS(692),
    [anon_sym_DASH_DASH] = ACTIONS(692),
    [anon_sym_new] = ACTIONS(694),
    [anon_sym_class] = ACTIONS(694),
    [anon_sym_switch] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(692),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_case] = ACTIONS(694),
    [anon_sym_default] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(692),
    [anon_sym_assert] = ACTIONS(694),
    [anon_sym_do] = ACTIONS(694),
    [anon_sym_while] = ACTIONS(694),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(694),
    [anon_sym_return] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(694),
    [anon_sym_synchronized] = ACTIONS(694),
    [anon_sym_throw] = ACTIONS(694),
    [anon_sym_try] = ACTIONS(694),
    [anon_sym_if] = ACTIONS(694),
    [anon_sym_else] = ACTIONS(694),
    [anon_sym_for] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_open] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(694),
    [anon_sym_static] = ACTIONS(694),
    [anon_sym_package] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_public] = ACTIONS(694),
    [anon_sym_protected] = ACTIONS(694),
    [anon_sym_private] = ACTIONS(694),
    [anon_sym_abstract] = ACTIONS(694),
    [anon_sym_strictfp] = ACTIONS(694),
    [anon_sym_native] = ACTIONS(694),
    [anon_sym_transient] = ACTIONS(694),
    [anon_sym_volatile] = ACTIONS(694),
    [anon_sym_sealed] = ACTIONS(694),
    [anon_sym_non_DASHsealed] = ACTIONS(692),
    [anon_sym_record] = ACTIONS(694),
    [anon_sym_ATinterface] = ACTIONS(692),
    [anon_sym_interface] = ACTIONS(694),
    [anon_sym_byte] = ACTIONS(694),
    [anon_sym_short] = ACTIONS(694),
    [anon_sym_int] = ACTIONS(694),
    [anon_sym_long] = ACTIONS(694),
    [anon_sym_char] = ACTIONS(694),
    [anon_sym_float] = ACTIONS(694),
    [anon_sym_double] = ACTIONS(694),
    [sym_boolean_type] = ACTIONS(694),
    [sym_void_type] = ACTIONS(694),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(694),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(698),
    [sym_hex_integer_literal] = ACTIONS(698),
    [sym_octal_integer_literal] = ACTIONS(698),
    [sym_binary_integer_literal] = ACTIONS(696),
    [sym_decimal_floating_point_literal] = ACTIONS(696),
    [sym_hex_floating_point_literal] = ACTIONS(698),
    [sym_true] = ACTIONS(698),
    [sym_false] = ACTIONS(698),
    [sym_character_literal] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(696),
    [sym_null_literal] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_LT] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_final] = ACTIONS(698),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(696),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_new] = ACTIONS(698),
    [anon_sym_class] = ACTIONS(698),
    [anon_sym_switch] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(696),
    [anon_sym_case] = ACTIONS(698),
    [anon_sym_default] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_assert] = ACTIONS(698),
    [anon_sym_do] = ACTIONS(698),
    [anon_sym_while] = ACTIONS(698),
    [anon_sym_break] = ACTIONS(698),
    [anon_sym_continue] = ACTIONS(698),
    [anon_sym_return] = ACTIONS(698),
    [anon_sym_yield] = ACTIONS(698),
    [anon_sym_synchronized] = ACTIONS(698),
    [anon_sym_throw] = ACTIONS(698),
    [anon_sym_try] = ACTIONS(698),
    [anon_sym_if] = ACTIONS(698),
    [anon_sym_else] = ACTIONS(698),
    [anon_sym_for] = ACTIONS(698),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_open] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_package] = ACTIONS(698),
    [anon_sym_import] = ACTIONS(698),
    [anon_sym_enum] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_abstract] = ACTIONS(698),
    [anon_sym_strictfp] = ACTIONS(698),
    [anon_sym_native] = ACTIONS(698),
    [anon_sym_transient] = ACTIONS(698),
    [anon_sym_volatile] = ACTIONS(698),
    [anon_sym_sealed] = ACTIONS(698),
    [anon_sym_non_DASHsealed] = ACTIONS(696),
    [anon_sym_record] = ACTIONS(698),
    [anon_sym_ATinterface] = ACTIONS(696),
    [anon_sym_interface] = ACTIONS(698),
    [anon_sym_byte] = ACTIONS(698),
    [anon_sym_short] = ACTIONS(698),
    [anon_sym_int] = ACTIONS(698),
    [anon_sym_long] = ACTIONS(698),
    [anon_sym_char] = ACTIONS(698),
    [anon_sym_float] = ACTIONS(698),
    [anon_sym_double] = ACTIONS(698),
    [sym_boolean_type] = ACTIONS(698),
    [sym_void_type] = ACTIONS(698),
    [sym_this] = ACTIONS(698),
    [sym_super] = ACTIONS(698),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(700),
    [sym_identifier] = ACTIONS(702),
    [sym_decimal_integer_literal] = ACTIONS(702),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_octal_integer_literal] = ACTIONS(702),
    [sym_binary_integer_literal] = ACTIONS(700),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [sym_hex_floating_point_literal] = ACTIONS(702),
    [sym_true] = ACTIONS(702),
    [sym_false] = ACTIONS(702),
    [sym_character_literal] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(700),
    [sym_null_literal] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_final] = ACTIONS(702),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(700),
    [anon_sym_new] = ACTIONS(702),
    [anon_sym_class] = ACTIONS(702),
    [anon_sym_switch] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_case] = ACTIONS(702),
    [anon_sym_default] = ACTIONS(702),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym_assert] = ACTIONS(702),
    [anon_sym_do] = ACTIONS(702),
    [anon_sym_while] = ACTIONS(702),
    [anon_sym_break] = ACTIONS(702),
    [anon_sym_continue] = ACTIONS(702),
    [anon_sym_return] = ACTIONS(702),
    [anon_sym_yield] = ACTIONS(702),
    [anon_sym_synchronized] = ACTIONS(702),
    [anon_sym_throw] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(702),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_else] = ACTIONS(702),
    [anon_sym_for] = ACTIONS(702),
    [anon_sym_AT] = ACTIONS(702),
    [anon_sym_open] = ACTIONS(702),
    [anon_sym_module] = ACTIONS(702),
    [anon_sym_static] = ACTIONS(702),
    [anon_sym_package] = ACTIONS(702),
    [anon_sym_import] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(702),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_abstract] = ACTIONS(702),
    [anon_sym_strictfp] = ACTIONS(702),
    [anon_sym_native] = ACTIONS(702),
    [anon_sym_transient] = ACTIONS(702),
    [anon_sym_volatile] = ACTIONS(702),
    [anon_sym_sealed] = ACTIONS(702),
    [anon_sym_non_DASHsealed] = ACTIONS(700),
    [anon_sym_record] = ACTIONS(702),
    [anon_sym_ATinterface] = ACTIONS(700),
    [anon_sym_interface] = ACTIONS(702),
    [anon_sym_byte] = ACTIONS(702),
    [anon_sym_short] = ACTIONS(702),
    [anon_sym_int] = ACTIONS(702),
    [anon_sym_long] = ACTIONS(702),
    [anon_sym_char] = ACTIONS(702),
    [anon_sym_float] = ACTIONS(702),
    [anon_sym_double] = ACTIONS(702),
    [sym_boolean_type] = ACTIONS(702),
    [sym_void_type] = ACTIONS(702),
    [sym_this] = ACTIONS(702),
    [sym_super] = ACTIONS(702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(704),
    [sym_identifier] = ACTIONS(706),
    [sym_decimal_integer_literal] = ACTIONS(706),
    [sym_hex_integer_literal] = ACTIONS(706),
    [sym_octal_integer_literal] = ACTIONS(706),
    [sym_binary_integer_literal] = ACTIONS(704),
    [sym_decimal_floating_point_literal] = ACTIONS(704),
    [sym_hex_floating_point_literal] = ACTIONS(706),
    [sym_true] = ACTIONS(706),
    [sym_false] = ACTIONS(706),
    [sym_character_literal] = ACTIONS(704),
    [anon_sym_DQUOTE] = ACTIONS(706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(704),
    [sym_null_literal] = ACTIONS(706),
    [anon_sym_LPAREN] = ACTIONS(704),
    [anon_sym_LT] = ACTIONS(704),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_final] = ACTIONS(706),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(704),
    [anon_sym_new] = ACTIONS(706),
    [anon_sym_class] = ACTIONS(706),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_case] = ACTIONS(706),
    [anon_sym_default] = ACTIONS(706),
    [anon_sym_SEMI] = ACTIONS(704),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(706),
    [anon_sym_break] = ACTIONS(706),
    [anon_sym_continue] = ACTIONS(706),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_synchronized] = ACTIONS(706),
    [anon_sym_throw] = ACTIONS(706),
    [anon_sym_try] = ACTIONS(706),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_else] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(706),
    [anon_sym_open] = ACTIONS(706),
    [anon_sym_module] = ACTIONS(706),
    [anon_sym_static] = ACTIONS(706),
    [anon_sym_package] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(706),
    [anon_sym_enum] = ACTIONS(706),
    [anon_sym_public] = ACTIONS(706),
    [anon_sym_protected] = ACTIONS(706),
    [anon_sym_private] = ACTIONS(706),
    [anon_sym_abstract] = ACTIONS(706),
    [anon_sym_strictfp] = ACTIONS(706),
    [anon_sym_native] = ACTIONS(706),
    [anon_sym_transient] = ACTIONS(706),
    [anon_sym_volatile] = ACTIONS(706),
    [anon_sym_sealed] = ACTIONS(706),
    [anon_sym_non_DASHsealed] = ACTIONS(704),
    [anon_sym_record] = ACTIONS(706),
    [anon_sym_ATinterface] = ACTIONS(704),
    [anon_sym_interface] = ACTIONS(706),
    [anon_sym_byte] = ACTIONS(706),
    [anon_sym_short] = ACTIONS(706),
    [anon_sym_int] = ACTIONS(706),
    [anon_sym_long] = ACTIONS(706),
    [anon_sym_char] = ACTIONS(706),
    [anon_sym_float] = ACTIONS(706),
    [anon_sym_double] = ACTIONS(706),
    [sym_boolean_type] = ACTIONS(706),
    [sym_void_type] = ACTIONS(706),
    [sym_this] = ACTIONS(706),
    [sym_super] = ACTIONS(706),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [258] = {
    [ts_builtin_sym_end] = ACTIONS(708),
    [sym_identifier] = ACTIONS(710),
    [sym_decimal_integer_literal] = ACTIONS(710),
    [sym_hex_integer_literal] = ACTIONS(710),
    [sym_octal_integer_literal] = ACTIONS(710),
    [sym_binary_integer_literal] = ACTIONS(708),
    [sym_decimal_floating_point_literal] = ACTIONS(708),
    [sym_hex_floating_point_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(710),
    [sym_false] = ACTIONS(710),
    [sym_character_literal] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(708),
    [sym_null_literal] = ACTIONS(710),
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_final] = ACTIONS(710),
    [anon_sym_BANG] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_new] = ACTIONS(710),
    [anon_sym_class] = ACTIONS(710),
    [anon_sym_switch] = ACTIONS(710),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_RBRACE] = ACTIONS(708),
    [anon_sym_case] = ACTIONS(710),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_SEMI] = ACTIONS(708),
    [anon_sym_assert] = ACTIONS(710),
    [anon_sym_do] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(710),
    [anon_sym_break] = ACTIONS(710),
    [anon_sym_continue] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(710),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_synchronized] = ACTIONS(710),
    [anon_sym_throw] = ACTIONS(710),
    [anon_sym_try] = ACTIONS(710),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_else] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(710),
    [anon_sym_open] = ACTIONS(710),
    [anon_sym_module] = ACTIONS(710),
    [anon_sym_static] = ACTIONS(710),
    [anon_sym_package] = ACTIONS(710),
    [anon_sym_import] = ACTIONS(710),
    [anon_sym_enum] = ACTIONS(710),
    [anon_sym_public] = ACTIONS(710),
    [anon_sym_protected] = ACTIONS(710),
    [anon_sym_private] = ACTIONS(710),
    [anon_sym_abstract] = ACTIONS(710),
    [anon_sym_strictfp] = ACTIONS(710),
    [anon_sym_native] = ACTIONS(710),
    [anon_sym_transient] = ACTIONS(710),
    [anon_sym_volatile] = ACTIONS(710),
    [anon_sym_sealed] = ACTIONS(710),
    [anon_sym_non_DASHsealed] = ACTIONS(708),
    [anon_sym_record] = ACTIONS(710),
    [anon_sym_ATinterface] = ACTIONS(708),
    [anon_sym_interface] = ACTIONS(710),
    [anon_sym_byte] = ACTIONS(710),
    [anon_sym_short] = ACTIONS(710),
    [anon_sym_int] = ACTIONS(710),
    [anon_sym_long] = ACTIONS(710),
    [anon_sym_char] = ACTIONS(710),
    [anon_sym_float] = ACTIONS(710),
    [anon_sym_double] = ACTIONS(710),
    [sym_boolean_type] = ACTIONS(710),
    [sym_void_type] = ACTIONS(710),
    [sym_this] = ACTIONS(710),
    [sym_super] = ACTIONS(710),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_decimal_integer_literal] = ACTIONS(714),
    [sym_hex_integer_literal] = ACTIONS(714),
    [sym_octal_integer_literal] = ACTIONS(714),
    [sym_binary_integer_literal] = ACTIONS(712),
    [sym_decimal_floating_point_literal] = ACTIONS(712),
    [sym_hex_floating_point_literal] = ACTIONS(714),
    [sym_true] = ACTIONS(714),
    [sym_false] = ACTIONS(714),
    [sym_character_literal] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [sym_null_literal] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(712),
    [anon_sym_LT] = ACTIONS(712),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_final] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(712),
    [anon_sym_TILDE] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(712),
    [anon_sym_DASH_DASH] = ACTIONS(712),
    [anon_sym_new] = ACTIONS(714),
    [anon_sym_class] = ACTIONS(714),
    [anon_sym_switch] = ACTIONS(714),
    [anon_sym_LBRACE] = ACTIONS(712),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_case] = ACTIONS(714),
    [anon_sym_default] = ACTIONS(714),
    [anon_sym_SEMI] = ACTIONS(712),
    [anon_sym_assert] = ACTIONS(714),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_while] = ACTIONS(714),
    [anon_sym_break] = ACTIONS(714),
    [anon_sym_continue] = ACTIONS(714),
    [anon_sym_return] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_synchronized] = ACTIONS(714),
    [anon_sym_throw] = ACTIONS(714),
    [anon_sym_try] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_else] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(714),
    [anon_sym_open] = ACTIONS(714),
    [anon_sym_module] = ACTIONS(714),
    [anon_sym_static] = ACTIONS(714),
    [anon_sym_package] = ACTIONS(714),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_enum] = ACTIONS(714),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_abstract] = ACTIONS(714),
    [anon_sym_strictfp] = ACTIONS(714),
    [anon_sym_native] = ACTIONS(714),
    [anon_sym_transient] = ACTIONS(714),
    [anon_sym_volatile] = ACTIONS(714),
    [anon_sym_sealed] = ACTIONS(714),
    [anon_sym_non_DASHsealed] = ACTIONS(712),
    [anon_sym_record] = ACTIONS(714),
    [anon_sym_ATinterface] = ACTIONS(712),
    [anon_sym_interface] = ACTIONS(714),
    [anon_sym_byte] = ACTIONS(714),
    [anon_sym_short] = ACTIONS(714),
    [anon_sym_int] = ACTIONS(714),
    [anon_sym_long] = ACTIONS(714),
    [anon_sym_char] = ACTIONS(714),
    [anon_sym_float] = ACTIONS(714),
    [anon_sym_double] = ACTIONS(714),
    [sym_boolean_type] = ACTIONS(714),
    [sym_void_type] = ACTIONS(714),
    [sym_this] = ACTIONS(714),
    [sym_super] = ACTIONS(714),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(716),
    [sym_identifier] = ACTIONS(718),
    [sym_decimal_integer_literal] = ACTIONS(718),
    [sym_hex_integer_literal] = ACTIONS(718),
    [sym_octal_integer_literal] = ACTIONS(718),
    [sym_binary_integer_literal] = ACTIONS(716),
    [sym_decimal_floating_point_literal] = ACTIONS(716),
    [sym_hex_floating_point_literal] = ACTIONS(718),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_character_literal] = ACTIONS(716),
    [anon_sym_DQUOTE] = ACTIONS(718),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(716),
    [sym_null_literal] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_final] = ACTIONS(718),
    [anon_sym_BANG] = ACTIONS(716),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_PLUS_PLUS] = ACTIONS(716),
    [anon_sym_DASH_DASH] = ACTIONS(716),
    [anon_sym_new] = ACTIONS(718),
    [anon_sym_class] = ACTIONS(718),
    [anon_sym_switch] = ACTIONS(718),
    [anon_sym_LBRACE] = ACTIONS(716),
    [anon_sym_RBRACE] = ACTIONS(716),
    [anon_sym_case] = ACTIONS(718),
    [anon_sym_default] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(716),
    [anon_sym_assert] = ACTIONS(718),
    [anon_sym_do] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(718),
    [anon_sym_continue] = ACTIONS(718),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(718),
    [anon_sym_synchronized] = ACTIONS(718),
    [anon_sym_throw] = ACTIONS(718),
    [anon_sym_try] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_else] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(718),
    [anon_sym_open] = ACTIONS(718),
    [anon_sym_module] = ACTIONS(718),
    [anon_sym_static] = ACTIONS(718),
    [anon_sym_package] = ACTIONS(718),
    [anon_sym_import] = ACTIONS(718),
    [anon_sym_enum] = ACTIONS(718),
    [anon_sym_public] = ACTIONS(718),
    [anon_sym_protected] = ACTIONS(718),
    [anon_sym_private] = ACTIONS(718),
    [anon_sym_abstract] = ACTIONS(718),
    [anon_sym_strictfp] = ACTIONS(718),
    [anon_sym_native] = ACTIONS(718),
    [anon_sym_transient] = ACTIONS(718),
    [anon_sym_volatile] = ACTIONS(718),
    [anon_sym_sealed] = ACTIONS(718),
    [anon_sym_non_DASHsealed] = ACTIONS(716),
    [anon_sym_record] = ACTIONS(718),
    [anon_sym_ATinterface] = ACTIONS(716),
    [anon_sym_interface] = ACTIONS(718),
    [anon_sym_byte] = ACTIONS(718),
    [anon_sym_short] = ACTIONS(718),
    [anon_sym_int] = ACTIONS(718),
    [anon_sym_long] = ACTIONS(718),
    [anon_sym_char] = ACTIONS(718),
    [anon_sym_float] = ACTIONS(718),
    [anon_sym_double] = ACTIONS(718),
    [sym_boolean_type] = ACTIONS(718),
    [sym_void_type] = ACTIONS(718),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(718),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [261] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(644),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [262] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(648),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [263] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(625),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(720),
    [sym_identifier] = ACTIONS(722),
    [sym_decimal_integer_literal] = ACTIONS(722),
    [sym_hex_integer_literal] = ACTIONS(722),
    [sym_octal_integer_literal] = ACTIONS(722),
    [sym_binary_integer_literal] = ACTIONS(720),
    [sym_decimal_floating_point_literal] = ACTIONS(720),
    [sym_hex_floating_point_literal] = ACTIONS(722),
    [sym_true] = ACTIONS(722),
    [sym_false] = ACTIONS(722),
    [sym_character_literal] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [sym_null_literal] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_final] = ACTIONS(722),
    [anon_sym_BANG] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_PLUS_PLUS] = ACTIONS(720),
    [anon_sym_DASH_DASH] = ACTIONS(720),
    [anon_sym_new] = ACTIONS(722),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_switch] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_default] = ACTIONS(722),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_assert] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_break] = ACTIONS(722),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_yield] = ACTIONS(722),
    [anon_sym_synchronized] = ACTIONS(722),
    [anon_sym_throw] = ACTIONS(722),
    [anon_sym_try] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_else] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(722),
    [anon_sym_open] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_package] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(722),
    [anon_sym_enum] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_abstract] = ACTIONS(722),
    [anon_sym_strictfp] = ACTIONS(722),
    [anon_sym_native] = ACTIONS(722),
    [anon_sym_transient] = ACTIONS(722),
    [anon_sym_volatile] = ACTIONS(722),
    [anon_sym_sealed] = ACTIONS(722),
    [anon_sym_non_DASHsealed] = ACTIONS(720),
    [anon_sym_record] = ACTIONS(722),
    [anon_sym_ATinterface] = ACTIONS(720),
    [anon_sym_interface] = ACTIONS(722),
    [anon_sym_byte] = ACTIONS(722),
    [anon_sym_short] = ACTIONS(722),
    [anon_sym_int] = ACTIONS(722),
    [anon_sym_long] = ACTIONS(722),
    [anon_sym_char] = ACTIONS(722),
    [anon_sym_float] = ACTIONS(722),
    [anon_sym_double] = ACTIONS(722),
    [sym_boolean_type] = ACTIONS(722),
    [sym_void_type] = ACTIONS(722),
    [sym_this] = ACTIONS(722),
    [sym_super] = ACTIONS(722),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(724),
    [sym_identifier] = ACTIONS(726),
    [sym_decimal_integer_literal] = ACTIONS(726),
    [sym_hex_integer_literal] = ACTIONS(726),
    [sym_octal_integer_literal] = ACTIONS(726),
    [sym_binary_integer_literal] = ACTIONS(724),
    [sym_decimal_floating_point_literal] = ACTIONS(724),
    [sym_hex_floating_point_literal] = ACTIONS(726),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_character_literal] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(724),
    [sym_null_literal] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(724),
    [anon_sym_LT] = ACTIONS(724),
    [anon_sym_PLUS] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_final] = ACTIONS(726),
    [anon_sym_BANG] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_new] = ACTIONS(726),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_switch] = ACTIONS(726),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_RBRACE] = ACTIONS(724),
    [anon_sym_case] = ACTIONS(726),
    [anon_sym_default] = ACTIONS(726),
    [anon_sym_SEMI] = ACTIONS(724),
    [anon_sym_assert] = ACTIONS(726),
    [anon_sym_do] = ACTIONS(726),
    [anon_sym_while] = ACTIONS(726),
    [anon_sym_break] = ACTIONS(726),
    [anon_sym_continue] = ACTIONS(726),
    [anon_sym_return] = ACTIONS(726),
    [anon_sym_yield] = ACTIONS(726),
    [anon_sym_synchronized] = ACTIONS(726),
    [anon_sym_throw] = ACTIONS(726),
    [anon_sym_try] = ACTIONS(726),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_else] = ACTIONS(726),
    [anon_sym_for] = ACTIONS(726),
    [anon_sym_AT] = ACTIONS(726),
    [anon_sym_open] = ACTIONS(726),
    [anon_sym_module] = ACTIONS(726),
    [anon_sym_static] = ACTIONS(726),
    [anon_sym_package] = ACTIONS(726),
    [anon_sym_import] = ACTIONS(726),
    [anon_sym_enum] = ACTIONS(726),
    [anon_sym_public] = ACTIONS(726),
    [anon_sym_protected] = ACTIONS(726),
    [anon_sym_private] = ACTIONS(726),
    [anon_sym_abstract] = ACTIONS(726),
    [anon_sym_strictfp] = ACTIONS(726),
    [anon_sym_native] = ACTIONS(726),
    [anon_sym_transient] = ACTIONS(726),
    [anon_sym_volatile] = ACTIONS(726),
    [anon_sym_sealed] = ACTIONS(726),
    [anon_sym_non_DASHsealed] = ACTIONS(724),
    [anon_sym_record] = ACTIONS(726),
    [anon_sym_ATinterface] = ACTIONS(724),
    [anon_sym_interface] = ACTIONS(726),
    [anon_sym_byte] = ACTIONS(726),
    [anon_sym_short] = ACTIONS(726),
    [anon_sym_int] = ACTIONS(726),
    [anon_sym_long] = ACTIONS(726),
    [anon_sym_char] = ACTIONS(726),
    [anon_sym_float] = ACTIONS(726),
    [anon_sym_double] = ACTIONS(726),
    [sym_boolean_type] = ACTIONS(726),
    [sym_void_type] = ACTIONS(726),
    [sym_this] = ACTIONS(726),
    [sym_super] = ACTIONS(726),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [266] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(651),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_decimal_integer_literal] = ACTIONS(730),
    [sym_hex_integer_literal] = ACTIONS(730),
    [sym_octal_integer_literal] = ACTIONS(730),
    [sym_binary_integer_literal] = ACTIONS(728),
    [sym_decimal_floating_point_literal] = ACTIONS(728),
    [sym_hex_floating_point_literal] = ACTIONS(730),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_character_literal] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(728),
    [sym_null_literal] = ACTIONS(730),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_final] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(728),
    [anon_sym_DASH_DASH] = ACTIONS(728),
    [anon_sym_new] = ACTIONS(730),
    [anon_sym_class] = ACTIONS(730),
    [anon_sym_switch] = ACTIONS(730),
    [anon_sym_LBRACE] = ACTIONS(728),
    [anon_sym_RBRACE] = ACTIONS(728),
    [anon_sym_case] = ACTIONS(730),
    [anon_sym_default] = ACTIONS(730),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_assert] = ACTIONS(730),
    [anon_sym_do] = ACTIONS(730),
    [anon_sym_while] = ACTIONS(730),
    [anon_sym_break] = ACTIONS(730),
    [anon_sym_continue] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(730),
    [anon_sym_yield] = ACTIONS(730),
    [anon_sym_synchronized] = ACTIONS(730),
    [anon_sym_throw] = ACTIONS(730),
    [anon_sym_try] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_else] = ACTIONS(730),
    [anon_sym_for] = ACTIONS(730),
    [anon_sym_AT] = ACTIONS(730),
    [anon_sym_open] = ACTIONS(730),
    [anon_sym_module] = ACTIONS(730),
    [anon_sym_static] = ACTIONS(730),
    [anon_sym_package] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_enum] = ACTIONS(730),
    [anon_sym_public] = ACTIONS(730),
    [anon_sym_protected] = ACTIONS(730),
    [anon_sym_private] = ACTIONS(730),
    [anon_sym_abstract] = ACTIONS(730),
    [anon_sym_strictfp] = ACTIONS(730),
    [anon_sym_native] = ACTIONS(730),
    [anon_sym_transient] = ACTIONS(730),
    [anon_sym_volatile] = ACTIONS(730),
    [anon_sym_sealed] = ACTIONS(730),
    [anon_sym_non_DASHsealed] = ACTIONS(728),
    [anon_sym_record] = ACTIONS(730),
    [anon_sym_ATinterface] = ACTIONS(728),
    [anon_sym_interface] = ACTIONS(730),
    [anon_sym_byte] = ACTIONS(730),
    [anon_sym_short] = ACTIONS(730),
    [anon_sym_int] = ACTIONS(730),
    [anon_sym_long] = ACTIONS(730),
    [anon_sym_char] = ACTIONS(730),
    [anon_sym_float] = ACTIONS(730),
    [anon_sym_double] = ACTIONS(730),
    [sym_boolean_type] = ACTIONS(730),
    [sym_void_type] = ACTIONS(730),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(730),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [268] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(650),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [269] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [270] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_expression] = STATE(543),
    [sym_cast_expression] = STATE(524),
    [sym_assignment_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_instanceof_expression] = STATE(524),
    [sym_lambda_expression] = STATE(524),
    [sym_inferred_parameters] = STATE(1259),
    [sym_ternary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_primary_expression] = STATE(470),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(384),
    [sym_array_access] = STATE(384),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_switch_expression] = STATE(524),
    [sym__annotation] = STATE(683),
    [sym_marker_annotation] = STATE(683),
    [sym_annotation] = STATE(683),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(795),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [sym_formal_parameters] = STATE(1259),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [sym_identifier] = ACTIONS(301),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(25),
    [anon_sym_new] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(732),
    [sym_identifier] = ACTIONS(734),
    [sym_decimal_integer_literal] = ACTIONS(734),
    [sym_hex_integer_literal] = ACTIONS(734),
    [sym_octal_integer_literal] = ACTIONS(734),
    [sym_binary_integer_literal] = ACTIONS(732),
    [sym_decimal_floating_point_literal] = ACTIONS(732),
    [sym_hex_floating_point_literal] = ACTIONS(734),
    [sym_true] = ACTIONS(734),
    [sym_false] = ACTIONS(734),
    [sym_character_literal] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(732),
    [sym_null_literal] = ACTIONS(734),
    [anon_sym_LPAREN] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_final] = ACTIONS(734),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_PLUS_PLUS] = ACTIONS(732),
    [anon_sym_DASH_DASH] = ACTIONS(732),
    [anon_sym_new] = ACTIONS(734),
    [anon_sym_class] = ACTIONS(734),
    [anon_sym_switch] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(732),
    [anon_sym_RBRACE] = ACTIONS(732),
    [anon_sym_case] = ACTIONS(734),
    [anon_sym_default] = ACTIONS(734),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(734),
    [anon_sym_while] = ACTIONS(734),
    [anon_sym_break] = ACTIONS(734),
    [anon_sym_continue] = ACTIONS(734),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_synchronized] = ACTIONS(734),
    [anon_sym_throw] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(734),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_else] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(734),
    [anon_sym_open] = ACTIONS(734),
    [anon_sym_module] = ACTIONS(734),
    [anon_sym_static] = ACTIONS(734),
    [anon_sym_package] = ACTIONS(734),
    [anon_sym_import] = ACTIONS(734),
    [anon_sym_enum] = ACTIONS(734),
    [anon_sym_public] = ACTIONS(734),
    [anon_sym_protected] = ACTIONS(734),
    [anon_sym_private] = ACTIONS(734),
    [anon_sym_abstract] = ACTIONS(734),
    [anon_sym_strictfp] = ACTIONS(734),
    [anon_sym_native] = ACTIONS(734),
    [anon_sym_transient] = ACTIONS(734),
    [anon_sym_volatile] = ACTIONS(734),
    [anon_sym_sealed] = ACTIONS(734),
    [anon_sym_non_DASHsealed] = ACTIONS(732),
    [anon_sym_record] = ACTIONS(734),
    [anon_sym_ATinterface] = ACTIONS(732),
    [anon_sym_interface] = ACTIONS(734),
    [anon_sym_byte] = ACTIONS(734),
    [anon_sym_short] = ACTIONS(734),
    [anon_sym_int] = ACTIONS(734),
    [anon_sym_long] = ACTIONS(734),
    [anon_sym_char] = ACTIONS(734),
    [anon_sym_float] = ACTIONS(734),
    [anon_sym_double] = ACTIONS(734),
    [sym_boolean_type] = ACTIONS(734),
    [sym_void_type] = ACTIONS(734),
    [sym_this] = ACTIONS(734),
    [sym_super] = ACTIONS(734),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(736),
    [sym_identifier] = ACTIONS(738),
    [sym_decimal_integer_literal] = ACTIONS(738),
    [sym_hex_integer_literal] = ACTIONS(738),
    [sym_octal_integer_literal] = ACTIONS(738),
    [sym_binary_integer_literal] = ACTIONS(736),
    [sym_decimal_floating_point_literal] = ACTIONS(736),
    [sym_hex_floating_point_literal] = ACTIONS(738),
    [sym_true] = ACTIONS(738),
    [sym_false] = ACTIONS(738),
    [sym_character_literal] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(736),
    [sym_null_literal] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_final] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(736),
    [anon_sym_DASH_DASH] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(738),
    [anon_sym_class] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_case] = ACTIONS(738),
    [anon_sym_default] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_assert] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(738),
    [anon_sym_while] = ACTIONS(738),
    [anon_sym_break] = ACTIONS(738),
    [anon_sym_continue] = ACTIONS(738),
    [anon_sym_return] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_synchronized] = ACTIONS(738),
    [anon_sym_throw] = ACTIONS(738),
    [anon_sym_try] = ACTIONS(738),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_else] = ACTIONS(738),
    [anon_sym_for] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_open] = ACTIONS(738),
    [anon_sym_module] = ACTIONS(738),
    [anon_sym_static] = ACTIONS(738),
    [anon_sym_package] = ACTIONS(738),
    [anon_sym_import] = ACTIONS(738),
    [anon_sym_enum] = ACTIONS(738),
    [anon_sym_public] = ACTIONS(738),
    [anon_sym_protected] = ACTIONS(738),
    [anon_sym_private] = ACTIONS(738),
    [anon_sym_abstract] = ACTIONS(738),
    [anon_sym_strictfp] = ACTIONS(738),
    [anon_sym_native] = ACTIONS(738),
    [anon_sym_transient] = ACTIONS(738),
    [anon_sym_volatile] = ACTIONS(738),
    [anon_sym_sealed] = ACTIONS(738),
    [anon_sym_non_DASHsealed] = ACTIONS(736),
    [anon_sym_record] = ACTIONS(738),
    [anon_sym_ATinterface] = ACTIONS(736),
    [anon_sym_interface] = ACTIONS(738),
    [anon_sym_byte] = ACTIONS(738),
    [anon_sym_short] = ACTIONS(738),
    [anon_sym_int] = ACTIONS(738),
    [anon_sym_long] = ACTIONS(738),
    [anon_sym_char] = ACTIONS(738),
    [anon_sym_float] = ACTIONS(738),
    [anon_sym_double] = ACTIONS(738),
    [sym_boolean_type] = ACTIONS(738),
    [sym_void_type] = ACTIONS(738),
    [sym_this] = ACTIONS(738),
    [sym_super] = ACTIONS(738),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(740),
    [sym_identifier] = ACTIONS(742),
    [sym_decimal_integer_literal] = ACTIONS(742),
    [sym_hex_integer_literal] = ACTIONS(742),
    [sym_octal_integer_literal] = ACTIONS(742),
    [sym_binary_integer_literal] = ACTIONS(740),
    [sym_decimal_floating_point_literal] = ACTIONS(740),
    [sym_hex_floating_point_literal] = ACTIONS(742),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_character_literal] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(740),
    [sym_null_literal] = ACTIONS(742),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_final] = ACTIONS(742),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_assert] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_yield] = ACTIONS(742),
    [anon_sym_synchronized] = ACTIONS(742),
    [anon_sym_throw] = ACTIONS(742),
    [anon_sym_try] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_else] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(742),
    [anon_sym_open] = ACTIONS(742),
    [anon_sym_module] = ACTIONS(742),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_package] = ACTIONS(742),
    [anon_sym_import] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_public] = ACTIONS(742),
    [anon_sym_protected] = ACTIONS(742),
    [anon_sym_private] = ACTIONS(742),
    [anon_sym_abstract] = ACTIONS(742),
    [anon_sym_strictfp] = ACTIONS(742),
    [anon_sym_native] = ACTIONS(742),
    [anon_sym_transient] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym_sealed] = ACTIONS(742),
    [anon_sym_non_DASHsealed] = ACTIONS(740),
    [anon_sym_record] = ACTIONS(742),
    [anon_sym_ATinterface] = ACTIONS(740),
    [anon_sym_interface] = ACTIONS(742),
    [anon_sym_byte] = ACTIONS(742),
    [anon_sym_short] = ACTIONS(742),
    [anon_sym_int] = ACTIONS(742),
    [anon_sym_long] = ACTIONS(742),
    [anon_sym_char] = ACTIONS(742),
    [anon_sym_float] = ACTIONS(742),
    [anon_sym_double] = ACTIONS(742),
    [sym_boolean_type] = ACTIONS(742),
    [sym_void_type] = ACTIONS(742),
    [sym_this] = ACTIONS(742),
    [sym_super] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(744),
    [sym_identifier] = ACTIONS(746),
    [sym_decimal_integer_literal] = ACTIONS(746),
    [sym_hex_integer_literal] = ACTIONS(746),
    [sym_octal_integer_literal] = ACTIONS(746),
    [sym_binary_integer_literal] = ACTIONS(744),
    [sym_decimal_floating_point_literal] = ACTIONS(744),
    [sym_hex_floating_point_literal] = ACTIONS(746),
    [sym_true] = ACTIONS(746),
    [sym_false] = ACTIONS(746),
    [sym_character_literal] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(744),
    [sym_null_literal] = ACTIONS(746),
    [anon_sym_LPAREN] = ACTIONS(744),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_final] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_new] = ACTIONS(746),
    [anon_sym_class] = ACTIONS(746),
    [anon_sym_switch] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(744),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_case] = ACTIONS(746),
    [anon_sym_default] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(744),
    [anon_sym_assert] = ACTIONS(746),
    [anon_sym_do] = ACTIONS(746),
    [anon_sym_while] = ACTIONS(746),
    [anon_sym_break] = ACTIONS(746),
    [anon_sym_continue] = ACTIONS(746),
    [anon_sym_return] = ACTIONS(746),
    [anon_sym_yield] = ACTIONS(746),
    [anon_sym_synchronized] = ACTIONS(746),
    [anon_sym_throw] = ACTIONS(746),
    [anon_sym_try] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_else] = ACTIONS(746),
    [anon_sym_for] = ACTIONS(746),
    [anon_sym_AT] = ACTIONS(746),
    [anon_sym_open] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_package] = ACTIONS(746),
    [anon_sym_import] = ACTIONS(746),
    [anon_sym_enum] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_abstract] = ACTIONS(746),
    [anon_sym_strictfp] = ACTIONS(746),
    [anon_sym_native] = ACTIONS(746),
    [anon_sym_transient] = ACTIONS(746),
    [anon_sym_volatile] = ACTIONS(746),
    [anon_sym_sealed] = ACTIONS(746),
    [anon_sym_non_DASHsealed] = ACTIONS(744),
    [anon_sym_record] = ACTIONS(746),
    [anon_sym_ATinterface] = ACTIONS(744),
    [anon_sym_interface] = ACTIONS(746),
    [anon_sym_byte] = ACTIONS(746),
    [anon_sym_short] = ACTIONS(746),
    [anon_sym_int] = ACTIONS(746),
    [anon_sym_long] = ACTIONS(746),
    [anon_sym_char] = ACTIONS(746),
    [anon_sym_float] = ACTIONS(746),
    [anon_sym_double] = ACTIONS(746),
    [sym_boolean_type] = ACTIONS(746),
    [sym_void_type] = ACTIONS(746),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(746),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_switch_label] = STATE(1308),
    [aux_sym_switch_block_statement_group_repeat1] = STATE(275),
    [sym_identifier] = ACTIONS(748),
    [sym_decimal_integer_literal] = ACTIONS(748),
    [sym_hex_integer_literal] = ACTIONS(748),
    [sym_octal_integer_literal] = ACTIONS(748),
    [sym_binary_integer_literal] = ACTIONS(750),
    [sym_decimal_floating_point_literal] = ACTIONS(750),
    [sym_hex_floating_point_literal] = ACTIONS(748),
    [sym_true] = ACTIONS(748),
    [sym_false] = ACTIONS(748),
    [sym_character_literal] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(750),
    [sym_null_literal] = ACTIONS(748),
    [anon_sym_LPAREN] = ACTIONS(750),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(748),
    [anon_sym_final] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_TILDE] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(750),
    [anon_sym_DASH_DASH] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(748),
    [anon_sym_class] = ACTIONS(748),
    [anon_sym_switch] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_RBRACE] = ACTIONS(750),
    [anon_sym_case] = ACTIONS(752),
    [anon_sym_default] = ACTIONS(755),
    [anon_sym_SEMI] = ACTIONS(750),
    [anon_sym_assert] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_break] = ACTIONS(748),
    [anon_sym_continue] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_yield] = ACTIONS(748),
    [anon_sym_synchronized] = ACTIONS(748),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_try] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [anon_sym_open] = ACTIONS(748),
    [anon_sym_module] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(748),
    [anon_sym_package] = ACTIONS(748),
    [anon_sym_import] = ACTIONS(748),
    [anon_sym_enum] = ACTIONS(748),
    [anon_sym_public] = ACTIONS(748),
    [anon_sym_protected] = ACTIONS(748),
    [anon_sym_private] = ACTIONS(748),
    [anon_sym_abstract] = ACTIONS(748),
    [anon_sym_strictfp] = ACTIONS(748),
    [anon_sym_native] = ACTIONS(748),
    [anon_sym_transient] = ACTIONS(748),
    [anon_sym_volatile] = ACTIONS(748),
    [anon_sym_sealed] = ACTIONS(748),
    [anon_sym_non_DASHsealed] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(748),
    [anon_sym_ATinterface] = ACTIONS(750),
    [anon_sym_interface] = ACTIONS(748),
    [anon_sym_byte] = ACTIONS(748),
    [anon_sym_short] = ACTIONS(748),
    [anon_sym_int] = ACTIONS(748),
    [anon_sym_long] = ACTIONS(748),
    [anon_sym_char] = ACTIONS(748),
    [anon_sym_float] = ACTIONS(748),
    [anon_sym_double] = ACTIONS(748),
    [sym_boolean_type] = ACTIONS(748),
    [sym_void_type] = ACTIONS(748),
    [sym_this] = ACTIONS(748),
    [sym_super] = ACTIONS(748),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(309),
    [sym_identifier] = ACTIONS(311),
    [sym_decimal_integer_literal] = ACTIONS(311),
    [sym_hex_integer_literal] = ACTIONS(311),
    [sym_octal_integer_literal] = ACTIONS(311),
    [sym_binary_integer_literal] = ACTIONS(309),
    [sym_decimal_floating_point_literal] = ACTIONS(309),
    [sym_hex_floating_point_literal] = ACTIONS(311),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_character_literal] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(309),
    [sym_null_literal] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(311),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_final] = ACTIONS(311),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_PLUS_PLUS] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(309),
    [anon_sym_new] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(311),
    [anon_sym_switch] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_RBRACE] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(309),
    [anon_sym_assert] = ACTIONS(311),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(311),
    [anon_sym_yield] = ACTIONS(311),
    [anon_sym_synchronized] = ACTIONS(311),
    [anon_sym_throw] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(311),
    [anon_sym_if] = ACTIONS(311),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(311),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_static] = ACTIONS(311),
    [anon_sym_package] = ACTIONS(311),
    [anon_sym_import] = ACTIONS(311),
    [anon_sym_enum] = ACTIONS(311),
    [anon_sym_public] = ACTIONS(311),
    [anon_sym_protected] = ACTIONS(311),
    [anon_sym_private] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(311),
    [anon_sym_strictfp] = ACTIONS(311),
    [anon_sym_native] = ACTIONS(311),
    [anon_sym_transient] = ACTIONS(311),
    [anon_sym_volatile] = ACTIONS(311),
    [anon_sym_sealed] = ACTIONS(311),
    [anon_sym_non_DASHsealed] = ACTIONS(309),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_ATinterface] = ACTIONS(309),
    [anon_sym_interface] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(311),
    [anon_sym_short] = ACTIONS(311),
    [anon_sym_int] = ACTIONS(311),
    [anon_sym_long] = ACTIONS(311),
    [anon_sym_char] = ACTIONS(311),
    [anon_sym_float] = ACTIONS(311),
    [anon_sym_double] = ACTIONS(311),
    [sym_boolean_type] = ACTIONS(311),
    [sym_void_type] = ACTIONS(311),
    [sym_this] = ACTIONS(311),
    [sym_super] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [277] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_primary_expression] = STATE(1073),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(912),
    [sym_array_access] = STATE(507),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_resource] = STATE(1127),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(721),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(742),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(758),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_RPAREN] = ACTIONS(762),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_new] = ACTIONS(764),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(766),
    [anon_sym_module] = ACTIONS(766),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(766),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_decimal_integer_literal] = ACTIONS(770),
    [sym_hex_integer_literal] = ACTIONS(770),
    [sym_octal_integer_literal] = ACTIONS(770),
    [sym_binary_integer_literal] = ACTIONS(768),
    [sym_decimal_floating_point_literal] = ACTIONS(768),
    [sym_hex_floating_point_literal] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_character_literal] = ACTIONS(768),
    [anon_sym_DQUOTE] = ACTIONS(770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(768),
    [sym_null_literal] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(768),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_final] = ACTIONS(770),
    [anon_sym_BANG] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_PLUS_PLUS] = ACTIONS(768),
    [anon_sym_DASH_DASH] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(770),
    [anon_sym_class] = ACTIONS(770),
    [anon_sym_switch] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(768),
    [anon_sym_RBRACE] = ACTIONS(768),
    [anon_sym_case] = ACTIONS(770),
    [anon_sym_default] = ACTIONS(770),
    [anon_sym_SEMI] = ACTIONS(768),
    [anon_sym_assert] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_break] = ACTIONS(770),
    [anon_sym_continue] = ACTIONS(770),
    [anon_sym_return] = ACTIONS(770),
    [anon_sym_yield] = ACTIONS(770),
    [anon_sym_synchronized] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(770),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(770),
    [anon_sym_open] = ACTIONS(770),
    [anon_sym_module] = ACTIONS(770),
    [anon_sym_static] = ACTIONS(770),
    [anon_sym_package] = ACTIONS(770),
    [anon_sym_import] = ACTIONS(770),
    [anon_sym_enum] = ACTIONS(770),
    [anon_sym_public] = ACTIONS(770),
    [anon_sym_protected] = ACTIONS(770),
    [anon_sym_private] = ACTIONS(770),
    [anon_sym_abstract] = ACTIONS(770),
    [anon_sym_strictfp] = ACTIONS(770),
    [anon_sym_native] = ACTIONS(770),
    [anon_sym_transient] = ACTIONS(770),
    [anon_sym_volatile] = ACTIONS(770),
    [anon_sym_sealed] = ACTIONS(770),
    [anon_sym_non_DASHsealed] = ACTIONS(768),
    [anon_sym_record] = ACTIONS(770),
    [anon_sym_ATinterface] = ACTIONS(768),
    [anon_sym_interface] = ACTIONS(770),
    [anon_sym_byte] = ACTIONS(770),
    [anon_sym_short] = ACTIONS(770),
    [anon_sym_int] = ACTIONS(770),
    [anon_sym_long] = ACTIONS(770),
    [anon_sym_char] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(770),
    [anon_sym_double] = ACTIONS(770),
    [sym_boolean_type] = ACTIONS(770),
    [sym_void_type] = ACTIONS(770),
    [sym_this] = ACTIONS(770),
    [sym_super] = ACTIONS(770),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [279] = {
    [ts_builtin_sym_end] = ACTIONS(772),
    [sym_identifier] = ACTIONS(774),
    [sym_decimal_integer_literal] = ACTIONS(774),
    [sym_hex_integer_literal] = ACTIONS(774),
    [sym_octal_integer_literal] = ACTIONS(774),
    [sym_binary_integer_literal] = ACTIONS(772),
    [sym_decimal_floating_point_literal] = ACTIONS(772),
    [sym_hex_floating_point_literal] = ACTIONS(774),
    [sym_true] = ACTIONS(774),
    [sym_false] = ACTIONS(774),
    [sym_character_literal] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(774),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(772),
    [sym_null_literal] = ACTIONS(774),
    [anon_sym_LPAREN] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(774),
    [anon_sym_DASH] = ACTIONS(774),
    [anon_sym_final] = ACTIONS(774),
    [anon_sym_BANG] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_PLUS_PLUS] = ACTIONS(772),
    [anon_sym_DASH_DASH] = ACTIONS(772),
    [anon_sym_new] = ACTIONS(774),
    [anon_sym_class] = ACTIONS(774),
    [anon_sym_switch] = ACTIONS(774),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_RBRACE] = ACTIONS(772),
    [anon_sym_case] = ACTIONS(774),
    [anon_sym_default] = ACTIONS(774),
    [anon_sym_SEMI] = ACTIONS(772),
    [anon_sym_assert] = ACTIONS(774),
    [anon_sym_do] = ACTIONS(774),
    [anon_sym_while] = ACTIONS(774),
    [anon_sym_break] = ACTIONS(774),
    [anon_sym_continue] = ACTIONS(774),
    [anon_sym_return] = ACTIONS(774),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_synchronized] = ACTIONS(774),
    [anon_sym_throw] = ACTIONS(774),
    [anon_sym_try] = ACTIONS(774),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_else] = ACTIONS(774),
    [anon_sym_for] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(774),
    [anon_sym_open] = ACTIONS(774),
    [anon_sym_module] = ACTIONS(774),
    [anon_sym_static] = ACTIONS(774),
    [anon_sym_package] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_enum] = ACTIONS(774),
    [anon_sym_public] = ACTIONS(774),
    [anon_sym_protected] = ACTIONS(774),
    [anon_sym_private] = ACTIONS(774),
    [anon_sym_abstract] = ACTIONS(774),
    [anon_sym_strictfp] = ACTIONS(774),
    [anon_sym_native] = ACTIONS(774),
    [anon_sym_transient] = ACTIONS(774),
    [anon_sym_volatile] = ACTIONS(774),
    [anon_sym_sealed] = ACTIONS(774),
    [anon_sym_non_DASHsealed] = ACTIONS(772),
    [anon_sym_record] = ACTIONS(774),
    [anon_sym_ATinterface] = ACTIONS(772),
    [anon_sym_interface] = ACTIONS(774),
    [anon_sym_byte] = ACTIONS(774),
    [anon_sym_short] = ACTIONS(774),
    [anon_sym_int] = ACTIONS(774),
    [anon_sym_long] = ACTIONS(774),
    [anon_sym_char] = ACTIONS(774),
    [anon_sym_float] = ACTIONS(774),
    [anon_sym_double] = ACTIONS(774),
    [sym_boolean_type] = ACTIONS(774),
    [sym_void_type] = ACTIONS(774),
    [sym_this] = ACTIONS(774),
    [sym_super] = ACTIONS(774),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(776),
    [sym_identifier] = ACTIONS(778),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(778),
    [sym_octal_integer_literal] = ACTIONS(778),
    [sym_binary_integer_literal] = ACTIONS(776),
    [sym_decimal_floating_point_literal] = ACTIONS(776),
    [sym_hex_floating_point_literal] = ACTIONS(778),
    [sym_true] = ACTIONS(778),
    [sym_false] = ACTIONS(778),
    [sym_character_literal] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(776),
    [sym_null_literal] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_final] = ACTIONS(778),
    [anon_sym_BANG] = ACTIONS(776),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_PLUS_PLUS] = ACTIONS(776),
    [anon_sym_DASH_DASH] = ACTIONS(776),
    [anon_sym_new] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(778),
    [anon_sym_switch] = ACTIONS(778),
    [anon_sym_LBRACE] = ACTIONS(776),
    [anon_sym_RBRACE] = ACTIONS(776),
    [anon_sym_case] = ACTIONS(778),
    [anon_sym_default] = ACTIONS(778),
    [anon_sym_SEMI] = ACTIONS(776),
    [anon_sym_assert] = ACTIONS(778),
    [anon_sym_do] = ACTIONS(778),
    [anon_sym_while] = ACTIONS(778),
    [anon_sym_break] = ACTIONS(778),
    [anon_sym_continue] = ACTIONS(778),
    [anon_sym_return] = ACTIONS(778),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_synchronized] = ACTIONS(778),
    [anon_sym_throw] = ACTIONS(778),
    [anon_sym_try] = ACTIONS(778),
    [anon_sym_if] = ACTIONS(778),
    [anon_sym_else] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(778),
    [anon_sym_open] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_package] = ACTIONS(778),
    [anon_sym_import] = ACTIONS(778),
    [anon_sym_enum] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_abstract] = ACTIONS(778),
    [anon_sym_strictfp] = ACTIONS(778),
    [anon_sym_native] = ACTIONS(778),
    [anon_sym_transient] = ACTIONS(778),
    [anon_sym_volatile] = ACTIONS(778),
    [anon_sym_sealed] = ACTIONS(778),
    [anon_sym_non_DASHsealed] = ACTIONS(776),
    [anon_sym_record] = ACTIONS(778),
    [anon_sym_ATinterface] = ACTIONS(776),
    [anon_sym_interface] = ACTIONS(778),
    [anon_sym_byte] = ACTIONS(778),
    [anon_sym_short] = ACTIONS(778),
    [anon_sym_int] = ACTIONS(778),
    [anon_sym_long] = ACTIONS(778),
    [anon_sym_char] = ACTIONS(778),
    [anon_sym_float] = ACTIONS(778),
    [anon_sym_double] = ACTIONS(778),
    [sym_boolean_type] = ACTIONS(778),
    [sym_void_type] = ACTIONS(778),
    [sym_this] = ACTIONS(778),
    [sym_super] = ACTIONS(778),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(780),
    [sym_identifier] = ACTIONS(782),
    [sym_decimal_integer_literal] = ACTIONS(782),
    [sym_hex_integer_literal] = ACTIONS(782),
    [sym_octal_integer_literal] = ACTIONS(782),
    [sym_binary_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(780),
    [sym_hex_floating_point_literal] = ACTIONS(782),
    [sym_true] = ACTIONS(782),
    [sym_false] = ACTIONS(782),
    [sym_character_literal] = ACTIONS(780),
    [anon_sym_DQUOTE] = ACTIONS(782),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(780),
    [sym_null_literal] = ACTIONS(782),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_final] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(780),
    [anon_sym_DASH_DASH] = ACTIONS(780),
    [anon_sym_new] = ACTIONS(782),
    [anon_sym_class] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(782),
    [anon_sym_LBRACE] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(780),
    [anon_sym_case] = ACTIONS(782),
    [anon_sym_default] = ACTIONS(782),
    [anon_sym_SEMI] = ACTIONS(780),
    [anon_sym_assert] = ACTIONS(782),
    [anon_sym_do] = ACTIONS(782),
    [anon_sym_while] = ACTIONS(782),
    [anon_sym_break] = ACTIONS(782),
    [anon_sym_continue] = ACTIONS(782),
    [anon_sym_return] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(782),
    [anon_sym_synchronized] = ACTIONS(782),
    [anon_sym_throw] = ACTIONS(782),
    [anon_sym_try] = ACTIONS(782),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_else] = ACTIONS(782),
    [anon_sym_for] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(782),
    [anon_sym_open] = ACTIONS(782),
    [anon_sym_module] = ACTIONS(782),
    [anon_sym_static] = ACTIONS(782),
    [anon_sym_package] = ACTIONS(782),
    [anon_sym_import] = ACTIONS(782),
    [anon_sym_enum] = ACTIONS(782),
    [anon_sym_public] = ACTIONS(782),
    [anon_sym_protected] = ACTIONS(782),
    [anon_sym_private] = ACTIONS(782),
    [anon_sym_abstract] = ACTIONS(782),
    [anon_sym_strictfp] = ACTIONS(782),
    [anon_sym_native] = ACTIONS(782),
    [anon_sym_transient] = ACTIONS(782),
    [anon_sym_volatile] = ACTIONS(782),
    [anon_sym_sealed] = ACTIONS(782),
    [anon_sym_non_DASHsealed] = ACTIONS(780),
    [anon_sym_record] = ACTIONS(782),
    [anon_sym_ATinterface] = ACTIONS(780),
    [anon_sym_interface] = ACTIONS(782),
    [anon_sym_byte] = ACTIONS(782),
    [anon_sym_short] = ACTIONS(782),
    [anon_sym_int] = ACTIONS(782),
    [anon_sym_long] = ACTIONS(782),
    [anon_sym_char] = ACTIONS(782),
    [anon_sym_float] = ACTIONS(782),
    [anon_sym_double] = ACTIONS(782),
    [sym_boolean_type] = ACTIONS(782),
    [sym_void_type] = ACTIONS(782),
    [sym_this] = ACTIONS(782),
    [sym_super] = ACTIONS(782),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(784),
    [sym_identifier] = ACTIONS(786),
    [sym_decimal_integer_literal] = ACTIONS(786),
    [sym_hex_integer_literal] = ACTIONS(786),
    [sym_octal_integer_literal] = ACTIONS(786),
    [sym_binary_integer_literal] = ACTIONS(784),
    [sym_decimal_floating_point_literal] = ACTIONS(784),
    [sym_hex_floating_point_literal] = ACTIONS(786),
    [sym_true] = ACTIONS(786),
    [sym_false] = ACTIONS(786),
    [sym_character_literal] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(784),
    [sym_null_literal] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_final] = ACTIONS(786),
    [anon_sym_BANG] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_class] = ACTIONS(786),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_RBRACE] = ACTIONS(784),
    [anon_sym_case] = ACTIONS(786),
    [anon_sym_default] = ACTIONS(786),
    [anon_sym_SEMI] = ACTIONS(784),
    [anon_sym_assert] = ACTIONS(786),
    [anon_sym_do] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(786),
    [anon_sym_break] = ACTIONS(786),
    [anon_sym_continue] = ACTIONS(786),
    [anon_sym_return] = ACTIONS(786),
    [anon_sym_yield] = ACTIONS(786),
    [anon_sym_synchronized] = ACTIONS(786),
    [anon_sym_throw] = ACTIONS(786),
    [anon_sym_try] = ACTIONS(786),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(786),
    [anon_sym_open] = ACTIONS(786),
    [anon_sym_module] = ACTIONS(786),
    [anon_sym_static] = ACTIONS(786),
    [anon_sym_package] = ACTIONS(786),
    [anon_sym_import] = ACTIONS(786),
    [anon_sym_enum] = ACTIONS(786),
    [anon_sym_public] = ACTIONS(786),
    [anon_sym_protected] = ACTIONS(786),
    [anon_sym_private] = ACTIONS(786),
    [anon_sym_abstract] = ACTIONS(786),
    [anon_sym_strictfp] = ACTIONS(786),
    [anon_sym_native] = ACTIONS(786),
    [anon_sym_transient] = ACTIONS(786),
    [anon_sym_volatile] = ACTIONS(786),
    [anon_sym_sealed] = ACTIONS(786),
    [anon_sym_non_DASHsealed] = ACTIONS(784),
    [anon_sym_record] = ACTIONS(786),
    [anon_sym_ATinterface] = ACTIONS(784),
    [anon_sym_interface] = ACTIONS(786),
    [anon_sym_byte] = ACTIONS(786),
    [anon_sym_short] = ACTIONS(786),
    [anon_sym_int] = ACTIONS(786),
    [anon_sym_long] = ACTIONS(786),
    [anon_sym_char] = ACTIONS(786),
    [anon_sym_float] = ACTIONS(786),
    [anon_sym_double] = ACTIONS(786),
    [sym_boolean_type] = ACTIONS(786),
    [sym_void_type] = ACTIONS(786),
    [sym_this] = ACTIONS(786),
    [sym_super] = ACTIONS(786),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(788),
    [sym_identifier] = ACTIONS(790),
    [sym_decimal_integer_literal] = ACTIONS(790),
    [sym_hex_integer_literal] = ACTIONS(790),
    [sym_octal_integer_literal] = ACTIONS(790),
    [sym_binary_integer_literal] = ACTIONS(788),
    [sym_decimal_floating_point_literal] = ACTIONS(788),
    [sym_hex_floating_point_literal] = ACTIONS(790),
    [sym_true] = ACTIONS(790),
    [sym_false] = ACTIONS(790),
    [sym_character_literal] = ACTIONS(788),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(788),
    [sym_null_literal] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(790),
    [anon_sym_DASH] = ACTIONS(790),
    [anon_sym_final] = ACTIONS(790),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_TILDE] = ACTIONS(788),
    [anon_sym_PLUS_PLUS] = ACTIONS(788),
    [anon_sym_DASH_DASH] = ACTIONS(788),
    [anon_sym_new] = ACTIONS(790),
    [anon_sym_class] = ACTIONS(790),
    [anon_sym_switch] = ACTIONS(790),
    [anon_sym_LBRACE] = ACTIONS(788),
    [anon_sym_RBRACE] = ACTIONS(788),
    [anon_sym_case] = ACTIONS(790),
    [anon_sym_default] = ACTIONS(790),
    [anon_sym_SEMI] = ACTIONS(788),
    [anon_sym_assert] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_break] = ACTIONS(790),
    [anon_sym_continue] = ACTIONS(790),
    [anon_sym_return] = ACTIONS(790),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_synchronized] = ACTIONS(790),
    [anon_sym_throw] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(790),
    [anon_sym_if] = ACTIONS(790),
    [anon_sym_else] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(790),
    [anon_sym_AT] = ACTIONS(790),
    [anon_sym_open] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(790),
    [anon_sym_static] = ACTIONS(790),
    [anon_sym_package] = ACTIONS(790),
    [anon_sym_import] = ACTIONS(790),
    [anon_sym_enum] = ACTIONS(790),
    [anon_sym_public] = ACTIONS(790),
    [anon_sym_protected] = ACTIONS(790),
    [anon_sym_private] = ACTIONS(790),
    [anon_sym_abstract] = ACTIONS(790),
    [anon_sym_strictfp] = ACTIONS(790),
    [anon_sym_native] = ACTIONS(790),
    [anon_sym_transient] = ACTIONS(790),
    [anon_sym_volatile] = ACTIONS(790),
    [anon_sym_sealed] = ACTIONS(790),
    [anon_sym_non_DASHsealed] = ACTIONS(788),
    [anon_sym_record] = ACTIONS(790),
    [anon_sym_ATinterface] = ACTIONS(788),
    [anon_sym_interface] = ACTIONS(790),
    [anon_sym_byte] = ACTIONS(790),
    [anon_sym_short] = ACTIONS(790),
    [anon_sym_int] = ACTIONS(790),
    [anon_sym_long] = ACTIONS(790),
    [anon_sym_char] = ACTIONS(790),
    [anon_sym_float] = ACTIONS(790),
    [anon_sym_double] = ACTIONS(790),
    [sym_boolean_type] = ACTIONS(790),
    [sym_void_type] = ACTIONS(790),
    [sym_this] = ACTIONS(790),
    [sym_super] = ACTIONS(790),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [284] = {
    [ts_builtin_sym_end] = ACTIONS(792),
    [sym_identifier] = ACTIONS(794),
    [sym_decimal_integer_literal] = ACTIONS(794),
    [sym_hex_integer_literal] = ACTIONS(794),
    [sym_octal_integer_literal] = ACTIONS(794),
    [sym_binary_integer_literal] = ACTIONS(792),
    [sym_decimal_floating_point_literal] = ACTIONS(792),
    [sym_hex_floating_point_literal] = ACTIONS(794),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_character_literal] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(792),
    [sym_null_literal] = ACTIONS(794),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_PLUS] = ACTIONS(794),
    [anon_sym_DASH] = ACTIONS(794),
    [anon_sym_final] = ACTIONS(794),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_new] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(794),
    [anon_sym_switch] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(792),
    [anon_sym_RBRACE] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(794),
    [anon_sym_default] = ACTIONS(794),
    [anon_sym_SEMI] = ACTIONS(792),
    [anon_sym_assert] = ACTIONS(794),
    [anon_sym_do] = ACTIONS(794),
    [anon_sym_while] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(794),
    [anon_sym_return] = ACTIONS(794),
    [anon_sym_yield] = ACTIONS(794),
    [anon_sym_synchronized] = ACTIONS(794),
    [anon_sym_throw] = ACTIONS(794),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_if] = ACTIONS(794),
    [anon_sym_else] = ACTIONS(794),
    [anon_sym_for] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(794),
    [anon_sym_open] = ACTIONS(794),
    [anon_sym_module] = ACTIONS(794),
    [anon_sym_static] = ACTIONS(794),
    [anon_sym_package] = ACTIONS(794),
    [anon_sym_import] = ACTIONS(794),
    [anon_sym_enum] = ACTIONS(794),
    [anon_sym_public] = ACTIONS(794),
    [anon_sym_protected] = ACTIONS(794),
    [anon_sym_private] = ACTIONS(794),
    [anon_sym_abstract] = ACTIONS(794),
    [anon_sym_strictfp] = ACTIONS(794),
    [anon_sym_native] = ACTIONS(794),
    [anon_sym_transient] = ACTIONS(794),
    [anon_sym_volatile] = ACTIONS(794),
    [anon_sym_sealed] = ACTIONS(794),
    [anon_sym_non_DASHsealed] = ACTIONS(792),
    [anon_sym_record] = ACTIONS(794),
    [anon_sym_ATinterface] = ACTIONS(792),
    [anon_sym_interface] = ACTIONS(794),
    [anon_sym_byte] = ACTIONS(794),
    [anon_sym_short] = ACTIONS(794),
    [anon_sym_int] = ACTIONS(794),
    [anon_sym_long] = ACTIONS(794),
    [anon_sym_char] = ACTIONS(794),
    [anon_sym_float] = ACTIONS(794),
    [anon_sym_double] = ACTIONS(794),
    [sym_boolean_type] = ACTIONS(794),
    [sym_void_type] = ACTIONS(794),
    [sym_this] = ACTIONS(794),
    [sym_super] = ACTIONS(794),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [285] = {
    [ts_builtin_sym_end] = ACTIONS(796),
    [sym_identifier] = ACTIONS(798),
    [sym_decimal_integer_literal] = ACTIONS(798),
    [sym_hex_integer_literal] = ACTIONS(798),
    [sym_octal_integer_literal] = ACTIONS(798),
    [sym_binary_integer_literal] = ACTIONS(796),
    [sym_decimal_floating_point_literal] = ACTIONS(796),
    [sym_hex_floating_point_literal] = ACTIONS(798),
    [sym_true] = ACTIONS(798),
    [sym_false] = ACTIONS(798),
    [sym_character_literal] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(796),
    [sym_null_literal] = ACTIONS(798),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_final] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(796),
    [anon_sym_TILDE] = ACTIONS(796),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_new] = ACTIONS(798),
    [anon_sym_class] = ACTIONS(798),
    [anon_sym_switch] = ACTIONS(798),
    [anon_sym_LBRACE] = ACTIONS(796),
    [anon_sym_RBRACE] = ACTIONS(796),
    [anon_sym_case] = ACTIONS(798),
    [anon_sym_default] = ACTIONS(798),
    [anon_sym_SEMI] = ACTIONS(796),
    [anon_sym_assert] = ACTIONS(798),
    [anon_sym_do] = ACTIONS(798),
    [anon_sym_while] = ACTIONS(798),
    [anon_sym_break] = ACTIONS(798),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(798),
    [anon_sym_yield] = ACTIONS(798),
    [anon_sym_synchronized] = ACTIONS(798),
    [anon_sym_throw] = ACTIONS(798),
    [anon_sym_try] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(798),
    [anon_sym_else] = ACTIONS(798),
    [anon_sym_for] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(798),
    [anon_sym_open] = ACTIONS(798),
    [anon_sym_module] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(798),
    [anon_sym_package] = ACTIONS(798),
    [anon_sym_import] = ACTIONS(798),
    [anon_sym_enum] = ACTIONS(798),
    [anon_sym_public] = ACTIONS(798),
    [anon_sym_protected] = ACTIONS(798),
    [anon_sym_private] = ACTIONS(798),
    [anon_sym_abstract] = ACTIONS(798),
    [anon_sym_strictfp] = ACTIONS(798),
    [anon_sym_native] = ACTIONS(798),
    [anon_sym_transient] = ACTIONS(798),
    [anon_sym_volatile] = ACTIONS(798),
    [anon_sym_sealed] = ACTIONS(798),
    [anon_sym_non_DASHsealed] = ACTIONS(796),
    [anon_sym_record] = ACTIONS(798),
    [anon_sym_ATinterface] = ACTIONS(796),
    [anon_sym_interface] = ACTIONS(798),
    [anon_sym_byte] = ACTIONS(798),
    [anon_sym_short] = ACTIONS(798),
    [anon_sym_int] = ACTIONS(798),
    [anon_sym_long] = ACTIONS(798),
    [anon_sym_char] = ACTIONS(798),
    [anon_sym_float] = ACTIONS(798),
    [anon_sym_double] = ACTIONS(798),
    [sym_boolean_type] = ACTIONS(798),
    [sym_void_type] = ACTIONS(798),
    [sym_this] = ACTIONS(798),
    [sym_super] = ACTIONS(798),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(800),
    [sym_identifier] = ACTIONS(802),
    [sym_decimal_integer_literal] = ACTIONS(802),
    [sym_hex_integer_literal] = ACTIONS(802),
    [sym_octal_integer_literal] = ACTIONS(802),
    [sym_binary_integer_literal] = ACTIONS(800),
    [sym_decimal_floating_point_literal] = ACTIONS(800),
    [sym_hex_floating_point_literal] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_character_literal] = ACTIONS(800),
    [anon_sym_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(800),
    [sym_null_literal] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(800),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_final] = ACTIONS(802),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(800),
    [anon_sym_PLUS_PLUS] = ACTIONS(800),
    [anon_sym_DASH_DASH] = ACTIONS(800),
    [anon_sym_new] = ACTIONS(802),
    [anon_sym_class] = ACTIONS(802),
    [anon_sym_switch] = ACTIONS(802),
    [anon_sym_LBRACE] = ACTIONS(800),
    [anon_sym_RBRACE] = ACTIONS(800),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_default] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(800),
    [anon_sym_assert] = ACTIONS(802),
    [anon_sym_do] = ACTIONS(802),
    [anon_sym_while] = ACTIONS(802),
    [anon_sym_break] = ACTIONS(802),
    [anon_sym_continue] = ACTIONS(802),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_yield] = ACTIONS(802),
    [anon_sym_synchronized] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_try] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_else] = ACTIONS(802),
    [anon_sym_for] = ACTIONS(802),
    [anon_sym_AT] = ACTIONS(802),
    [anon_sym_open] = ACTIONS(802),
    [anon_sym_module] = ACTIONS(802),
    [anon_sym_static] = ACTIONS(802),
    [anon_sym_package] = ACTIONS(802),
    [anon_sym_import] = ACTIONS(802),
    [anon_sym_enum] = ACTIONS(802),
    [anon_sym_public] = ACTIONS(802),
    [anon_sym_protected] = ACTIONS(802),
    [anon_sym_private] = ACTIONS(802),
    [anon_sym_abstract] = ACTIONS(802),
    [anon_sym_strictfp] = ACTIONS(802),
    [anon_sym_native] = ACTIONS(802),
    [anon_sym_transient] = ACTIONS(802),
    [anon_sym_volatile] = ACTIONS(802),
    [anon_sym_sealed] = ACTIONS(802),
    [anon_sym_non_DASHsealed] = ACTIONS(800),
    [anon_sym_record] = ACTIONS(802),
    [anon_sym_ATinterface] = ACTIONS(800),
    [anon_sym_interface] = ACTIONS(802),
    [anon_sym_byte] = ACTIONS(802),
    [anon_sym_short] = ACTIONS(802),
    [anon_sym_int] = ACTIONS(802),
    [anon_sym_long] = ACTIONS(802),
    [anon_sym_char] = ACTIONS(802),
    [anon_sym_float] = ACTIONS(802),
    [anon_sym_double] = ACTIONS(802),
    [sym_boolean_type] = ACTIONS(802),
    [sym_void_type] = ACTIONS(802),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(804),
    [sym_identifier] = ACTIONS(806),
    [sym_decimal_integer_literal] = ACTIONS(806),
    [sym_hex_integer_literal] = ACTIONS(806),
    [sym_octal_integer_literal] = ACTIONS(806),
    [sym_binary_integer_literal] = ACTIONS(804),
    [sym_decimal_floating_point_literal] = ACTIONS(804),
    [sym_hex_floating_point_literal] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_character_literal] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_null_literal] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_final] = ACTIONS(806),
    [anon_sym_BANG] = ACTIONS(804),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_new] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_switch] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_RBRACE] = ACTIONS(804),
    [anon_sym_case] = ACTIONS(806),
    [anon_sym_default] = ACTIONS(806),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_do] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(806),
    [anon_sym_synchronized] = ACTIONS(806),
    [anon_sym_throw] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_else] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(806),
    [anon_sym_open] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [anon_sym_static] = ACTIONS(806),
    [anon_sym_package] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_enum] = ACTIONS(806),
    [anon_sym_public] = ACTIONS(806),
    [anon_sym_protected] = ACTIONS(806),
    [anon_sym_private] = ACTIONS(806),
    [anon_sym_abstract] = ACTIONS(806),
    [anon_sym_strictfp] = ACTIONS(806),
    [anon_sym_native] = ACTIONS(806),
    [anon_sym_transient] = ACTIONS(806),
    [anon_sym_volatile] = ACTIONS(806),
    [anon_sym_sealed] = ACTIONS(806),
    [anon_sym_non_DASHsealed] = ACTIONS(804),
    [anon_sym_record] = ACTIONS(806),
    [anon_sym_ATinterface] = ACTIONS(804),
    [anon_sym_interface] = ACTIONS(806),
    [anon_sym_byte] = ACTIONS(806),
    [anon_sym_short] = ACTIONS(806),
    [anon_sym_int] = ACTIONS(806),
    [anon_sym_long] = ACTIONS(806),
    [anon_sym_char] = ACTIONS(806),
    [anon_sym_float] = ACTIONS(806),
    [anon_sym_double] = ACTIONS(806),
    [sym_boolean_type] = ACTIONS(806),
    [sym_void_type] = ACTIONS(806),
    [sym_this] = ACTIONS(806),
    [sym_super] = ACTIONS(806),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(808),
    [sym_identifier] = ACTIONS(810),
    [sym_decimal_integer_literal] = ACTIONS(810),
    [sym_hex_integer_literal] = ACTIONS(810),
    [sym_octal_integer_literal] = ACTIONS(810),
    [sym_binary_integer_literal] = ACTIONS(808),
    [sym_decimal_floating_point_literal] = ACTIONS(808),
    [sym_hex_floating_point_literal] = ACTIONS(810),
    [sym_true] = ACTIONS(810),
    [sym_false] = ACTIONS(810),
    [sym_character_literal] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(808),
    [sym_null_literal] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(810),
    [anon_sym_DASH] = ACTIONS(810),
    [anon_sym_final] = ACTIONS(810),
    [anon_sym_BANG] = ACTIONS(808),
    [anon_sym_TILDE] = ACTIONS(808),
    [anon_sym_PLUS_PLUS] = ACTIONS(808),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_new] = ACTIONS(810),
    [anon_sym_class] = ACTIONS(810),
    [anon_sym_switch] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_RBRACE] = ACTIONS(808),
    [anon_sym_case] = ACTIONS(810),
    [anon_sym_default] = ACTIONS(810),
    [anon_sym_SEMI] = ACTIONS(808),
    [anon_sym_assert] = ACTIONS(810),
    [anon_sym_do] = ACTIONS(810),
    [anon_sym_while] = ACTIONS(810),
    [anon_sym_break] = ACTIONS(810),
    [anon_sym_continue] = ACTIONS(810),
    [anon_sym_return] = ACTIONS(810),
    [anon_sym_yield] = ACTIONS(810),
    [anon_sym_synchronized] = ACTIONS(810),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_try] = ACTIONS(810),
    [anon_sym_if] = ACTIONS(810),
    [anon_sym_else] = ACTIONS(810),
    [anon_sym_for] = ACTIONS(810),
    [anon_sym_AT] = ACTIONS(810),
    [anon_sym_open] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_package] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(810),
    [anon_sym_enum] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_abstract] = ACTIONS(810),
    [anon_sym_strictfp] = ACTIONS(810),
    [anon_sym_native] = ACTIONS(810),
    [anon_sym_transient] = ACTIONS(810),
    [anon_sym_volatile] = ACTIONS(810),
    [anon_sym_sealed] = ACTIONS(810),
    [anon_sym_non_DASHsealed] = ACTIONS(808),
    [anon_sym_record] = ACTIONS(810),
    [anon_sym_ATinterface] = ACTIONS(808),
    [anon_sym_interface] = ACTIONS(810),
    [anon_sym_byte] = ACTIONS(810),
    [anon_sym_short] = ACTIONS(810),
    [anon_sym_int] = ACTIONS(810),
    [anon_sym_long] = ACTIONS(810),
    [anon_sym_char] = ACTIONS(810),
    [anon_sym_float] = ACTIONS(810),
    [anon_sym_double] = ACTIONS(810),
    [sym_boolean_type] = ACTIONS(810),
    [sym_void_type] = ACTIONS(810),
    [sym_this] = ACTIONS(810),
    [sym_super] = ACTIONS(810),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [289] = {
    [ts_builtin_sym_end] = ACTIONS(812),
    [sym_identifier] = ACTIONS(814),
    [sym_decimal_integer_literal] = ACTIONS(814),
    [sym_hex_integer_literal] = ACTIONS(814),
    [sym_octal_integer_literal] = ACTIONS(814),
    [sym_binary_integer_literal] = ACTIONS(812),
    [sym_decimal_floating_point_literal] = ACTIONS(812),
    [sym_hex_floating_point_literal] = ACTIONS(814),
    [sym_true] = ACTIONS(814),
    [sym_false] = ACTIONS(814),
    [sym_character_literal] = ACTIONS(812),
    [anon_sym_DQUOTE] = ACTIONS(814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(812),
    [sym_null_literal] = ACTIONS(814),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_final] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(812),
    [anon_sym_TILDE] = ACTIONS(812),
    [anon_sym_PLUS_PLUS] = ACTIONS(812),
    [anon_sym_DASH_DASH] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_class] = ACTIONS(814),
    [anon_sym_switch] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_case] = ACTIONS(814),
    [anon_sym_default] = ACTIONS(814),
    [anon_sym_SEMI] = ACTIONS(812),
    [anon_sym_assert] = ACTIONS(814),
    [anon_sym_do] = ACTIONS(814),
    [anon_sym_while] = ACTIONS(814),
    [anon_sym_break] = ACTIONS(814),
    [anon_sym_continue] = ACTIONS(814),
    [anon_sym_return] = ACTIONS(814),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_synchronized] = ACTIONS(814),
    [anon_sym_throw] = ACTIONS(814),
    [anon_sym_try] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(814),
    [anon_sym_else] = ACTIONS(814),
    [anon_sym_for] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_open] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(814),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_package] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(814),
    [anon_sym_enum] = ACTIONS(814),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(814),
    [anon_sym_strictfp] = ACTIONS(814),
    [anon_sym_native] = ACTIONS(814),
    [anon_sym_transient] = ACTIONS(814),
    [anon_sym_volatile] = ACTIONS(814),
    [anon_sym_sealed] = ACTIONS(814),
    [anon_sym_non_DASHsealed] = ACTIONS(812),
    [anon_sym_record] = ACTIONS(814),
    [anon_sym_ATinterface] = ACTIONS(812),
    [anon_sym_interface] = ACTIONS(814),
    [anon_sym_byte] = ACTIONS(814),
    [anon_sym_short] = ACTIONS(814),
    [anon_sym_int] = ACTIONS(814),
    [anon_sym_long] = ACTIONS(814),
    [anon_sym_char] = ACTIONS(814),
    [anon_sym_float] = ACTIONS(814),
    [anon_sym_double] = ACTIONS(814),
    [sym_boolean_type] = ACTIONS(814),
    [sym_void_type] = ACTIONS(814),
    [sym_this] = ACTIONS(814),
    [sym_super] = ACTIONS(814),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [290] = {
    [ts_builtin_sym_end] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_decimal_integer_literal] = ACTIONS(818),
    [sym_hex_integer_literal] = ACTIONS(818),
    [sym_octal_integer_literal] = ACTIONS(818),
    [sym_binary_integer_literal] = ACTIONS(816),
    [sym_decimal_floating_point_literal] = ACTIONS(816),
    [sym_hex_floating_point_literal] = ACTIONS(818),
    [sym_true] = ACTIONS(818),
    [sym_false] = ACTIONS(818),
    [sym_character_literal] = ACTIONS(816),
    [anon_sym_DQUOTE] = ACTIONS(818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(816),
    [sym_null_literal] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_final] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [anon_sym_PLUS_PLUS] = ACTIONS(816),
    [anon_sym_DASH_DASH] = ACTIONS(816),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_class] = ACTIONS(818),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_RBRACE] = ACTIONS(816),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_default] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_assert] = ACTIONS(818),
    [anon_sym_do] = ACTIONS(818),
    [anon_sym_while] = ACTIONS(818),
    [anon_sym_break] = ACTIONS(818),
    [anon_sym_continue] = ACTIONS(818),
    [anon_sym_return] = ACTIONS(818),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_synchronized] = ACTIONS(818),
    [anon_sym_throw] = ACTIONS(818),
    [anon_sym_try] = ACTIONS(818),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_for] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(818),
    [anon_sym_open] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_package] = ACTIONS(818),
    [anon_sym_import] = ACTIONS(818),
    [anon_sym_enum] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_abstract] = ACTIONS(818),
    [anon_sym_strictfp] = ACTIONS(818),
    [anon_sym_native] = ACTIONS(818),
    [anon_sym_transient] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym_sealed] = ACTIONS(818),
    [anon_sym_non_DASHsealed] = ACTIONS(816),
    [anon_sym_record] = ACTIONS(818),
    [anon_sym_ATinterface] = ACTIONS(816),
    [anon_sym_interface] = ACTIONS(818),
    [anon_sym_byte] = ACTIONS(818),
    [anon_sym_short] = ACTIONS(818),
    [anon_sym_int] = ACTIONS(818),
    [anon_sym_long] = ACTIONS(818),
    [anon_sym_char] = ACTIONS(818),
    [anon_sym_float] = ACTIONS(818),
    [anon_sym_double] = ACTIONS(818),
    [sym_boolean_type] = ACTIONS(818),
    [sym_void_type] = ACTIONS(818),
    [sym_this] = ACTIONS(818),
    [sym_super] = ACTIONS(818),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [291] = {
    [ts_builtin_sym_end] = ACTIONS(820),
    [sym_identifier] = ACTIONS(822),
    [sym_decimal_integer_literal] = ACTIONS(822),
    [sym_hex_integer_literal] = ACTIONS(822),
    [sym_octal_integer_literal] = ACTIONS(822),
    [sym_binary_integer_literal] = ACTIONS(820),
    [sym_decimal_floating_point_literal] = ACTIONS(820),
    [sym_hex_floating_point_literal] = ACTIONS(822),
    [sym_true] = ACTIONS(822),
    [sym_false] = ACTIONS(822),
    [sym_character_literal] = ACTIONS(820),
    [anon_sym_DQUOTE] = ACTIONS(822),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(820),
    [sym_null_literal] = ACTIONS(822),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_final] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_PLUS_PLUS] = ACTIONS(820),
    [anon_sym_DASH_DASH] = ACTIONS(820),
    [anon_sym_new] = ACTIONS(822),
    [anon_sym_class] = ACTIONS(822),
    [anon_sym_switch] = ACTIONS(822),
    [anon_sym_LBRACE] = ACTIONS(820),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_case] = ACTIONS(822),
    [anon_sym_default] = ACTIONS(822),
    [anon_sym_SEMI] = ACTIONS(820),
    [anon_sym_assert] = ACTIONS(822),
    [anon_sym_do] = ACTIONS(822),
    [anon_sym_while] = ACTIONS(822),
    [anon_sym_break] = ACTIONS(822),
    [anon_sym_continue] = ACTIONS(822),
    [anon_sym_return] = ACTIONS(822),
    [anon_sym_yield] = ACTIONS(822),
    [anon_sym_synchronized] = ACTIONS(822),
    [anon_sym_throw] = ACTIONS(822),
    [anon_sym_try] = ACTIONS(822),
    [anon_sym_if] = ACTIONS(822),
    [anon_sym_else] = ACTIONS(822),
    [anon_sym_for] = ACTIONS(822),
    [anon_sym_AT] = ACTIONS(822),
    [anon_sym_open] = ACTIONS(822),
    [anon_sym_module] = ACTIONS(822),
    [anon_sym_static] = ACTIONS(822),
    [anon_sym_package] = ACTIONS(822),
    [anon_sym_import] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(822),
    [anon_sym_public] = ACTIONS(822),
    [anon_sym_protected] = ACTIONS(822),
    [anon_sym_private] = ACTIONS(822),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_strictfp] = ACTIONS(822),
    [anon_sym_native] = ACTIONS(822),
    [anon_sym_transient] = ACTIONS(822),
    [anon_sym_volatile] = ACTIONS(822),
    [anon_sym_sealed] = ACTIONS(822),
    [anon_sym_non_DASHsealed] = ACTIONS(820),
    [anon_sym_record] = ACTIONS(822),
    [anon_sym_ATinterface] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_byte] = ACTIONS(822),
    [anon_sym_short] = ACTIONS(822),
    [anon_sym_int] = ACTIONS(822),
    [anon_sym_long] = ACTIONS(822),
    [anon_sym_char] = ACTIONS(822),
    [anon_sym_float] = ACTIONS(822),
    [anon_sym_double] = ACTIONS(822),
    [sym_boolean_type] = ACTIONS(822),
    [sym_void_type] = ACTIONS(822),
    [sym_this] = ACTIONS(822),
    [sym_super] = ACTIONS(822),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(824),
    [sym_identifier] = ACTIONS(826),
    [sym_decimal_integer_literal] = ACTIONS(826),
    [sym_hex_integer_literal] = ACTIONS(826),
    [sym_octal_integer_literal] = ACTIONS(826),
    [sym_binary_integer_literal] = ACTIONS(824),
    [sym_decimal_floating_point_literal] = ACTIONS(824),
    [sym_hex_floating_point_literal] = ACTIONS(826),
    [sym_true] = ACTIONS(826),
    [sym_false] = ACTIONS(826),
    [sym_character_literal] = ACTIONS(824),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(824),
    [sym_null_literal] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_PLUS] = ACTIONS(826),
    [anon_sym_DASH] = ACTIONS(826),
    [anon_sym_final] = ACTIONS(826),
    [anon_sym_BANG] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_PLUS_PLUS] = ACTIONS(824),
    [anon_sym_DASH_DASH] = ACTIONS(824),
    [anon_sym_new] = ACTIONS(826),
    [anon_sym_class] = ACTIONS(826),
    [anon_sym_switch] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_RBRACE] = ACTIONS(824),
    [anon_sym_case] = ACTIONS(826),
    [anon_sym_default] = ACTIONS(826),
    [anon_sym_SEMI] = ACTIONS(824),
    [anon_sym_assert] = ACTIONS(826),
    [anon_sym_do] = ACTIONS(826),
    [anon_sym_while] = ACTIONS(826),
    [anon_sym_break] = ACTIONS(826),
    [anon_sym_continue] = ACTIONS(826),
    [anon_sym_return] = ACTIONS(826),
    [anon_sym_yield] = ACTIONS(826),
    [anon_sym_synchronized] = ACTIONS(826),
    [anon_sym_throw] = ACTIONS(826),
    [anon_sym_try] = ACTIONS(826),
    [anon_sym_if] = ACTIONS(826),
    [anon_sym_else] = ACTIONS(826),
    [anon_sym_for] = ACTIONS(826),
    [anon_sym_AT] = ACTIONS(826),
    [anon_sym_open] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_package] = ACTIONS(826),
    [anon_sym_import] = ACTIONS(826),
    [anon_sym_enum] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_abstract] = ACTIONS(826),
    [anon_sym_strictfp] = ACTIONS(826),
    [anon_sym_native] = ACTIONS(826),
    [anon_sym_transient] = ACTIONS(826),
    [anon_sym_volatile] = ACTIONS(826),
    [anon_sym_sealed] = ACTIONS(826),
    [anon_sym_non_DASHsealed] = ACTIONS(824),
    [anon_sym_record] = ACTIONS(826),
    [anon_sym_ATinterface] = ACTIONS(824),
    [anon_sym_interface] = ACTIONS(826),
    [anon_sym_byte] = ACTIONS(826),
    [anon_sym_short] = ACTIONS(826),
    [anon_sym_int] = ACTIONS(826),
    [anon_sym_long] = ACTIONS(826),
    [anon_sym_char] = ACTIONS(826),
    [anon_sym_float] = ACTIONS(826),
    [anon_sym_double] = ACTIONS(826),
    [sym_boolean_type] = ACTIONS(826),
    [sym_void_type] = ACTIONS(826),
    [sym_this] = ACTIONS(826),
    [sym_super] = ACTIONS(826),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [293] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_primary_expression] = STATE(1073),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(912),
    [sym_array_access] = STATE(507),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_resource] = STATE(1127),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(721),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(742),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(758),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_RPAREN] = ACTIONS(828),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_new] = ACTIONS(764),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(766),
    [anon_sym_module] = ACTIONS(766),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(766),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(830),
    [sym_identifier] = ACTIONS(832),
    [sym_decimal_integer_literal] = ACTIONS(832),
    [sym_hex_integer_literal] = ACTIONS(832),
    [sym_octal_integer_literal] = ACTIONS(832),
    [sym_binary_integer_literal] = ACTIONS(830),
    [sym_decimal_floating_point_literal] = ACTIONS(830),
    [sym_hex_floating_point_literal] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_character_literal] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(830),
    [sym_null_literal] = ACTIONS(832),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_final] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(830),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_new] = ACTIONS(832),
    [anon_sym_class] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_case] = ACTIONS(832),
    [anon_sym_default] = ACTIONS(832),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_assert] = ACTIONS(832),
    [anon_sym_do] = ACTIONS(832),
    [anon_sym_while] = ACTIONS(832),
    [anon_sym_break] = ACTIONS(832),
    [anon_sym_continue] = ACTIONS(832),
    [anon_sym_return] = ACTIONS(832),
    [anon_sym_yield] = ACTIONS(832),
    [anon_sym_synchronized] = ACTIONS(832),
    [anon_sym_throw] = ACTIONS(832),
    [anon_sym_try] = ACTIONS(832),
    [anon_sym_if] = ACTIONS(832),
    [anon_sym_else] = ACTIONS(832),
    [anon_sym_for] = ACTIONS(832),
    [anon_sym_AT] = ACTIONS(832),
    [anon_sym_open] = ACTIONS(832),
    [anon_sym_module] = ACTIONS(832),
    [anon_sym_static] = ACTIONS(832),
    [anon_sym_package] = ACTIONS(832),
    [anon_sym_import] = ACTIONS(832),
    [anon_sym_enum] = ACTIONS(832),
    [anon_sym_public] = ACTIONS(832),
    [anon_sym_protected] = ACTIONS(832),
    [anon_sym_private] = ACTIONS(832),
    [anon_sym_abstract] = ACTIONS(832),
    [anon_sym_strictfp] = ACTIONS(832),
    [anon_sym_native] = ACTIONS(832),
    [anon_sym_transient] = ACTIONS(832),
    [anon_sym_volatile] = ACTIONS(832),
    [anon_sym_sealed] = ACTIONS(832),
    [anon_sym_non_DASHsealed] = ACTIONS(830),
    [anon_sym_record] = ACTIONS(832),
    [anon_sym_ATinterface] = ACTIONS(830),
    [anon_sym_interface] = ACTIONS(832),
    [anon_sym_byte] = ACTIONS(832),
    [anon_sym_short] = ACTIONS(832),
    [anon_sym_int] = ACTIONS(832),
    [anon_sym_long] = ACTIONS(832),
    [anon_sym_char] = ACTIONS(832),
    [anon_sym_float] = ACTIONS(832),
    [anon_sym_double] = ACTIONS(832),
    [sym_boolean_type] = ACTIONS(832),
    [sym_void_type] = ACTIONS(832),
    [sym_this] = ACTIONS(832),
    [sym_super] = ACTIONS(832),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(834),
    [sym_identifier] = ACTIONS(836),
    [sym_decimal_integer_literal] = ACTIONS(836),
    [sym_hex_integer_literal] = ACTIONS(836),
    [sym_octal_integer_literal] = ACTIONS(836),
    [sym_binary_integer_literal] = ACTIONS(834),
    [sym_decimal_floating_point_literal] = ACTIONS(834),
    [sym_hex_floating_point_literal] = ACTIONS(836),
    [sym_true] = ACTIONS(836),
    [sym_false] = ACTIONS(836),
    [sym_character_literal] = ACTIONS(834),
    [anon_sym_DQUOTE] = ACTIONS(836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(834),
    [sym_null_literal] = ACTIONS(836),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_PLUS] = ACTIONS(836),
    [anon_sym_DASH] = ACTIONS(836),
    [anon_sym_final] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(834),
    [anon_sym_TILDE] = ACTIONS(834),
    [anon_sym_PLUS_PLUS] = ACTIONS(834),
    [anon_sym_DASH_DASH] = ACTIONS(834),
    [anon_sym_new] = ACTIONS(836),
    [anon_sym_class] = ACTIONS(836),
    [anon_sym_switch] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_RBRACE] = ACTIONS(834),
    [anon_sym_case] = ACTIONS(836),
    [anon_sym_default] = ACTIONS(836),
    [anon_sym_SEMI] = ACTIONS(834),
    [anon_sym_assert] = ACTIONS(836),
    [anon_sym_do] = ACTIONS(836),
    [anon_sym_while] = ACTIONS(836),
    [anon_sym_break] = ACTIONS(836),
    [anon_sym_continue] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(836),
    [anon_sym_yield] = ACTIONS(836),
    [anon_sym_synchronized] = ACTIONS(836),
    [anon_sym_throw] = ACTIONS(836),
    [anon_sym_try] = ACTIONS(836),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_else] = ACTIONS(836),
    [anon_sym_for] = ACTIONS(836),
    [anon_sym_AT] = ACTIONS(836),
    [anon_sym_open] = ACTIONS(836),
    [anon_sym_module] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(836),
    [anon_sym_package] = ACTIONS(836),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_enum] = ACTIONS(836),
    [anon_sym_public] = ACTIONS(836),
    [anon_sym_protected] = ACTIONS(836),
    [anon_sym_private] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(836),
    [anon_sym_strictfp] = ACTIONS(836),
    [anon_sym_native] = ACTIONS(836),
    [anon_sym_transient] = ACTIONS(836),
    [anon_sym_volatile] = ACTIONS(836),
    [anon_sym_sealed] = ACTIONS(836),
    [anon_sym_non_DASHsealed] = ACTIONS(834),
    [anon_sym_record] = ACTIONS(836),
    [anon_sym_ATinterface] = ACTIONS(834),
    [anon_sym_interface] = ACTIONS(836),
    [anon_sym_byte] = ACTIONS(836),
    [anon_sym_short] = ACTIONS(836),
    [anon_sym_int] = ACTIONS(836),
    [anon_sym_long] = ACTIONS(836),
    [anon_sym_char] = ACTIONS(836),
    [anon_sym_float] = ACTIONS(836),
    [anon_sym_double] = ACTIONS(836),
    [sym_boolean_type] = ACTIONS(836),
    [sym_void_type] = ACTIONS(836),
    [sym_this] = ACTIONS(836),
    [sym_super] = ACTIONS(836),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(838),
    [sym_identifier] = ACTIONS(840),
    [sym_decimal_integer_literal] = ACTIONS(840),
    [sym_hex_integer_literal] = ACTIONS(840),
    [sym_octal_integer_literal] = ACTIONS(840),
    [sym_binary_integer_literal] = ACTIONS(838),
    [sym_decimal_floating_point_literal] = ACTIONS(838),
    [sym_hex_floating_point_literal] = ACTIONS(840),
    [sym_true] = ACTIONS(840),
    [sym_false] = ACTIONS(840),
    [sym_character_literal] = ACTIONS(838),
    [anon_sym_DQUOTE] = ACTIONS(840),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(838),
    [sym_null_literal] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_final] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_new] = ACTIONS(840),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_switch] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_default] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_assert] = ACTIONS(840),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_while] = ACTIONS(840),
    [anon_sym_break] = ACTIONS(840),
    [anon_sym_continue] = ACTIONS(840),
    [anon_sym_return] = ACTIONS(840),
    [anon_sym_yield] = ACTIONS(840),
    [anon_sym_synchronized] = ACTIONS(840),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_try] = ACTIONS(840),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_for] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(840),
    [anon_sym_open] = ACTIONS(840),
    [anon_sym_module] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(840),
    [anon_sym_package] = ACTIONS(840),
    [anon_sym_import] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(840),
    [anon_sym_public] = ACTIONS(840),
    [anon_sym_protected] = ACTIONS(840),
    [anon_sym_private] = ACTIONS(840),
    [anon_sym_abstract] = ACTIONS(840),
    [anon_sym_strictfp] = ACTIONS(840),
    [anon_sym_native] = ACTIONS(840),
    [anon_sym_transient] = ACTIONS(840),
    [anon_sym_volatile] = ACTIONS(840),
    [anon_sym_sealed] = ACTIONS(840),
    [anon_sym_non_DASHsealed] = ACTIONS(838),
    [anon_sym_record] = ACTIONS(840),
    [anon_sym_ATinterface] = ACTIONS(838),
    [anon_sym_interface] = ACTIONS(840),
    [anon_sym_byte] = ACTIONS(840),
    [anon_sym_short] = ACTIONS(840),
    [anon_sym_int] = ACTIONS(840),
    [anon_sym_long] = ACTIONS(840),
    [anon_sym_char] = ACTIONS(840),
    [anon_sym_float] = ACTIONS(840),
    [anon_sym_double] = ACTIONS(840),
    [sym_boolean_type] = ACTIONS(840),
    [sym_void_type] = ACTIONS(840),
    [sym_this] = ACTIONS(840),
    [sym_super] = ACTIONS(840),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(842),
    [sym_identifier] = ACTIONS(844),
    [sym_decimal_integer_literal] = ACTIONS(844),
    [sym_hex_integer_literal] = ACTIONS(844),
    [sym_octal_integer_literal] = ACTIONS(844),
    [sym_binary_integer_literal] = ACTIONS(842),
    [sym_decimal_floating_point_literal] = ACTIONS(842),
    [sym_hex_floating_point_literal] = ACTIONS(844),
    [sym_true] = ACTIONS(844),
    [sym_false] = ACTIONS(844),
    [sym_character_literal] = ACTIONS(842),
    [anon_sym_DQUOTE] = ACTIONS(844),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(842),
    [sym_null_literal] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(842),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_final] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(842),
    [anon_sym_TILDE] = ACTIONS(842),
    [anon_sym_PLUS_PLUS] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(842),
    [anon_sym_new] = ACTIONS(844),
    [anon_sym_class] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(842),
    [anon_sym_RBRACE] = ACTIONS(842),
    [anon_sym_case] = ACTIONS(844),
    [anon_sym_default] = ACTIONS(844),
    [anon_sym_SEMI] = ACTIONS(842),
    [anon_sym_assert] = ACTIONS(844),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_while] = ACTIONS(844),
    [anon_sym_break] = ACTIONS(844),
    [anon_sym_continue] = ACTIONS(844),
    [anon_sym_return] = ACTIONS(844),
    [anon_sym_yield] = ACTIONS(844),
    [anon_sym_synchronized] = ACTIONS(844),
    [anon_sym_throw] = ACTIONS(844),
    [anon_sym_try] = ACTIONS(844),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_else] = ACTIONS(844),
    [anon_sym_for] = ACTIONS(844),
    [anon_sym_AT] = ACTIONS(844),
    [anon_sym_open] = ACTIONS(844),
    [anon_sym_module] = ACTIONS(844),
    [anon_sym_static] = ACTIONS(844),
    [anon_sym_package] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(844),
    [anon_sym_enum] = ACTIONS(844),
    [anon_sym_public] = ACTIONS(844),
    [anon_sym_protected] = ACTIONS(844),
    [anon_sym_private] = ACTIONS(844),
    [anon_sym_abstract] = ACTIONS(844),
    [anon_sym_strictfp] = ACTIONS(844),
    [anon_sym_native] = ACTIONS(844),
    [anon_sym_transient] = ACTIONS(844),
    [anon_sym_volatile] = ACTIONS(844),
    [anon_sym_sealed] = ACTIONS(844),
    [anon_sym_non_DASHsealed] = ACTIONS(842),
    [anon_sym_record] = ACTIONS(844),
    [anon_sym_ATinterface] = ACTIONS(842),
    [anon_sym_interface] = ACTIONS(844),
    [anon_sym_byte] = ACTIONS(844),
    [anon_sym_short] = ACTIONS(844),
    [anon_sym_int] = ACTIONS(844),
    [anon_sym_long] = ACTIONS(844),
    [anon_sym_char] = ACTIONS(844),
    [anon_sym_float] = ACTIONS(844),
    [anon_sym_double] = ACTIONS(844),
    [sym_boolean_type] = ACTIONS(844),
    [sym_void_type] = ACTIONS(844),
    [sym_this] = ACTIONS(844),
    [sym_super] = ACTIONS(844),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(846),
    [sym_identifier] = ACTIONS(848),
    [sym_decimal_integer_literal] = ACTIONS(848),
    [sym_hex_integer_literal] = ACTIONS(848),
    [sym_octal_integer_literal] = ACTIONS(848),
    [sym_binary_integer_literal] = ACTIONS(846),
    [sym_decimal_floating_point_literal] = ACTIONS(846),
    [sym_hex_floating_point_literal] = ACTIONS(848),
    [sym_true] = ACTIONS(848),
    [sym_false] = ACTIONS(848),
    [sym_character_literal] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(846),
    [sym_null_literal] = ACTIONS(848),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_final] = ACTIONS(848),
    [anon_sym_BANG] = ACTIONS(846),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_new] = ACTIONS(848),
    [anon_sym_class] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_case] = ACTIONS(848),
    [anon_sym_default] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_assert] = ACTIONS(848),
    [anon_sym_do] = ACTIONS(848),
    [anon_sym_while] = ACTIONS(848),
    [anon_sym_break] = ACTIONS(848),
    [anon_sym_continue] = ACTIONS(848),
    [anon_sym_return] = ACTIONS(848),
    [anon_sym_yield] = ACTIONS(848),
    [anon_sym_synchronized] = ACTIONS(848),
    [anon_sym_throw] = ACTIONS(848),
    [anon_sym_try] = ACTIONS(848),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_else] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(848),
    [anon_sym_AT] = ACTIONS(848),
    [anon_sym_open] = ACTIONS(848),
    [anon_sym_module] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(848),
    [anon_sym_package] = ACTIONS(848),
    [anon_sym_import] = ACTIONS(848),
    [anon_sym_enum] = ACTIONS(848),
    [anon_sym_public] = ACTIONS(848),
    [anon_sym_protected] = ACTIONS(848),
    [anon_sym_private] = ACTIONS(848),
    [anon_sym_abstract] = ACTIONS(848),
    [anon_sym_strictfp] = ACTIONS(848),
    [anon_sym_native] = ACTIONS(848),
    [anon_sym_transient] = ACTIONS(848),
    [anon_sym_volatile] = ACTIONS(848),
    [anon_sym_sealed] = ACTIONS(848),
    [anon_sym_non_DASHsealed] = ACTIONS(846),
    [anon_sym_record] = ACTIONS(848),
    [anon_sym_ATinterface] = ACTIONS(846),
    [anon_sym_interface] = ACTIONS(848),
    [anon_sym_byte] = ACTIONS(848),
    [anon_sym_short] = ACTIONS(848),
    [anon_sym_int] = ACTIONS(848),
    [anon_sym_long] = ACTIONS(848),
    [anon_sym_char] = ACTIONS(848),
    [anon_sym_float] = ACTIONS(848),
    [anon_sym_double] = ACTIONS(848),
    [sym_boolean_type] = ACTIONS(848),
    [sym_void_type] = ACTIONS(848),
    [sym_this] = ACTIONS(848),
    [sym_super] = ACTIONS(848),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(355),
    [sym_identifier] = ACTIONS(357),
    [sym_decimal_integer_literal] = ACTIONS(357),
    [sym_hex_integer_literal] = ACTIONS(357),
    [sym_octal_integer_literal] = ACTIONS(357),
    [sym_binary_integer_literal] = ACTIONS(355),
    [sym_decimal_floating_point_literal] = ACTIONS(355),
    [sym_hex_floating_point_literal] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_character_literal] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(355),
    [sym_null_literal] = ACTIONS(357),
    [anon_sym_LPAREN] = ACTIONS(355),
    [anon_sym_PLUS] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(357),
    [anon_sym_final] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(355),
    [anon_sym_DASH_DASH] = ACTIONS(355),
    [anon_sym_new] = ACTIONS(357),
    [anon_sym_class] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_RBRACE] = ACTIONS(355),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_assert] = ACTIONS(357),
    [anon_sym_do] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_break] = ACTIONS(357),
    [anon_sym_continue] = ACTIONS(357),
    [anon_sym_return] = ACTIONS(357),
    [anon_sym_yield] = ACTIONS(357),
    [anon_sym_synchronized] = ACTIONS(357),
    [anon_sym_throw] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(357),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_else] = ACTIONS(357),
    [anon_sym_for] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(357),
    [anon_sym_open] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(357),
    [anon_sym_package] = ACTIONS(357),
    [anon_sym_import] = ACTIONS(357),
    [anon_sym_enum] = ACTIONS(357),
    [anon_sym_public] = ACTIONS(357),
    [anon_sym_protected] = ACTIONS(357),
    [anon_sym_private] = ACTIONS(357),
    [anon_sym_abstract] = ACTIONS(357),
    [anon_sym_strictfp] = ACTIONS(357),
    [anon_sym_native] = ACTIONS(357),
    [anon_sym_transient] = ACTIONS(357),
    [anon_sym_volatile] = ACTIONS(357),
    [anon_sym_sealed] = ACTIONS(357),
    [anon_sym_non_DASHsealed] = ACTIONS(355),
    [anon_sym_record] = ACTIONS(357),
    [anon_sym_ATinterface] = ACTIONS(355),
    [anon_sym_interface] = ACTIONS(357),
    [anon_sym_byte] = ACTIONS(357),
    [anon_sym_short] = ACTIONS(357),
    [anon_sym_int] = ACTIONS(357),
    [anon_sym_long] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_float] = ACTIONS(357),
    [anon_sym_double] = ACTIONS(357),
    [sym_boolean_type] = ACTIONS(357),
    [sym_void_type] = ACTIONS(357),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(357),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(850),
    [sym_identifier] = ACTIONS(852),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(852),
    [sym_octal_integer_literal] = ACTIONS(852),
    [sym_binary_integer_literal] = ACTIONS(850),
    [sym_decimal_floating_point_literal] = ACTIONS(850),
    [sym_hex_floating_point_literal] = ACTIONS(852),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_character_literal] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(850),
    [sym_null_literal] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_final] = ACTIONS(852),
    [anon_sym_BANG] = ACTIONS(850),
    [anon_sym_TILDE] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_new] = ACTIONS(852),
    [anon_sym_class] = ACTIONS(852),
    [anon_sym_switch] = ACTIONS(852),
    [anon_sym_LBRACE] = ACTIONS(850),
    [anon_sym_RBRACE] = ACTIONS(850),
    [anon_sym_case] = ACTIONS(852),
    [anon_sym_default] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(850),
    [anon_sym_assert] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(852),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_break] = ACTIONS(852),
    [anon_sym_continue] = ACTIONS(852),
    [anon_sym_return] = ACTIONS(852),
    [anon_sym_yield] = ACTIONS(852),
    [anon_sym_synchronized] = ACTIONS(852),
    [anon_sym_throw] = ACTIONS(852),
    [anon_sym_try] = ACTIONS(852),
    [anon_sym_if] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(852),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(852),
    [anon_sym_open] = ACTIONS(852),
    [anon_sym_module] = ACTIONS(852),
    [anon_sym_static] = ACTIONS(852),
    [anon_sym_package] = ACTIONS(852),
    [anon_sym_import] = ACTIONS(852),
    [anon_sym_enum] = ACTIONS(852),
    [anon_sym_public] = ACTIONS(852),
    [anon_sym_protected] = ACTIONS(852),
    [anon_sym_private] = ACTIONS(852),
    [anon_sym_abstract] = ACTIONS(852),
    [anon_sym_strictfp] = ACTIONS(852),
    [anon_sym_native] = ACTIONS(852),
    [anon_sym_transient] = ACTIONS(852),
    [anon_sym_volatile] = ACTIONS(852),
    [anon_sym_sealed] = ACTIONS(852),
    [anon_sym_non_DASHsealed] = ACTIONS(850),
    [anon_sym_record] = ACTIONS(852),
    [anon_sym_ATinterface] = ACTIONS(850),
    [anon_sym_interface] = ACTIONS(852),
    [anon_sym_byte] = ACTIONS(852),
    [anon_sym_short] = ACTIONS(852),
    [anon_sym_int] = ACTIONS(852),
    [anon_sym_long] = ACTIONS(852),
    [anon_sym_char] = ACTIONS(852),
    [anon_sym_float] = ACTIONS(852),
    [anon_sym_double] = ACTIONS(852),
    [sym_boolean_type] = ACTIONS(852),
    [sym_void_type] = ACTIONS(852),
    [sym_this] = ACTIONS(852),
    [sym_super] = ACTIONS(852),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [301] = {
    [ts_builtin_sym_end] = ACTIONS(854),
    [sym_identifier] = ACTIONS(856),
    [sym_decimal_integer_literal] = ACTIONS(856),
    [sym_hex_integer_literal] = ACTIONS(856),
    [sym_octal_integer_literal] = ACTIONS(856),
    [sym_binary_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(854),
    [sym_hex_floating_point_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(856),
    [sym_false] = ACTIONS(856),
    [sym_character_literal] = ACTIONS(854),
    [anon_sym_DQUOTE] = ACTIONS(856),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(854),
    [sym_null_literal] = ACTIONS(856),
    [anon_sym_LPAREN] = ACTIONS(854),
    [anon_sym_PLUS] = ACTIONS(856),
    [anon_sym_DASH] = ACTIONS(856),
    [anon_sym_final] = ACTIONS(856),
    [anon_sym_BANG] = ACTIONS(854),
    [anon_sym_TILDE] = ACTIONS(854),
    [anon_sym_PLUS_PLUS] = ACTIONS(854),
    [anon_sym_DASH_DASH] = ACTIONS(854),
    [anon_sym_new] = ACTIONS(856),
    [anon_sym_class] = ACTIONS(856),
    [anon_sym_switch] = ACTIONS(856),
    [anon_sym_LBRACE] = ACTIONS(854),
    [anon_sym_RBRACE] = ACTIONS(854),
    [anon_sym_case] = ACTIONS(856),
    [anon_sym_default] = ACTIONS(856),
    [anon_sym_SEMI] = ACTIONS(854),
    [anon_sym_assert] = ACTIONS(856),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_while] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(856),
    [anon_sym_continue] = ACTIONS(856),
    [anon_sym_return] = ACTIONS(856),
    [anon_sym_yield] = ACTIONS(856),
    [anon_sym_synchronized] = ACTIONS(856),
    [anon_sym_throw] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_else] = ACTIONS(858),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_AT] = ACTIONS(856),
    [anon_sym_open] = ACTIONS(856),
    [anon_sym_module] = ACTIONS(856),
    [anon_sym_static] = ACTIONS(856),
    [anon_sym_package] = ACTIONS(856),
    [anon_sym_import] = ACTIONS(856),
    [anon_sym_enum] = ACTIONS(856),
    [anon_sym_public] = ACTIONS(856),
    [anon_sym_protected] = ACTIONS(856),
    [anon_sym_private] = ACTIONS(856),
    [anon_sym_abstract] = ACTIONS(856),
    [anon_sym_strictfp] = ACTIONS(856),
    [anon_sym_native] = ACTIONS(856),
    [anon_sym_transient] = ACTIONS(856),
    [anon_sym_volatile] = ACTIONS(856),
    [anon_sym_sealed] = ACTIONS(856),
    [anon_sym_non_DASHsealed] = ACTIONS(854),
    [anon_sym_record] = ACTIONS(856),
    [anon_sym_ATinterface] = ACTIONS(854),
    [anon_sym_interface] = ACTIONS(856),
    [anon_sym_byte] = ACTIONS(856),
    [anon_sym_short] = ACTIONS(856),
    [anon_sym_int] = ACTIONS(856),
    [anon_sym_long] = ACTIONS(856),
    [anon_sym_char] = ACTIONS(856),
    [anon_sym_float] = ACTIONS(856),
    [anon_sym_double] = ACTIONS(856),
    [sym_boolean_type] = ACTIONS(856),
    [sym_void_type] = ACTIONS(856),
    [sym_this] = ACTIONS(856),
    [sym_super] = ACTIONS(856),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(860),
    [sym_identifier] = ACTIONS(862),
    [sym_decimal_integer_literal] = ACTIONS(862),
    [sym_hex_integer_literal] = ACTIONS(862),
    [sym_octal_integer_literal] = ACTIONS(862),
    [sym_binary_integer_literal] = ACTIONS(860),
    [sym_decimal_floating_point_literal] = ACTIONS(860),
    [sym_hex_floating_point_literal] = ACTIONS(862),
    [sym_true] = ACTIONS(862),
    [sym_false] = ACTIONS(862),
    [sym_character_literal] = ACTIONS(860),
    [anon_sym_DQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(860),
    [sym_null_literal] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(862),
    [anon_sym_DASH] = ACTIONS(862),
    [anon_sym_final] = ACTIONS(862),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_TILDE] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(860),
    [anon_sym_DASH_DASH] = ACTIONS(860),
    [anon_sym_new] = ACTIONS(862),
    [anon_sym_class] = ACTIONS(862),
    [anon_sym_switch] = ACTIONS(862),
    [anon_sym_LBRACE] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(860),
    [anon_sym_case] = ACTIONS(862),
    [anon_sym_default] = ACTIONS(862),
    [anon_sym_SEMI] = ACTIONS(860),
    [anon_sym_assert] = ACTIONS(862),
    [anon_sym_do] = ACTIONS(862),
    [anon_sym_while] = ACTIONS(862),
    [anon_sym_break] = ACTIONS(862),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(862),
    [anon_sym_yield] = ACTIONS(862),
    [anon_sym_synchronized] = ACTIONS(862),
    [anon_sym_throw] = ACTIONS(862),
    [anon_sym_try] = ACTIONS(862),
    [anon_sym_if] = ACTIONS(862),
    [anon_sym_else] = ACTIONS(862),
    [anon_sym_for] = ACTIONS(862),
    [anon_sym_AT] = ACTIONS(862),
    [anon_sym_open] = ACTIONS(862),
    [anon_sym_module] = ACTIONS(862),
    [anon_sym_static] = ACTIONS(862),
    [anon_sym_package] = ACTIONS(862),
    [anon_sym_import] = ACTIONS(862),
    [anon_sym_enum] = ACTIONS(862),
    [anon_sym_public] = ACTIONS(862),
    [anon_sym_protected] = ACTIONS(862),
    [anon_sym_private] = ACTIONS(862),
    [anon_sym_abstract] = ACTIONS(862),
    [anon_sym_strictfp] = ACTIONS(862),
    [anon_sym_native] = ACTIONS(862),
    [anon_sym_transient] = ACTIONS(862),
    [anon_sym_volatile] = ACTIONS(862),
    [anon_sym_sealed] = ACTIONS(862),
    [anon_sym_non_DASHsealed] = ACTIONS(860),
    [anon_sym_record] = ACTIONS(862),
    [anon_sym_ATinterface] = ACTIONS(860),
    [anon_sym_interface] = ACTIONS(862),
    [anon_sym_byte] = ACTIONS(862),
    [anon_sym_short] = ACTIONS(862),
    [anon_sym_int] = ACTIONS(862),
    [anon_sym_long] = ACTIONS(862),
    [anon_sym_char] = ACTIONS(862),
    [anon_sym_float] = ACTIONS(862),
    [anon_sym_double] = ACTIONS(862),
    [sym_boolean_type] = ACTIONS(862),
    [sym_void_type] = ACTIONS(862),
    [sym_this] = ACTIONS(862),
    [sym_super] = ACTIONS(862),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(361),
    [sym_identifier] = ACTIONS(363),
    [sym_decimal_integer_literal] = ACTIONS(363),
    [sym_hex_integer_literal] = ACTIONS(363),
    [sym_octal_integer_literal] = ACTIONS(363),
    [sym_binary_integer_literal] = ACTIONS(361),
    [sym_decimal_floating_point_literal] = ACTIONS(361),
    [sym_hex_floating_point_literal] = ACTIONS(363),
    [sym_true] = ACTIONS(363),
    [sym_false] = ACTIONS(363),
    [sym_character_literal] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(361),
    [sym_null_literal] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_final] = ACTIONS(363),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(361),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_new] = ACTIONS(363),
    [anon_sym_class] = ACTIONS(363),
    [anon_sym_switch] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(363),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_assert] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(363),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_break] = ACTIONS(363),
    [anon_sym_continue] = ACTIONS(363),
    [anon_sym_return] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(363),
    [anon_sym_synchronized] = ACTIONS(363),
    [anon_sym_throw] = ACTIONS(363),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_else] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_open] = ACTIONS(363),
    [anon_sym_module] = ACTIONS(363),
    [anon_sym_static] = ACTIONS(363),
    [anon_sym_package] = ACTIONS(363),
    [anon_sym_import] = ACTIONS(363),
    [anon_sym_enum] = ACTIONS(363),
    [anon_sym_public] = ACTIONS(363),
    [anon_sym_protected] = ACTIONS(363),
    [anon_sym_private] = ACTIONS(363),
    [anon_sym_abstract] = ACTIONS(363),
    [anon_sym_strictfp] = ACTIONS(363),
    [anon_sym_native] = ACTIONS(363),
    [anon_sym_transient] = ACTIONS(363),
    [anon_sym_volatile] = ACTIONS(363),
    [anon_sym_sealed] = ACTIONS(363),
    [anon_sym_non_DASHsealed] = ACTIONS(361),
    [anon_sym_record] = ACTIONS(363),
    [anon_sym_ATinterface] = ACTIONS(361),
    [anon_sym_interface] = ACTIONS(363),
    [anon_sym_byte] = ACTIONS(363),
    [anon_sym_short] = ACTIONS(363),
    [anon_sym_int] = ACTIONS(363),
    [anon_sym_long] = ACTIONS(363),
    [anon_sym_char] = ACTIONS(363),
    [anon_sym_float] = ACTIONS(363),
    [anon_sym_double] = ACTIONS(363),
    [sym_boolean_type] = ACTIONS(363),
    [sym_void_type] = ACTIONS(363),
    [sym_this] = ACTIONS(363),
    [sym_super] = ACTIONS(363),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(864),
    [sym_identifier] = ACTIONS(866),
    [sym_decimal_integer_literal] = ACTIONS(866),
    [sym_hex_integer_literal] = ACTIONS(866),
    [sym_octal_integer_literal] = ACTIONS(866),
    [sym_binary_integer_literal] = ACTIONS(864),
    [sym_decimal_floating_point_literal] = ACTIONS(864),
    [sym_hex_floating_point_literal] = ACTIONS(866),
    [sym_true] = ACTIONS(866),
    [sym_false] = ACTIONS(866),
    [sym_character_literal] = ACTIONS(864),
    [anon_sym_DQUOTE] = ACTIONS(866),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [sym_null_literal] = ACTIONS(866),
    [anon_sym_LPAREN] = ACTIONS(864),
    [anon_sym_PLUS] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(866),
    [anon_sym_final] = ACTIONS(866),
    [anon_sym_BANG] = ACTIONS(864),
    [anon_sym_TILDE] = ACTIONS(864),
    [anon_sym_PLUS_PLUS] = ACTIONS(864),
    [anon_sym_DASH_DASH] = ACTIONS(864),
    [anon_sym_new] = ACTIONS(866),
    [anon_sym_class] = ACTIONS(866),
    [anon_sym_switch] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_RBRACE] = ACTIONS(864),
    [anon_sym_case] = ACTIONS(866),
    [anon_sym_default] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(864),
    [anon_sym_assert] = ACTIONS(866),
    [anon_sym_do] = ACTIONS(866),
    [anon_sym_while] = ACTIONS(866),
    [anon_sym_break] = ACTIONS(866),
    [anon_sym_continue] = ACTIONS(866),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_yield] = ACTIONS(866),
    [anon_sym_synchronized] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_try] = ACTIONS(866),
    [anon_sym_if] = ACTIONS(866),
    [anon_sym_else] = ACTIONS(866),
    [anon_sym_for] = ACTIONS(866),
    [anon_sym_AT] = ACTIONS(866),
    [anon_sym_open] = ACTIONS(866),
    [anon_sym_module] = ACTIONS(866),
    [anon_sym_static] = ACTIONS(866),
    [anon_sym_package] = ACTIONS(866),
    [anon_sym_import] = ACTIONS(866),
    [anon_sym_enum] = ACTIONS(866),
    [anon_sym_public] = ACTIONS(866),
    [anon_sym_protected] = ACTIONS(866),
    [anon_sym_private] = ACTIONS(866),
    [anon_sym_abstract] = ACTIONS(866),
    [anon_sym_strictfp] = ACTIONS(866),
    [anon_sym_native] = ACTIONS(866),
    [anon_sym_transient] = ACTIONS(866),
    [anon_sym_volatile] = ACTIONS(866),
    [anon_sym_sealed] = ACTIONS(866),
    [anon_sym_non_DASHsealed] = ACTIONS(864),
    [anon_sym_record] = ACTIONS(866),
    [anon_sym_ATinterface] = ACTIONS(864),
    [anon_sym_interface] = ACTIONS(866),
    [anon_sym_byte] = ACTIONS(866),
    [anon_sym_short] = ACTIONS(866),
    [anon_sym_int] = ACTIONS(866),
    [anon_sym_long] = ACTIONS(866),
    [anon_sym_char] = ACTIONS(866),
    [anon_sym_float] = ACTIONS(866),
    [anon_sym_double] = ACTIONS(866),
    [sym_boolean_type] = ACTIONS(866),
    [sym_void_type] = ACTIONS(866),
    [sym_this] = ACTIONS(866),
    [sym_super] = ACTIONS(866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(868),
    [sym_identifier] = ACTIONS(870),
    [sym_decimal_integer_literal] = ACTIONS(870),
    [sym_hex_integer_literal] = ACTIONS(870),
    [sym_octal_integer_literal] = ACTIONS(870),
    [sym_binary_integer_literal] = ACTIONS(868),
    [sym_decimal_floating_point_literal] = ACTIONS(868),
    [sym_hex_floating_point_literal] = ACTIONS(870),
    [sym_true] = ACTIONS(870),
    [sym_false] = ACTIONS(870),
    [sym_character_literal] = ACTIONS(868),
    [anon_sym_DQUOTE] = ACTIONS(870),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(868),
    [sym_null_literal] = ACTIONS(870),
    [anon_sym_LPAREN] = ACTIONS(868),
    [anon_sym_PLUS] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(870),
    [anon_sym_final] = ACTIONS(870),
    [anon_sym_BANG] = ACTIONS(868),
    [anon_sym_TILDE] = ACTIONS(868),
    [anon_sym_PLUS_PLUS] = ACTIONS(868),
    [anon_sym_DASH_DASH] = ACTIONS(868),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_switch] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(868),
    [anon_sym_RBRACE] = ACTIONS(868),
    [anon_sym_case] = ACTIONS(870),
    [anon_sym_default] = ACTIONS(870),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_assert] = ACTIONS(870),
    [anon_sym_do] = ACTIONS(870),
    [anon_sym_while] = ACTIONS(870),
    [anon_sym_break] = ACTIONS(870),
    [anon_sym_continue] = ACTIONS(870),
    [anon_sym_return] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(870),
    [anon_sym_synchronized] = ACTIONS(870),
    [anon_sym_throw] = ACTIONS(870),
    [anon_sym_try] = ACTIONS(870),
    [anon_sym_if] = ACTIONS(870),
    [anon_sym_else] = ACTIONS(870),
    [anon_sym_for] = ACTIONS(870),
    [anon_sym_AT] = ACTIONS(870),
    [anon_sym_open] = ACTIONS(870),
    [anon_sym_module] = ACTIONS(870),
    [anon_sym_static] = ACTIONS(870),
    [anon_sym_package] = ACTIONS(870),
    [anon_sym_import] = ACTIONS(870),
    [anon_sym_enum] = ACTIONS(870),
    [anon_sym_public] = ACTIONS(870),
    [anon_sym_protected] = ACTIONS(870),
    [anon_sym_private] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_strictfp] = ACTIONS(870),
    [anon_sym_native] = ACTIONS(870),
    [anon_sym_transient] = ACTIONS(870),
    [anon_sym_volatile] = ACTIONS(870),
    [anon_sym_sealed] = ACTIONS(870),
    [anon_sym_non_DASHsealed] = ACTIONS(868),
    [anon_sym_record] = ACTIONS(870),
    [anon_sym_ATinterface] = ACTIONS(868),
    [anon_sym_interface] = ACTIONS(870),
    [anon_sym_byte] = ACTIONS(870),
    [anon_sym_short] = ACTIONS(870),
    [anon_sym_int] = ACTIONS(870),
    [anon_sym_long] = ACTIONS(870),
    [anon_sym_char] = ACTIONS(870),
    [anon_sym_float] = ACTIONS(870),
    [anon_sym_double] = ACTIONS(870),
    [sym_boolean_type] = ACTIONS(870),
    [sym_void_type] = ACTIONS(870),
    [sym_this] = ACTIONS(870),
    [sym_super] = ACTIONS(870),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(872),
    [sym_identifier] = ACTIONS(874),
    [sym_decimal_integer_literal] = ACTIONS(874),
    [sym_hex_integer_literal] = ACTIONS(874),
    [sym_octal_integer_literal] = ACTIONS(874),
    [sym_binary_integer_literal] = ACTIONS(872),
    [sym_decimal_floating_point_literal] = ACTIONS(872),
    [sym_hex_floating_point_literal] = ACTIONS(874),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_character_literal] = ACTIONS(872),
    [anon_sym_DQUOTE] = ACTIONS(874),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [sym_null_literal] = ACTIONS(874),
    [anon_sym_LPAREN] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(874),
    [anon_sym_final] = ACTIONS(874),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_PLUS_PLUS] = ACTIONS(872),
    [anon_sym_DASH_DASH] = ACTIONS(872),
    [anon_sym_new] = ACTIONS(874),
    [anon_sym_class] = ACTIONS(874),
    [anon_sym_switch] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_RBRACE] = ACTIONS(872),
    [anon_sym_case] = ACTIONS(874),
    [anon_sym_default] = ACTIONS(874),
    [anon_sym_SEMI] = ACTIONS(872),
    [anon_sym_assert] = ACTIONS(874),
    [anon_sym_do] = ACTIONS(874),
    [anon_sym_while] = ACTIONS(874),
    [anon_sym_break] = ACTIONS(874),
    [anon_sym_continue] = ACTIONS(874),
    [anon_sym_return] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(874),
    [anon_sym_synchronized] = ACTIONS(874),
    [anon_sym_throw] = ACTIONS(874),
    [anon_sym_try] = ACTIONS(874),
    [anon_sym_if] = ACTIONS(874),
    [anon_sym_else] = ACTIONS(874),
    [anon_sym_for] = ACTIONS(874),
    [anon_sym_AT] = ACTIONS(874),
    [anon_sym_open] = ACTIONS(874),
    [anon_sym_module] = ACTIONS(874),
    [anon_sym_static] = ACTIONS(874),
    [anon_sym_package] = ACTIONS(874),
    [anon_sym_import] = ACTIONS(874),
    [anon_sym_enum] = ACTIONS(874),
    [anon_sym_public] = ACTIONS(874),
    [anon_sym_protected] = ACTIONS(874),
    [anon_sym_private] = ACTIONS(874),
    [anon_sym_abstract] = ACTIONS(874),
    [anon_sym_strictfp] = ACTIONS(874),
    [anon_sym_native] = ACTIONS(874),
    [anon_sym_transient] = ACTIONS(874),
    [anon_sym_volatile] = ACTIONS(874),
    [anon_sym_sealed] = ACTIONS(874),
    [anon_sym_non_DASHsealed] = ACTIONS(872),
    [anon_sym_record] = ACTIONS(874),
    [anon_sym_ATinterface] = ACTIONS(872),
    [anon_sym_interface] = ACTIONS(874),
    [anon_sym_byte] = ACTIONS(874),
    [anon_sym_short] = ACTIONS(874),
    [anon_sym_int] = ACTIONS(874),
    [anon_sym_long] = ACTIONS(874),
    [anon_sym_char] = ACTIONS(874),
    [anon_sym_float] = ACTIONS(874),
    [anon_sym_double] = ACTIONS(874),
    [sym_boolean_type] = ACTIONS(874),
    [sym_void_type] = ACTIONS(874),
    [sym_this] = ACTIONS(874),
    [sym_super] = ACTIONS(874),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(876),
    [sym_identifier] = ACTIONS(878),
    [sym_decimal_integer_literal] = ACTIONS(878),
    [sym_hex_integer_literal] = ACTIONS(878),
    [sym_octal_integer_literal] = ACTIONS(878),
    [sym_binary_integer_literal] = ACTIONS(876),
    [sym_decimal_floating_point_literal] = ACTIONS(876),
    [sym_hex_floating_point_literal] = ACTIONS(878),
    [sym_true] = ACTIONS(878),
    [sym_false] = ACTIONS(878),
    [sym_character_literal] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(878),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(876),
    [sym_null_literal] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(876),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_final] = ACTIONS(878),
    [anon_sym_BANG] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_PLUS_PLUS] = ACTIONS(876),
    [anon_sym_DASH_DASH] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_class] = ACTIONS(878),
    [anon_sym_switch] = ACTIONS(878),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(876),
    [anon_sym_case] = ACTIONS(878),
    [anon_sym_default] = ACTIONS(878),
    [anon_sym_SEMI] = ACTIONS(876),
    [anon_sym_assert] = ACTIONS(878),
    [anon_sym_do] = ACTIONS(878),
    [anon_sym_while] = ACTIONS(878),
    [anon_sym_break] = ACTIONS(878),
    [anon_sym_continue] = ACTIONS(878),
    [anon_sym_return] = ACTIONS(878),
    [anon_sym_yield] = ACTIONS(878),
    [anon_sym_synchronized] = ACTIONS(878),
    [anon_sym_throw] = ACTIONS(878),
    [anon_sym_try] = ACTIONS(878),
    [anon_sym_if] = ACTIONS(878),
    [anon_sym_else] = ACTIONS(878),
    [anon_sym_for] = ACTIONS(878),
    [anon_sym_AT] = ACTIONS(878),
    [anon_sym_open] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(878),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_package] = ACTIONS(878),
    [anon_sym_import] = ACTIONS(878),
    [anon_sym_enum] = ACTIONS(878),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(878),
    [anon_sym_strictfp] = ACTIONS(878),
    [anon_sym_native] = ACTIONS(878),
    [anon_sym_transient] = ACTIONS(878),
    [anon_sym_volatile] = ACTIONS(878),
    [anon_sym_sealed] = ACTIONS(878),
    [anon_sym_non_DASHsealed] = ACTIONS(876),
    [anon_sym_record] = ACTIONS(878),
    [anon_sym_ATinterface] = ACTIONS(876),
    [anon_sym_interface] = ACTIONS(878),
    [anon_sym_byte] = ACTIONS(878),
    [anon_sym_short] = ACTIONS(878),
    [anon_sym_int] = ACTIONS(878),
    [anon_sym_long] = ACTIONS(878),
    [anon_sym_char] = ACTIONS(878),
    [anon_sym_float] = ACTIONS(878),
    [anon_sym_double] = ACTIONS(878),
    [sym_boolean_type] = ACTIONS(878),
    [sym_void_type] = ACTIONS(878),
    [sym_this] = ACTIONS(878),
    [sym_super] = ACTIONS(878),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(880),
    [sym_identifier] = ACTIONS(882),
    [sym_decimal_integer_literal] = ACTIONS(882),
    [sym_hex_integer_literal] = ACTIONS(882),
    [sym_octal_integer_literal] = ACTIONS(882),
    [sym_binary_integer_literal] = ACTIONS(880),
    [sym_decimal_floating_point_literal] = ACTIONS(880),
    [sym_hex_floating_point_literal] = ACTIONS(882),
    [sym_true] = ACTIONS(882),
    [sym_false] = ACTIONS(882),
    [sym_character_literal] = ACTIONS(880),
    [anon_sym_DQUOTE] = ACTIONS(882),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(880),
    [sym_null_literal] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(882),
    [anon_sym_DASH] = ACTIONS(882),
    [anon_sym_final] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(880),
    [anon_sym_TILDE] = ACTIONS(880),
    [anon_sym_PLUS_PLUS] = ACTIONS(880),
    [anon_sym_DASH_DASH] = ACTIONS(880),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_class] = ACTIONS(882),
    [anon_sym_switch] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(880),
    [anon_sym_RBRACE] = ACTIONS(880),
    [anon_sym_case] = ACTIONS(882),
    [anon_sym_default] = ACTIONS(882),
    [anon_sym_SEMI] = ACTIONS(880),
    [anon_sym_assert] = ACTIONS(882),
    [anon_sym_do] = ACTIONS(882),
    [anon_sym_while] = ACTIONS(882),
    [anon_sym_break] = ACTIONS(882),
    [anon_sym_continue] = ACTIONS(882),
    [anon_sym_return] = ACTIONS(882),
    [anon_sym_yield] = ACTIONS(882),
    [anon_sym_synchronized] = ACTIONS(882),
    [anon_sym_throw] = ACTIONS(882),
    [anon_sym_try] = ACTIONS(882),
    [anon_sym_if] = ACTIONS(882),
    [anon_sym_else] = ACTIONS(882),
    [anon_sym_for] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(882),
    [anon_sym_open] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_package] = ACTIONS(882),
    [anon_sym_import] = ACTIONS(882),
    [anon_sym_enum] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_abstract] = ACTIONS(882),
    [anon_sym_strictfp] = ACTIONS(882),
    [anon_sym_native] = ACTIONS(882),
    [anon_sym_transient] = ACTIONS(882),
    [anon_sym_volatile] = ACTIONS(882),
    [anon_sym_sealed] = ACTIONS(882),
    [anon_sym_non_DASHsealed] = ACTIONS(880),
    [anon_sym_record] = ACTIONS(882),
    [anon_sym_ATinterface] = ACTIONS(880),
    [anon_sym_interface] = ACTIONS(882),
    [anon_sym_byte] = ACTIONS(882),
    [anon_sym_short] = ACTIONS(882),
    [anon_sym_int] = ACTIONS(882),
    [anon_sym_long] = ACTIONS(882),
    [anon_sym_char] = ACTIONS(882),
    [anon_sym_float] = ACTIONS(882),
    [anon_sym_double] = ACTIONS(882),
    [sym_boolean_type] = ACTIONS(882),
    [sym_void_type] = ACTIONS(882),
    [sym_this] = ACTIONS(882),
    [sym_super] = ACTIONS(882),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [309] = {
    [ts_builtin_sym_end] = ACTIONS(884),
    [sym_identifier] = ACTIONS(886),
    [sym_decimal_integer_literal] = ACTIONS(886),
    [sym_hex_integer_literal] = ACTIONS(886),
    [sym_octal_integer_literal] = ACTIONS(886),
    [sym_binary_integer_literal] = ACTIONS(884),
    [sym_decimal_floating_point_literal] = ACTIONS(884),
    [sym_hex_floating_point_literal] = ACTIONS(886),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_character_literal] = ACTIONS(884),
    [anon_sym_DQUOTE] = ACTIONS(886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(884),
    [sym_null_literal] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_final] = ACTIONS(886),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(884),
    [anon_sym_PLUS_PLUS] = ACTIONS(884),
    [anon_sym_DASH_DASH] = ACTIONS(884),
    [anon_sym_new] = ACTIONS(886),
    [anon_sym_class] = ACTIONS(886),
    [anon_sym_switch] = ACTIONS(886),
    [anon_sym_LBRACE] = ACTIONS(884),
    [anon_sym_RBRACE] = ACTIONS(884),
    [anon_sym_case] = ACTIONS(886),
    [anon_sym_default] = ACTIONS(886),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym_assert] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(886),
    [anon_sym_while] = ACTIONS(886),
    [anon_sym_break] = ACTIONS(886),
    [anon_sym_continue] = ACTIONS(886),
    [anon_sym_return] = ACTIONS(886),
    [anon_sym_yield] = ACTIONS(886),
    [anon_sym_synchronized] = ACTIONS(886),
    [anon_sym_throw] = ACTIONS(886),
    [anon_sym_try] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_else] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_open] = ACTIONS(886),
    [anon_sym_module] = ACTIONS(886),
    [anon_sym_static] = ACTIONS(886),
    [anon_sym_package] = ACTIONS(886),
    [anon_sym_import] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(886),
    [anon_sym_public] = ACTIONS(886),
    [anon_sym_protected] = ACTIONS(886),
    [anon_sym_private] = ACTIONS(886),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_strictfp] = ACTIONS(886),
    [anon_sym_native] = ACTIONS(886),
    [anon_sym_transient] = ACTIONS(886),
    [anon_sym_volatile] = ACTIONS(886),
    [anon_sym_sealed] = ACTIONS(886),
    [anon_sym_non_DASHsealed] = ACTIONS(884),
    [anon_sym_record] = ACTIONS(886),
    [anon_sym_ATinterface] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_byte] = ACTIONS(886),
    [anon_sym_short] = ACTIONS(886),
    [anon_sym_int] = ACTIONS(886),
    [anon_sym_long] = ACTIONS(886),
    [anon_sym_char] = ACTIONS(886),
    [anon_sym_float] = ACTIONS(886),
    [anon_sym_double] = ACTIONS(886),
    [sym_boolean_type] = ACTIONS(886),
    [sym_void_type] = ACTIONS(886),
    [sym_this] = ACTIONS(886),
    [sym_super] = ACTIONS(886),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(888),
    [sym_identifier] = ACTIONS(890),
    [sym_decimal_integer_literal] = ACTIONS(890),
    [sym_hex_integer_literal] = ACTIONS(890),
    [sym_octal_integer_literal] = ACTIONS(890),
    [sym_binary_integer_literal] = ACTIONS(888),
    [sym_decimal_floating_point_literal] = ACTIONS(888),
    [sym_hex_floating_point_literal] = ACTIONS(890),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_character_literal] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(888),
    [sym_null_literal] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_final] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(888),
    [anon_sym_PLUS_PLUS] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(888),
    [anon_sym_new] = ACTIONS(890),
    [anon_sym_class] = ACTIONS(890),
    [anon_sym_switch] = ACTIONS(890),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_RBRACE] = ACTIONS(888),
    [anon_sym_case] = ACTIONS(890),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_SEMI] = ACTIONS(888),
    [anon_sym_assert] = ACTIONS(890),
    [anon_sym_do] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_yield] = ACTIONS(890),
    [anon_sym_synchronized] = ACTIONS(890),
    [anon_sym_throw] = ACTIONS(890),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(890),
    [anon_sym_open] = ACTIONS(890),
    [anon_sym_module] = ACTIONS(890),
    [anon_sym_static] = ACTIONS(890),
    [anon_sym_package] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(890),
    [anon_sym_enum] = ACTIONS(890),
    [anon_sym_public] = ACTIONS(890),
    [anon_sym_protected] = ACTIONS(890),
    [anon_sym_private] = ACTIONS(890),
    [anon_sym_abstract] = ACTIONS(890),
    [anon_sym_strictfp] = ACTIONS(890),
    [anon_sym_native] = ACTIONS(890),
    [anon_sym_transient] = ACTIONS(890),
    [anon_sym_volatile] = ACTIONS(890),
    [anon_sym_sealed] = ACTIONS(890),
    [anon_sym_non_DASHsealed] = ACTIONS(888),
    [anon_sym_record] = ACTIONS(890),
    [anon_sym_ATinterface] = ACTIONS(888),
    [anon_sym_interface] = ACTIONS(890),
    [anon_sym_byte] = ACTIONS(890),
    [anon_sym_short] = ACTIONS(890),
    [anon_sym_int] = ACTIONS(890),
    [anon_sym_long] = ACTIONS(890),
    [anon_sym_char] = ACTIONS(890),
    [anon_sym_float] = ACTIONS(890),
    [anon_sym_double] = ACTIONS(890),
    [sym_boolean_type] = ACTIONS(890),
    [sym_void_type] = ACTIONS(890),
    [sym_this] = ACTIONS(890),
    [sym_super] = ACTIONS(890),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(892),
    [sym_identifier] = ACTIONS(894),
    [sym_decimal_integer_literal] = ACTIONS(894),
    [sym_hex_integer_literal] = ACTIONS(894),
    [sym_octal_integer_literal] = ACTIONS(894),
    [sym_binary_integer_literal] = ACTIONS(892),
    [sym_decimal_floating_point_literal] = ACTIONS(892),
    [sym_hex_floating_point_literal] = ACTIONS(894),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_character_literal] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(894),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(892),
    [sym_null_literal] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_final] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_new] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(894),
    [anon_sym_switch] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_RBRACE] = ACTIONS(892),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_default] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(892),
    [anon_sym_assert] = ACTIONS(894),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(894),
    [anon_sym_synchronized] = ACTIONS(894),
    [anon_sym_throw] = ACTIONS(894),
    [anon_sym_try] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(894),
    [anon_sym_open] = ACTIONS(894),
    [anon_sym_module] = ACTIONS(894),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_package] = ACTIONS(894),
    [anon_sym_import] = ACTIONS(894),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_public] = ACTIONS(894),
    [anon_sym_protected] = ACTIONS(894),
    [anon_sym_private] = ACTIONS(894),
    [anon_sym_abstract] = ACTIONS(894),
    [anon_sym_strictfp] = ACTIONS(894),
    [anon_sym_native] = ACTIONS(894),
    [anon_sym_transient] = ACTIONS(894),
    [anon_sym_volatile] = ACTIONS(894),
    [anon_sym_sealed] = ACTIONS(894),
    [anon_sym_non_DASHsealed] = ACTIONS(892),
    [anon_sym_record] = ACTIONS(894),
    [anon_sym_ATinterface] = ACTIONS(892),
    [anon_sym_interface] = ACTIONS(894),
    [anon_sym_byte] = ACTIONS(894),
    [anon_sym_short] = ACTIONS(894),
    [anon_sym_int] = ACTIONS(894),
    [anon_sym_long] = ACTIONS(894),
    [anon_sym_char] = ACTIONS(894),
    [anon_sym_float] = ACTIONS(894),
    [anon_sym_double] = ACTIONS(894),
    [sym_boolean_type] = ACTIONS(894),
    [sym_void_type] = ACTIONS(894),
    [sym_this] = ACTIONS(894),
    [sym_super] = ACTIONS(894),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [312] = {
    [ts_builtin_sym_end] = ACTIONS(896),
    [sym_identifier] = ACTIONS(898),
    [sym_decimal_integer_literal] = ACTIONS(898),
    [sym_hex_integer_literal] = ACTIONS(898),
    [sym_octal_integer_literal] = ACTIONS(898),
    [sym_binary_integer_literal] = ACTIONS(896),
    [sym_decimal_floating_point_literal] = ACTIONS(896),
    [sym_hex_floating_point_literal] = ACTIONS(898),
    [sym_true] = ACTIONS(898),
    [sym_false] = ACTIONS(898),
    [sym_character_literal] = ACTIONS(896),
    [anon_sym_DQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(896),
    [sym_null_literal] = ACTIONS(898),
    [anon_sym_LPAREN] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_final] = ACTIONS(898),
    [anon_sym_BANG] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_PLUS_PLUS] = ACTIONS(896),
    [anon_sym_DASH_DASH] = ACTIONS(896),
    [anon_sym_new] = ACTIONS(898),
    [anon_sym_class] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(896),
    [anon_sym_case] = ACTIONS(898),
    [anon_sym_default] = ACTIONS(898),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(898),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_while] = ACTIONS(898),
    [anon_sym_break] = ACTIONS(898),
    [anon_sym_continue] = ACTIONS(898),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_yield] = ACTIONS(898),
    [anon_sym_synchronized] = ACTIONS(898),
    [anon_sym_throw] = ACTIONS(898),
    [anon_sym_try] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(898),
    [anon_sym_for] = ACTIONS(898),
    [anon_sym_AT] = ACTIONS(898),
    [anon_sym_open] = ACTIONS(898),
    [anon_sym_module] = ACTIONS(898),
    [anon_sym_static] = ACTIONS(898),
    [anon_sym_package] = ACTIONS(898),
    [anon_sym_import] = ACTIONS(898),
    [anon_sym_enum] = ACTIONS(898),
    [anon_sym_public] = ACTIONS(898),
    [anon_sym_protected] = ACTIONS(898),
    [anon_sym_private] = ACTIONS(898),
    [anon_sym_abstract] = ACTIONS(898),
    [anon_sym_strictfp] = ACTIONS(898),
    [anon_sym_native] = ACTIONS(898),
    [anon_sym_transient] = ACTIONS(898),
    [anon_sym_volatile] = ACTIONS(898),
    [anon_sym_sealed] = ACTIONS(898),
    [anon_sym_non_DASHsealed] = ACTIONS(896),
    [anon_sym_record] = ACTIONS(898),
    [anon_sym_ATinterface] = ACTIONS(896),
    [anon_sym_interface] = ACTIONS(898),
    [anon_sym_byte] = ACTIONS(898),
    [anon_sym_short] = ACTIONS(898),
    [anon_sym_int] = ACTIONS(898),
    [anon_sym_long] = ACTIONS(898),
    [anon_sym_char] = ACTIONS(898),
    [anon_sym_float] = ACTIONS(898),
    [anon_sym_double] = ACTIONS(898),
    [sym_boolean_type] = ACTIONS(898),
    [sym_void_type] = ACTIONS(898),
    [sym_this] = ACTIONS(898),
    [sym_super] = ACTIONS(898),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(900),
    [sym_identifier] = ACTIONS(902),
    [sym_decimal_integer_literal] = ACTIONS(902),
    [sym_hex_integer_literal] = ACTIONS(902),
    [sym_octal_integer_literal] = ACTIONS(902),
    [sym_binary_integer_literal] = ACTIONS(900),
    [sym_decimal_floating_point_literal] = ACTIONS(900),
    [sym_hex_floating_point_literal] = ACTIONS(902),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_character_literal] = ACTIONS(900),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(900),
    [sym_null_literal] = ACTIONS(902),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_final] = ACTIONS(902),
    [anon_sym_BANG] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(900),
    [anon_sym_DASH_DASH] = ACTIONS(900),
    [anon_sym_new] = ACTIONS(902),
    [anon_sym_class] = ACTIONS(902),
    [anon_sym_switch] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_assert] = ACTIONS(902),
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_yield] = ACTIONS(902),
    [anon_sym_synchronized] = ACTIONS(902),
    [anon_sym_throw] = ACTIONS(902),
    [anon_sym_try] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(902),
    [anon_sym_open] = ACTIONS(902),
    [anon_sym_module] = ACTIONS(902),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_package] = ACTIONS(902),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_public] = ACTIONS(902),
    [anon_sym_protected] = ACTIONS(902),
    [anon_sym_private] = ACTIONS(902),
    [anon_sym_abstract] = ACTIONS(902),
    [anon_sym_strictfp] = ACTIONS(902),
    [anon_sym_native] = ACTIONS(902),
    [anon_sym_transient] = ACTIONS(902),
    [anon_sym_volatile] = ACTIONS(902),
    [anon_sym_sealed] = ACTIONS(902),
    [anon_sym_non_DASHsealed] = ACTIONS(900),
    [anon_sym_record] = ACTIONS(902),
    [anon_sym_ATinterface] = ACTIONS(900),
    [anon_sym_interface] = ACTIONS(902),
    [anon_sym_byte] = ACTIONS(902),
    [anon_sym_short] = ACTIONS(902),
    [anon_sym_int] = ACTIONS(902),
    [anon_sym_long] = ACTIONS(902),
    [anon_sym_char] = ACTIONS(902),
    [anon_sym_float] = ACTIONS(902),
    [anon_sym_double] = ACTIONS(902),
    [sym_boolean_type] = ACTIONS(902),
    [sym_void_type] = ACTIONS(902),
    [sym_this] = ACTIONS(902),
    [sym_super] = ACTIONS(902),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(904),
    [sym_identifier] = ACTIONS(906),
    [sym_decimal_integer_literal] = ACTIONS(906),
    [sym_hex_integer_literal] = ACTIONS(906),
    [sym_octal_integer_literal] = ACTIONS(906),
    [sym_binary_integer_literal] = ACTIONS(904),
    [sym_decimal_floating_point_literal] = ACTIONS(904),
    [sym_hex_floating_point_literal] = ACTIONS(906),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_character_literal] = ACTIONS(904),
    [anon_sym_DQUOTE] = ACTIONS(906),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [sym_null_literal] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_final] = ACTIONS(906),
    [anon_sym_BANG] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_PLUS_PLUS] = ACTIONS(904),
    [anon_sym_DASH_DASH] = ACTIONS(904),
    [anon_sym_new] = ACTIONS(906),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_switch] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_assert] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_yield] = ACTIONS(906),
    [anon_sym_synchronized] = ACTIONS(906),
    [anon_sym_throw] = ACTIONS(906),
    [anon_sym_try] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_AT] = ACTIONS(906),
    [anon_sym_open] = ACTIONS(906),
    [anon_sym_module] = ACTIONS(906),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_package] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_public] = ACTIONS(906),
    [anon_sym_protected] = ACTIONS(906),
    [anon_sym_private] = ACTIONS(906),
    [anon_sym_abstract] = ACTIONS(906),
    [anon_sym_strictfp] = ACTIONS(906),
    [anon_sym_native] = ACTIONS(906),
    [anon_sym_transient] = ACTIONS(906),
    [anon_sym_volatile] = ACTIONS(906),
    [anon_sym_sealed] = ACTIONS(906),
    [anon_sym_non_DASHsealed] = ACTIONS(904),
    [anon_sym_record] = ACTIONS(906),
    [anon_sym_ATinterface] = ACTIONS(904),
    [anon_sym_interface] = ACTIONS(906),
    [anon_sym_byte] = ACTIONS(906),
    [anon_sym_short] = ACTIONS(906),
    [anon_sym_int] = ACTIONS(906),
    [anon_sym_long] = ACTIONS(906),
    [anon_sym_char] = ACTIONS(906),
    [anon_sym_float] = ACTIONS(906),
    [anon_sym_double] = ACTIONS(906),
    [sym_boolean_type] = ACTIONS(906),
    [sym_void_type] = ACTIONS(906),
    [sym_this] = ACTIONS(906),
    [sym_super] = ACTIONS(906),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(908),
    [sym_identifier] = ACTIONS(910),
    [sym_decimal_integer_literal] = ACTIONS(910),
    [sym_hex_integer_literal] = ACTIONS(910),
    [sym_octal_integer_literal] = ACTIONS(910),
    [sym_binary_integer_literal] = ACTIONS(908),
    [sym_decimal_floating_point_literal] = ACTIONS(908),
    [sym_hex_floating_point_literal] = ACTIONS(910),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_character_literal] = ACTIONS(908),
    [anon_sym_DQUOTE] = ACTIONS(910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(908),
    [sym_null_literal] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_final] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_new] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_assert] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_synchronized] = ACTIONS(910),
    [anon_sym_throw] = ACTIONS(910),
    [anon_sym_try] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_AT] = ACTIONS(910),
    [anon_sym_open] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_package] = ACTIONS(910),
    [anon_sym_import] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_abstract] = ACTIONS(910),
    [anon_sym_strictfp] = ACTIONS(910),
    [anon_sym_native] = ACTIONS(910),
    [anon_sym_transient] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_sealed] = ACTIONS(910),
    [anon_sym_non_DASHsealed] = ACTIONS(908),
    [anon_sym_record] = ACTIONS(910),
    [anon_sym_ATinterface] = ACTIONS(908),
    [anon_sym_interface] = ACTIONS(910),
    [anon_sym_byte] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [anon_sym_int] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_float] = ACTIONS(910),
    [anon_sym_double] = ACTIONS(910),
    [sym_boolean_type] = ACTIONS(910),
    [sym_void_type] = ACTIONS(910),
    [sym_this] = ACTIONS(910),
    [sym_super] = ACTIONS(910),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(912),
    [sym_identifier] = ACTIONS(914),
    [sym_decimal_integer_literal] = ACTIONS(914),
    [sym_hex_integer_literal] = ACTIONS(914),
    [sym_octal_integer_literal] = ACTIONS(914),
    [sym_binary_integer_literal] = ACTIONS(912),
    [sym_decimal_floating_point_literal] = ACTIONS(912),
    [sym_hex_floating_point_literal] = ACTIONS(914),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_character_literal] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(912),
    [sym_null_literal] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_final] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_new] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(912),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_assert] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_yield] = ACTIONS(914),
    [anon_sym_synchronized] = ACTIONS(914),
    [anon_sym_throw] = ACTIONS(914),
    [anon_sym_try] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_AT] = ACTIONS(914),
    [anon_sym_open] = ACTIONS(914),
    [anon_sym_module] = ACTIONS(914),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_package] = ACTIONS(914),
    [anon_sym_import] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_public] = ACTIONS(914),
    [anon_sym_protected] = ACTIONS(914),
    [anon_sym_private] = ACTIONS(914),
    [anon_sym_abstract] = ACTIONS(914),
    [anon_sym_strictfp] = ACTIONS(914),
    [anon_sym_native] = ACTIONS(914),
    [anon_sym_transient] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_sealed] = ACTIONS(914),
    [anon_sym_non_DASHsealed] = ACTIONS(912),
    [anon_sym_record] = ACTIONS(914),
    [anon_sym_ATinterface] = ACTIONS(912),
    [anon_sym_interface] = ACTIONS(914),
    [anon_sym_byte] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [anon_sym_int] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_float] = ACTIONS(914),
    [anon_sym_double] = ACTIONS(914),
    [sym_boolean_type] = ACTIONS(914),
    [sym_void_type] = ACTIONS(914),
    [sym_this] = ACTIONS(914),
    [sym_super] = ACTIONS(914),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [317] = {
    [ts_builtin_sym_end] = ACTIONS(916),
    [sym_identifier] = ACTIONS(918),
    [sym_decimal_integer_literal] = ACTIONS(918),
    [sym_hex_integer_literal] = ACTIONS(918),
    [sym_octal_integer_literal] = ACTIONS(918),
    [sym_binary_integer_literal] = ACTIONS(916),
    [sym_decimal_floating_point_literal] = ACTIONS(916),
    [sym_hex_floating_point_literal] = ACTIONS(918),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_character_literal] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(916),
    [sym_null_literal] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(916),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_final] = ACTIONS(918),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_class] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_RBRACE] = ACTIONS(916),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_assert] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_synchronized] = ACTIONS(918),
    [anon_sym_throw] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(918),
    [anon_sym_open] = ACTIONS(918),
    [anon_sym_module] = ACTIONS(918),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_package] = ACTIONS(918),
    [anon_sym_import] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_public] = ACTIONS(918),
    [anon_sym_protected] = ACTIONS(918),
    [anon_sym_private] = ACTIONS(918),
    [anon_sym_abstract] = ACTIONS(918),
    [anon_sym_strictfp] = ACTIONS(918),
    [anon_sym_native] = ACTIONS(918),
    [anon_sym_transient] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_sealed] = ACTIONS(918),
    [anon_sym_non_DASHsealed] = ACTIONS(916),
    [anon_sym_record] = ACTIONS(918),
    [anon_sym_ATinterface] = ACTIONS(916),
    [anon_sym_interface] = ACTIONS(918),
    [anon_sym_byte] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [anon_sym_int] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_char] = ACTIONS(918),
    [anon_sym_float] = ACTIONS(918),
    [anon_sym_double] = ACTIONS(918),
    [sym_boolean_type] = ACTIONS(918),
    [sym_void_type] = ACTIONS(918),
    [sym_this] = ACTIONS(918),
    [sym_super] = ACTIONS(918),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(920),
    [sym_identifier] = ACTIONS(922),
    [sym_decimal_integer_literal] = ACTIONS(922),
    [sym_hex_integer_literal] = ACTIONS(922),
    [sym_octal_integer_literal] = ACTIONS(922),
    [sym_binary_integer_literal] = ACTIONS(920),
    [sym_decimal_floating_point_literal] = ACTIONS(920),
    [sym_hex_floating_point_literal] = ACTIONS(922),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_character_literal] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(922),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(920),
    [sym_null_literal] = ACTIONS(922),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_final] = ACTIONS(922),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_new] = ACTIONS(922),
    [anon_sym_class] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_RBRACE] = ACTIONS(920),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_assert] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_synchronized] = ACTIONS(922),
    [anon_sym_throw] = ACTIONS(922),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_AT] = ACTIONS(922),
    [anon_sym_open] = ACTIONS(922),
    [anon_sym_module] = ACTIONS(922),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_package] = ACTIONS(922),
    [anon_sym_import] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_public] = ACTIONS(922),
    [anon_sym_protected] = ACTIONS(922),
    [anon_sym_private] = ACTIONS(922),
    [anon_sym_abstract] = ACTIONS(922),
    [anon_sym_strictfp] = ACTIONS(922),
    [anon_sym_native] = ACTIONS(922),
    [anon_sym_transient] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_sealed] = ACTIONS(922),
    [anon_sym_non_DASHsealed] = ACTIONS(920),
    [anon_sym_record] = ACTIONS(922),
    [anon_sym_ATinterface] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(922),
    [anon_sym_byte] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [anon_sym_int] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_char] = ACTIONS(922),
    [anon_sym_float] = ACTIONS(922),
    [anon_sym_double] = ACTIONS(922),
    [sym_boolean_type] = ACTIONS(922),
    [sym_void_type] = ACTIONS(922),
    [sym_this] = ACTIONS(922),
    [sym_super] = ACTIONS(922),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(924),
    [sym_identifier] = ACTIONS(926),
    [sym_decimal_integer_literal] = ACTIONS(926),
    [sym_hex_integer_literal] = ACTIONS(926),
    [sym_octal_integer_literal] = ACTIONS(926),
    [sym_binary_integer_literal] = ACTIONS(924),
    [sym_decimal_floating_point_literal] = ACTIONS(924),
    [sym_hex_floating_point_literal] = ACTIONS(926),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_character_literal] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(924),
    [sym_null_literal] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(924),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_final] = ACTIONS(926),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_new] = ACTIONS(926),
    [anon_sym_class] = ACTIONS(926),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_RBRACE] = ACTIONS(924),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_assert] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_yield] = ACTIONS(926),
    [anon_sym_synchronized] = ACTIONS(926),
    [anon_sym_throw] = ACTIONS(926),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_AT] = ACTIONS(926),
    [anon_sym_open] = ACTIONS(926),
    [anon_sym_module] = ACTIONS(926),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_package] = ACTIONS(926),
    [anon_sym_import] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_public] = ACTIONS(926),
    [anon_sym_protected] = ACTIONS(926),
    [anon_sym_private] = ACTIONS(926),
    [anon_sym_abstract] = ACTIONS(926),
    [anon_sym_strictfp] = ACTIONS(926),
    [anon_sym_native] = ACTIONS(926),
    [anon_sym_transient] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_sealed] = ACTIONS(926),
    [anon_sym_non_DASHsealed] = ACTIONS(924),
    [anon_sym_record] = ACTIONS(926),
    [anon_sym_ATinterface] = ACTIONS(924),
    [anon_sym_interface] = ACTIONS(926),
    [anon_sym_byte] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [anon_sym_int] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_char] = ACTIONS(926),
    [anon_sym_float] = ACTIONS(926),
    [anon_sym_double] = ACTIONS(926),
    [sym_boolean_type] = ACTIONS(926),
    [sym_void_type] = ACTIONS(926),
    [sym_this] = ACTIONS(926),
    [sym_super] = ACTIONS(926),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(928),
    [sym_identifier] = ACTIONS(930),
    [sym_decimal_integer_literal] = ACTIONS(930),
    [sym_hex_integer_literal] = ACTIONS(930),
    [sym_octal_integer_literal] = ACTIONS(930),
    [sym_binary_integer_literal] = ACTIONS(928),
    [sym_decimal_floating_point_literal] = ACTIONS(928),
    [sym_hex_floating_point_literal] = ACTIONS(930),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_character_literal] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(928),
    [sym_null_literal] = ACTIONS(930),
    [anon_sym_LPAREN] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_final] = ACTIONS(930),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(930),
    [anon_sym_class] = ACTIONS(930),
    [anon_sym_switch] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_RBRACE] = ACTIONS(928),
    [anon_sym_case] = ACTIONS(930),
    [anon_sym_default] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_assert] = ACTIONS(930),
    [anon_sym_do] = ACTIONS(930),
    [anon_sym_while] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(930),
    [anon_sym_continue] = ACTIONS(930),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_yield] = ACTIONS(930),
    [anon_sym_synchronized] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(930),
    [anon_sym_open] = ACTIONS(930),
    [anon_sym_module] = ACTIONS(930),
    [anon_sym_static] = ACTIONS(930),
    [anon_sym_package] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(930),
    [anon_sym_enum] = ACTIONS(930),
    [anon_sym_public] = ACTIONS(930),
    [anon_sym_protected] = ACTIONS(930),
    [anon_sym_private] = ACTIONS(930),
    [anon_sym_abstract] = ACTIONS(930),
    [anon_sym_strictfp] = ACTIONS(930),
    [anon_sym_native] = ACTIONS(930),
    [anon_sym_transient] = ACTIONS(930),
    [anon_sym_volatile] = ACTIONS(930),
    [anon_sym_sealed] = ACTIONS(930),
    [anon_sym_non_DASHsealed] = ACTIONS(928),
    [anon_sym_record] = ACTIONS(930),
    [anon_sym_ATinterface] = ACTIONS(928),
    [anon_sym_interface] = ACTIONS(930),
    [anon_sym_byte] = ACTIONS(930),
    [anon_sym_short] = ACTIONS(930),
    [anon_sym_int] = ACTIONS(930),
    [anon_sym_long] = ACTIONS(930),
    [anon_sym_char] = ACTIONS(930),
    [anon_sym_float] = ACTIONS(930),
    [anon_sym_double] = ACTIONS(930),
    [sym_boolean_type] = ACTIONS(930),
    [sym_void_type] = ACTIONS(930),
    [sym_this] = ACTIONS(930),
    [sym_super] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(932),
    [sym_identifier] = ACTIONS(934),
    [sym_decimal_integer_literal] = ACTIONS(934),
    [sym_hex_integer_literal] = ACTIONS(934),
    [sym_octal_integer_literal] = ACTIONS(934),
    [sym_binary_integer_literal] = ACTIONS(932),
    [sym_decimal_floating_point_literal] = ACTIONS(932),
    [sym_hex_floating_point_literal] = ACTIONS(934),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_character_literal] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(934),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(932),
    [sym_null_literal] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_final] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(932),
    [anon_sym_new] = ACTIONS(934),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_switch] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_RBRACE] = ACTIONS(932),
    [anon_sym_case] = ACTIONS(934),
    [anon_sym_default] = ACTIONS(934),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_assert] = ACTIONS(934),
    [anon_sym_do] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(934),
    [anon_sym_break] = ACTIONS(934),
    [anon_sym_continue] = ACTIONS(934),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(934),
    [anon_sym_synchronized] = ACTIONS(934),
    [anon_sym_throw] = ACTIONS(934),
    [anon_sym_try] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_else] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(934),
    [anon_sym_AT] = ACTIONS(934),
    [anon_sym_open] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_package] = ACTIONS(934),
    [anon_sym_import] = ACTIONS(934),
    [anon_sym_enum] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(934),
    [anon_sym_strictfp] = ACTIONS(934),
    [anon_sym_native] = ACTIONS(934),
    [anon_sym_transient] = ACTIONS(934),
    [anon_sym_volatile] = ACTIONS(934),
    [anon_sym_sealed] = ACTIONS(934),
    [anon_sym_non_DASHsealed] = ACTIONS(932),
    [anon_sym_record] = ACTIONS(934),
    [anon_sym_ATinterface] = ACTIONS(932),
    [anon_sym_interface] = ACTIONS(934),
    [anon_sym_byte] = ACTIONS(934),
    [anon_sym_short] = ACTIONS(934),
    [anon_sym_int] = ACTIONS(934),
    [anon_sym_long] = ACTIONS(934),
    [anon_sym_char] = ACTIONS(934),
    [anon_sym_float] = ACTIONS(934),
    [anon_sym_double] = ACTIONS(934),
    [sym_boolean_type] = ACTIONS(934),
    [sym_void_type] = ACTIONS(934),
    [sym_this] = ACTIONS(934),
    [sym_super] = ACTIONS(934),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(936),
    [sym_identifier] = ACTIONS(938),
    [sym_decimal_integer_literal] = ACTIONS(938),
    [sym_hex_integer_literal] = ACTIONS(938),
    [sym_octal_integer_literal] = ACTIONS(938),
    [sym_binary_integer_literal] = ACTIONS(936),
    [sym_decimal_floating_point_literal] = ACTIONS(936),
    [sym_hex_floating_point_literal] = ACTIONS(938),
    [sym_true] = ACTIONS(938),
    [sym_false] = ACTIONS(938),
    [sym_character_literal] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(936),
    [sym_null_literal] = ACTIONS(938),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_final] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(936),
    [anon_sym_PLUS_PLUS] = ACTIONS(936),
    [anon_sym_DASH_DASH] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(938),
    [anon_sym_class] = ACTIONS(938),
    [anon_sym_switch] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(936),
    [anon_sym_RBRACE] = ACTIONS(936),
    [anon_sym_case] = ACTIONS(938),
    [anon_sym_default] = ACTIONS(938),
    [anon_sym_SEMI] = ACTIONS(936),
    [anon_sym_assert] = ACTIONS(938),
    [anon_sym_do] = ACTIONS(938),
    [anon_sym_while] = ACTIONS(938),
    [anon_sym_break] = ACTIONS(938),
    [anon_sym_continue] = ACTIONS(938),
    [anon_sym_return] = ACTIONS(938),
    [anon_sym_yield] = ACTIONS(938),
    [anon_sym_synchronized] = ACTIONS(938),
    [anon_sym_throw] = ACTIONS(938),
    [anon_sym_try] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(938),
    [anon_sym_else] = ACTIONS(938),
    [anon_sym_for] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(938),
    [anon_sym_open] = ACTIONS(938),
    [anon_sym_module] = ACTIONS(938),
    [anon_sym_static] = ACTIONS(938),
    [anon_sym_package] = ACTIONS(938),
    [anon_sym_import] = ACTIONS(938),
    [anon_sym_enum] = ACTIONS(938),
    [anon_sym_public] = ACTIONS(938),
    [anon_sym_protected] = ACTIONS(938),
    [anon_sym_private] = ACTIONS(938),
    [anon_sym_abstract] = ACTIONS(938),
    [anon_sym_strictfp] = ACTIONS(938),
    [anon_sym_native] = ACTIONS(938),
    [anon_sym_transient] = ACTIONS(938),
    [anon_sym_volatile] = ACTIONS(938),
    [anon_sym_sealed] = ACTIONS(938),
    [anon_sym_non_DASHsealed] = ACTIONS(936),
    [anon_sym_record] = ACTIONS(938),
    [anon_sym_ATinterface] = ACTIONS(936),
    [anon_sym_interface] = ACTIONS(938),
    [anon_sym_byte] = ACTIONS(938),
    [anon_sym_short] = ACTIONS(938),
    [anon_sym_int] = ACTIONS(938),
    [anon_sym_long] = ACTIONS(938),
    [anon_sym_char] = ACTIONS(938),
    [anon_sym_float] = ACTIONS(938),
    [anon_sym_double] = ACTIONS(938),
    [sym_boolean_type] = ACTIONS(938),
    [sym_void_type] = ACTIONS(938),
    [sym_this] = ACTIONS(938),
    [sym_super] = ACTIONS(938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(940),
    [sym_identifier] = ACTIONS(942),
    [sym_decimal_integer_literal] = ACTIONS(942),
    [sym_hex_integer_literal] = ACTIONS(942),
    [sym_octal_integer_literal] = ACTIONS(942),
    [sym_binary_integer_literal] = ACTIONS(940),
    [sym_decimal_floating_point_literal] = ACTIONS(940),
    [sym_hex_floating_point_literal] = ACTIONS(942),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_character_literal] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(942),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(940),
    [sym_null_literal] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_final] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_class] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_assert] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_synchronized] = ACTIONS(942),
    [anon_sym_throw] = ACTIONS(942),
    [anon_sym_try] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_AT] = ACTIONS(942),
    [anon_sym_open] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(942),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_package] = ACTIONS(942),
    [anon_sym_import] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(942),
    [anon_sym_strictfp] = ACTIONS(942),
    [anon_sym_native] = ACTIONS(942),
    [anon_sym_transient] = ACTIONS(942),
    [anon_sym_volatile] = ACTIONS(942),
    [anon_sym_sealed] = ACTIONS(942),
    [anon_sym_non_DASHsealed] = ACTIONS(940),
    [anon_sym_record] = ACTIONS(942),
    [anon_sym_ATinterface] = ACTIONS(940),
    [anon_sym_interface] = ACTIONS(942),
    [anon_sym_byte] = ACTIONS(942),
    [anon_sym_short] = ACTIONS(942),
    [anon_sym_int] = ACTIONS(942),
    [anon_sym_long] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_float] = ACTIONS(942),
    [anon_sym_double] = ACTIONS(942),
    [sym_boolean_type] = ACTIONS(942),
    [sym_void_type] = ACTIONS(942),
    [sym_this] = ACTIONS(942),
    [sym_super] = ACTIONS(942),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(944),
    [sym_identifier] = ACTIONS(946),
    [sym_decimal_integer_literal] = ACTIONS(946),
    [sym_hex_integer_literal] = ACTIONS(946),
    [sym_octal_integer_literal] = ACTIONS(946),
    [sym_binary_integer_literal] = ACTIONS(944),
    [sym_decimal_floating_point_literal] = ACTIONS(944),
    [sym_hex_floating_point_literal] = ACTIONS(946),
    [sym_true] = ACTIONS(946),
    [sym_false] = ACTIONS(946),
    [sym_character_literal] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(944),
    [sym_null_literal] = ACTIONS(946),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_final] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(944),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_PLUS_PLUS] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(944),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_class] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_assert] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_synchronized] = ACTIONS(946),
    [anon_sym_throw] = ACTIONS(946),
    [anon_sym_try] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(946),
    [anon_sym_open] = ACTIONS(946),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_package] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(946),
    [anon_sym_protected] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym_abstract] = ACTIONS(946),
    [anon_sym_strictfp] = ACTIONS(946),
    [anon_sym_native] = ACTIONS(946),
    [anon_sym_transient] = ACTIONS(946),
    [anon_sym_volatile] = ACTIONS(946),
    [anon_sym_sealed] = ACTIONS(946),
    [anon_sym_non_DASHsealed] = ACTIONS(944),
    [anon_sym_record] = ACTIONS(946),
    [anon_sym_ATinterface] = ACTIONS(944),
    [anon_sym_interface] = ACTIONS(946),
    [anon_sym_byte] = ACTIONS(946),
    [anon_sym_short] = ACTIONS(946),
    [anon_sym_int] = ACTIONS(946),
    [anon_sym_long] = ACTIONS(946),
    [anon_sym_char] = ACTIONS(946),
    [anon_sym_float] = ACTIONS(946),
    [anon_sym_double] = ACTIONS(946),
    [sym_boolean_type] = ACTIONS(946),
    [sym_void_type] = ACTIONS(946),
    [sym_this] = ACTIONS(946),
    [sym_super] = ACTIONS(946),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(948),
    [sym_identifier] = ACTIONS(950),
    [sym_decimal_integer_literal] = ACTIONS(950),
    [sym_hex_integer_literal] = ACTIONS(950),
    [sym_octal_integer_literal] = ACTIONS(950),
    [sym_binary_integer_literal] = ACTIONS(948),
    [sym_decimal_floating_point_literal] = ACTIONS(948),
    [sym_hex_floating_point_literal] = ACTIONS(950),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_character_literal] = ACTIONS(948),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(948),
    [sym_null_literal] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_final] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(948),
    [anon_sym_DASH_DASH] = ACTIONS(948),
    [anon_sym_new] = ACTIONS(950),
    [anon_sym_class] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_case] = ACTIONS(950),
    [anon_sym_default] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(948),
    [anon_sym_assert] = ACTIONS(950),
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_while] = ACTIONS(950),
    [anon_sym_break] = ACTIONS(950),
    [anon_sym_continue] = ACTIONS(950),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_synchronized] = ACTIONS(950),
    [anon_sym_throw] = ACTIONS(950),
    [anon_sym_try] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_else] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(950),
    [anon_sym_AT] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(950),
    [anon_sym_module] = ACTIONS(950),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_package] = ACTIONS(950),
    [anon_sym_import] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_public] = ACTIONS(950),
    [anon_sym_protected] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_strictfp] = ACTIONS(950),
    [anon_sym_native] = ACTIONS(950),
    [anon_sym_transient] = ACTIONS(950),
    [anon_sym_volatile] = ACTIONS(950),
    [anon_sym_sealed] = ACTIONS(950),
    [anon_sym_non_DASHsealed] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_ATinterface] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_byte] = ACTIONS(950),
    [anon_sym_short] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(950),
    [anon_sym_long] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_float] = ACTIONS(950),
    [anon_sym_double] = ACTIONS(950),
    [sym_boolean_type] = ACTIONS(950),
    [sym_void_type] = ACTIONS(950),
    [sym_this] = ACTIONS(950),
    [sym_super] = ACTIONS(950),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(952),
    [sym_identifier] = ACTIONS(954),
    [sym_decimal_integer_literal] = ACTIONS(954),
    [sym_hex_integer_literal] = ACTIONS(954),
    [sym_octal_integer_literal] = ACTIONS(954),
    [sym_binary_integer_literal] = ACTIONS(952),
    [sym_decimal_floating_point_literal] = ACTIONS(952),
    [sym_hex_floating_point_literal] = ACTIONS(954),
    [sym_true] = ACTIONS(954),
    [sym_false] = ACTIONS(954),
    [sym_character_literal] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(952),
    [sym_null_literal] = ACTIONS(954),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_final] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(952),
    [anon_sym_PLUS_PLUS] = ACTIONS(952),
    [anon_sym_DASH_DASH] = ACTIONS(952),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_class] = ACTIONS(954),
    [anon_sym_switch] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(954),
    [anon_sym_default] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_assert] = ACTIONS(954),
    [anon_sym_do] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_yield] = ACTIONS(954),
    [anon_sym_synchronized] = ACTIONS(954),
    [anon_sym_throw] = ACTIONS(954),
    [anon_sym_try] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_else] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(954),
    [anon_sym_open] = ACTIONS(954),
    [anon_sym_module] = ACTIONS(954),
    [anon_sym_static] = ACTIONS(954),
    [anon_sym_package] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(954),
    [anon_sym_enum] = ACTIONS(954),
    [anon_sym_public] = ACTIONS(954),
    [anon_sym_protected] = ACTIONS(954),
    [anon_sym_private] = ACTIONS(954),
    [anon_sym_abstract] = ACTIONS(954),
    [anon_sym_strictfp] = ACTIONS(954),
    [anon_sym_native] = ACTIONS(954),
    [anon_sym_transient] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_sealed] = ACTIONS(954),
    [anon_sym_non_DASHsealed] = ACTIONS(952),
    [anon_sym_record] = ACTIONS(954),
    [anon_sym_ATinterface] = ACTIONS(952),
    [anon_sym_interface] = ACTIONS(954),
    [anon_sym_byte] = ACTIONS(954),
    [anon_sym_short] = ACTIONS(954),
    [anon_sym_int] = ACTIONS(954),
    [anon_sym_long] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_float] = ACTIONS(954),
    [anon_sym_double] = ACTIONS(954),
    [sym_boolean_type] = ACTIONS(954),
    [sym_void_type] = ACTIONS(954),
    [sym_this] = ACTIONS(954),
    [sym_super] = ACTIONS(954),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(958),
    [sym_decimal_integer_literal] = ACTIONS(958),
    [sym_hex_integer_literal] = ACTIONS(958),
    [sym_octal_integer_literal] = ACTIONS(958),
    [sym_binary_integer_literal] = ACTIONS(956),
    [sym_decimal_floating_point_literal] = ACTIONS(956),
    [sym_hex_floating_point_literal] = ACTIONS(958),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_character_literal] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(956),
    [sym_null_literal] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_final] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_new] = ACTIONS(958),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_assert] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_synchronized] = ACTIONS(958),
    [anon_sym_throw] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(958),
    [anon_sym_open] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_package] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_abstract] = ACTIONS(958),
    [anon_sym_strictfp] = ACTIONS(958),
    [anon_sym_native] = ACTIONS(958),
    [anon_sym_transient] = ACTIONS(958),
    [anon_sym_volatile] = ACTIONS(958),
    [anon_sym_sealed] = ACTIONS(958),
    [anon_sym_non_DASHsealed] = ACTIONS(956),
    [anon_sym_record] = ACTIONS(958),
    [anon_sym_ATinterface] = ACTIONS(956),
    [anon_sym_interface] = ACTIONS(958),
    [anon_sym_byte] = ACTIONS(958),
    [anon_sym_short] = ACTIONS(958),
    [anon_sym_int] = ACTIONS(958),
    [anon_sym_long] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_float] = ACTIONS(958),
    [anon_sym_double] = ACTIONS(958),
    [sym_boolean_type] = ACTIONS(958),
    [sym_void_type] = ACTIONS(958),
    [sym_this] = ACTIONS(958),
    [sym_super] = ACTIONS(958),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(960),
    [sym_identifier] = ACTIONS(962),
    [sym_decimal_integer_literal] = ACTIONS(962),
    [sym_hex_integer_literal] = ACTIONS(962),
    [sym_octal_integer_literal] = ACTIONS(962),
    [sym_binary_integer_literal] = ACTIONS(960),
    [sym_decimal_floating_point_literal] = ACTIONS(960),
    [sym_hex_floating_point_literal] = ACTIONS(962),
    [sym_true] = ACTIONS(962),
    [sym_false] = ACTIONS(962),
    [sym_character_literal] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_null_literal] = ACTIONS(962),
    [anon_sym_LPAREN] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(962),
    [anon_sym_final] = ACTIONS(962),
    [anon_sym_BANG] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(962),
    [anon_sym_switch] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_RBRACE] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(962),
    [anon_sym_default] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(960),
    [anon_sym_assert] = ACTIONS(962),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_while] = ACTIONS(962),
    [anon_sym_break] = ACTIONS(962),
    [anon_sym_continue] = ACTIONS(962),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_yield] = ACTIONS(962),
    [anon_sym_synchronized] = ACTIONS(962),
    [anon_sym_throw] = ACTIONS(962),
    [anon_sym_try] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(962),
    [anon_sym_for] = ACTIONS(962),
    [anon_sym_AT] = ACTIONS(962),
    [anon_sym_open] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(962),
    [anon_sym_package] = ACTIONS(962),
    [anon_sym_import] = ACTIONS(962),
    [anon_sym_enum] = ACTIONS(962),
    [anon_sym_public] = ACTIONS(962),
    [anon_sym_protected] = ACTIONS(962),
    [anon_sym_private] = ACTIONS(962),
    [anon_sym_abstract] = ACTIONS(962),
    [anon_sym_strictfp] = ACTIONS(962),
    [anon_sym_native] = ACTIONS(962),
    [anon_sym_transient] = ACTIONS(962),
    [anon_sym_volatile] = ACTIONS(962),
    [anon_sym_sealed] = ACTIONS(962),
    [anon_sym_non_DASHsealed] = ACTIONS(960),
    [anon_sym_record] = ACTIONS(962),
    [anon_sym_ATinterface] = ACTIONS(960),
    [anon_sym_interface] = ACTIONS(962),
    [anon_sym_byte] = ACTIONS(962),
    [anon_sym_short] = ACTIONS(962),
    [anon_sym_int] = ACTIONS(962),
    [anon_sym_long] = ACTIONS(962),
    [anon_sym_char] = ACTIONS(962),
    [anon_sym_float] = ACTIONS(962),
    [anon_sym_double] = ACTIONS(962),
    [sym_boolean_type] = ACTIONS(962),
    [sym_void_type] = ACTIONS(962),
    [sym_this] = ACTIONS(962),
    [sym_super] = ACTIONS(962),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_decimal_integer_literal] = ACTIONS(966),
    [sym_hex_integer_literal] = ACTIONS(966),
    [sym_octal_integer_literal] = ACTIONS(966),
    [sym_binary_integer_literal] = ACTIONS(964),
    [sym_decimal_floating_point_literal] = ACTIONS(964),
    [sym_hex_floating_point_literal] = ACTIONS(966),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_character_literal] = ACTIONS(964),
    [anon_sym_DQUOTE] = ACTIONS(966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(964),
    [sym_null_literal] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(966),
    [anon_sym_final] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(964),
    [anon_sym_DASH_DASH] = ACTIONS(964),
    [anon_sym_new] = ACTIONS(966),
    [anon_sym_class] = ACTIONS(966),
    [anon_sym_switch] = ACTIONS(966),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_case] = ACTIONS(966),
    [anon_sym_default] = ACTIONS(966),
    [anon_sym_SEMI] = ACTIONS(964),
    [anon_sym_assert] = ACTIONS(966),
    [anon_sym_do] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_yield] = ACTIONS(966),
    [anon_sym_synchronized] = ACTIONS(966),
    [anon_sym_throw] = ACTIONS(966),
    [anon_sym_try] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_else] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_AT] = ACTIONS(966),
    [anon_sym_open] = ACTIONS(966),
    [anon_sym_module] = ACTIONS(966),
    [anon_sym_static] = ACTIONS(966),
    [anon_sym_package] = ACTIONS(966),
    [anon_sym_import] = ACTIONS(966),
    [anon_sym_enum] = ACTIONS(966),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_abstract] = ACTIONS(966),
    [anon_sym_strictfp] = ACTIONS(966),
    [anon_sym_native] = ACTIONS(966),
    [anon_sym_transient] = ACTIONS(966),
    [anon_sym_volatile] = ACTIONS(966),
    [anon_sym_sealed] = ACTIONS(966),
    [anon_sym_non_DASHsealed] = ACTIONS(964),
    [anon_sym_record] = ACTIONS(966),
    [anon_sym_ATinterface] = ACTIONS(964),
    [anon_sym_interface] = ACTIONS(966),
    [anon_sym_byte] = ACTIONS(966),
    [anon_sym_short] = ACTIONS(966),
    [anon_sym_int] = ACTIONS(966),
    [anon_sym_long] = ACTIONS(966),
    [anon_sym_char] = ACTIONS(966),
    [anon_sym_float] = ACTIONS(966),
    [anon_sym_double] = ACTIONS(966),
    [sym_boolean_type] = ACTIONS(966),
    [sym_void_type] = ACTIONS(966),
    [sym_this] = ACTIONS(966),
    [sym_super] = ACTIONS(966),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(970),
    [sym_decimal_integer_literal] = ACTIONS(970),
    [sym_hex_integer_literal] = ACTIONS(970),
    [sym_octal_integer_literal] = ACTIONS(970),
    [sym_binary_integer_literal] = ACTIONS(968),
    [sym_decimal_floating_point_literal] = ACTIONS(968),
    [sym_hex_floating_point_literal] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_character_literal] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(968),
    [sym_null_literal] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_final] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_assert] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [anon_sym_synchronized] = ACTIONS(970),
    [anon_sym_throw] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(970),
    [anon_sym_open] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_package] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_strictfp] = ACTIONS(970),
    [anon_sym_native] = ACTIONS(970),
    [anon_sym_transient] = ACTIONS(970),
    [anon_sym_volatile] = ACTIONS(970),
    [anon_sym_sealed] = ACTIONS(970),
    [anon_sym_non_DASHsealed] = ACTIONS(968),
    [anon_sym_record] = ACTIONS(970),
    [anon_sym_ATinterface] = ACTIONS(968),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_byte] = ACTIONS(970),
    [anon_sym_short] = ACTIONS(970),
    [anon_sym_int] = ACTIONS(970),
    [anon_sym_long] = ACTIONS(970),
    [anon_sym_char] = ACTIONS(970),
    [anon_sym_float] = ACTIONS(970),
    [anon_sym_double] = ACTIONS(970),
    [sym_boolean_type] = ACTIONS(970),
    [sym_void_type] = ACTIONS(970),
    [sym_this] = ACTIONS(970),
    [sym_super] = ACTIONS(970),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(972),
    [sym_identifier] = ACTIONS(974),
    [sym_decimal_integer_literal] = ACTIONS(974),
    [sym_hex_integer_literal] = ACTIONS(974),
    [sym_octal_integer_literal] = ACTIONS(974),
    [sym_binary_integer_literal] = ACTIONS(972),
    [sym_decimal_floating_point_literal] = ACTIONS(972),
    [sym_hex_floating_point_literal] = ACTIONS(974),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_character_literal] = ACTIONS(972),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(972),
    [sym_null_literal] = ACTIONS(974),
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(974),
    [anon_sym_final] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(972),
    [anon_sym_TILDE] = ACTIONS(972),
    [anon_sym_PLUS_PLUS] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(972),
    [anon_sym_new] = ACTIONS(974),
    [anon_sym_class] = ACTIONS(974),
    [anon_sym_switch] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_default] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(972),
    [anon_sym_assert] = ACTIONS(974),
    [anon_sym_do] = ACTIONS(974),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_break] = ACTIONS(974),
    [anon_sym_continue] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(974),
    [anon_sym_yield] = ACTIONS(974),
    [anon_sym_synchronized] = ACTIONS(974),
    [anon_sym_throw] = ACTIONS(974),
    [anon_sym_try] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(974),
    [anon_sym_else] = ACTIONS(974),
    [anon_sym_for] = ACTIONS(974),
    [anon_sym_AT] = ACTIONS(974),
    [anon_sym_open] = ACTIONS(974),
    [anon_sym_module] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(974),
    [anon_sym_package] = ACTIONS(974),
    [anon_sym_import] = ACTIONS(974),
    [anon_sym_enum] = ACTIONS(974),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_abstract] = ACTIONS(974),
    [anon_sym_strictfp] = ACTIONS(974),
    [anon_sym_native] = ACTIONS(974),
    [anon_sym_transient] = ACTIONS(974),
    [anon_sym_volatile] = ACTIONS(974),
    [anon_sym_sealed] = ACTIONS(974),
    [anon_sym_non_DASHsealed] = ACTIONS(972),
    [anon_sym_record] = ACTIONS(974),
    [anon_sym_ATinterface] = ACTIONS(972),
    [anon_sym_interface] = ACTIONS(974),
    [anon_sym_byte] = ACTIONS(974),
    [anon_sym_short] = ACTIONS(974),
    [anon_sym_int] = ACTIONS(974),
    [anon_sym_long] = ACTIONS(974),
    [anon_sym_char] = ACTIONS(974),
    [anon_sym_float] = ACTIONS(974),
    [anon_sym_double] = ACTIONS(974),
    [sym_boolean_type] = ACTIONS(974),
    [sym_void_type] = ACTIONS(974),
    [sym_this] = ACTIONS(974),
    [sym_super] = ACTIONS(974),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(976),
    [sym_identifier] = ACTIONS(978),
    [sym_decimal_integer_literal] = ACTIONS(978),
    [sym_hex_integer_literal] = ACTIONS(978),
    [sym_octal_integer_literal] = ACTIONS(978),
    [sym_binary_integer_literal] = ACTIONS(976),
    [sym_decimal_floating_point_literal] = ACTIONS(976),
    [sym_hex_floating_point_literal] = ACTIONS(978),
    [sym_true] = ACTIONS(978),
    [sym_false] = ACTIONS(978),
    [sym_character_literal] = ACTIONS(976),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(976),
    [sym_null_literal] = ACTIONS(978),
    [anon_sym_LPAREN] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(978),
    [anon_sym_final] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(976),
    [anon_sym_TILDE] = ACTIONS(976),
    [anon_sym_PLUS_PLUS] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(976),
    [anon_sym_new] = ACTIONS(978),
    [anon_sym_class] = ACTIONS(978),
    [anon_sym_switch] = ACTIONS(978),
    [anon_sym_LBRACE] = ACTIONS(976),
    [anon_sym_RBRACE] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(978),
    [anon_sym_default] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(976),
    [anon_sym_assert] = ACTIONS(978),
    [anon_sym_do] = ACTIONS(978),
    [anon_sym_while] = ACTIONS(978),
    [anon_sym_break] = ACTIONS(978),
    [anon_sym_continue] = ACTIONS(978),
    [anon_sym_return] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(978),
    [anon_sym_synchronized] = ACTIONS(978),
    [anon_sym_throw] = ACTIONS(978),
    [anon_sym_try] = ACTIONS(978),
    [anon_sym_if] = ACTIONS(978),
    [anon_sym_else] = ACTIONS(978),
    [anon_sym_for] = ACTIONS(978),
    [anon_sym_AT] = ACTIONS(978),
    [anon_sym_open] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_package] = ACTIONS(978),
    [anon_sym_import] = ACTIONS(978),
    [anon_sym_enum] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_abstract] = ACTIONS(978),
    [anon_sym_strictfp] = ACTIONS(978),
    [anon_sym_native] = ACTIONS(978),
    [anon_sym_transient] = ACTIONS(978),
    [anon_sym_volatile] = ACTIONS(978),
    [anon_sym_sealed] = ACTIONS(978),
    [anon_sym_non_DASHsealed] = ACTIONS(976),
    [anon_sym_record] = ACTIONS(978),
    [anon_sym_ATinterface] = ACTIONS(976),
    [anon_sym_interface] = ACTIONS(978),
    [anon_sym_byte] = ACTIONS(978),
    [anon_sym_short] = ACTIONS(978),
    [anon_sym_int] = ACTIONS(978),
    [anon_sym_long] = ACTIONS(978),
    [anon_sym_char] = ACTIONS(978),
    [anon_sym_float] = ACTIONS(978),
    [anon_sym_double] = ACTIONS(978),
    [sym_boolean_type] = ACTIONS(978),
    [sym_void_type] = ACTIONS(978),
    [sym_this] = ACTIONS(978),
    [sym_super] = ACTIONS(978),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(980),
    [sym_identifier] = ACTIONS(982),
    [sym_decimal_integer_literal] = ACTIONS(982),
    [sym_hex_integer_literal] = ACTIONS(982),
    [sym_octal_integer_literal] = ACTIONS(982),
    [sym_binary_integer_literal] = ACTIONS(980),
    [sym_decimal_floating_point_literal] = ACTIONS(980),
    [sym_hex_floating_point_literal] = ACTIONS(982),
    [sym_true] = ACTIONS(982),
    [sym_false] = ACTIONS(982),
    [sym_character_literal] = ACTIONS(980),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(980),
    [sym_null_literal] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_final] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(980),
    [anon_sym_TILDE] = ACTIONS(980),
    [anon_sym_PLUS_PLUS] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(980),
    [anon_sym_new] = ACTIONS(982),
    [anon_sym_class] = ACTIONS(982),
    [anon_sym_switch] = ACTIONS(982),
    [anon_sym_LBRACE] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(982),
    [anon_sym_default] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(980),
    [anon_sym_assert] = ACTIONS(982),
    [anon_sym_do] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(982),
    [anon_sym_break] = ACTIONS(982),
    [anon_sym_continue] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(982),
    [anon_sym_yield] = ACTIONS(982),
    [anon_sym_synchronized] = ACTIONS(982),
    [anon_sym_throw] = ACTIONS(982),
    [anon_sym_try] = ACTIONS(982),
    [anon_sym_if] = ACTIONS(982),
    [anon_sym_else] = ACTIONS(982),
    [anon_sym_for] = ACTIONS(982),
    [anon_sym_AT] = ACTIONS(982),
    [anon_sym_open] = ACTIONS(982),
    [anon_sym_module] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(982),
    [anon_sym_package] = ACTIONS(982),
    [anon_sym_import] = ACTIONS(982),
    [anon_sym_enum] = ACTIONS(982),
    [anon_sym_public] = ACTIONS(982),
    [anon_sym_protected] = ACTIONS(982),
    [anon_sym_private] = ACTIONS(982),
    [anon_sym_abstract] = ACTIONS(982),
    [anon_sym_strictfp] = ACTIONS(982),
    [anon_sym_native] = ACTIONS(982),
    [anon_sym_transient] = ACTIONS(982),
    [anon_sym_volatile] = ACTIONS(982),
    [anon_sym_sealed] = ACTIONS(982),
    [anon_sym_non_DASHsealed] = ACTIONS(980),
    [anon_sym_record] = ACTIONS(982),
    [anon_sym_ATinterface] = ACTIONS(980),
    [anon_sym_interface] = ACTIONS(982),
    [anon_sym_byte] = ACTIONS(982),
    [anon_sym_short] = ACTIONS(982),
    [anon_sym_int] = ACTIONS(982),
    [anon_sym_long] = ACTIONS(982),
    [anon_sym_char] = ACTIONS(982),
    [anon_sym_float] = ACTIONS(982),
    [anon_sym_double] = ACTIONS(982),
    [sym_boolean_type] = ACTIONS(982),
    [sym_void_type] = ACTIONS(982),
    [sym_this] = ACTIONS(982),
    [sym_super] = ACTIONS(982),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(984),
    [sym_identifier] = ACTIONS(986),
    [sym_decimal_integer_literal] = ACTIONS(986),
    [sym_hex_integer_literal] = ACTIONS(986),
    [sym_octal_integer_literal] = ACTIONS(986),
    [sym_binary_integer_literal] = ACTIONS(984),
    [sym_decimal_floating_point_literal] = ACTIONS(984),
    [sym_hex_floating_point_literal] = ACTIONS(986),
    [sym_true] = ACTIONS(986),
    [sym_false] = ACTIONS(986),
    [sym_character_literal] = ACTIONS(984),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(984),
    [sym_null_literal] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_final] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(984),
    [anon_sym_PLUS_PLUS] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(984),
    [anon_sym_new] = ACTIONS(986),
    [anon_sym_class] = ACTIONS(986),
    [anon_sym_switch] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_RBRACE] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(986),
    [anon_sym_default] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(984),
    [anon_sym_assert] = ACTIONS(986),
    [anon_sym_do] = ACTIONS(986),
    [anon_sym_while] = ACTIONS(986),
    [anon_sym_break] = ACTIONS(986),
    [anon_sym_continue] = ACTIONS(986),
    [anon_sym_return] = ACTIONS(986),
    [anon_sym_yield] = ACTIONS(986),
    [anon_sym_synchronized] = ACTIONS(986),
    [anon_sym_throw] = ACTIONS(986),
    [anon_sym_try] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(986),
    [anon_sym_else] = ACTIONS(986),
    [anon_sym_for] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(986),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(986),
    [anon_sym_package] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(986),
    [anon_sym_enum] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(986),
    [anon_sym_private] = ACTIONS(986),
    [anon_sym_abstract] = ACTIONS(986),
    [anon_sym_strictfp] = ACTIONS(986),
    [anon_sym_native] = ACTIONS(986),
    [anon_sym_transient] = ACTIONS(986),
    [anon_sym_volatile] = ACTIONS(986),
    [anon_sym_sealed] = ACTIONS(986),
    [anon_sym_non_DASHsealed] = ACTIONS(984),
    [anon_sym_record] = ACTIONS(986),
    [anon_sym_ATinterface] = ACTIONS(984),
    [anon_sym_interface] = ACTIONS(986),
    [anon_sym_byte] = ACTIONS(986),
    [anon_sym_short] = ACTIONS(986),
    [anon_sym_int] = ACTIONS(986),
    [anon_sym_long] = ACTIONS(986),
    [anon_sym_char] = ACTIONS(986),
    [anon_sym_float] = ACTIONS(986),
    [anon_sym_double] = ACTIONS(986),
    [sym_boolean_type] = ACTIONS(986),
    [sym_void_type] = ACTIONS(986),
    [sym_this] = ACTIONS(986),
    [sym_super] = ACTIONS(986),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(988),
    [sym_identifier] = ACTIONS(990),
    [sym_decimal_integer_literal] = ACTIONS(990),
    [sym_hex_integer_literal] = ACTIONS(990),
    [sym_octal_integer_literal] = ACTIONS(990),
    [sym_binary_integer_literal] = ACTIONS(988),
    [sym_decimal_floating_point_literal] = ACTIONS(988),
    [sym_hex_floating_point_literal] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_character_literal] = ACTIONS(988),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(988),
    [sym_null_literal] = ACTIONS(990),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(990),
    [anon_sym_final] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(988),
    [anon_sym_TILDE] = ACTIONS(988),
    [anon_sym_PLUS_PLUS] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(988),
    [anon_sym_new] = ACTIONS(990),
    [anon_sym_class] = ACTIONS(990),
    [anon_sym_switch] = ACTIONS(990),
    [anon_sym_LBRACE] = ACTIONS(988),
    [anon_sym_RBRACE] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(990),
    [anon_sym_default] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(988),
    [anon_sym_assert] = ACTIONS(990),
    [anon_sym_do] = ACTIONS(990),
    [anon_sym_while] = ACTIONS(990),
    [anon_sym_break] = ACTIONS(990),
    [anon_sym_continue] = ACTIONS(990),
    [anon_sym_return] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(990),
    [anon_sym_synchronized] = ACTIONS(990),
    [anon_sym_throw] = ACTIONS(990),
    [anon_sym_try] = ACTIONS(990),
    [anon_sym_if] = ACTIONS(990),
    [anon_sym_else] = ACTIONS(990),
    [anon_sym_for] = ACTIONS(990),
    [anon_sym_AT] = ACTIONS(990),
    [anon_sym_open] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_package] = ACTIONS(990),
    [anon_sym_import] = ACTIONS(990),
    [anon_sym_enum] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_abstract] = ACTIONS(990),
    [anon_sym_strictfp] = ACTIONS(990),
    [anon_sym_native] = ACTIONS(990),
    [anon_sym_transient] = ACTIONS(990),
    [anon_sym_volatile] = ACTIONS(990),
    [anon_sym_sealed] = ACTIONS(990),
    [anon_sym_non_DASHsealed] = ACTIONS(988),
    [anon_sym_record] = ACTIONS(990),
    [anon_sym_ATinterface] = ACTIONS(988),
    [anon_sym_interface] = ACTIONS(990),
    [anon_sym_byte] = ACTIONS(990),
    [anon_sym_short] = ACTIONS(990),
    [anon_sym_int] = ACTIONS(990),
    [anon_sym_long] = ACTIONS(990),
    [anon_sym_char] = ACTIONS(990),
    [anon_sym_float] = ACTIONS(990),
    [anon_sym_double] = ACTIONS(990),
    [sym_boolean_type] = ACTIONS(990),
    [sym_void_type] = ACTIONS(990),
    [sym_this] = ACTIONS(990),
    [sym_super] = ACTIONS(990),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(992),
    [sym_identifier] = ACTIONS(994),
    [sym_decimal_integer_literal] = ACTIONS(994),
    [sym_hex_integer_literal] = ACTIONS(994),
    [sym_octal_integer_literal] = ACTIONS(994),
    [sym_binary_integer_literal] = ACTIONS(992),
    [sym_decimal_floating_point_literal] = ACTIONS(992),
    [sym_hex_floating_point_literal] = ACTIONS(994),
    [sym_true] = ACTIONS(994),
    [sym_false] = ACTIONS(994),
    [sym_character_literal] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(992),
    [sym_null_literal] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_final] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_PLUS_PLUS] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(992),
    [anon_sym_new] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(994),
    [anon_sym_switch] = ACTIONS(994),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_RBRACE] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(994),
    [anon_sym_default] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(992),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(994),
    [anon_sym_while] = ACTIONS(994),
    [anon_sym_break] = ACTIONS(994),
    [anon_sym_continue] = ACTIONS(994),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_synchronized] = ACTIONS(994),
    [anon_sym_throw] = ACTIONS(994),
    [anon_sym_try] = ACTIONS(994),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_else] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(994),
    [anon_sym_open] = ACTIONS(994),
    [anon_sym_module] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(994),
    [anon_sym_package] = ACTIONS(994),
    [anon_sym_import] = ACTIONS(994),
    [anon_sym_enum] = ACTIONS(994),
    [anon_sym_public] = ACTIONS(994),
    [anon_sym_protected] = ACTIONS(994),
    [anon_sym_private] = ACTIONS(994),
    [anon_sym_abstract] = ACTIONS(994),
    [anon_sym_strictfp] = ACTIONS(994),
    [anon_sym_native] = ACTIONS(994),
    [anon_sym_transient] = ACTIONS(994),
    [anon_sym_volatile] = ACTIONS(994),
    [anon_sym_sealed] = ACTIONS(994),
    [anon_sym_non_DASHsealed] = ACTIONS(992),
    [anon_sym_record] = ACTIONS(994),
    [anon_sym_ATinterface] = ACTIONS(992),
    [anon_sym_interface] = ACTIONS(994),
    [anon_sym_byte] = ACTIONS(994),
    [anon_sym_short] = ACTIONS(994),
    [anon_sym_int] = ACTIONS(994),
    [anon_sym_long] = ACTIONS(994),
    [anon_sym_char] = ACTIONS(994),
    [anon_sym_float] = ACTIONS(994),
    [anon_sym_double] = ACTIONS(994),
    [sym_boolean_type] = ACTIONS(994),
    [sym_void_type] = ACTIONS(994),
    [sym_this] = ACTIONS(994),
    [sym_super] = ACTIONS(994),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [337] = {
    [ts_builtin_sym_end] = ACTIONS(996),
    [sym_identifier] = ACTIONS(998),
    [sym_decimal_integer_literal] = ACTIONS(998),
    [sym_hex_integer_literal] = ACTIONS(998),
    [sym_octal_integer_literal] = ACTIONS(998),
    [sym_binary_integer_literal] = ACTIONS(996),
    [sym_decimal_floating_point_literal] = ACTIONS(996),
    [sym_hex_floating_point_literal] = ACTIONS(998),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_character_literal] = ACTIONS(996),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(996),
    [sym_null_literal] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(998),
    [anon_sym_final] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_PLUS_PLUS] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(996),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_class] = ACTIONS(998),
    [anon_sym_switch] = ACTIONS(998),
    [anon_sym_LBRACE] = ACTIONS(996),
    [anon_sym_RBRACE] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(998),
    [anon_sym_default] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(996),
    [anon_sym_assert] = ACTIONS(998),
    [anon_sym_do] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(998),
    [anon_sym_synchronized] = ACTIONS(998),
    [anon_sym_throw] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_else] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_AT] = ACTIONS(998),
    [anon_sym_open] = ACTIONS(998),
    [anon_sym_module] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(998),
    [anon_sym_package] = ACTIONS(998),
    [anon_sym_import] = ACTIONS(998),
    [anon_sym_enum] = ACTIONS(998),
    [anon_sym_public] = ACTIONS(998),
    [anon_sym_protected] = ACTIONS(998),
    [anon_sym_private] = ACTIONS(998),
    [anon_sym_abstract] = ACTIONS(998),
    [anon_sym_strictfp] = ACTIONS(998),
    [anon_sym_native] = ACTIONS(998),
    [anon_sym_transient] = ACTIONS(998),
    [anon_sym_volatile] = ACTIONS(998),
    [anon_sym_sealed] = ACTIONS(998),
    [anon_sym_non_DASHsealed] = ACTIONS(996),
    [anon_sym_record] = ACTIONS(998),
    [anon_sym_ATinterface] = ACTIONS(996),
    [anon_sym_interface] = ACTIONS(998),
    [anon_sym_byte] = ACTIONS(998),
    [anon_sym_short] = ACTIONS(998),
    [anon_sym_int] = ACTIONS(998),
    [anon_sym_long] = ACTIONS(998),
    [anon_sym_char] = ACTIONS(998),
    [anon_sym_float] = ACTIONS(998),
    [anon_sym_double] = ACTIONS(998),
    [sym_boolean_type] = ACTIONS(998),
    [sym_void_type] = ACTIONS(998),
    [sym_this] = ACTIONS(998),
    [sym_super] = ACTIONS(998),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(1000),
    [sym_identifier] = ACTIONS(1002),
    [sym_decimal_integer_literal] = ACTIONS(1002),
    [sym_hex_integer_literal] = ACTIONS(1002),
    [sym_octal_integer_literal] = ACTIONS(1002),
    [sym_binary_integer_literal] = ACTIONS(1000),
    [sym_decimal_floating_point_literal] = ACTIONS(1000),
    [sym_hex_floating_point_literal] = ACTIONS(1002),
    [sym_true] = ACTIONS(1002),
    [sym_false] = ACTIONS(1002),
    [sym_character_literal] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1000),
    [sym_null_literal] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1002),
    [anon_sym_final] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1000),
    [anon_sym_TILDE] = ACTIONS(1000),
    [anon_sym_PLUS_PLUS] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_class] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_RBRACE] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1002),
    [anon_sym_default] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1000),
    [anon_sym_assert] = ACTIONS(1002),
    [anon_sym_do] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1002),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_yield] = ACTIONS(1002),
    [anon_sym_synchronized] = ACTIONS(1002),
    [anon_sym_throw] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_if] = ACTIONS(1002),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_AT] = ACTIONS(1002),
    [anon_sym_open] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_package] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1002),
    [anon_sym_enum] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_abstract] = ACTIONS(1002),
    [anon_sym_strictfp] = ACTIONS(1002),
    [anon_sym_native] = ACTIONS(1002),
    [anon_sym_transient] = ACTIONS(1002),
    [anon_sym_volatile] = ACTIONS(1002),
    [anon_sym_sealed] = ACTIONS(1002),
    [anon_sym_non_DASHsealed] = ACTIONS(1000),
    [anon_sym_record] = ACTIONS(1002),
    [anon_sym_ATinterface] = ACTIONS(1000),
    [anon_sym_interface] = ACTIONS(1002),
    [anon_sym_byte] = ACTIONS(1002),
    [anon_sym_short] = ACTIONS(1002),
    [anon_sym_int] = ACTIONS(1002),
    [anon_sym_long] = ACTIONS(1002),
    [anon_sym_char] = ACTIONS(1002),
    [anon_sym_float] = ACTIONS(1002),
    [anon_sym_double] = ACTIONS(1002),
    [sym_boolean_type] = ACTIONS(1002),
    [sym_void_type] = ACTIONS(1002),
    [sym_this] = ACTIONS(1002),
    [sym_super] = ACTIONS(1002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [339] = {
    [ts_builtin_sym_end] = ACTIONS(1004),
    [sym_identifier] = ACTIONS(1006),
    [sym_decimal_integer_literal] = ACTIONS(1006),
    [sym_hex_integer_literal] = ACTIONS(1006),
    [sym_octal_integer_literal] = ACTIONS(1006),
    [sym_binary_integer_literal] = ACTIONS(1004),
    [sym_decimal_floating_point_literal] = ACTIONS(1004),
    [sym_hex_floating_point_literal] = ACTIONS(1006),
    [sym_true] = ACTIONS(1006),
    [sym_false] = ACTIONS(1006),
    [sym_character_literal] = ACTIONS(1004),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1004),
    [sym_null_literal] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1006),
    [anon_sym_final] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_PLUS_PLUS] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1004),
    [anon_sym_new] = ACTIONS(1006),
    [anon_sym_class] = ACTIONS(1006),
    [anon_sym_switch] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(1004),
    [anon_sym_RBRACE] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1006),
    [anon_sym_default] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1004),
    [anon_sym_assert] = ACTIONS(1006),
    [anon_sym_do] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(1006),
    [anon_sym_break] = ACTIONS(1006),
    [anon_sym_continue] = ACTIONS(1006),
    [anon_sym_return] = ACTIONS(1006),
    [anon_sym_yield] = ACTIONS(1006),
    [anon_sym_synchronized] = ACTIONS(1006),
    [anon_sym_throw] = ACTIONS(1006),
    [anon_sym_try] = ACTIONS(1006),
    [anon_sym_if] = ACTIONS(1006),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_for] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(1006),
    [anon_sym_open] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1006),
    [anon_sym_package] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_enum] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_abstract] = ACTIONS(1006),
    [anon_sym_strictfp] = ACTIONS(1006),
    [anon_sym_native] = ACTIONS(1006),
    [anon_sym_transient] = ACTIONS(1006),
    [anon_sym_volatile] = ACTIONS(1006),
    [anon_sym_sealed] = ACTIONS(1006),
    [anon_sym_non_DASHsealed] = ACTIONS(1004),
    [anon_sym_record] = ACTIONS(1006),
    [anon_sym_ATinterface] = ACTIONS(1004),
    [anon_sym_interface] = ACTIONS(1006),
    [anon_sym_byte] = ACTIONS(1006),
    [anon_sym_short] = ACTIONS(1006),
    [anon_sym_int] = ACTIONS(1006),
    [anon_sym_long] = ACTIONS(1006),
    [anon_sym_char] = ACTIONS(1006),
    [anon_sym_float] = ACTIONS(1006),
    [anon_sym_double] = ACTIONS(1006),
    [sym_boolean_type] = ACTIONS(1006),
    [sym_void_type] = ACTIONS(1006),
    [sym_this] = ACTIONS(1006),
    [sym_super] = ACTIONS(1006),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(1008),
    [sym_identifier] = ACTIONS(1010),
    [sym_decimal_integer_literal] = ACTIONS(1010),
    [sym_hex_integer_literal] = ACTIONS(1010),
    [sym_octal_integer_literal] = ACTIONS(1010),
    [sym_binary_integer_literal] = ACTIONS(1008),
    [sym_decimal_floating_point_literal] = ACTIONS(1008),
    [sym_hex_floating_point_literal] = ACTIONS(1010),
    [sym_true] = ACTIONS(1010),
    [sym_false] = ACTIONS(1010),
    [sym_character_literal] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1008),
    [sym_null_literal] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1010),
    [anon_sym_final] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_PLUS_PLUS] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1008),
    [anon_sym_new] = ACTIONS(1010),
    [anon_sym_class] = ACTIONS(1010),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1008),
    [anon_sym_RBRACE] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1010),
    [anon_sym_default] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1008),
    [anon_sym_assert] = ACTIONS(1010),
    [anon_sym_do] = ACTIONS(1010),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1010),
    [anon_sym_synchronized] = ACTIONS(1010),
    [anon_sym_throw] = ACTIONS(1010),
    [anon_sym_try] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1010),
    [anon_sym_else] = ACTIONS(1010),
    [anon_sym_for] = ACTIONS(1010),
    [anon_sym_AT] = ACTIONS(1010),
    [anon_sym_open] = ACTIONS(1010),
    [anon_sym_module] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1010),
    [anon_sym_package] = ACTIONS(1010),
    [anon_sym_import] = ACTIONS(1010),
    [anon_sym_enum] = ACTIONS(1010),
    [anon_sym_public] = ACTIONS(1010),
    [anon_sym_protected] = ACTIONS(1010),
    [anon_sym_private] = ACTIONS(1010),
    [anon_sym_abstract] = ACTIONS(1010),
    [anon_sym_strictfp] = ACTIONS(1010),
    [anon_sym_native] = ACTIONS(1010),
    [anon_sym_transient] = ACTIONS(1010),
    [anon_sym_volatile] = ACTIONS(1010),
    [anon_sym_sealed] = ACTIONS(1010),
    [anon_sym_non_DASHsealed] = ACTIONS(1008),
    [anon_sym_record] = ACTIONS(1010),
    [anon_sym_ATinterface] = ACTIONS(1008),
    [anon_sym_interface] = ACTIONS(1010),
    [anon_sym_byte] = ACTIONS(1010),
    [anon_sym_short] = ACTIONS(1010),
    [anon_sym_int] = ACTIONS(1010),
    [anon_sym_long] = ACTIONS(1010),
    [anon_sym_char] = ACTIONS(1010),
    [anon_sym_float] = ACTIONS(1010),
    [anon_sym_double] = ACTIONS(1010),
    [sym_boolean_type] = ACTIONS(1010),
    [sym_void_type] = ACTIONS(1010),
    [sym_this] = ACTIONS(1010),
    [sym_super] = ACTIONS(1010),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(1012),
    [sym_identifier] = ACTIONS(1014),
    [sym_decimal_integer_literal] = ACTIONS(1014),
    [sym_hex_integer_literal] = ACTIONS(1014),
    [sym_octal_integer_literal] = ACTIONS(1014),
    [sym_binary_integer_literal] = ACTIONS(1012),
    [sym_decimal_floating_point_literal] = ACTIONS(1012),
    [sym_hex_floating_point_literal] = ACTIONS(1014),
    [sym_true] = ACTIONS(1014),
    [sym_false] = ACTIONS(1014),
    [sym_character_literal] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1012),
    [sym_null_literal] = ACTIONS(1014),
    [anon_sym_LPAREN] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1014),
    [anon_sym_final] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1012),
    [anon_sym_TILDE] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1012),
    [anon_sym_new] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(1014),
    [anon_sym_switch] = ACTIONS(1014),
    [anon_sym_LBRACE] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1014),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_assert] = ACTIONS(1014),
    [anon_sym_do] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1014),
    [anon_sym_break] = ACTIONS(1014),
    [anon_sym_continue] = ACTIONS(1014),
    [anon_sym_return] = ACTIONS(1014),
    [anon_sym_yield] = ACTIONS(1014),
    [anon_sym_synchronized] = ACTIONS(1014),
    [anon_sym_throw] = ACTIONS(1014),
    [anon_sym_try] = ACTIONS(1014),
    [anon_sym_if] = ACTIONS(1014),
    [anon_sym_else] = ACTIONS(1014),
    [anon_sym_for] = ACTIONS(1014),
    [anon_sym_AT] = ACTIONS(1014),
    [anon_sym_open] = ACTIONS(1014),
    [anon_sym_module] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1014),
    [anon_sym_package] = ACTIONS(1014),
    [anon_sym_import] = ACTIONS(1014),
    [anon_sym_enum] = ACTIONS(1014),
    [anon_sym_public] = ACTIONS(1014),
    [anon_sym_protected] = ACTIONS(1014),
    [anon_sym_private] = ACTIONS(1014),
    [anon_sym_abstract] = ACTIONS(1014),
    [anon_sym_strictfp] = ACTIONS(1014),
    [anon_sym_native] = ACTIONS(1014),
    [anon_sym_transient] = ACTIONS(1014),
    [anon_sym_volatile] = ACTIONS(1014),
    [anon_sym_sealed] = ACTIONS(1014),
    [anon_sym_non_DASHsealed] = ACTIONS(1012),
    [anon_sym_record] = ACTIONS(1014),
    [anon_sym_ATinterface] = ACTIONS(1012),
    [anon_sym_interface] = ACTIONS(1014),
    [anon_sym_byte] = ACTIONS(1014),
    [anon_sym_short] = ACTIONS(1014),
    [anon_sym_int] = ACTIONS(1014),
    [anon_sym_long] = ACTIONS(1014),
    [anon_sym_char] = ACTIONS(1014),
    [anon_sym_float] = ACTIONS(1014),
    [anon_sym_double] = ACTIONS(1014),
    [sym_boolean_type] = ACTIONS(1014),
    [sym_void_type] = ACTIONS(1014),
    [sym_this] = ACTIONS(1014),
    [sym_super] = ACTIONS(1014),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(1016),
    [sym_identifier] = ACTIONS(1018),
    [sym_decimal_integer_literal] = ACTIONS(1018),
    [sym_hex_integer_literal] = ACTIONS(1018),
    [sym_octal_integer_literal] = ACTIONS(1018),
    [sym_binary_integer_literal] = ACTIONS(1016),
    [sym_decimal_floating_point_literal] = ACTIONS(1016),
    [sym_hex_floating_point_literal] = ACTIONS(1018),
    [sym_true] = ACTIONS(1018),
    [sym_false] = ACTIONS(1018),
    [sym_character_literal] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1016),
    [sym_null_literal] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_final] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS_PLUS] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_new] = ACTIONS(1018),
    [anon_sym_class] = ACTIONS(1018),
    [anon_sym_switch] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1018),
    [anon_sym_default] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1016),
    [anon_sym_assert] = ACTIONS(1018),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_while] = ACTIONS(1018),
    [anon_sym_break] = ACTIONS(1018),
    [anon_sym_continue] = ACTIONS(1018),
    [anon_sym_return] = ACTIONS(1018),
    [anon_sym_yield] = ACTIONS(1018),
    [anon_sym_synchronized] = ACTIONS(1018),
    [anon_sym_throw] = ACTIONS(1018),
    [anon_sym_try] = ACTIONS(1018),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_else] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1018),
    [anon_sym_open] = ACTIONS(1018),
    [anon_sym_module] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1018),
    [anon_sym_package] = ACTIONS(1018),
    [anon_sym_import] = ACTIONS(1018),
    [anon_sym_enum] = ACTIONS(1018),
    [anon_sym_public] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1018),
    [anon_sym_private] = ACTIONS(1018),
    [anon_sym_abstract] = ACTIONS(1018),
    [anon_sym_strictfp] = ACTIONS(1018),
    [anon_sym_native] = ACTIONS(1018),
    [anon_sym_transient] = ACTIONS(1018),
    [anon_sym_volatile] = ACTIONS(1018),
    [anon_sym_sealed] = ACTIONS(1018),
    [anon_sym_non_DASHsealed] = ACTIONS(1016),
    [anon_sym_record] = ACTIONS(1018),
    [anon_sym_ATinterface] = ACTIONS(1016),
    [anon_sym_interface] = ACTIONS(1018),
    [anon_sym_byte] = ACTIONS(1018),
    [anon_sym_short] = ACTIONS(1018),
    [anon_sym_int] = ACTIONS(1018),
    [anon_sym_long] = ACTIONS(1018),
    [anon_sym_char] = ACTIONS(1018),
    [anon_sym_float] = ACTIONS(1018),
    [anon_sym_double] = ACTIONS(1018),
    [sym_boolean_type] = ACTIONS(1018),
    [sym_void_type] = ACTIONS(1018),
    [sym_this] = ACTIONS(1018),
    [sym_super] = ACTIONS(1018),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(1020),
    [sym_identifier] = ACTIONS(1022),
    [sym_decimal_integer_literal] = ACTIONS(1022),
    [sym_hex_integer_literal] = ACTIONS(1022),
    [sym_octal_integer_literal] = ACTIONS(1022),
    [sym_binary_integer_literal] = ACTIONS(1020),
    [sym_decimal_floating_point_literal] = ACTIONS(1020),
    [sym_hex_floating_point_literal] = ACTIONS(1022),
    [sym_true] = ACTIONS(1022),
    [sym_false] = ACTIONS(1022),
    [sym_character_literal] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1020),
    [sym_null_literal] = ACTIONS(1022),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_final] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS_PLUS] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1020),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_class] = ACTIONS(1022),
    [anon_sym_switch] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1022),
    [anon_sym_default] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1020),
    [anon_sym_assert] = ACTIONS(1022),
    [anon_sym_do] = ACTIONS(1022),
    [anon_sym_while] = ACTIONS(1022),
    [anon_sym_break] = ACTIONS(1022),
    [anon_sym_continue] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1022),
    [anon_sym_yield] = ACTIONS(1022),
    [anon_sym_synchronized] = ACTIONS(1022),
    [anon_sym_throw] = ACTIONS(1022),
    [anon_sym_try] = ACTIONS(1022),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_else] = ACTIONS(1022),
    [anon_sym_for] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1022),
    [anon_sym_open] = ACTIONS(1022),
    [anon_sym_module] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1022),
    [anon_sym_package] = ACTIONS(1022),
    [anon_sym_import] = ACTIONS(1022),
    [anon_sym_enum] = ACTIONS(1022),
    [anon_sym_public] = ACTIONS(1022),
    [anon_sym_protected] = ACTIONS(1022),
    [anon_sym_private] = ACTIONS(1022),
    [anon_sym_abstract] = ACTIONS(1022),
    [anon_sym_strictfp] = ACTIONS(1022),
    [anon_sym_native] = ACTIONS(1022),
    [anon_sym_transient] = ACTIONS(1022),
    [anon_sym_volatile] = ACTIONS(1022),
    [anon_sym_sealed] = ACTIONS(1022),
    [anon_sym_non_DASHsealed] = ACTIONS(1020),
    [anon_sym_record] = ACTIONS(1022),
    [anon_sym_ATinterface] = ACTIONS(1020),
    [anon_sym_interface] = ACTIONS(1022),
    [anon_sym_byte] = ACTIONS(1022),
    [anon_sym_short] = ACTIONS(1022),
    [anon_sym_int] = ACTIONS(1022),
    [anon_sym_long] = ACTIONS(1022),
    [anon_sym_char] = ACTIONS(1022),
    [anon_sym_float] = ACTIONS(1022),
    [anon_sym_double] = ACTIONS(1022),
    [sym_boolean_type] = ACTIONS(1022),
    [sym_void_type] = ACTIONS(1022),
    [sym_this] = ACTIONS(1022),
    [sym_super] = ACTIONS(1022),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(1024),
    [sym_identifier] = ACTIONS(1026),
    [sym_decimal_integer_literal] = ACTIONS(1026),
    [sym_hex_integer_literal] = ACTIONS(1026),
    [sym_octal_integer_literal] = ACTIONS(1026),
    [sym_binary_integer_literal] = ACTIONS(1024),
    [sym_decimal_floating_point_literal] = ACTIONS(1024),
    [sym_hex_floating_point_literal] = ACTIONS(1026),
    [sym_true] = ACTIONS(1026),
    [sym_false] = ACTIONS(1026),
    [sym_character_literal] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1024),
    [sym_null_literal] = ACTIONS(1026),
    [anon_sym_LPAREN] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_final] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1024),
    [anon_sym_new] = ACTIONS(1026),
    [anon_sym_class] = ACTIONS(1026),
    [anon_sym_switch] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1026),
    [anon_sym_default] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1024),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1026),
    [anon_sym_while] = ACTIONS(1026),
    [anon_sym_break] = ACTIONS(1026),
    [anon_sym_continue] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_synchronized] = ACTIONS(1026),
    [anon_sym_throw] = ACTIONS(1026),
    [anon_sym_try] = ACTIONS(1026),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_else] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1026),
    [anon_sym_open] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_package] = ACTIONS(1026),
    [anon_sym_import] = ACTIONS(1026),
    [anon_sym_enum] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(1026),
    [anon_sym_strictfp] = ACTIONS(1026),
    [anon_sym_native] = ACTIONS(1026),
    [anon_sym_transient] = ACTIONS(1026),
    [anon_sym_volatile] = ACTIONS(1026),
    [anon_sym_sealed] = ACTIONS(1026),
    [anon_sym_non_DASHsealed] = ACTIONS(1024),
    [anon_sym_record] = ACTIONS(1026),
    [anon_sym_ATinterface] = ACTIONS(1024),
    [anon_sym_interface] = ACTIONS(1026),
    [anon_sym_byte] = ACTIONS(1026),
    [anon_sym_short] = ACTIONS(1026),
    [anon_sym_int] = ACTIONS(1026),
    [anon_sym_long] = ACTIONS(1026),
    [anon_sym_char] = ACTIONS(1026),
    [anon_sym_float] = ACTIONS(1026),
    [anon_sym_double] = ACTIONS(1026),
    [sym_boolean_type] = ACTIONS(1026),
    [sym_void_type] = ACTIONS(1026),
    [sym_this] = ACTIONS(1026),
    [sym_super] = ACTIONS(1026),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(1028),
    [sym_identifier] = ACTIONS(1030),
    [sym_decimal_integer_literal] = ACTIONS(1030),
    [sym_hex_integer_literal] = ACTIONS(1030),
    [sym_octal_integer_literal] = ACTIONS(1030),
    [sym_binary_integer_literal] = ACTIONS(1028),
    [sym_decimal_floating_point_literal] = ACTIONS(1028),
    [sym_hex_floating_point_literal] = ACTIONS(1030),
    [sym_true] = ACTIONS(1030),
    [sym_false] = ACTIONS(1030),
    [sym_character_literal] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1028),
    [sym_null_literal] = ACTIONS(1030),
    [anon_sym_LPAREN] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_final] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_PLUS] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1028),
    [anon_sym_new] = ACTIONS(1030),
    [anon_sym_class] = ACTIONS(1030),
    [anon_sym_switch] = ACTIONS(1030),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_RBRACE] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1030),
    [anon_sym_default] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1028),
    [anon_sym_assert] = ACTIONS(1030),
    [anon_sym_do] = ACTIONS(1030),
    [anon_sym_while] = ACTIONS(1030),
    [anon_sym_break] = ACTIONS(1030),
    [anon_sym_continue] = ACTIONS(1030),
    [anon_sym_return] = ACTIONS(1030),
    [anon_sym_yield] = ACTIONS(1030),
    [anon_sym_synchronized] = ACTIONS(1030),
    [anon_sym_throw] = ACTIONS(1030),
    [anon_sym_try] = ACTIONS(1030),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_else] = ACTIONS(1030),
    [anon_sym_for] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1030),
    [anon_sym_open] = ACTIONS(1030),
    [anon_sym_module] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1030),
    [anon_sym_package] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(1030),
    [anon_sym_enum] = ACTIONS(1030),
    [anon_sym_public] = ACTIONS(1030),
    [anon_sym_protected] = ACTIONS(1030),
    [anon_sym_private] = ACTIONS(1030),
    [anon_sym_abstract] = ACTIONS(1030),
    [anon_sym_strictfp] = ACTIONS(1030),
    [anon_sym_native] = ACTIONS(1030),
    [anon_sym_transient] = ACTIONS(1030),
    [anon_sym_volatile] = ACTIONS(1030),
    [anon_sym_sealed] = ACTIONS(1030),
    [anon_sym_non_DASHsealed] = ACTIONS(1028),
    [anon_sym_record] = ACTIONS(1030),
    [anon_sym_ATinterface] = ACTIONS(1028),
    [anon_sym_interface] = ACTIONS(1030),
    [anon_sym_byte] = ACTIONS(1030),
    [anon_sym_short] = ACTIONS(1030),
    [anon_sym_int] = ACTIONS(1030),
    [anon_sym_long] = ACTIONS(1030),
    [anon_sym_char] = ACTIONS(1030),
    [anon_sym_float] = ACTIONS(1030),
    [anon_sym_double] = ACTIONS(1030),
    [sym_boolean_type] = ACTIONS(1030),
    [sym_void_type] = ACTIONS(1030),
    [sym_this] = ACTIONS(1030),
    [sym_super] = ACTIONS(1030),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(1032),
    [sym_identifier] = ACTIONS(1034),
    [sym_decimal_integer_literal] = ACTIONS(1034),
    [sym_hex_integer_literal] = ACTIONS(1034),
    [sym_octal_integer_literal] = ACTIONS(1034),
    [sym_binary_integer_literal] = ACTIONS(1032),
    [sym_decimal_floating_point_literal] = ACTIONS(1032),
    [sym_hex_floating_point_literal] = ACTIONS(1034),
    [sym_true] = ACTIONS(1034),
    [sym_false] = ACTIONS(1034),
    [sym_character_literal] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1032),
    [sym_null_literal] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1034),
    [anon_sym_final] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1032),
    [anon_sym_TILDE] = ACTIONS(1032),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_new] = ACTIONS(1034),
    [anon_sym_class] = ACTIONS(1034),
    [anon_sym_switch] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [anon_sym_RBRACE] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1034),
    [anon_sym_default] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1032),
    [anon_sym_assert] = ACTIONS(1034),
    [anon_sym_do] = ACTIONS(1034),
    [anon_sym_while] = ACTIONS(1034),
    [anon_sym_break] = ACTIONS(1034),
    [anon_sym_continue] = ACTIONS(1034),
    [anon_sym_return] = ACTIONS(1034),
    [anon_sym_yield] = ACTIONS(1034),
    [anon_sym_synchronized] = ACTIONS(1034),
    [anon_sym_throw] = ACTIONS(1034),
    [anon_sym_try] = ACTIONS(1034),
    [anon_sym_if] = ACTIONS(1034),
    [anon_sym_else] = ACTIONS(1034),
    [anon_sym_for] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(1034),
    [anon_sym_open] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_package] = ACTIONS(1034),
    [anon_sym_import] = ACTIONS(1034),
    [anon_sym_enum] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_abstract] = ACTIONS(1034),
    [anon_sym_strictfp] = ACTIONS(1034),
    [anon_sym_native] = ACTIONS(1034),
    [anon_sym_transient] = ACTIONS(1034),
    [anon_sym_volatile] = ACTIONS(1034),
    [anon_sym_sealed] = ACTIONS(1034),
    [anon_sym_non_DASHsealed] = ACTIONS(1032),
    [anon_sym_record] = ACTIONS(1034),
    [anon_sym_ATinterface] = ACTIONS(1032),
    [anon_sym_interface] = ACTIONS(1034),
    [anon_sym_byte] = ACTIONS(1034),
    [anon_sym_short] = ACTIONS(1034),
    [anon_sym_int] = ACTIONS(1034),
    [anon_sym_long] = ACTIONS(1034),
    [anon_sym_char] = ACTIONS(1034),
    [anon_sym_float] = ACTIONS(1034),
    [anon_sym_double] = ACTIONS(1034),
    [sym_boolean_type] = ACTIONS(1034),
    [sym_void_type] = ACTIONS(1034),
    [sym_this] = ACTIONS(1034),
    [sym_super] = ACTIONS(1034),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [347] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_primary_expression] = STATE(1073),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(912),
    [sym_array_access] = STATE(507),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_resource] = STATE(1127),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(721),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(742),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(758),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_new] = ACTIONS(764),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(766),
    [anon_sym_module] = ACTIONS(766),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(766),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [348] = {
    [sym__literal] = STATE(507),
    [sym_string_literal] = STATE(510),
    [sym__string_literal] = STATE(498),
    [sym__multiline_string_literal] = STATE(498),
    [sym_primary_expression] = STATE(1073),
    [sym_array_creation_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_class_literal] = STATE(507),
    [sym_object_creation_expression] = STATE(507),
    [sym__unqualified_object_creation_expression] = STATE(483),
    [sym_field_access] = STATE(912),
    [sym_array_access] = STATE(507),
    [sym_method_invocation] = STATE(507),
    [sym_method_reference] = STATE(507),
    [sym_resource] = STATE(1072),
    [sym__annotation] = STATE(628),
    [sym_marker_annotation] = STATE(628),
    [sym_annotation] = STATE(628),
    [sym_modifiers] = STATE(721),
    [sym__type] = STATE(1266),
    [sym__unannotated_type] = STATE(742),
    [sym_annotated_type] = STATE(797),
    [sym_scoped_type_identifier] = STATE(745),
    [sym_generic_type] = STATE(771),
    [sym_array_type] = STATE(702),
    [sym_integral_type] = STATE(702),
    [sym_floating_point_type] = STATE(702),
    [aux_sym_array_creation_expression_repeat1] = STATE(683),
    [aux_sym_modifiers_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(758),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(9),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(15),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_final] = ACTIONS(291),
    [anon_sym_new] = ACTIONS(764),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_synchronized] = ACTIONS(291),
    [anon_sym_AT] = ACTIONS(293),
    [anon_sym_open] = ACTIONS(766),
    [anon_sym_module] = ACTIONS(766),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_abstract] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_native] = ACTIONS(291),
    [anon_sym_transient] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_sealed] = ACTIONS(291),
    [anon_sym_non_DASHsealed] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(766),
    [anon_sym_byte] = ACTIONS(81),
    [anon_sym_short] = ACTIONS(81),
    [anon_sym_int] = ACTIONS(81),
    [anon_sym_long] = ACTIONS(81),
    [anon_sym_char] = ACTIONS(81),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_double] = ACTIONS(83),
    [sym_boolean_type] = ACTIONS(85),
    [sym_void_type] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_identifier] = ACTIONS(748),
    [sym_decimal_integer_literal] = ACTIONS(748),
    [sym_hex_integer_literal] = ACTIONS(748),
    [sym_octal_integer_literal] = ACTIONS(748),
    [sym_binary_integer_literal] = ACTIONS(750),
    [sym_decimal_floating_point_literal] = ACTIONS(750),
    [sym_hex_floating_point_literal] = ACTIONS(748),
    [sym_true] = ACTIONS(748),
    [sym_false] = ACTIONS(748),
    [sym_character_literal] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(750),
    [sym_null_literal] = ACTIONS(748),
    [anon_sym_LPAREN] = ACTIONS(750),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(748),
    [anon_sym_final] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_TILDE] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(750),
    [anon_sym_DASH_DASH] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(748),
    [anon_sym_class] = ACTIONS(748),
    [anon_sym_switch] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_RBRACE] = ACTIONS(750),
    [anon_sym_case] = ACTIONS(748),
    [anon_sym_default] = ACTIONS(748),
    [anon_sym_SEMI] = ACTIONS(750),
    [anon_sym_assert] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_break] = ACTIONS(748),
    [anon_sym_continue] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_yield] = ACTIONS(748),
    [anon_sym_synchronized] = ACTIONS(748),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_try] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [anon_sym_open] = ACTIONS(748),
    [anon_sym_module] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(748),
    [anon_sym_package] = ACTIONS(748),
    [anon_sym_import] = ACTIONS(748),
    [anon_sym_enum] = ACTIONS(748),
    [anon_sym_public] = ACTIONS(748),
    [anon_sym_protected] = ACTIONS(748),
    [anon_sym_private] = ACTIONS(748),
    [anon_sym_abstract] = ACTIONS(748),
    [anon_sym_strictfp] = ACTIONS(748),
    [anon_sym_native] = ACTIONS(748),
    [anon_sym_transient] = ACTIONS(748),
    [anon_sym_volatile] = ACTIONS(748),
    [anon_sym_sealed] = ACTIONS(748),
    [anon_sym_non_DASHsealed] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(748),
    [anon_sym_ATinterface] = ACTIONS(750),
    [anon_sym_interface] = ACTIONS(748),
    [anon_sym_byte] = ACTIONS(748),
    [anon_sym_short] = ACTIONS(748),
    [anon_sym_int] = ACTIONS(748),
    [anon_sym_long] = ACTIONS(748),
    [anon_sym_char] = ACTIONS(748),
    [anon_sym_float] = ACTIONS(748),
    [anon_sym_double] = ACTIONS(748),
    [sym_boolean_type] = ACTIONS(748),
    [sym_void_type] = ACTIONS(748),
    [sym_this] = ACTIONS(748),
    [sym_super] = ACTIONS(748),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1036),
    [sym_decimal_integer_literal] = ACTIONS(1036),
    [sym_hex_integer_literal] = ACTIONS(1036),
    [sym_octal_integer_literal] = ACTIONS(1036),
    [sym_binary_integer_literal] = ACTIONS(1038),
    [sym_decimal_floating_point_literal] = ACTIONS(1038),
    [sym_hex_floating_point_literal] = ACTIONS(1036),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_character_literal] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1038),
    [sym_null_literal] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_final] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_new] = ACTIONS(1036),
    [anon_sym_class] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_assert] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1036),
    [anon_sym_synchronized] = ACTIONS(1036),
    [anon_sym_throw] = ACTIONS(1036),
    [anon_sym_try] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_AT] = ACTIONS(1036),
    [anon_sym_open] = ACTIONS(1036),
    [anon_sym_module] = ACTIONS(1036),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_package] = ACTIONS(1036),
    [anon_sym_import] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_public] = ACTIONS(1036),
    [anon_sym_protected] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym_abstract] = ACTIONS(1036),
    [anon_sym_strictfp] = ACTIONS(1036),
    [anon_sym_native] = ACTIONS(1036),
    [anon_sym_transient] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_sealed] = ACTIONS(1036),
    [anon_sym_non_DASHsealed] = ACTIONS(1038),
    [anon_sym_record] = ACTIONS(1036),
    [anon_sym_ATinterface] = ACTIONS(1038),
    [anon_sym_interface] = ACTIONS(1036),
    [anon_sym_byte] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [sym_boolean_type] = ACTIONS(1036),
    [sym_void_type] = ACTIONS(1036),
    [sym_this] = ACTIONS(1036),
    [sym_super] = ACTIONS(1036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1040),
    [sym_decimal_integer_literal] = ACTIONS(1040),
    [sym_hex_integer_literal] = ACTIONS(1040),
    [sym_octal_integer_literal] = ACTIONS(1040),
    [sym_binary_integer_literal] = ACTIONS(1042),
    [sym_decimal_floating_point_literal] = ACTIONS(1042),
    [sym_hex_floating_point_literal] = ACTIONS(1040),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_character_literal] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1042),
    [sym_null_literal] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_final] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_new] = ACTIONS(1040),
    [anon_sym_class] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_assert] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_yield] = ACTIONS(1040),
    [anon_sym_synchronized] = ACTIONS(1040),
    [anon_sym_throw] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_open] = ACTIONS(1040),
    [anon_sym_module] = ACTIONS(1040),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_package] = ACTIONS(1040),
    [anon_sym_import] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_public] = ACTIONS(1040),
    [anon_sym_protected] = ACTIONS(1040),
    [anon_sym_private] = ACTIONS(1040),
    [anon_sym_abstract] = ACTIONS(1040),
    [anon_sym_strictfp] = ACTIONS(1040),
    [anon_sym_native] = ACTIONS(1040),
    [anon_sym_transient] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_sealed] = ACTIONS(1040),
    [anon_sym_non_DASHsealed] = ACTIONS(1042),
    [anon_sym_record] = ACTIONS(1040),
    [anon_sym_ATinterface] = ACTIONS(1042),
    [anon_sym_interface] = ACTIONS(1040),
    [anon_sym_byte] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [anon_sym_int] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_char] = ACTIONS(1040),
    [anon_sym_float] = ACTIONS(1040),
    [anon_sym_double] = ACTIONS(1040),
    [sym_boolean_type] = ACTIONS(1040),
    [sym_void_type] = ACTIONS(1040),
    [sym_this] = ACTIONS(1040),
    [sym_super] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1044),
    [sym_decimal_integer_literal] = ACTIONS(1044),
    [sym_hex_integer_literal] = ACTIONS(1044),
    [sym_octal_integer_literal] = ACTIONS(1044),
    [sym_binary_integer_literal] = ACTIONS(1046),
    [sym_decimal_floating_point_literal] = ACTIONS(1046),
    [sym_hex_floating_point_literal] = ACTIONS(1044),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_character_literal] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1046),
    [sym_null_literal] = ACTIONS(1044),
    [anon_sym_LPAREN] = ACTIONS(1046),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_final] = ACTIONS(1044),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_new] = ACTIONS(1044),
    [anon_sym_class] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_assert] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_yield] = ACTIONS(1044),
    [anon_sym_synchronized] = ACTIONS(1044),
    [anon_sym_throw] = ACTIONS(1044),
    [anon_sym_try] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(1044),
    [anon_sym_open] = ACTIONS(1044),
    [anon_sym_module] = ACTIONS(1044),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_package] = ACTIONS(1044),
    [anon_sym_import] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_public] = ACTIONS(1044),
    [anon_sym_protected] = ACTIONS(1044),
    [anon_sym_private] = ACTIONS(1044),
    [anon_sym_abstract] = ACTIONS(1044),
    [anon_sym_strictfp] = ACTIONS(1044),
    [anon_sym_native] = ACTIONS(1044),
    [anon_sym_transient] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_sealed] = ACTIONS(1044),
    [anon_sym_non_DASHsealed] = ACTIONS(1046),
    [anon_sym_record] = ACTIONS(1044),
    [anon_sym_ATinterface] = ACTIONS(1046),
    [anon_sym_interface] = ACTIONS(1044),
    [anon_sym_byte] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [anon_sym_int] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_char] = ACTIONS(1044),
    [anon_sym_float] = ACTIONS(1044),
    [anon_sym_double] = ACTIONS(1044),
    [sym_boolean_type] = ACTIONS(1044),
    [sym_void_type] = ACTIONS(1044),
    [sym_this] = ACTIONS(1044),
    [sym_super] = ACTIONS(1044),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_identifier] = ACTIONS(1048),
    [sym_decimal_integer_literal] = ACTIONS(1048),
    [sym_hex_integer_literal] = ACTIONS(1048),
    [sym_octal_integer_literal] = ACTIONS(1048),
    [sym_binary_integer_literal] = ACTIONS(1050),
    [sym_decimal_floating_point_literal] = ACTIONS(1050),
    [sym_hex_floating_point_literal] = ACTIONS(1048),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_character_literal] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1050),
    [sym_null_literal] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_final] = ACTIONS(1048),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_new] = ACTIONS(1048),
    [anon_sym_class] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_assert] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_yield] = ACTIONS(1048),
    [anon_sym_synchronized] = ACTIONS(1048),
    [anon_sym_throw] = ACTIONS(1048),
    [anon_sym_try] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_AT] = ACTIONS(1048),
    [anon_sym_open] = ACTIONS(1048),
    [anon_sym_module] = ACTIONS(1048),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_package] = ACTIONS(1048),
    [anon_sym_import] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_public] = ACTIONS(1048),
    [anon_sym_protected] = ACTIONS(1048),
    [anon_sym_private] = ACTIONS(1048),
    [anon_sym_abstract] = ACTIONS(1048),
    [anon_sym_strictfp] = ACTIONS(1048),
    [anon_sym_native] = ACTIONS(1048),
    [anon_sym_transient] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_sealed] = ACTIONS(1048),
    [anon_sym_non_DASHsealed] = ACTIONS(1050),
    [anon_sym_record] = ACTIONS(1048),
    [anon_sym_ATinterface] = ACTIONS(1050),
    [anon_sym_interface] = ACTIONS(1048),
    [anon_sym_byte] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [anon_sym_int] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_char] = ACTIONS(1048),
    [anon_sym_float] = ACTIONS(1048),
    [anon_sym_double] = ACTIONS(1048),
    [sym_boolean_type] = ACTIONS(1048),
    [sym_void_type] = ACTIONS(1048),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(1048),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_identifier] = ACTIONS(1052),
    [sym_decimal_integer_literal] = ACTIONS(1052),
    [sym_hex_integer_literal] = ACTIONS(1052),
    [sym_octal_integer_literal] = ACTIONS(1052),
    [sym_binary_integer_literal] = ACTIONS(1054),
    [sym_decimal_floating_point_literal] = ACTIONS(1054),
    [sym_hex_floating_point_literal] = ACTIONS(1052),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_character_literal] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1054),
    [sym_null_literal] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1054),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_final] = ACTIONS(1052),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_new] = ACTIONS(1052),
    [anon_sym_class] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_assert] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_synchronized] = ACTIONS(1052),
    [anon_sym_throw] = ACTIONS(1052),
    [anon_sym_try] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(1052),
    [anon_sym_open] = ACTIONS(1052),
    [anon_sym_module] = ACTIONS(1052),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_package] = ACTIONS(1052),
    [anon_sym_import] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_public] = ACTIONS(1052),
    [anon_sym_protected] = ACTIONS(1052),
    [anon_sym_private] = ACTIONS(1052),
    [anon_sym_abstract] = ACTIONS(1052),
    [anon_sym_strictfp] = ACTIONS(1052),
    [anon_sym_native] = ACTIONS(1052),
    [anon_sym_transient] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_sealed] = ACTIONS(1052),
    [anon_sym_non_DASHsealed] = ACTIONS(1054),
    [anon_sym_record] = ACTIONS(1052),
    [anon_sym_ATinterface] = ACTIONS(1054),
    [anon_sym_interface] = ACTIONS(1052),
    [anon_sym_byte] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [anon_sym_int] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_char] = ACTIONS(1052),
    [anon_sym_float] = ACTIONS(1052),
    [anon_sym_double] = ACTIONS(1052),
    [sym_boolean_type] = ACTIONS(1052),
    [sym_void_type] = ACTIONS(1052),
    [sym_this] = ACTIONS(1052),
    [sym_super] = ACTIONS(1052),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 28,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(77), 1,
      anon_sym_ATinterface,
    ACTIONS(79), 1,
      anon_sym_interface,
    ACTIONS(1056), 1,
      sym_identifier,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1060), 1,
      anon_sym_RBRACE,
    ACTIONS(1062), 1,
      anon_sym_SEMI,
    ACTIONS(1064), 1,
      anon_sym_static,
    ACTIONS(1066), 1,
      anon_sym_record,
    STATE(632), 1,
      sym_modifiers,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(693), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(720), 1,
      sym__unannotated_type,
    STATE(1001), 1,
      sym__constructor_declarator,
    STATE(1007), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(21), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(356), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [119] = 28,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(77), 1,
      anon_sym_ATinterface,
    ACTIONS(79), 1,
      anon_sym_interface,
    ACTIONS(1056), 1,
      sym_identifier,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1064), 1,
      anon_sym_static,
    ACTIONS(1066), 1,
      anon_sym_record,
    ACTIONS(1068), 1,
      anon_sym_RBRACE,
    ACTIONS(1070), 1,
      anon_sym_SEMI,
    STATE(632), 1,
      sym_modifiers,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(693), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(720), 1,
      sym__unannotated_type,
    STATE(1001), 1,
      sym__constructor_declarator,
    STATE(1007), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(21), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(359), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [238] = 28,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(77), 1,
      anon_sym_ATinterface,
    ACTIONS(79), 1,
      anon_sym_interface,
    ACTIONS(1056), 1,
      sym_identifier,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1064), 1,
      anon_sym_static,
    ACTIONS(1066), 1,
      anon_sym_record,
    ACTIONS(1070), 1,
      anon_sym_SEMI,
    ACTIONS(1072), 1,
      anon_sym_RBRACE,
    STATE(632), 1,
      sym_modifiers,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(693), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(720), 1,
      sym__unannotated_type,
    STATE(1001), 1,
      sym__constructor_declarator,
    STATE(1007), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(21), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(359), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [357] = 28,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(77), 1,
      anon_sym_ATinterface,
    ACTIONS(79), 1,
      anon_sym_interface,
    ACTIONS(1056), 1,
      sym_identifier,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1064), 1,
      anon_sym_static,
    ACTIONS(1066), 1,
      anon_sym_record,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(1076), 1,
      anon_sym_SEMI,
    STATE(632), 1,
      sym_modifiers,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(693), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(720), 1,
      sym__unannotated_type,
    STATE(1001), 1,
      sym__constructor_declarator,
    STATE(1007), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(21), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(357), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [476] = 28,
    ACTIONS(1078), 1,
      sym_identifier,
    ACTIONS(1081), 1,
      anon_sym_LT,
    ACTIONS(1087), 1,
      anon_sym_class,
    ACTIONS(1090), 1,
      anon_sym_LBRACE,
    ACTIONS(1093), 1,
      anon_sym_RBRACE,
    ACTIONS(1095), 1,
      anon_sym_SEMI,
    ACTIONS(1098), 1,
      anon_sym_AT,
    ACTIONS(1101), 1,
      anon_sym_static,
    ACTIONS(1104), 1,
      anon_sym_enum,
    ACTIONS(1107), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1110), 1,
      anon_sym_record,
    ACTIONS(1113), 1,
      anon_sym_ATinterface,
    ACTIONS(1116), 1,
      anon_sym_interface,
    STATE(632), 1,
      sym_modifiers,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(693), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(720), 1,
      sym__unannotated_type,
    STATE(1001), 1,
      sym__constructor_declarator,
    STATE(1007), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1122), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1125), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1119), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(1084), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(359), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [595] = 29,
    ACTIONS(13), 1,
      anon_sym_DQUOTE,
    ACTIONS(15), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(27), 1,
      anon_sym_new,
    ACTIONS(87), 1,
      sym_this,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      sym_super,
    STATE(483), 1,
      sym__unqualified_object_creation_expression,
    STATE(491), 1,
      sym_primary_expression,
    STATE(510), 1,
      sym_string_literal,
    STATE(540), 1,
      sym_lambda_expression,
    STATE(745), 1,
      sym_scoped_type_identifier,
    STATE(771), 1,
      sym_generic_type,
    STATE(795), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1266), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(498), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1259), 2,
      sym_inferred_parameters,
      sym_formal_parameters,
    ACTIONS(11), 3,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
    ACTIONS(1132), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(9), 7,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_octal_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      sym_null_literal,
    STATE(507), 9,
      sym__literal,
      sym_array_creation_expression,
      sym_parenthesized_expression,
      sym_class_literal,
      sym_object_creation_expression,
      sym_field_access,
      sym_array_access,
      sym_method_invocation,
      sym_method_reference,
  [715] = 29,
    ACTIONS(13), 1,
      anon_sym_DQUOTE,
    ACTIONS(15), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(27), 1,
      anon_sym_new,
    ACTIONS(87), 1,
      sym_this,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      sym_super,
    ACTIONS(1136), 1,
      sym_identifier,
    STATE(483), 1,
      sym__unqualified_object_creation_expression,
    STATE(491), 1,
      sym_primary_expression,
    STATE(510), 1,
      sym_string_literal,
    STATE(540), 1,
      sym_lambda_expression,
    STATE(745), 1,
      sym_scoped_type_identifier,
    STATE(771), 1,
      sym_generic_type,
    STATE(795), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1266), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(498), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1273), 2,
      sym_inferred_parameters,
      sym_formal_parameters,
    ACTIONS(11), 3,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
    ACTIONS(1138), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(9), 7,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_octal_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      sym_null_literal,
    STATE(507), 9,
      sym__literal,
      sym_array_creation_expression,
      sym_parenthesized_expression,
      sym_class_literal,
      sym_object_creation_expression,
      sym_field_access,
      sym_array_access,
      sym_method_invocation,
      sym_method_reference,
  [835] = 25,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(77), 1,
      anon_sym_ATinterface,
    ACTIONS(79), 1,
      anon_sym_interface,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1066), 1,
      anon_sym_record,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(1142), 1,
      anon_sym_RBRACE,
    ACTIONS(1144), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_modifiers,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(688), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(730), 1,
      sym__unannotated_type,
    STATE(1007), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(363), 8,
      sym_enum_declaration,
      sym_class_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(21), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [942] = 25,
    ACTIONS(1146), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LT,
    ACTIONS(1155), 1,
      anon_sym_class,
    ACTIONS(1158), 1,
      anon_sym_RBRACE,
    ACTIONS(1160), 1,
      anon_sym_SEMI,
    ACTIONS(1163), 1,
      anon_sym_AT,
    ACTIONS(1166), 1,
      anon_sym_enum,
    ACTIONS(1169), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1172), 1,
      anon_sym_record,
    ACTIONS(1175), 1,
      anon_sym_ATinterface,
    ACTIONS(1178), 1,
      anon_sym_interface,
    STATE(662), 1,
      sym_modifiers,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(688), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(730), 1,
      sym__unannotated_type,
    STATE(1007), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1184), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1187), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1181), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(363), 8,
      sym_enum_declaration,
      sym_class_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(1152), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1049] = 25,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(77), 1,
      anon_sym_ATinterface,
    ACTIONS(79), 1,
      anon_sym_interface,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1066), 1,
      anon_sym_record,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(1190), 1,
      anon_sym_RBRACE,
    ACTIONS(1192), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_modifiers,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(688), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(730), 1,
      sym__unannotated_type,
    STATE(1007), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(362), 8,
      sym_enum_declaration,
      sym_class_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(21), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1156] = 14,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1202), 1,
      anon_sym_EQ,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1209), 1,
      anon_sym_DASH_GT,
    ACTIONS(1214), 1,
      anon_sym_DOT,
    ACTIONS(1218), 1,
      anon_sym_AT,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1194), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1204), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1198), 14,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1200), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
  [1240] = 17,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1202), 1,
      anon_sym_EQ,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1209), 1,
      anon_sym_DASH_GT,
    ACTIONS(1220), 1,
      anon_sym_RPAREN,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(1225), 1,
      anon_sym_DOT,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1091), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1218), 2,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1194), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1198), 9,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1204), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1200), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1329] = 18,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1202), 1,
      anon_sym_EQ,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1209), 1,
      anon_sym_DASH_GT,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(1225), 1,
      anon_sym_DOT,
    ACTIONS(1229), 1,
      anon_sym_RPAREN,
    ACTIONS(1233), 1,
      anon_sym_AMP,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1091), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1218), 2,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1194), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1198), 9,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1204), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1200), 12,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1420] = 15,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1202), 1,
      anon_sym_EQ,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1209), 1,
      anon_sym_DASH_GT,
    ACTIONS(1214), 1,
      anon_sym_DOT,
    ACTIONS(1218), 1,
      anon_sym_AT,
    ACTIONS(1236), 1,
      anon_sym_COLON,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1194), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1198), 10,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
    ACTIONS(1204), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1200), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1502] = 15,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1202), 1,
      anon_sym_EQ,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1209), 1,
      anon_sym_DASH_GT,
    ACTIONS(1214), 1,
      anon_sym_DOT,
    ACTIONS(1218), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_COLON,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1194), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1198), 10,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
    ACTIONS(1204), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1200), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1584] = 20,
    ACTIONS(1240), 1,
      sym_identifier,
    ACTIONS(1246), 1,
      anon_sym_class,
    ACTIONS(1249), 1,
      anon_sym_RBRACE,
    ACTIONS(1251), 1,
      anon_sym_AT,
    ACTIONS(1254), 1,
      anon_sym_enum,
    ACTIONS(1257), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1260), 1,
      anon_sym_ATinterface,
    ACTIONS(1263), 1,
      anon_sym_interface,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(700), 1,
      sym_modifiers,
    STATE(711), 1,
      sym_generic_type,
    STATE(736), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1269), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1272), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1266), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(370), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(1243), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1675] = 20,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(77), 1,
      anon_sym_ATinterface,
    ACTIONS(79), 1,
      anon_sym_interface,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(1275), 1,
      anon_sym_RBRACE,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(700), 1,
      sym_modifiers,
    STATE(711), 1,
      sym_generic_type,
    STATE(736), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(370), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(21), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1766] = 20,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(77), 1,
      anon_sym_ATinterface,
    ACTIONS(79), 1,
      anon_sym_interface,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(1277), 1,
      anon_sym_RBRACE,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(700), 1,
      sym_modifiers,
    STATE(711), 1,
      sym_generic_type,
    STATE(736), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(428), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(371), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(21), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1857] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(476), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1281), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1279), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1917] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(480), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1285), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1283), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1977] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(514), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1289), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1287), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2037] = 11,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1295), 1,
      anon_sym_EQ,
    ACTIONS(1301), 1,
      anon_sym_DASH_GT,
    STATE(499), 1,
      sym_argument_list,
    STATE(1025), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1303), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    ACTIONS(1297), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1299), 13,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
    ACTIONS(1293), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [2109] = 8,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1295), 1,
      anon_sym_EQ,
    ACTIONS(1301), 1,
      anon_sym_DASH_GT,
    STATE(499), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1297), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1293), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1299), 18,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2175] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(512), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1307), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1305), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2235] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1289), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1287), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2289] = 13,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1214), 1,
      anon_sym_DOT,
    ACTIONS(1218), 1,
      anon_sym_AT,
    ACTIONS(1309), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_DASH_GT,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1198), 11,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1311), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1200), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
  [2363] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1318), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1316), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2417] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1285), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1283), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2471] = 11,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(1295), 1,
      anon_sym_EQ,
    ACTIONS(1301), 1,
      anon_sym_DASH_GT,
    ACTIONS(1320), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym_argument_list,
    STATE(1092), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1297), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1293), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(1299), 13,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [2540] = 5,
    ACTIONS(1202), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1204), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1200), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1198), 18,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2597] = 13,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1209), 1,
      anon_sym_DASH_GT,
    ACTIONS(1214), 1,
      anon_sym_DOT,
    ACTIONS(1218), 1,
      anon_sym_AT,
    ACTIONS(1323), 1,
      anon_sym_EQ,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1198), 11,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1204), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1200), 12,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
  [2670] = 9,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1295), 1,
      anon_sym_EQ,
    ACTIONS(1301), 1,
      anon_sym_DASH_GT,
    ACTIONS(1325), 1,
      sym_identifier,
    STATE(499), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1297), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1299), 13,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
    ACTIONS(1293), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [2734] = 7,
    ACTIONS(1331), 1,
      anon_sym_LBRACK,
    ACTIONS(1334), 1,
      anon_sym_AT,
    STATE(387), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(871), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1327), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1329), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2794] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      anon_sym_LBRACK,
    STATE(387), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(871), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1337), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1339), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2854] = 8,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1343), 1,
      anon_sym_EQ,
    ACTIONS(1347), 1,
      anon_sym_DASH_GT,
    STATE(499), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1345), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1293), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1299), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [2916] = 9,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1295), 1,
      anon_sym_EQ,
    ACTIONS(1301), 1,
      anon_sym_DASH_GT,
    ACTIONS(1350), 1,
      anon_sym_module,
    STATE(499), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1297), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1293), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(1299), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
  [2980] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1356), 1,
      anon_sym_LBRACK,
    STATE(388), 1,
      aux_sym_dimensions_repeat1,
    STATE(489), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(870), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1354), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1352), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3043] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      anon_sym_LBRACK,
    STATE(388), 1,
      aux_sym_dimensions_repeat1,
    STATE(426), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(871), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1358), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1360), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3104] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1356), 1,
      anon_sym_LBRACK,
    STATE(388), 1,
      aux_sym_dimensions_repeat1,
    STATE(482), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(870), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1364), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1362), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3167] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      anon_sym_LBRACK,
    STATE(388), 1,
      aux_sym_dimensions_repeat1,
    STATE(426), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(871), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1366), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1368), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3228] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1356), 1,
      anon_sym_LBRACK,
    STATE(388), 1,
      aux_sym_dimensions_repeat1,
    STATE(469), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(870), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1372), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1370), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3291] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1356), 1,
      anon_sym_LBRACK,
    STATE(388), 1,
      aux_sym_dimensions_repeat1,
    STATE(511), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(870), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1376), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1374), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3354] = 19,
    ACTIONS(289), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(297), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(402), 1,
      sym_receiver_parameter,
    STATE(563), 1,
      aux_sym_modifiers_repeat1,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(692), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(711), 1,
      sym_generic_type,
    STATE(719), 1,
      sym_modifiers,
    STATE(740), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1030), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(628), 3,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(291), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3436] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 8,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1378), 33,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_to,
      anon_sym_with,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3486] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1384), 8,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1382), 33,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_to,
      anon_sym_with,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3536] = 5,
    ACTIONS(1309), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1311), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1200), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1198), 15,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [3590] = 7,
    ACTIONS(1390), 1,
      anon_sym_LBRACK,
    ACTIONS(1393), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(884), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1388), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1386), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3647] = 16,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(297), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(1396), 1,
      anon_sym_RPAREN,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(719), 1,
      sym_modifiers,
    STATE(747), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1086), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(563), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(291), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3721] = 6,
    ACTIONS(1398), 1,
      anon_sym_LT,
    ACTIONS(1401), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1194), 12,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1218), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3774] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1327), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1329), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3821] = 16,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(297), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(714), 1,
      sym_modifiers,
    STATE(748), 1,
      sym__unannotated_type,
    STATE(933), 1,
      sym_catch_type,
    STATE(1314), 1,
      sym_catch_formal_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(563), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(291), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3894] = 15,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(297), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(719), 1,
      sym_modifiers,
    STATE(747), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1148), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(563), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(291), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3965] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1020), 11,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1022), 27,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_octal_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      anon_sym_DQUOTE,
      sym_null_literal,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_switch,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [4012] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1403), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1405), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4059] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1024), 11,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1026), 27,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_octal_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      anon_sym_DQUOTE,
      sym_null_literal,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_switch,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [4106] = 6,
    ACTIONS(1411), 1,
      anon_sym_LT,
    ACTIONS(1414), 1,
      anon_sym_DOT,
    STATE(420), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1407), 12,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1409), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4159] = 6,
    ACTIONS(1418), 1,
      anon_sym_LPAREN,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    STATE(459), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1420), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1416), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4211] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1424), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1426), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4257] = 4,
    ACTIONS(1414), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1407), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1409), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4305] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1428), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1430), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4351] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1432), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1434), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4397] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1436), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1438), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4443] = 11,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1209), 1,
      anon_sym_DASH_GT,
    ACTIONS(1214), 1,
      anon_sym_DOT,
    ACTIONS(1218), 1,
      anon_sym_AT,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1200), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1198), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4505] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1440), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1442), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4551] = 6,
    ACTIONS(1418), 1,
      anon_sym_LPAREN,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    STATE(440), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1446), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1444), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4603] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1450), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1452), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4649] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1454), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1456), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4695] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1458), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1460), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4741] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1462), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1464), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4787] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1407), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1409), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4832] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1466), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1468), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4877] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1470), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1472), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4922] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1474), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1476), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4967] = 7,
    ACTIONS(61), 1,
      anon_sym_AT,
    ACTIONS(1484), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    STATE(433), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1482), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    ACTIONS(1478), 14,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5019] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(472), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1488), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1486), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5067] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(512), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1307), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1305), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5115] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1494), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1492), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5163] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(514), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1289), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1287), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5211] = 7,
    ACTIONS(1503), 1,
      anon_sym_AT,
    ACTIONS(1506), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1498), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    STATE(433), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1500), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    ACTIONS(1496), 14,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5263] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(490), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1511), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1509), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5311] = 6,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1301), 1,
      anon_sym_DASH_GT,
    STATE(499), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1293), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1299), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5361] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1515), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1513), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5409] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(480), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1285), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1283), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5457] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(476), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1281), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1279), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5505] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1519), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1517), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5548] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1523), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1521), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5591] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1527), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1525), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5634] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1531), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1529), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5677] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1535), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1533), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5720] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1539), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1537), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5763] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1543), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1541), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5806] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1547), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1545), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5849] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1551), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1549), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5892] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1555), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1553), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5935] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1559), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1557), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5978] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1563), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1561), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6021] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1567), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1565), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6064] = 5,
    ACTIONS(1569), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1575), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    ACTIONS(1573), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
    ACTIONS(1571), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6111] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1579), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1577), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6154] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1583), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1581), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6197] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1587), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1585), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6240] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1591), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1589), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6283] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1595), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1593), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6326] = 5,
    ACTIONS(1597), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1603), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    ACTIONS(1601), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
    ACTIONS(1599), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6373] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1607), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1605), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6416] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1611), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1609), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6459] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1615), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1613), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6502] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1619), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1617), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6545] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1623), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1621), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6588] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1627), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1625), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6631] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1631), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1629), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6674] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1358), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1360), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6717] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1635), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1633), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6760] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1639), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1637), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6803] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1643), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1641), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6845] = 6,
    ACTIONS(1645), 1,
      anon_sym_LBRACK,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(313), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(315), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6893] = 5,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1658), 2,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1656), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
    ACTIONS(1651), 11,
      anon_sym_AT,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1654), 17,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
  [6939] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1662), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1660), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6981] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1666), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1664), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7023] = 6,
    ACTIONS(1645), 1,
      anon_sym_LBRACK,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1670), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1668), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7071] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1674), 5,
      anon_sym_LT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1672), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7113] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1678), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1676), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7155] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1682), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1680), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7197] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1686), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1684), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7239] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1690), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1688), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7281] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1694), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1692), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7323] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1698), 5,
      anon_sym_LT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1696), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7365] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1702), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1700), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7407] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1706), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1704), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7449] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1710), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1708), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7491] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1318), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1316), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7533] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1714), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1712), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7575] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1716), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7617] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1722), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1720), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7659] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1726), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1724), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7701] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1730), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1728), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7743] = 6,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1736), 1,
      anon_sym_LBRACK,
    ACTIONS(1738), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1734), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1732), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7791] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1742), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1740), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7833] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1746), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1744), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7875] = 11,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_LT,
    ACTIONS(1214), 1,
      anon_sym_DOT,
    ACTIONS(1218), 1,
      anon_sym_AT,
    ACTIONS(1313), 1,
      anon_sym_DASH_GT,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1200), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1198), 16,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7933] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1750), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1748), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7975] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1754), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1752), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8017] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1758), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1756), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8059] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1762), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1760), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8101] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1766), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1764), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8143] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1770), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1768), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8185] = 5,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    STATE(467), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1658), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1654), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8231] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1774), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1772), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8273] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1289), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1287), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8315] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1778), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1776), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8357] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1782), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1780), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8399] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1786), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1784), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8441] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1200), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1198), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8483] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1285), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1283), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8525] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1790), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1788), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8567] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1794), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1792), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8609] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1798), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1796), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8651] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1802), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1800), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8693] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1806), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1804), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8735] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1810), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1808), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8777] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1814), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1812), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8819] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1818), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1816), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8861] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1822), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1820), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8903] = 5,
    ACTIONS(760), 1,
      anon_sym_LPAREN,
    STATE(1215), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1658), 2,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1654), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8948] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1438), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1436), 19,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [8988] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1464), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1462), 19,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [9028] = 6,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1347), 1,
      anon_sym_DASH_GT,
    STATE(499), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1293), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1299), 19,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [9074] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1426), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1424), 19,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [9114] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1670), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1668), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9155] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(313), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(315), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9194] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1670), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1668), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9233] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1828), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1826), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9272] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1832), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1830), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9311] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1836), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1834), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9350] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1840), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1838), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9389] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1844), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1842), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9428] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1848), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1846), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9467] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1852), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1850), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9506] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1856), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1854), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9545] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1860), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1858), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9584] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1864), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1862), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9623] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1868), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1866), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9662] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1872), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1870), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9701] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1876), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1874), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9740] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1880), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1878), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9779] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1734), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1732), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9818] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1884), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1882), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9859] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1888), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1886), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9898] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1892), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1890), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9937] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1856), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1854), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9976] = 14,
    ACTIONS(1884), 1,
      anon_sym_PIPE,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 10,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10036] = 7,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1884), 5,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1882), 17,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10082] = 15,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 9,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10144] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1830), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10212] = 6,
    ACTIONS(1927), 1,
      anon_sym_AT,
    ACTIONS(1930), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(549), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1496), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1924), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [10256] = 9,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1884), 4,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
    ACTIONS(1882), 15,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10306] = 6,
    ACTIONS(1933), 1,
      anon_sym_LPAREN,
    ACTIONS(1935), 1,
      anon_sym_DOT,
    STATE(575), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1446), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1444), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10350] = 16,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 8,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10414] = 6,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1884), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1882), 17,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10458] = 13,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1884), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 10,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10516] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1937), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10584] = 15,
    ACTIONS(1884), 1,
      anon_sym_PIPE,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 9,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10646] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1939), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10714] = 12,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1884), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 12,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10770] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1886), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10838] = 6,
    ACTIONS(1933), 1,
      anon_sym_LPAREN,
    ACTIONS(1941), 1,
      anon_sym_DOT,
    STATE(576), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1420), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1416), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10882] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(1253), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1200), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1198), 19,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
  [10924] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1943), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10992] = 6,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1947), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(549), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1478), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1945), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [11036] = 7,
    ACTIONS(1334), 1,
      anon_sym_AT,
    ACTIONS(1949), 1,
      anon_sym_LBRACK,
    STATE(564), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1329), 10,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1327), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_throws,
      sym_this,
      sym_identifier,
  [11081] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1384), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1382), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11118] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1378), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11155] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    STATE(564), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1339), 10,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1337), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_throws,
      sym_this,
      sym_identifier,
  [11200] = 20,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1964), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(1982), 1,
      anon_sym_COMMA,
    ACTIONS(1984), 1,
      anon_sym_QMARK,
    STATE(967), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1980), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [11270] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1986), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [11336] = 6,
    ACTIONS(1645), 1,
      anon_sym_LBRACK,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1988), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(313), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(315), 16,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
  [11378] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1990), 1,
      anon_sym_RPAREN,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    STATE(1065), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11447] = 14,
    ACTIONS(1884), 1,
      anon_sym_PIPE,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 7,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11504] = 18,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1964), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(1984), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1939), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [11569] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1994), 1,
      anon_sym_COMMA,
    ACTIONS(1996), 1,
      anon_sym_RBRACE,
    STATE(1080), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11638] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1523), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1521), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11673] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1607), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1605), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11708] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1611), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1609), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11743] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1998), 1,
      anon_sym_COMMA,
    ACTIONS(2000), 1,
      anon_sym_SEMI,
    STATE(1112), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11812] = 18,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1964), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(1984), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1937), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [11877] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2002), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11946] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2006), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(2004), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11981] = 15,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_GT,
    ACTIONS(2010), 1,
      anon_sym_QMARK,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1056), 2,
      sym_wildcard,
      sym__type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(678), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12040] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1519), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1517), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [12075] = 18,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1964), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(1984), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2012), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [12140] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2016), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(2014), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [12175] = 18,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1964), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(1984), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1943), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [12240] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2018), 1,
      anon_sym_RPAREN,
    ACTIONS(2020), 1,
      anon_sym_COMMA,
    STATE(1106), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12309] = 18,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1964), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(1984), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1886), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [12374] = 13,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1884), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 7,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [12429] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1998), 1,
      anon_sym_COMMA,
    ACTIONS(2022), 1,
      anon_sym_SEMI,
    STATE(1082), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12498] = 12,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(297), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(2024), 1,
      sym_identifier,
    ACTIONS(2026), 1,
      anon_sym_COMMA,
    ACTIONS(2028), 1,
      anon_sym_RBRACE,
    ACTIONS(2030), 1,
      anon_sym_SEMI,
    STATE(899), 1,
      sym_enum_constant,
    STATE(1290), 1,
      sym_enum_body_declarations,
    STATE(1294), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(563), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(291), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [12551] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(309), 2,
      anon_sym_while,
      anon_sym_else,
    ACTIONS(313), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(315), 16,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
  [12588] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2032), 1,
      anon_sym_RPAREN,
    STATE(1040), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12657] = 9,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1884), 4,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
    ACTIONS(1882), 12,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [12704] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2036), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(2034), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [12739] = 12,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1884), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 9,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [12792] = 15,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [12851] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2012), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [12916] = 16,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [12977] = 6,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1884), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1882), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [13018] = 15,
    ACTIONS(1884), 1,
      anon_sym_PIPE,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1882), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [13077] = 18,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1954), 1,
      anon_sym_AMP,
    ACTIONS(1962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1964), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(1974), 1,
      anon_sym_CARET,
    ACTIONS(1978), 1,
      anon_sym_GT_GT,
    ACTIONS(1984), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1956), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1958), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1976), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1830), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [13142] = 7,
    ACTIONS(1970), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1966), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1968), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1884), 5,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1882), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [13185] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2038), 1,
      anon_sym_RPAREN,
    STATE(1014), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13254] = 15,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_QMARK,
    ACTIONS(2040), 1,
      anon_sym_GT,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1084), 2,
      sym_wildcard,
      sym__type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(678), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13313] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2042), 1,
      anon_sym_RPAREN,
    STATE(1071), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13382] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2044), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [13447] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1980), 1,
      anon_sym_COLON,
    ACTIONS(2020), 1,
      anon_sym_COMMA,
    STATE(1107), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13516] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2046), 1,
      anon_sym_RPAREN,
    STATE(1101), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13585] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2048), 1,
      anon_sym_RPAREN,
    STATE(1018), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13654] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2050), 1,
      anon_sym_RPAREN,
    STATE(1104), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13723] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2052), 1,
      anon_sym_RPAREN,
    STATE(1079), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13792] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2054), 1,
      anon_sym_RPAREN,
    STATE(1099), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13861] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2056), 1,
      anon_sym_RPAREN,
    STATE(1085), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13930] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2058), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13999] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2060), 1,
      anon_sym_RPAREN,
    STATE(1109), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14068] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1591), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1589), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14103] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2062), 1,
      anon_sym_RPAREN,
    STATE(1093), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14172] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2064), 1,
      anon_sym_RPAREN,
    STATE(1029), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14241] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2068), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(2066), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14276] = 20,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2070), 1,
      anon_sym_RPAREN,
    STATE(1096), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14345] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2072), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [14409] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1986), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [14473] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(297), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(2024), 1,
      sym_identifier,
    ACTIONS(2030), 1,
      anon_sym_SEMI,
    ACTIONS(2074), 1,
      anon_sym_RBRACE,
    STATE(1058), 1,
      sym_enum_constant,
    STATE(1294), 1,
      sym_modifiers,
    STATE(1318), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(563), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(291), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [14523] = 19,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2076), 1,
      anon_sym_COLON,
    ACTIONS(2078), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14589] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2080), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [14653] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(297), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(2024), 1,
      sym_identifier,
    ACTIONS(2030), 1,
      anon_sym_SEMI,
    ACTIONS(2082), 1,
      anon_sym_RBRACE,
    STATE(1058), 1,
      sym_enum_constant,
    STATE(1264), 1,
      sym_enum_body_declarations,
    STATE(1294), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(563), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(291), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [14703] = 5,
    ACTIONS(1658), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(2084), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1651), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1654), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [14741] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2087), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [14805] = 14,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_QMARK,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1176), 2,
      sym_wildcard,
      sym__type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(678), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14861] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2089), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [14925] = 18,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(2091), 1,
      sym_identifier,
    ACTIONS(2093), 1,
      anon_sym_class,
    ACTIONS(2095), 1,
      anon_sym_enum,
    ACTIONS(2097), 1,
      anon_sym_record,
    ACTIONS(2099), 1,
      anon_sym_ATinterface,
    ACTIONS(2101), 1,
      anon_sym_interface,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(693), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(722), 1,
      sym__unannotated_type,
    STATE(996), 1,
      sym__constructor_declarator,
    STATE(1031), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14989] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2103), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [15053] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2105), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15116] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2107), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15179] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15242] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2111), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15305] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2113), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15368] = 14,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2115), 1,
      sym_identifier,
    ACTIONS(2117), 1,
      anon_sym_final,
    STATE(392), 1,
      sym__unannotated_type,
    STATE(410), 1,
      sym_scoped_type_identifier,
    STATE(413), 1,
      sym_generic_type,
    STATE(452), 1,
      sym__type,
    STATE(466), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2121), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2123), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(424), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2119), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15423] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15486] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2127), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15549] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2129), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15612] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2131), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15675] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2133), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15738] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2135), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15801] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2137), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15864] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2139), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15927] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2141), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15990] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2143), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16053] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16116] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16179] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2149), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16242] = 14,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1004), 1,
      sym__type,
    STATE(1214), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16297] = 14,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1004), 1,
      sym__type,
    STATE(1250), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16352] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16415] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16478] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2155), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16541] = 14,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(2157), 1,
      anon_sym_open,
    ACTIONS(2159), 1,
      anon_sym_module,
    ACTIONS(2161), 1,
      anon_sym_package,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(716), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16596] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2163), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16659] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2165), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16722] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2167), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16785] = 17,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(2093), 1,
      anon_sym_class,
    ACTIONS(2095), 1,
      anon_sym_enum,
    ACTIONS(2097), 1,
      anon_sym_record,
    ACTIONS(2099), 1,
      anon_sym_ATinterface,
    ACTIONS(2101), 1,
      anon_sym_interface,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(688), 1,
      sym_type_parameters,
    STATE(711), 1,
      sym_generic_type,
    STATE(731), 1,
      sym__unannotated_type,
    STATE(1031), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16846] = 14,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1004), 1,
      sym__type,
    STATE(1211), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16901] = 18,
    ACTIONS(1894), 1,
      anon_sym_AMP,
    ACTIONS(1906), 1,
      anon_sym_SLASH,
    ACTIONS(1910), 1,
      anon_sym_GT_GT,
    ACTIONS(1912), 1,
      anon_sym_instanceof,
    ACTIONS(1914), 1,
      anon_sym_PIPE,
    ACTIONS(1916), 1,
      anon_sym_CARET,
    ACTIONS(1918), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1922), 1,
      anon_sym_QMARK,
    ACTIONS(2169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1824), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1896), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1900), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1902), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1904), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [16964] = 13,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(985), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17016] = 13,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2115), 1,
      sym_identifier,
    STATE(392), 1,
      sym__unannotated_type,
    STATE(410), 1,
      sym_scoped_type_identifier,
    STATE(413), 1,
      sym_generic_type,
    STATE(458), 1,
      sym__type,
    STATE(466), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2121), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2123), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(424), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2119), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17068] = 13,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1089), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17120] = 13,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(998), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17172] = 13,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1175), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17224] = 13,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(975), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17276] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1327), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1329), 12,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17308] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1403), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1405), 12,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17340] = 13,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1156), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17392] = 13,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(725), 1,
      sym__unannotated_type,
    STATE(797), 1,
      sym_annotated_type,
    STATE(1045), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17444] = 6,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    ACTIONS(2173), 1,
      anon_sym_DOT,
    STATE(710), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1420), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1416), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17481] = 6,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    ACTIONS(2175), 1,
      anon_sym_DOT,
    STATE(713), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1446), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1444), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17518] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(297), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(2024), 1,
      sym_identifier,
    STATE(1058), 1,
      sym_enum_constant,
    STATE(1294), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(563), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(291), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [17559] = 12,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(2177), 1,
      anon_sym_QMARK,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(716), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17608] = 14,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(2093), 1,
      anon_sym_class,
    ACTIONS(2095), 1,
      anon_sym_enum,
    ACTIONS(2097), 1,
      anon_sym_record,
    ACTIONS(2099), 1,
      anon_sym_ATinterface,
    ACTIONS(2101), 1,
      anon_sym_interface,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(737), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17660] = 12,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      sym_identifier,
    STATE(738), 1,
      sym_scoped_type_identifier,
    STATE(749), 1,
      sym_type_arguments,
    STATE(758), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2181), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(776), 2,
      sym_integral_type,
      sym_floating_point_type,
    STATE(706), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17708] = 11,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(765), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17754] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1458), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1460), 13,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17784] = 11,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(716), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17830] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1378), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17860] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2183), 1,
      anon_sym_DOT,
    STATE(699), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1407), 7,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1409), 11,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17896] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1384), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1382), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17926] = 11,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2115), 1,
      sym_identifier,
    STATE(394), 1,
      sym__unannotated_type,
    STATE(410), 1,
      sym_scoped_type_identifier,
    STATE(413), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2121), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2123), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(424), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2119), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17972] = 11,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(761), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(689), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18018] = 11,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(750), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18064] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1454), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1456), 13,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18094] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1432), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1434), 13,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18124] = 11,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(790), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18170] = 11,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2185), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(761), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(689), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18216] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1428), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1430), 13,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18246] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2187), 1,
      anon_sym_DOT,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1194), 7,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1218), 11,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18282] = 12,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2189), 1,
      sym_identifier,
    STATE(733), 1,
      sym_scoped_type_identifier,
    STATE(749), 1,
      sym_type_arguments,
    STATE(760), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2191), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(773), 2,
      sym_integral_type,
      sym_floating_point_type,
    STATE(704), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18330] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1474), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1476), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18359] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1440), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1442), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18388] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1450), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1452), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18417] = 13,
    ACTIONS(1140), 1,
      sym_identifier,
    ACTIONS(2093), 1,
      anon_sym_class,
    ACTIONS(2095), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      anon_sym_ATinterface,
    ACTIONS(2101), 1,
      anon_sym_interface,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(732), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18466] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1466), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1468), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18495] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1407), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1409), 11,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18523] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1470), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1472), 11,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18551] = 10,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2193), 1,
      sym_identifier,
    STATE(751), 1,
      sym_scoped_type_identifier,
    STATE(782), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2195), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(794), 2,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18593] = 5,
    ACTIONS(2199), 1,
      anon_sym_QMARK,
    ACTIONS(2201), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2197), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [18625] = 10,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2204), 1,
      sym_identifier,
    STATE(755), 1,
      sym_scoped_type_identifier,
    STATE(780), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2206), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(789), 2,
      sym_integral_type,
      sym_floating_point_type,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18667] = 13,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2208), 1,
      sym_identifier,
    ACTIONS(2210), 1,
      anon_sym_DOT,
    ACTIONS(2214), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2216), 1,
      sym_this,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(1125), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1360), 3,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18715] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1611), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1609), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [18743] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1519), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1517), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [18771] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1607), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1605), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [18799] = 4,
    ACTIONS(2183), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1407), 7,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1409), 11,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18829] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1591), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1589), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [18857] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1523), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1521), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [18885] = 10,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(748), 1,
      sym__unannotated_type,
    STATE(932), 1,
      sym_catch_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18925] = 13,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1360), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(971), 1,
      sym__variable_declarator_id,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1261), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18971] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1368), 9,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [19005] = 13,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1360), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(951), 1,
      sym__variable_declarator_id,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1261), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19051] = 13,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1360), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1304), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19097] = 9,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(746), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [19134] = 12,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2222), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(979), 1,
      sym__method_declarator,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1296), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2224), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19177] = 9,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(753), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [19214] = 12,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2222), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(979), 1,
      sym__method_declarator,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1317), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2224), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19257] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2228), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
    ACTIONS(2226), 13,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [19282] = 9,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(734), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [19319] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1360), 8,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [19352] = 9,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(743), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [19389] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2232), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
    ACTIONS(2230), 13,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [19414] = 10,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2234), 1,
      sym_identifier,
    STATE(749), 1,
      sym_type_arguments,
    STATE(908), 1,
      sym_scoped_type_identifier,
    STATE(1074), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2236), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1200), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [19453] = 9,
    ACTIONS(1140), 1,
      sym_identifier,
    STATE(685), 1,
      sym_scoped_type_identifier,
    STATE(711), 1,
      sym_generic_type,
    STATE(762), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(85), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(702), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [19490] = 12,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2222), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(979), 1,
      sym__method_declarator,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1255), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2224), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19533] = 12,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2222), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(979), 1,
      sym__method_declarator,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1282), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2224), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19576] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2238), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1282), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19616] = 12,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(436), 1,
      sym_argument_list,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(699), 1,
      sym_type_arguments,
    STATE(1187), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(778), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19658] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(950), 1,
      sym__variable_declarator_id,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1257), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19698] = 12,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    STATE(431), 1,
      sym_argument_list,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1183), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(772), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19740] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2246), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1255), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19780] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1265), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19820] = 12,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(436), 1,
      sym_argument_list,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(699), 1,
      sym_type_arguments,
    STATE(1187), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(395), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19862] = 4,
    ACTIONS(2248), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1986), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1656), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [19888] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2208), 1,
      sym_identifier,
    ACTIONS(2214), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2216), 1,
      sym_this,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(1125), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19928] = 12,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    STATE(431), 1,
      sym_argument_list,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1183), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(396), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19970] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1360), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(1280), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20010] = 11,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(978), 1,
      sym__variable_declarator_id,
    STATE(1100), 1,
      sym_variable_declarator,
    STATE(1257), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20050] = 10,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1214), 1,
      anon_sym_DOT,
    ACTIONS(1218), 1,
      anon_sym_AT,
    STATE(505), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1211), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(2250), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1194), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [20087] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2252), 1,
      anon_sym_DOT,
    STATE(699), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1407), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1409), 6,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [20116] = 10,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    ACTIONS(2255), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(1157), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20153] = 10,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2214), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(1125), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20190] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2259), 1,
      anon_sym_PIPE,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(829), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2257), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20225] = 8,
    ACTIONS(2261), 1,
      sym_identifier,
    STATE(898), 1,
      sym_scoped_type_identifier,
    STATE(1081), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(83), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2263), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1181), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(81), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [20258] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(986), 1,
      sym__method_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2267), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20292] = 10,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(699), 1,
      sym_type_arguments,
    STATE(1159), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(775), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20328] = 10,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(449), 1,
      sym_block,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1217), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1218), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1194), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [20364] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(1279), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20398] = 10,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1173), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(393), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20434] = 10,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(699), 1,
      sym_type_arguments,
    STATE(1159), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(391), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20470] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(783), 1,
      sym_formal_parameters,
    STATE(916), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2271), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20504] = 9,
    ACTIONS(2273), 1,
      anon_sym_RBRACE,
    ACTIONS(2275), 1,
      anon_sym_requires,
    ACTIONS(2277), 1,
      anon_sym_exports,
    ACTIONS(2279), 1,
      anon_sym_opens,
    ACTIONS(2281), 1,
      anon_sym_uses,
    ACTIONS(2283), 1,
      anon_sym_provides,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(767), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(834), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [20538] = 10,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(436), 1,
      sym_argument_list,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1187), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(395), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20574] = 10,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(468), 1,
      sym_block,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1217), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1218), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1194), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [20610] = 10,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(436), 1,
      sym_argument_list,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1187), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(778), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20646] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    STATE(981), 1,
      sym__method_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2267), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20680] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2287), 1,
      anon_sym_PIPE,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2285), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20712] = 10,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1173), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(774), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20748] = 9,
    ACTIONS(2275), 1,
      anon_sym_requires,
    ACTIONS(2277), 1,
      anon_sym_exports,
    ACTIONS(2279), 1,
      anon_sym_opens,
    ACTIONS(2281), 1,
      anon_sym_uses,
    ACTIONS(2283), 1,
      anon_sym_provides,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(757), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(834), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [20782] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      sym_identifier,
    ACTIONS(2293), 1,
      sym_this,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1368), 3,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20816] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(784), 1,
      sym_formal_parameters,
    STATE(917), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2295), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20850] = 9,
    ACTIONS(2297), 1,
      anon_sym_RBRACE,
    ACTIONS(2299), 1,
      anon_sym_requires,
    ACTIONS(2302), 1,
      anon_sym_exports,
    ACTIONS(2305), 1,
      anon_sym_opens,
    ACTIONS(2308), 1,
      anon_sym_uses,
    ACTIONS(2311), 1,
      anon_sym_provides,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(767), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(834), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [20884] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(916), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2271), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [20914] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(917), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2295), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [20944] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2314), 1,
      anon_sym_LPAREN,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(917), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2295), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20975] = 4,
    ACTIONS(2252), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1407), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1409), 6,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [20998] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    STATE(511), 1,
      sym_dimensions,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1374), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21029] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    STATE(436), 1,
      sym_argument_list,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1187), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(778), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21062] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    STATE(482), 1,
      sym_dimensions,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1362), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21093] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    STATE(489), 1,
      sym_dimensions,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1352), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21124] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    STATE(436), 1,
      sym_argument_list,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1187), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(395), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21157] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2316), 1,
      anon_sym_LPAREN,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(917), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2295), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21188] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    STATE(469), 1,
      sym_dimensions,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1370), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(401), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21219] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(917), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2295), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21249] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1159), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(391), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21279] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2320), 1,
      anon_sym_default,
    ACTIONS(2322), 1,
      anon_sym_SEMI,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1062), 1,
      sym_dimensions,
    STATE(1270), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21311] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1159), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(775), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21341] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1042), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2324), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21369] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1034), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2326), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21397] = 8,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(698), 1,
      sym_type_arguments,
    STATE(1123), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1218), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1194), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [21427] = 9,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2320), 1,
      anon_sym_default,
    ACTIONS(2328), 1,
      anon_sym_SEMI,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1026), 1,
      sym_dimensions,
    STATE(1244), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21459] = 9,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_new,
    ACTIONS(2336), 1,
      sym_this,
    ACTIONS(2338), 1,
      sym_super,
    STATE(479), 1,
      sym__unqualified_object_creation_expression,
    STATE(992), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2334), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21490] = 11,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_extends,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(234), 1,
      sym_class_body,
    STATE(805), 1,
      sym_type_parameters,
    STATE(847), 1,
      sym_superclass,
    STATE(976), 1,
      sym_super_interfaces,
    STATE(1143), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21525] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1159), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(391), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21552] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      sym_identifier,
    ACTIONS(2293), 1,
      sym_this,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21581] = 9,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2332), 1,
      anon_sym_new,
    ACTIONS(2346), 1,
      sym_identifier,
    ACTIONS(2350), 1,
      sym_this,
    ACTIONS(2352), 1,
      sym_super,
    STATE(479), 1,
      sym__unqualified_object_creation_expression,
    STATE(923), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2348), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21612] = 11,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_extends,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(206), 1,
      sym_class_body,
    STATE(803), 1,
      sym_type_parameters,
    STATE(823), 1,
      sym_superclass,
    STATE(973), 1,
      sym_super_interfaces,
    STATE(1165), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21647] = 9,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2332), 1,
      anon_sym_new,
    ACTIONS(2346), 1,
      sym_identifier,
    ACTIONS(2350), 1,
      sym_this,
    ACTIONS(2354), 1,
      sym_super,
    STATE(479), 1,
      sym__unqualified_object_creation_expression,
    STATE(992), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2348), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21678] = 7,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(1159), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(775), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(873), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21705] = 8,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(1360), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    STATE(567), 1,
      aux_sym_dimensions_repeat1,
    STATE(703), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(865), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21734] = 7,
    ACTIONS(2356), 1,
      sym_identifier,
    STATE(798), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(827), 1,
      sym_requires_modifier,
    STATE(1197), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2360), 2,
      anon_sym_transitive,
      anon_sym_static,
    ACTIONS(2358), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21760] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1360), 9,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [21776] = 9,
    ACTIONS(2362), 1,
      sym_identifier,
    ACTIONS(2364), 1,
      anon_sym_open,
    ACTIONS(2366), 1,
      anon_sym_module,
    ACTIONS(2368), 1,
      anon_sym_record,
    STATE(800), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(827), 1,
      sym_requires_modifier,
    STATE(1198), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2360), 2,
      anon_sym_transitive,
      anon_sym_static,
  [21806] = 8,
    ACTIONS(2370), 1,
      anon_sym_RBRACE,
    ACTIONS(2372), 1,
      anon_sym_case,
    ACTIONS(2374), 1,
      anon_sym_default,
    STATE(2), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1168), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(813), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
    STATE(882), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [21834] = 5,
    STATE(800), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(827), 1,
      sym_requires_modifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2378), 2,
      anon_sym_transitive,
      anon_sym_static,
    ACTIONS(2376), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [21855] = 7,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      sym_this,
    ACTIONS(2338), 1,
      sym_super,
    STATE(992), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2334), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21880] = 6,
    ACTIONS(2381), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2383), 1,
      aux_sym__multiline_string_fragment_token1,
    ACTIONS(2386), 1,
      aux_sym__multiline_string_fragment_token2,
    ACTIONS(2389), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(802), 3,
      sym__multiline_string_fragment,
      sym__escape_sequence,
      aux_sym__multiline_string_literal_repeat1,
  [21903] = 9,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_extends,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(231), 1,
      sym_class_body,
    STATE(863), 1,
      sym_superclass,
    STATE(957), 1,
      sym_super_interfaces,
    STATE(1167), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21932] = 6,
    ACTIONS(2394), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2396), 1,
      aux_sym__multiline_string_fragment_token1,
    ACTIONS(2398), 1,
      aux_sym__multiline_string_fragment_token2,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2400), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(802), 3,
      sym__multiline_string_fragment,
      sym__escape_sequence,
      aux_sym__multiline_string_literal_repeat1,
  [21955] = 9,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_extends,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(200), 1,
      sym_class_body,
    STATE(867), 1,
      sym_superclass,
    STATE(1002), 1,
      sym_super_interfaces,
    STATE(1222), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21984] = 7,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2346), 1,
      sym_identifier,
    ACTIONS(2350), 1,
      sym_this,
    ACTIONS(2354), 1,
      sym_super,
    STATE(992), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2348), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22009] = 6,
    ACTIONS(2396), 1,
      aux_sym__multiline_string_fragment_token1,
    ACTIONS(2398), 1,
      aux_sym__multiline_string_fragment_token2,
    ACTIONS(2402), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2404), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(804), 3,
      sym__multiline_string_fragment,
      sym__escape_sequence,
      aux_sym__multiline_string_literal_repeat1,
  [22032] = 9,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(2344), 1,
      anon_sym_permits,
    ACTIONS(2406), 1,
      anon_sym_extends,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(211), 1,
      sym_interface_body,
    STATE(822), 1,
      sym_type_parameters,
    STATE(970), 1,
      sym_extends_interfaces,
    STATE(1122), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22061] = 9,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(2344), 1,
      anon_sym_permits,
    ACTIONS(2406), 1,
      anon_sym_extends,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(267), 1,
      sym_interface_body,
    STATE(877), 1,
      sym_type_parameters,
    STATE(991), 1,
      sym_extends_interfaces,
    STATE(1224), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22090] = 6,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(924), 1,
      sym_argument_list,
    STATE(1036), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2410), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [22112] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2412), 7,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_implements,
      anon_sym_throws,
  [22126] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2414), 7,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_implements,
      anon_sym_throws,
  [22140] = 7,
    ACTIONS(2374), 1,
      anon_sym_default,
    ACTIONS(2416), 1,
      anon_sym_RBRACE,
    ACTIONS(2418), 1,
      anon_sym_case,
    STATE(2), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1308), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(815), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
  [22164] = 5,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2420), 1,
      sym_identifier,
    STATE(1047), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(843), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22184] = 7,
    ACTIONS(2422), 1,
      anon_sym_RBRACE,
    ACTIONS(2424), 1,
      anon_sym_case,
    ACTIONS(2427), 1,
      anon_sym_default,
    STATE(2), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1308), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(815), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
  [22208] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2430), 7,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_implements,
      anon_sym_throws,
  [22222] = 6,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(903), 1,
      sym_argument_list,
    STATE(1113), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2432), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [22244] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      sym_identifier,
    ACTIONS(2438), 1,
      sym_this,
    STATE(953), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2436), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22266] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2440), 7,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_implements,
      anon_sym_throws,
  [22280] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(2442), 1,
      sym_identifier,
    ACTIONS(2446), 1,
      sym_this,
    STATE(953), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2444), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22302] = 5,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2420), 1,
      sym_identifier,
    STATE(1151), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(843), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22322] = 7,
    ACTIONS(2344), 1,
      anon_sym_permits,
    ACTIONS(2406), 1,
      anon_sym_extends,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(213), 1,
      sym_interface_body,
    STATE(963), 1,
      sym_extends_interfaces,
    STATE(1140), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22345] = 7,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(229), 1,
      sym_class_body,
    STATE(960), 1,
      sym_super_interfaces,
    STATE(1161), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22368] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2448), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22381] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2450), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22394] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2450), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22407] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2452), 6,
      anon_sym_open,
      anon_sym_module,
      anon_sym_transitive,
      anon_sym_static,
      anon_sym_record,
      sym_identifier,
  [22420] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2448), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22433] = 4,
    ACTIONS(2259), 1,
      anon_sym_PIPE,
    STATE(860), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2454), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [22450] = 4,
    ACTIONS(2458), 1,
      aux_sym__multiline_string_fragment_token1,
    STATE(868), 1,
      aux_sym__multiline_string_fragment_repeat1,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2456), 4,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym__multiline_string_fragment_token2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [22467] = 5,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(1164), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22486] = 4,
    ACTIONS(2462), 1,
      aux_sym__multiline_string_fragment_token1,
    STATE(832), 1,
      aux_sym__multiline_string_fragment_repeat1,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2460), 4,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym__multiline_string_fragment_token2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [22503] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2465), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22520] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2467), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22533] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2469), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22546] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22559] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2473), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22576] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2475), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22593] = 4,
    ACTIONS(2199), 1,
      anon_sym_LBRACK,
    ACTIONS(2477), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(839), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22610] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2480), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(833), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22627] = 6,
    ACTIONS(2482), 1,
      anon_sym_RBRACE,
    ACTIONS(2484), 1,
      anon_sym_case,
    ACTIONS(2487), 1,
      anon_sym_default,
    STATE(1269), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(841), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [22648] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2490), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22661] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22678] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2494), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22691] = 5,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(1130), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22710] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2496), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22723] = 7,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(199), 1,
      sym_class_body,
    STATE(989), 1,
      sym_super_interfaces,
    STATE(1219), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22746] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2498), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22759] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2500), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22772] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2502), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22785] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2504), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22798] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2506), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22811] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2508), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22824] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2510), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22837] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2512), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22850] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2514), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22863] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2516), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(837), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22880] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2518), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22893] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2520), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22906] = 4,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    STATE(860), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2285), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [22923] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2525), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22936] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2527), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [22949] = 7,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(175), 1,
      sym_class_body,
    STATE(968), 1,
      sym_super_interfaces,
    STATE(1124), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22972] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2529), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(875), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [22989] = 4,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2531), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(839), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [23006] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2533), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(838), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [23023] = 7,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(254), 1,
      sym_class_body,
    STATE(966), 1,
      sym_super_interfaces,
    STATE(1152), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23046] = 4,
    ACTIONS(2537), 1,
      aux_sym__multiline_string_fragment_token1,
    STATE(832), 1,
      aux_sym__multiline_string_fragment_repeat1,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2535), 4,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym__multiline_string_fragment_token2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [23063] = 5,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(1155), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23082] = 4,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2539), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(839), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [23099] = 4,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2541), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(839), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [23116] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2543), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23129] = 4,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2545), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(839), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [23146] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2547), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23159] = 4,
    ACTIONS(329), 1,
      anon_sym_AT,
    ACTIONS(2549), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(705), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [23176] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2448), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23189] = 7,
    ACTIONS(2344), 1,
      anon_sym_permits,
    ACTIONS(2406), 1,
      anon_sym_extends,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(183), 1,
      sym_interface_body,
    STATE(987), 1,
      sym_extends_interfaces,
    STATE(1195), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23212] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2551), 6,
      anon_sym_open,
      anon_sym_module,
      anon_sym_transitive,
      anon_sym_static,
      anon_sym_record,
      sym_identifier,
  [23225] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2553), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23238] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2555), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23251] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2557), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23264] = 6,
    ACTIONS(2372), 1,
      anon_sym_case,
    ACTIONS(2374), 1,
      anon_sym_default,
    ACTIONS(2416), 1,
      anon_sym_RBRACE,
    STATE(1269), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(841), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [23285] = 5,
    ACTIONS(2559), 1,
      sym_identifier,
    ACTIONS(2563), 1,
      anon_sym_static,
    STATE(1182), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2561), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23304] = 4,
    ACTIONS(293), 1,
      anon_sym_AT,
    ACTIONS(2565), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(839), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [23321] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2567), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23334] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2569), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23347] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2571), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23360] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2573), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23373] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2575), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23386] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2577), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23399] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2579), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23412] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2581), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23425] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2583), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [23438] = 4,
    ACTIONS(2585), 1,
      sym_identifier,
    STATE(945), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2587), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23454] = 4,
    ACTIONS(2589), 1,
      sym_identifier,
    STATE(1069), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2591), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23470] = 4,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(499), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1299), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [23486] = 4,
    ACTIONS(2593), 1,
      sym_identifier,
    STATE(943), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2595), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23502] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(429), 1,
      sym_argument_list,
    STATE(699), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23522] = 6,
    ACTIONS(2030), 1,
      anon_sym_SEMI,
    ACTIONS(2597), 1,
      anon_sym_COMMA,
    ACTIONS(2599), 1,
      anon_sym_RBRACE,
    STATE(922), 1,
      aux_sym_enum_body_repeat1,
    STATE(1238), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23542] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    STATE(434), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23562] = 4,
    STATE(1160), 1,
      sym__wildcard_bounds,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2601), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    ACTIONS(2603), 2,
      anon_sym_extends,
      sym_super,
  [23578] = 4,
    ACTIONS(2605), 1,
      sym_identifier,
    STATE(1174), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2607), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23594] = 4,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(1111), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2609), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [23610] = 4,
    ACTIONS(2611), 1,
      sym_identifier,
    STATE(1171), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2613), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23626] = 4,
    ACTIONS(2615), 1,
      sym_identifier,
    STATE(1011), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2617), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23642] = 4,
    ACTIONS(2619), 1,
      sym_identifier,
    STATE(1055), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2621), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23658] = 4,
    ACTIONS(2623), 1,
      sym_identifier,
    STATE(551), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2625), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23674] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(436), 1,
      sym_argument_list,
    STATE(699), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23694] = 4,
    ACTIONS(2627), 1,
      sym_identifier,
    STATE(1023), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2629), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23710] = 4,
    ACTIONS(2631), 1,
      sym_identifier,
    STATE(1225), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2633), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23726] = 4,
    ACTIONS(2635), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2637), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23742] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2250), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1198), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [23756] = 4,
    ACTIONS(2639), 1,
      sym_identifier,
    STATE(949), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2641), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23772] = 4,
    ACTIONS(2643), 1,
      sym_identifier,
    STATE(934), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2645), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23788] = 4,
    ACTIONS(2647), 1,
      sym_identifier,
    STATE(947), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2649), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23804] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [23816] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2653), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [23828] = 4,
    ACTIONS(2655), 1,
      sym_identifier,
    STATE(941), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2657), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23844] = 4,
    ACTIONS(2659), 1,
      sym_identifier,
    STATE(1044), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2661), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23860] = 5,
    ACTIONS(2663), 1,
      anon_sym_catch,
    ACTIONS(2665), 1,
      anon_sym_finally,
    STATE(303), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(98), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [23878] = 4,
    ACTIONS(2667), 1,
      sym_identifier,
    STATE(1103), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2669), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23894] = 6,
    ACTIONS(2030), 1,
      anon_sym_SEMI,
    ACTIONS(2082), 1,
      anon_sym_RBRACE,
    ACTIONS(2671), 1,
      anon_sym_COMMA,
    STATE(938), 1,
      aux_sym_enum_body_repeat1,
    STATE(1264), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23914] = 4,
    ACTIONS(2673), 1,
      sym_identifier,
    ACTIONS(2677), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2675), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23930] = 4,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(1061), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2679), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [23946] = 2,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2456), 5,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym__multiline_string_fragment_token1,
      aux_sym__multiline_string_fragment_token2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
  [23958] = 4,
    STATE(1179), 1,
      sym__wildcard_bounds,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2603), 2,
      anon_sym_extends,
      sym_super,
    ACTIONS(2681), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [23974] = 4,
    ACTIONS(2683), 1,
      anon_sym_COMMA,
    STATE(927), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2686), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_permits,
  [23990] = 6,
    ACTIONS(95), 1,
      anon_sym_LT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_DOT,
    STATE(431), 1,
      sym_argument_list,
    STATE(698), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24010] = 4,
    ACTIONS(2688), 1,
      sym_identifier,
    STATE(676), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2690), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [24026] = 4,
    ACTIONS(2692), 1,
      sym_identifier,
    STATE(1166), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2694), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [24042] = 4,
    ACTIONS(2696), 1,
      sym_identifier,
    STATE(419), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2698), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [24058] = 4,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(1248), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [24074] = 4,
    ACTIONS(2218), 1,
      sym_identifier,
    STATE(1249), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [24090] = 5,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2702), 1,
      anon_sym_SEMI,
    STATE(1024), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24107] = 5,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2704), 1,
      anon_sym_LBRACE,
    STATE(207), 1,
      sym_enum_body,
    STATE(1169), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24124] = 4,
    ACTIONS(2706), 1,
      anon_sym_DQUOTE,
    STATE(1003), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2708), 2,
      sym_string_fragment,
      sym_escape_sequence,
  [24139] = 5,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2710), 1,
      anon_sym_RPAREN,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    STATE(1050), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24156] = 4,
    ACTIONS(2714), 1,
      anon_sym_COMMA,
    STATE(938), 1,
      aux_sym_enum_body_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2717), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [24171] = 5,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2719), 1,
      anon_sym_SEMI,
    STATE(1028), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24188] = 5,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2721), 1,
      anon_sym_SEMI,
    STATE(1020), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24205] = 5,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2723), 1,
      anon_sym_SEMI,
    STATE(1013), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24222] = 5,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2725), 1,
      anon_sym_SEMI,
    STATE(1006), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24239] = 5,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2727), 1,
      anon_sym_SEMI,
    STATE(1008), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24256] = 5,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2729), 1,
      anon_sym_SEMI,
    STATE(1010), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24273] = 5,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2731), 1,
      anon_sym_SEMI,
    STATE(1012), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24290] = 5,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2735), 1,
      anon_sym_SEMI,
    STATE(1015), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24307] = 5,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2737), 1,
      anon_sym_SEMI,
    STATE(1017), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24324] = 5,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2739), 1,
      anon_sym_SEMI,
    STATE(1019), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24341] = 5,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2741), 1,
      anon_sym_SEMI,
    STATE(1021), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24358] = 4,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2747), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2745), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24373] = 4,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2749), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2745), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24388] = 5,
    ACTIONS(2342), 1,
      anon_sym_implements,
    ACTIONS(2704), 1,
      anon_sym_LBRACE,
    STATE(264), 1,
      sym_enum_body,
    STATE(1131), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24405] = 3,
    ACTIONS(2751), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2753), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [24418] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2342), 1,
      anon_sym_implements,
    STATE(251), 1,
      sym_class_body,
    STATE(1218), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24435] = 5,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(983), 1,
      sym_formal_parameters,
    STATE(1128), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24452] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2755), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [24463] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(176), 1,
      sym_class_body,
    STATE(1120), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24480] = 4,
    ACTIONS(2757), 1,
      anon_sym_COMMA,
    STATE(958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2012), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [24495] = 5,
    ACTIONS(2760), 1,
      anon_sym_LPAREN,
    ACTIONS(2762), 1,
      anon_sym_LBRACE,
    STATE(920), 1,
      sym_block,
    STATE(1201), 1,
      sym_resource_specification,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24512] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(180), 1,
      sym_class_body,
    STATE(1184), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24529] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2342), 1,
      anon_sym_implements,
    STATE(187), 1,
      sym_class_body,
    STATE(1162), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24546] = 3,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2745), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24559] = 5,
    ACTIONS(2344), 1,
      anon_sym_permits,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(190), 1,
      sym_interface_body,
    STATE(1133), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24576] = 4,
    ACTIONS(2764), 1,
      anon_sym_DQUOTE,
    STATE(964), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2766), 2,
      sym_string_fragment,
      sym_escape_sequence,
  [24591] = 3,
    ACTIONS(2769), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2771), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [24604] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(182), 1,
      sym_class_body,
    STATE(1134), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24621] = 4,
    ACTIONS(1982), 1,
      anon_sym_COMMA,
    STATE(958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2773), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [24636] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(241), 1,
      sym_class_body,
    STATE(1142), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24653] = 4,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    STATE(969), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2778), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [24668] = 5,
    ACTIONS(2344), 1,
      anon_sym_permits,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(209), 1,
      sym_interface_body,
    STATE(1117), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24685] = 4,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2780), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2745), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24700] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2342), 1,
      anon_sym_implements,
    STATE(215), 1,
      sym_class_body,
    STATE(1149), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24717] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(228), 1,
      sym_class_body,
    STATE(1154), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24734] = 4,
    ACTIONS(2782), 1,
      anon_sym_COMMA,
    STATE(927), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2784), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [24749] = 4,
    ACTIONS(2786), 1,
      anon_sym_AMP,
    STATE(984), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2788), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [24764] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(198), 1,
      sym_class_body,
    STATE(1209), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24781] = 4,
    ACTIONS(95), 1,
      anon_sym_LT,
    STATE(1230), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2790), 2,
      anon_sym_new,
      sym_identifier,
  [24796] = 4,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2792), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2745), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24811] = 4,
    ACTIONS(2796), 1,
      anon_sym_throws,
    STATE(1192), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2794), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [24826] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2798), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [24837] = 4,
    ACTIONS(2796), 1,
      anon_sym_throws,
    STATE(1212), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2800), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [24852] = 4,
    ACTIONS(2804), 1,
      anon_sym_extends,
    STATE(1203), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2802), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [24867] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2342), 1,
      anon_sym_implements,
    STATE(151), 1,
      sym_class_body,
    STATE(1193), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24884] = 4,
    ACTIONS(2786), 1,
      anon_sym_AMP,
    STATE(969), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2806), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [24899] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2686), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_permits,
  [24910] = 4,
    ACTIONS(2796), 1,
      anon_sym_throws,
    STATE(1158), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2808), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [24925] = 5,
    ACTIONS(2344), 1,
      anon_sym_permits,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(235), 1,
      sym_interface_body,
    STATE(1202), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24942] = 4,
    ACTIONS(2804), 1,
      anon_sym_extends,
    STATE(1147), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2810), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [24957] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(258), 1,
      sym_class_body,
    STATE(1145), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24974] = 4,
    ACTIONS(2782), 1,
      anon_sym_COMMA,
    STATE(927), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2812), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [24989] = 5,
    ACTIONS(2344), 1,
      anon_sym_permits,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(192), 1,
      sym_interface_body,
    STATE(1194), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25006] = 3,
    ACTIONS(2673), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2675), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [25019] = 4,
    ACTIONS(2814), 1,
      anon_sym_COMMA,
    STATE(993), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2012), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [25034] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2817), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [25045] = 5,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2819), 1,
      anon_sym_DOT,
    STATE(1253), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25062] = 5,
    ACTIONS(2796), 1,
      anon_sym_throws,
    ACTIONS(2821), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_constructor_body,
    STATE(1136), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25079] = 5,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2823), 1,
      anon_sym_RPAREN,
    STATE(1090), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25096] = 4,
    ACTIONS(2782), 1,
      anon_sym_COMMA,
    STATE(990), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2825), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [25111] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2827), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [25122] = 5,
    ACTIONS(1058), 1,
      anon_sym_LT,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(972), 1,
      sym_formal_parameters,
    STATE(1188), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25139] = 5,
    ACTIONS(2796), 1,
      anon_sym_throws,
    ACTIONS(2821), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_constructor_body,
    STATE(1190), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25156] = 5,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(2344), 1,
      anon_sym_permits,
    STATE(255), 1,
      sym_class_body,
    STATE(1150), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25173] = 4,
    ACTIONS(2829), 1,
      anon_sym_DQUOTE,
    STATE(964), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2831), 2,
      sym_string_fragment,
      sym_escape_sequence,
  [25188] = 4,
    ACTIONS(2782), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2833), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [25203] = 4,
    ACTIONS(2835), 1,
      anon_sym_RPAREN,
    ACTIONS(2837), 1,
      anon_sym_COMMA,
    STATE(1027), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25217] = 4,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2839), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25231] = 4,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2841), 1,
      anon_sym_SEMI,
    STATE(446), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25245] = 4,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2843), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25259] = 4,
    ACTIONS(2845), 1,
      anon_sym_RPAREN,
    ACTIONS(2847), 1,
      anon_sym_COMMA,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25273] = 4,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2850), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25287] = 4,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2852), 1,
      anon_sym_SEMI,
    ACTIONS(2854), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25301] = 4,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2856), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25315] = 4,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2858), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25329] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2860), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25343] = 4,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2862), 1,
      anon_sym_SEMI,
    STATE(1057), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25357] = 4,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2864), 1,
      anon_sym_SEMI,
    ACTIONS(2866), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25371] = 4,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2868), 1,
      anon_sym_SEMI,
    STATE(1057), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25385] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2870), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25399] = 4,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2872), 1,
      anon_sym_SEMI,
    STATE(1057), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25413] = 4,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2874), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25427] = 4,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2876), 1,
      anon_sym_SEMI,
    STATE(1057), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25441] = 4,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      anon_sym_STAR,
    STATE(1315), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25455] = 4,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2882), 1,
      anon_sym_SEMI,
    ACTIONS(2884), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25469] = 4,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2886), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25483] = 4,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2888), 1,
      anon_sym_LBRACE,
    STATE(281), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25497] = 4,
    ACTIONS(2320), 1,
      anon_sym_default,
    ACTIONS(2890), 1,
      anon_sym_SEMI,
    STATE(1303), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25511] = 4,
    ACTIONS(2837), 1,
      anon_sym_COMMA,
    ACTIONS(2892), 1,
      anon_sym_RPAREN,
    STATE(1051), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25525] = 4,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    ACTIONS(2894), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25539] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2896), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25553] = 4,
    ACTIONS(1396), 1,
      anon_sym_RPAREN,
    ACTIONS(2898), 1,
      anon_sym_COMMA,
    STATE(1087), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25567] = 4,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2900), 1,
      anon_sym_SEMI,
    STATE(462), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25581] = 4,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2902), 1,
      anon_sym_SEMI,
    ACTIONS(2904), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25595] = 4,
    ACTIONS(339), 1,
      anon_sym_RBRACE,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    STATE(1115), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25609] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2908), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
  [25619] = 4,
    ACTIONS(2880), 1,
      anon_sym_STAR,
    ACTIONS(2910), 1,
      sym_identifier,
    STATE(1237), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25633] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2912), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [25643] = 4,
    ACTIONS(2837), 1,
      anon_sym_COMMA,
    ACTIONS(2914), 1,
      anon_sym_RPAREN,
    STATE(1051), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25657] = 4,
    ACTIONS(2837), 1,
      anon_sym_COMMA,
    ACTIONS(2916), 1,
      anon_sym_RPAREN,
    STATE(1051), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25671] = 4,
    ACTIONS(2030), 1,
      anon_sym_SEMI,
    ACTIONS(2599), 1,
      anon_sym_RBRACE,
    STATE(1238), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25685] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2918), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25699] = 4,
    ACTIONS(2837), 1,
      anon_sym_COMMA,
    ACTIONS(2920), 1,
      anon_sym_RPAREN,
    STATE(1038), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25713] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2922), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
  [25723] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2924), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [25735] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2926), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [25747] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2928), 3,
      anon_sym_LBRACE,
      anon_sym_implements,
      anon_sym_permits,
  [25757] = 4,
    ACTIONS(2930), 1,
      anon_sym_COMMA,
    ACTIONS(2933), 1,
      anon_sym_SEMI,
    STATE(1046), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25771] = 4,
    ACTIONS(2935), 1,
      anon_sym_GT,
    ACTIONS(2937), 1,
      anon_sym_COMMA,
    STATE(1053), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25785] = 4,
    ACTIONS(2939), 1,
      anon_sym_COMMA,
    ACTIONS(2941), 1,
      anon_sym_SEMI,
    STATE(1094), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25799] = 4,
    ACTIONS(2943), 1,
      anon_sym_GT,
    ACTIONS(2945), 1,
      anon_sym_COMMA,
    STATE(1110), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25813] = 4,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2947), 1,
      anon_sym_RPAREN,
    STATE(1095), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25827] = 4,
    ACTIONS(2949), 1,
      anon_sym_RPAREN,
    ACTIONS(2951), 1,
      anon_sym_COMMA,
    STATE(1051), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25841] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2954), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25855] = 4,
    ACTIONS(2937), 1,
      anon_sym_COMMA,
    ACTIONS(2956), 1,
      anon_sym_GT,
    STATE(1077), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25869] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2958), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [25881] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2960), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [25893] = 4,
    ACTIONS(2945), 1,
      anon_sym_COMMA,
    ACTIONS(2962), 1,
      anon_sym_GT,
    STATE(1049), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25907] = 4,
    ACTIONS(2964), 1,
      anon_sym_COMMA,
    ACTIONS(2967), 1,
      anon_sym_SEMI,
    STATE(1057), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25921] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2717), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [25931] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2969), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [25941] = 4,
    ACTIONS(2087), 1,
      anon_sym_RBRACE,
    ACTIONS(2971), 1,
      anon_sym_COMMA,
    STATE(1060), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25955] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2974), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [25965] = 4,
    ACTIONS(2320), 1,
      anon_sym_default,
    ACTIONS(2976), 1,
      anon_sym_SEMI,
    STATE(1307), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25979] = 4,
    ACTIONS(1994), 1,
      anon_sym_COMMA,
    ACTIONS(1996), 1,
      anon_sym_RBRACE,
    STATE(1080), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25993] = 4,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2888), 1,
      anon_sym_LBRACE,
    STATE(280), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26007] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2978), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26021] = 4,
    ACTIONS(2880), 1,
      anon_sym_STAR,
    ACTIONS(2910), 1,
      sym_identifier,
    STATE(1262), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26035] = 4,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26049] = 4,
    ACTIONS(2980), 1,
      anon_sym_COMMA,
    ACTIONS(2982), 1,
      anon_sym_RBRACE,
    STATE(1033), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26063] = 4,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2888), 1,
      anon_sym_LBRACE,
    STATE(345), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26077] = 4,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2888), 1,
      anon_sym_LBRACE,
    STATE(346), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26091] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(2984), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26105] = 4,
    ACTIONS(2986), 1,
      anon_sym_RPAREN,
    ACTIONS(2988), 1,
      anon_sym_SEMI,
    STATE(1076), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26119] = 4,
    ACTIONS(1645), 1,
      anon_sym_LBRACK,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26133] = 4,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(436), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26147] = 4,
    ACTIONS(2990), 1,
      anon_sym_COMMA,
    ACTIONS(2993), 1,
      anon_sym_SEMI,
    STATE(1075), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26161] = 4,
    ACTIONS(828), 1,
      anon_sym_RPAREN,
    ACTIONS(2995), 1,
      anon_sym_SEMI,
    STATE(1114), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26175] = 4,
    ACTIONS(2997), 1,
      anon_sym_GT,
    ACTIONS(2999), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26189] = 4,
    ACTIONS(3002), 1,
      anon_sym_RPAREN,
    ACTIONS(3004), 1,
      anon_sym_COMMA,
    STATE(1078), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26203] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3007), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26217] = 4,
    ACTIONS(374), 1,
      anon_sym_RBRACE,
    ACTIONS(3009), 1,
      anon_sym_COMMA,
    STATE(1060), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26231] = 4,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(2242), 1,
      anon_sym_DOT,
    STATE(429), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26245] = 4,
    ACTIONS(1998), 1,
      anon_sym_COMMA,
    ACTIONS(3011), 1,
      anon_sym_SEMI,
    STATE(1075), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26259] = 4,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    ACTIONS(3013), 1,
      anon_sym_DOT,
    STATE(1243), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26273] = 4,
    ACTIONS(2945), 1,
      anon_sym_COMMA,
    ACTIONS(3015), 1,
      anon_sym_GT,
    STATE(1116), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26287] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3017), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26301] = 4,
    ACTIONS(2898), 1,
      anon_sym_COMMA,
    ACTIONS(3019), 1,
      anon_sym_RPAREN,
    STATE(1108), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26315] = 4,
    ACTIONS(2898), 1,
      anon_sym_COMMA,
    ACTIONS(3019), 1,
      anon_sym_RPAREN,
    STATE(1105), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26329] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3021), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26343] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2778), 3,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_COMMA,
  [26353] = 4,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(3023), 1,
      anon_sym_RPAREN,
    STATE(1095), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26367] = 4,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(3025), 1,
      anon_sym_RPAREN,
    STATE(1078), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26381] = 4,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(3027), 1,
      anon_sym_RPAREN,
    STATE(1078), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26395] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3029), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26409] = 4,
    ACTIONS(3031), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_SEMI,
    STATE(1094), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26423] = 4,
    ACTIONS(3036), 1,
      anon_sym_RPAREN,
    ACTIONS(3038), 1,
      anon_sym_AMP,
    STATE(1095), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26437] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3041), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26451] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2044), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [26461] = 4,
    ACTIONS(2837), 1,
      anon_sym_COMMA,
    ACTIONS(3043), 1,
      anon_sym_RPAREN,
    STATE(1037), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26475] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3045), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26489] = 4,
    ACTIONS(2939), 1,
      anon_sym_COMMA,
    ACTIONS(3047), 1,
      anon_sym_SEMI,
    STATE(1048), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26503] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3049), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26517] = 4,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(2888), 1,
      anon_sym_LBRACE,
    STATE(331), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26531] = 4,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(2888), 1,
      anon_sym_LBRACE,
    STATE(321), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26545] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3051), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26559] = 4,
    ACTIONS(3053), 1,
      anon_sym_RPAREN,
    ACTIONS(3055), 1,
      anon_sym_COMMA,
    STATE(1105), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26573] = 4,
    ACTIONS(2020), 1,
      anon_sym_COMMA,
    ACTIONS(3058), 1,
      anon_sym_RPAREN,
    STATE(993), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26587] = 4,
    ACTIONS(2020), 1,
      anon_sym_COMMA,
    ACTIONS(2773), 1,
      anon_sym_COLON,
    STATE(993), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26601] = 4,
    ACTIONS(2898), 1,
      anon_sym_COMMA,
    ACTIONS(3060), 1,
      anon_sym_RPAREN,
    STATE(1105), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26615] = 4,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(3062), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26629] = 4,
    ACTIONS(3064), 1,
      anon_sym_GT,
    ACTIONS(3066), 1,
      anon_sym_COMMA,
    STATE(1110), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26643] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [26653] = 4,
    ACTIONS(1998), 1,
      anon_sym_COMMA,
    ACTIONS(3071), 1,
      anon_sym_SEMI,
    STATE(1075), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26667] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3073), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [26677] = 4,
    ACTIONS(3075), 1,
      anon_sym_RPAREN,
    ACTIONS(3077), 1,
      anon_sym_SEMI,
    STATE(1114), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26691] = 4,
    ACTIONS(3080), 1,
      anon_sym_COMMA,
    ACTIONS(3083), 1,
      anon_sym_RBRACE,
    STATE(1115), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26705] = 4,
    ACTIONS(2945), 1,
      anon_sym_COMMA,
    ACTIONS(3085), 1,
      anon_sym_GT,
    STATE(1110), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26719] = 3,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(193), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26730] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2949), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [26739] = 3,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(783), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26750] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(243), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26761] = 3,
    ACTIONS(3087), 1,
      anon_sym_DOT,
    ACTIONS(3089), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26772] = 3,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(210), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26783] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3091), 2,
      anon_sym_LBRACE,
      anon_sym_throws,
  [26792] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(242), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26803] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3093), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [26812] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2087), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [26821] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3075), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [26830] = 3,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(954), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26841] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3083), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [26850] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3095), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [26859] = 3,
    ACTIONS(2704), 1,
      anon_sym_LBRACE,
    STATE(156), 1,
      sym_enum_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26870] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3097), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [26879] = 3,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(246), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26890] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(203), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26901] = 3,
    ACTIONS(760), 1,
      anon_sym_LPAREN,
    STATE(1227), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26912] = 3,
    ACTIONS(2821), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_constructor_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26923] = 3,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(477), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26934] = 3,
    ACTIONS(760), 1,
      anon_sym_LPAREN,
    STATE(1321), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26945] = 3,
    ACTIONS(3099), 1,
      anon_sym_LPAREN,
    STATE(53), 1,
      sym_condition,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26956] = 3,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(189), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26967] = 3,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(478), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26978] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(271), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26989] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(197), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27000] = 3,
    ACTIONS(3101), 1,
      sym_identifier,
    ACTIONS(3103), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27011] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(145), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27022] = 3,
    ACTIONS(3105), 1,
      sym_identifier,
    ACTIONS(3107), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27033] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3109), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [27042] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3053), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [27051] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(188), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27062] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(174), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27073] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2997), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [27082] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27093] = 3,
    ACTIONS(3099), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_condition,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27104] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(186), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27115] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3111), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [27124] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3113), 2,
      anon_sym_RPAREN,
      anon_sym_AMP,
  [27133] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3115), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [27142] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3117), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [27151] = 3,
    ACTIONS(343), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27162] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2681), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [27171] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(185), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27182] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(245), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27193] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3002), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [27202] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3119), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [27211] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(227), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27222] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3121), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27233] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27244] = 3,
    ACTIONS(3123), 1,
      anon_sym_DASH_GT,
    ACTIONS(3125), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27255] = 3,
    ACTIONS(2704), 1,
      anon_sym_LBRACE,
    STATE(216), 1,
      sym_enum_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27266] = 3,
    ACTIONS(3127), 1,
      anon_sym_LBRACE,
    STATE(265), 1,
      sym_annotation_type_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27277] = 3,
    ACTIONS(3129), 1,
      anon_sym_DOT,
    ACTIONS(3131), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27288] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3133), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [27297] = 3,
    ACTIONS(343), 1,
      anon_sym_LBRACE,
    STATE(486), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27308] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3135), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27319] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [27328] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3064), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [27337] = 3,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2819), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27348] = 3,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    STATE(294), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27359] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3139), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [27368] = 3,
    ACTIONS(854), 1,
      anon_sym_while,
    ACTIONS(3141), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27379] = 3,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(429), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27390] = 3,
    ACTIONS(3143), 1,
      anon_sym_DOT,
    ACTIONS(3145), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27401] = 3,
    ACTIONS(343), 1,
      anon_sym_LBRACE,
    STATE(509), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27412] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(244), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27423] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3147), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27434] = 3,
    ACTIONS(3149), 1,
      anon_sym_DOT,
    ACTIONS(3151), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27445] = 3,
    ACTIONS(343), 1,
      anon_sym_LBRACE,
    STATE(500), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27456] = 3,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(961), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27467] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3153), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27478] = 3,
    ACTIONS(2821), 1,
      anon_sym_LBRACE,
    STATE(442), 1,
      sym_constructor_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27489] = 3,
    ACTIONS(3155), 1,
      sym_identifier,
    STATE(1118), 1,
      sym_element_value_pair,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27500] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3157), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [27509] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(250), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27520] = 3,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(233), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27531] = 3,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(237), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27542] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3159), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27553] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3161), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27564] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3163), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27575] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3165), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27586] = 3,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(436), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27597] = 3,
    ACTIONS(2762), 1,
      anon_sym_LBRACE,
    STATE(95), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27608] = 3,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(171), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27619] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3167), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [27628] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3169), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27639] = 3,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3171), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27650] = 3,
    ACTIONS(3099), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_condition,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27661] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3173), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27672] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3175), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27683] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(260), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27694] = 3,
    ACTIONS(3099), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      sym_condition,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27705] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3177), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [27714] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3179), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [27723] = 3,
    ACTIONS(2762), 1,
      anon_sym_LBRACE,
    STATE(130), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27734] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3181), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [27743] = 3,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    STATE(312), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27754] = 3,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(1289), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27765] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3183), 2,
      anon_sym_LBRACE,
      anon_sym_throws,
  [27774] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(169), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27785] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(259), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27796] = 3,
    ACTIONS(3127), 1,
      anon_sym_LBRACE,
    STATE(208), 1,
      sym_annotation_type_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27807] = 3,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(784), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27818] = 3,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    STATE(256), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27829] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3185), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27840] = 3,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(184), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27851] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3187), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27862] = 3,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(1305), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27873] = 3,
    ACTIONS(3189), 1,
      anon_sym_LBRACE,
    STATE(78), 1,
      sym_switch_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27884] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3191), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [27893] = 3,
    ACTIONS(1422), 1,
      anon_sym_DOT,
    ACTIONS(3193), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27904] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3195), 2,
      anon_sym_new,
      sym_identifier,
  [27913] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3197), 2,
      sym_this,
      sym_super,
  [27922] = 3,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(497), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27933] = 3,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(495), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27944] = 3,
    ACTIONS(1448), 1,
      anon_sym_DOT,
    ACTIONS(3199), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27955] = 2,
    ACTIONS(3201), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27963] = 2,
    ACTIONS(3203), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27971] = 2,
    ACTIONS(3205), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27979] = 2,
    ACTIONS(2082), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27987] = 2,
    ACTIONS(3013), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27995] = 2,
    ACTIONS(3207), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28003] = 2,
    ACTIONS(3209), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28011] = 2,
    ACTIONS(3211), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28019] = 2,
    ACTIONS(3213), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28027] = 2,
    ACTIONS(3215), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28035] = 2,
    ACTIONS(3217), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28043] = 2,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28051] = 2,
    ACTIONS(2920), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28059] = 2,
    ACTIONS(3221), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28067] = 2,
    ACTIONS(3223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28075] = 2,
    ACTIONS(3225), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28083] = 2,
    ACTIONS(3227), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28091] = 2,
    ACTIONS(3229), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28099] = 2,
    ACTIONS(3231), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28107] = 2,
    ACTIONS(2835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28115] = 2,
    ACTIONS(3233), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28123] = 2,
    ACTIONS(408), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28131] = 2,
    ACTIONS(3235), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28139] = 2,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28147] = 2,
    ACTIONS(1209), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28155] = 2,
    ACTIONS(3239), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28163] = 2,
    ACTIONS(3241), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28171] = 2,
    ACTIONS(3243), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28179] = 2,
    ACTIONS(428), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28187] = 2,
    ACTIONS(2074), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28195] = 2,
    ACTIONS(3245), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28203] = 2,
    ACTIONS(1649), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28211] = 2,
    ACTIONS(3247), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28219] = 2,
    ACTIONS(3249), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28227] = 2,
    ACTIONS(3123), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28235] = 2,
    ACTIONS(3251), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28243] = 2,
    ACTIONS(3253), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28251] = 2,
    ACTIONS(414), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28259] = 2,
    ACTIONS(3255), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28267] = 2,
    ACTIONS(1996), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28275] = 2,
    ACTIONS(3257), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28283] = 2,
    ACTIONS(2982), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28291] = 2,
    ACTIONS(3259), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28299] = 2,
    ACTIONS(3261), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28307] = 2,
    ACTIONS(3263), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28315] = 2,
    ACTIONS(3265), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28323] = 2,
    ACTIONS(3267), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28331] = 2,
    ACTIONS(3269), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28339] = 2,
    ACTIONS(3271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28347] = 2,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28355] = 2,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28363] = 2,
    ACTIONS(3275), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28371] = 2,
    ACTIONS(3277), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28379] = 2,
    ACTIONS(3279), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28387] = 2,
    ACTIONS(3281), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28395] = 2,
    ACTIONS(2599), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28403] = 2,
    ACTIONS(3283), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28411] = 2,
    ACTIONS(3285), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28419] = 2,
    ACTIONS(3287), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28427] = 2,
    ACTIONS(3289), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28435] = 2,
    ACTIONS(3291), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28443] = 2,
    ACTIONS(3293), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28451] = 2,
    ACTIONS(3295), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28459] = 2,
    ACTIONS(3297), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28467] = 2,
    ACTIONS(2910), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28475] = 2,
    ACTIONS(412), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28483] = 2,
    ACTIONS(3299), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28491] = 2,
    ACTIONS(3301), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28499] = 2,
    ACTIONS(3303), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28507] = 2,
    ACTIONS(3305), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28515] = 2,
    ACTIONS(3307), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28523] = 2,
    ACTIONS(3043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28531] = 2,
    ACTIONS(3309), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28539] = 2,
    ACTIONS(3125), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28547] = 2,
    ACTIONS(3311), 1,
      anon_sym_module,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28555] = 2,
    ACTIONS(3313), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28563] = 2,
    ACTIONS(3315), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28571] = 2,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28579] = 2,
    ACTIONS(3319), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28587] = 2,
    ACTIONS(3321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28595] = 2,
    ACTIONS(3323), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28603] = 2,
    ACTIONS(3325), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28611] = 2,
    ACTIONS(3327), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28619] = 2,
    ACTIONS(3329), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28627] = 2,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28635] = 2,
    ACTIONS(3333), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28643] = 2,
    ACTIONS(3335), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [28651] = 2,
    ACTIONS(3337), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(355)] = 0,
  [SMALL_STATE(356)] = 119,
  [SMALL_STATE(357)] = 238,
  [SMALL_STATE(358)] = 357,
  [SMALL_STATE(359)] = 476,
  [SMALL_STATE(360)] = 595,
  [SMALL_STATE(361)] = 715,
  [SMALL_STATE(362)] = 835,
  [SMALL_STATE(363)] = 942,
  [SMALL_STATE(364)] = 1049,
  [SMALL_STATE(365)] = 1156,
  [SMALL_STATE(366)] = 1240,
  [SMALL_STATE(367)] = 1329,
  [SMALL_STATE(368)] = 1420,
  [SMALL_STATE(369)] = 1502,
  [SMALL_STATE(370)] = 1584,
  [SMALL_STATE(371)] = 1675,
  [SMALL_STATE(372)] = 1766,
  [SMALL_STATE(373)] = 1857,
  [SMALL_STATE(374)] = 1917,
  [SMALL_STATE(375)] = 1977,
  [SMALL_STATE(376)] = 2037,
  [SMALL_STATE(377)] = 2109,
  [SMALL_STATE(378)] = 2175,
  [SMALL_STATE(379)] = 2235,
  [SMALL_STATE(380)] = 2289,
  [SMALL_STATE(381)] = 2363,
  [SMALL_STATE(382)] = 2417,
  [SMALL_STATE(383)] = 2471,
  [SMALL_STATE(384)] = 2540,
  [SMALL_STATE(385)] = 2597,
  [SMALL_STATE(386)] = 2670,
  [SMALL_STATE(387)] = 2734,
  [SMALL_STATE(388)] = 2794,
  [SMALL_STATE(389)] = 2854,
  [SMALL_STATE(390)] = 2916,
  [SMALL_STATE(391)] = 2980,
  [SMALL_STATE(392)] = 3043,
  [SMALL_STATE(393)] = 3104,
  [SMALL_STATE(394)] = 3167,
  [SMALL_STATE(395)] = 3228,
  [SMALL_STATE(396)] = 3291,
  [SMALL_STATE(397)] = 3354,
  [SMALL_STATE(398)] = 3436,
  [SMALL_STATE(399)] = 3486,
  [SMALL_STATE(400)] = 3536,
  [SMALL_STATE(401)] = 3590,
  [SMALL_STATE(402)] = 3647,
  [SMALL_STATE(403)] = 3721,
  [SMALL_STATE(404)] = 3774,
  [SMALL_STATE(405)] = 3821,
  [SMALL_STATE(406)] = 3894,
  [SMALL_STATE(407)] = 3965,
  [SMALL_STATE(408)] = 4012,
  [SMALL_STATE(409)] = 4059,
  [SMALL_STATE(410)] = 4106,
  [SMALL_STATE(411)] = 4159,
  [SMALL_STATE(412)] = 4211,
  [SMALL_STATE(413)] = 4257,
  [SMALL_STATE(414)] = 4305,
  [SMALL_STATE(415)] = 4351,
  [SMALL_STATE(416)] = 4397,
  [SMALL_STATE(417)] = 4443,
  [SMALL_STATE(418)] = 4505,
  [SMALL_STATE(419)] = 4551,
  [SMALL_STATE(420)] = 4603,
  [SMALL_STATE(421)] = 4649,
  [SMALL_STATE(422)] = 4695,
  [SMALL_STATE(423)] = 4741,
  [SMALL_STATE(424)] = 4787,
  [SMALL_STATE(425)] = 4832,
  [SMALL_STATE(426)] = 4877,
  [SMALL_STATE(427)] = 4922,
  [SMALL_STATE(428)] = 4967,
  [SMALL_STATE(429)] = 5019,
  [SMALL_STATE(430)] = 5067,
  [SMALL_STATE(431)] = 5115,
  [SMALL_STATE(432)] = 5163,
  [SMALL_STATE(433)] = 5211,
  [SMALL_STATE(434)] = 5263,
  [SMALL_STATE(435)] = 5311,
  [SMALL_STATE(436)] = 5361,
  [SMALL_STATE(437)] = 5409,
  [SMALL_STATE(438)] = 5457,
  [SMALL_STATE(439)] = 5505,
  [SMALL_STATE(440)] = 5548,
  [SMALL_STATE(441)] = 5591,
  [SMALL_STATE(442)] = 5634,
  [SMALL_STATE(443)] = 5677,
  [SMALL_STATE(444)] = 5720,
  [SMALL_STATE(445)] = 5763,
  [SMALL_STATE(446)] = 5806,
  [SMALL_STATE(447)] = 5849,
  [SMALL_STATE(448)] = 5892,
  [SMALL_STATE(449)] = 5935,
  [SMALL_STATE(450)] = 5978,
  [SMALL_STATE(451)] = 6021,
  [SMALL_STATE(452)] = 6064,
  [SMALL_STATE(453)] = 6111,
  [SMALL_STATE(454)] = 6154,
  [SMALL_STATE(455)] = 6197,
  [SMALL_STATE(456)] = 6240,
  [SMALL_STATE(457)] = 6283,
  [SMALL_STATE(458)] = 6326,
  [SMALL_STATE(459)] = 6373,
  [SMALL_STATE(460)] = 6416,
  [SMALL_STATE(461)] = 6459,
  [SMALL_STATE(462)] = 6502,
  [SMALL_STATE(463)] = 6545,
  [SMALL_STATE(464)] = 6588,
  [SMALL_STATE(465)] = 6631,
  [SMALL_STATE(466)] = 6674,
  [SMALL_STATE(467)] = 6717,
  [SMALL_STATE(468)] = 6760,
  [SMALL_STATE(469)] = 6803,
  [SMALL_STATE(470)] = 6845,
  [SMALL_STATE(471)] = 6893,
  [SMALL_STATE(472)] = 6939,
  [SMALL_STATE(473)] = 6981,
  [SMALL_STATE(474)] = 7023,
  [SMALL_STATE(475)] = 7071,
  [SMALL_STATE(476)] = 7113,
  [SMALL_STATE(477)] = 7155,
  [SMALL_STATE(478)] = 7197,
  [SMALL_STATE(479)] = 7239,
  [SMALL_STATE(480)] = 7281,
  [SMALL_STATE(481)] = 7323,
  [SMALL_STATE(482)] = 7365,
  [SMALL_STATE(483)] = 7407,
  [SMALL_STATE(484)] = 7449,
  [SMALL_STATE(485)] = 7491,
  [SMALL_STATE(486)] = 7533,
  [SMALL_STATE(487)] = 7575,
  [SMALL_STATE(488)] = 7617,
  [SMALL_STATE(489)] = 7659,
  [SMALL_STATE(490)] = 7701,
  [SMALL_STATE(491)] = 7743,
  [SMALL_STATE(492)] = 7791,
  [SMALL_STATE(493)] = 7833,
  [SMALL_STATE(494)] = 7875,
  [SMALL_STATE(495)] = 7933,
  [SMALL_STATE(496)] = 7975,
  [SMALL_STATE(497)] = 8017,
  [SMALL_STATE(498)] = 8059,
  [SMALL_STATE(499)] = 8101,
  [SMALL_STATE(500)] = 8143,
  [SMALL_STATE(501)] = 8185,
  [SMALL_STATE(502)] = 8231,
  [SMALL_STATE(503)] = 8273,
  [SMALL_STATE(504)] = 8315,
  [SMALL_STATE(505)] = 8357,
  [SMALL_STATE(506)] = 8399,
  [SMALL_STATE(507)] = 8441,
  [SMALL_STATE(508)] = 8483,
  [SMALL_STATE(509)] = 8525,
  [SMALL_STATE(510)] = 8567,
  [SMALL_STATE(511)] = 8609,
  [SMALL_STATE(512)] = 8651,
  [SMALL_STATE(513)] = 8693,
  [SMALL_STATE(514)] = 8735,
  [SMALL_STATE(515)] = 8777,
  [SMALL_STATE(516)] = 8819,
  [SMALL_STATE(517)] = 8861,
  [SMALL_STATE(518)] = 8903,
  [SMALL_STATE(519)] = 8948,
  [SMALL_STATE(520)] = 8988,
  [SMALL_STATE(521)] = 9028,
  [SMALL_STATE(522)] = 9074,
  [SMALL_STATE(523)] = 9114,
  [SMALL_STATE(524)] = 9155,
  [SMALL_STATE(525)] = 9194,
  [SMALL_STATE(526)] = 9233,
  [SMALL_STATE(527)] = 9272,
  [SMALL_STATE(528)] = 9311,
  [SMALL_STATE(529)] = 9350,
  [SMALL_STATE(530)] = 9389,
  [SMALL_STATE(531)] = 9428,
  [SMALL_STATE(532)] = 9467,
  [SMALL_STATE(533)] = 9506,
  [SMALL_STATE(534)] = 9545,
  [SMALL_STATE(535)] = 9584,
  [SMALL_STATE(536)] = 9623,
  [SMALL_STATE(537)] = 9662,
  [SMALL_STATE(538)] = 9701,
  [SMALL_STATE(539)] = 9740,
  [SMALL_STATE(540)] = 9779,
  [SMALL_STATE(541)] = 9818,
  [SMALL_STATE(542)] = 9859,
  [SMALL_STATE(543)] = 9898,
  [SMALL_STATE(544)] = 9937,
  [SMALL_STATE(545)] = 9976,
  [SMALL_STATE(546)] = 10036,
  [SMALL_STATE(547)] = 10082,
  [SMALL_STATE(548)] = 10144,
  [SMALL_STATE(549)] = 10212,
  [SMALL_STATE(550)] = 10256,
  [SMALL_STATE(551)] = 10306,
  [SMALL_STATE(552)] = 10350,
  [SMALL_STATE(553)] = 10414,
  [SMALL_STATE(554)] = 10458,
  [SMALL_STATE(555)] = 10516,
  [SMALL_STATE(556)] = 10584,
  [SMALL_STATE(557)] = 10646,
  [SMALL_STATE(558)] = 10714,
  [SMALL_STATE(559)] = 10770,
  [SMALL_STATE(560)] = 10838,
  [SMALL_STATE(561)] = 10882,
  [SMALL_STATE(562)] = 10924,
  [SMALL_STATE(563)] = 10992,
  [SMALL_STATE(564)] = 11036,
  [SMALL_STATE(565)] = 11081,
  [SMALL_STATE(566)] = 11118,
  [SMALL_STATE(567)] = 11155,
  [SMALL_STATE(568)] = 11200,
  [SMALL_STATE(569)] = 11270,
  [SMALL_STATE(570)] = 11336,
  [SMALL_STATE(571)] = 11378,
  [SMALL_STATE(572)] = 11447,
  [SMALL_STATE(573)] = 11504,
  [SMALL_STATE(574)] = 11569,
  [SMALL_STATE(575)] = 11638,
  [SMALL_STATE(576)] = 11673,
  [SMALL_STATE(577)] = 11708,
  [SMALL_STATE(578)] = 11743,
  [SMALL_STATE(579)] = 11812,
  [SMALL_STATE(580)] = 11877,
  [SMALL_STATE(581)] = 11946,
  [SMALL_STATE(582)] = 11981,
  [SMALL_STATE(583)] = 12040,
  [SMALL_STATE(584)] = 12075,
  [SMALL_STATE(585)] = 12140,
  [SMALL_STATE(586)] = 12175,
  [SMALL_STATE(587)] = 12240,
  [SMALL_STATE(588)] = 12309,
  [SMALL_STATE(589)] = 12374,
  [SMALL_STATE(590)] = 12429,
  [SMALL_STATE(591)] = 12498,
  [SMALL_STATE(592)] = 12551,
  [SMALL_STATE(593)] = 12588,
  [SMALL_STATE(594)] = 12657,
  [SMALL_STATE(595)] = 12704,
  [SMALL_STATE(596)] = 12739,
  [SMALL_STATE(597)] = 12792,
  [SMALL_STATE(598)] = 12851,
  [SMALL_STATE(599)] = 12916,
  [SMALL_STATE(600)] = 12977,
  [SMALL_STATE(601)] = 13018,
  [SMALL_STATE(602)] = 13077,
  [SMALL_STATE(603)] = 13142,
  [SMALL_STATE(604)] = 13185,
  [SMALL_STATE(605)] = 13254,
  [SMALL_STATE(606)] = 13313,
  [SMALL_STATE(607)] = 13382,
  [SMALL_STATE(608)] = 13447,
  [SMALL_STATE(609)] = 13516,
  [SMALL_STATE(610)] = 13585,
  [SMALL_STATE(611)] = 13654,
  [SMALL_STATE(612)] = 13723,
  [SMALL_STATE(613)] = 13792,
  [SMALL_STATE(614)] = 13861,
  [SMALL_STATE(615)] = 13930,
  [SMALL_STATE(616)] = 13999,
  [SMALL_STATE(617)] = 14068,
  [SMALL_STATE(618)] = 14103,
  [SMALL_STATE(619)] = 14172,
  [SMALL_STATE(620)] = 14241,
  [SMALL_STATE(621)] = 14276,
  [SMALL_STATE(622)] = 14345,
  [SMALL_STATE(623)] = 14409,
  [SMALL_STATE(624)] = 14473,
  [SMALL_STATE(625)] = 14523,
  [SMALL_STATE(626)] = 14589,
  [SMALL_STATE(627)] = 14653,
  [SMALL_STATE(628)] = 14703,
  [SMALL_STATE(629)] = 14741,
  [SMALL_STATE(630)] = 14805,
  [SMALL_STATE(631)] = 14861,
  [SMALL_STATE(632)] = 14925,
  [SMALL_STATE(633)] = 14989,
  [SMALL_STATE(634)] = 15053,
  [SMALL_STATE(635)] = 15116,
  [SMALL_STATE(636)] = 15179,
  [SMALL_STATE(637)] = 15242,
  [SMALL_STATE(638)] = 15305,
  [SMALL_STATE(639)] = 15368,
  [SMALL_STATE(640)] = 15423,
  [SMALL_STATE(641)] = 15486,
  [SMALL_STATE(642)] = 15549,
  [SMALL_STATE(643)] = 15612,
  [SMALL_STATE(644)] = 15675,
  [SMALL_STATE(645)] = 15738,
  [SMALL_STATE(646)] = 15801,
  [SMALL_STATE(647)] = 15864,
  [SMALL_STATE(648)] = 15927,
  [SMALL_STATE(649)] = 15990,
  [SMALL_STATE(650)] = 16053,
  [SMALL_STATE(651)] = 16116,
  [SMALL_STATE(652)] = 16179,
  [SMALL_STATE(653)] = 16242,
  [SMALL_STATE(654)] = 16297,
  [SMALL_STATE(655)] = 16352,
  [SMALL_STATE(656)] = 16415,
  [SMALL_STATE(657)] = 16478,
  [SMALL_STATE(658)] = 16541,
  [SMALL_STATE(659)] = 16596,
  [SMALL_STATE(660)] = 16659,
  [SMALL_STATE(661)] = 16722,
  [SMALL_STATE(662)] = 16785,
  [SMALL_STATE(663)] = 16846,
  [SMALL_STATE(664)] = 16901,
  [SMALL_STATE(665)] = 16964,
  [SMALL_STATE(666)] = 17016,
  [SMALL_STATE(667)] = 17068,
  [SMALL_STATE(668)] = 17120,
  [SMALL_STATE(669)] = 17172,
  [SMALL_STATE(670)] = 17224,
  [SMALL_STATE(671)] = 17276,
  [SMALL_STATE(672)] = 17308,
  [SMALL_STATE(673)] = 17340,
  [SMALL_STATE(674)] = 17392,
  [SMALL_STATE(675)] = 17444,
  [SMALL_STATE(676)] = 17481,
  [SMALL_STATE(677)] = 17518,
  [SMALL_STATE(678)] = 17559,
  [SMALL_STATE(679)] = 17608,
  [SMALL_STATE(680)] = 17660,
  [SMALL_STATE(681)] = 17708,
  [SMALL_STATE(682)] = 17754,
  [SMALL_STATE(683)] = 17784,
  [SMALL_STATE(684)] = 17830,
  [SMALL_STATE(685)] = 17860,
  [SMALL_STATE(686)] = 17896,
  [SMALL_STATE(687)] = 17926,
  [SMALL_STATE(688)] = 17972,
  [SMALL_STATE(689)] = 18018,
  [SMALL_STATE(690)] = 18064,
  [SMALL_STATE(691)] = 18094,
  [SMALL_STATE(692)] = 18124,
  [SMALL_STATE(693)] = 18170,
  [SMALL_STATE(694)] = 18216,
  [SMALL_STATE(695)] = 18246,
  [SMALL_STATE(696)] = 18282,
  [SMALL_STATE(697)] = 18330,
  [SMALL_STATE(698)] = 18359,
  [SMALL_STATE(699)] = 18388,
  [SMALL_STATE(700)] = 18417,
  [SMALL_STATE(701)] = 18466,
  [SMALL_STATE(702)] = 18495,
  [SMALL_STATE(703)] = 18523,
  [SMALL_STATE(704)] = 18551,
  [SMALL_STATE(705)] = 18593,
  [SMALL_STATE(706)] = 18625,
  [SMALL_STATE(707)] = 18667,
  [SMALL_STATE(708)] = 18715,
  [SMALL_STATE(709)] = 18743,
  [SMALL_STATE(710)] = 18771,
  [SMALL_STATE(711)] = 18799,
  [SMALL_STATE(712)] = 18829,
  [SMALL_STATE(713)] = 18857,
  [SMALL_STATE(714)] = 18885,
  [SMALL_STATE(715)] = 18925,
  [SMALL_STATE(716)] = 18971,
  [SMALL_STATE(717)] = 19005,
  [SMALL_STATE(718)] = 19051,
  [SMALL_STATE(719)] = 19097,
  [SMALL_STATE(720)] = 19134,
  [SMALL_STATE(721)] = 19177,
  [SMALL_STATE(722)] = 19214,
  [SMALL_STATE(723)] = 19257,
  [SMALL_STATE(724)] = 19282,
  [SMALL_STATE(725)] = 19319,
  [SMALL_STATE(726)] = 19352,
  [SMALL_STATE(727)] = 19389,
  [SMALL_STATE(728)] = 19414,
  [SMALL_STATE(729)] = 19453,
  [SMALL_STATE(730)] = 19490,
  [SMALL_STATE(731)] = 19533,
  [SMALL_STATE(732)] = 19576,
  [SMALL_STATE(733)] = 19616,
  [SMALL_STATE(734)] = 19658,
  [SMALL_STATE(735)] = 19698,
  [SMALL_STATE(736)] = 19740,
  [SMALL_STATE(737)] = 19780,
  [SMALL_STATE(738)] = 19820,
  [SMALL_STATE(739)] = 19862,
  [SMALL_STATE(740)] = 19888,
  [SMALL_STATE(741)] = 19928,
  [SMALL_STATE(742)] = 19970,
  [SMALL_STATE(743)] = 20010,
  [SMALL_STATE(744)] = 20050,
  [SMALL_STATE(745)] = 20087,
  [SMALL_STATE(746)] = 20116,
  [SMALL_STATE(747)] = 20153,
  [SMALL_STATE(748)] = 20190,
  [SMALL_STATE(749)] = 20225,
  [SMALL_STATE(750)] = 20258,
  [SMALL_STATE(751)] = 20292,
  [SMALL_STATE(752)] = 20328,
  [SMALL_STATE(753)] = 20364,
  [SMALL_STATE(754)] = 20398,
  [SMALL_STATE(755)] = 20434,
  [SMALL_STATE(756)] = 20470,
  [SMALL_STATE(757)] = 20504,
  [SMALL_STATE(758)] = 20538,
  [SMALL_STATE(759)] = 20574,
  [SMALL_STATE(760)] = 20610,
  [SMALL_STATE(761)] = 20646,
  [SMALL_STATE(762)] = 20680,
  [SMALL_STATE(763)] = 20712,
  [SMALL_STATE(764)] = 20748,
  [SMALL_STATE(765)] = 20782,
  [SMALL_STATE(766)] = 20816,
  [SMALL_STATE(767)] = 20850,
  [SMALL_STATE(768)] = 20884,
  [SMALL_STATE(769)] = 20914,
  [SMALL_STATE(770)] = 20944,
  [SMALL_STATE(771)] = 20975,
  [SMALL_STATE(772)] = 20998,
  [SMALL_STATE(773)] = 21029,
  [SMALL_STATE(774)] = 21062,
  [SMALL_STATE(775)] = 21093,
  [SMALL_STATE(776)] = 21124,
  [SMALL_STATE(777)] = 21157,
  [SMALL_STATE(778)] = 21188,
  [SMALL_STATE(779)] = 21219,
  [SMALL_STATE(780)] = 21249,
  [SMALL_STATE(781)] = 21279,
  [SMALL_STATE(782)] = 21311,
  [SMALL_STATE(783)] = 21341,
  [SMALL_STATE(784)] = 21369,
  [SMALL_STATE(785)] = 21397,
  [SMALL_STATE(786)] = 21427,
  [SMALL_STATE(787)] = 21459,
  [SMALL_STATE(788)] = 21490,
  [SMALL_STATE(789)] = 21525,
  [SMALL_STATE(790)] = 21552,
  [SMALL_STATE(791)] = 21581,
  [SMALL_STATE(792)] = 21612,
  [SMALL_STATE(793)] = 21647,
  [SMALL_STATE(794)] = 21678,
  [SMALL_STATE(795)] = 21705,
  [SMALL_STATE(796)] = 21734,
  [SMALL_STATE(797)] = 21760,
  [SMALL_STATE(798)] = 21776,
  [SMALL_STATE(799)] = 21806,
  [SMALL_STATE(800)] = 21834,
  [SMALL_STATE(801)] = 21855,
  [SMALL_STATE(802)] = 21880,
  [SMALL_STATE(803)] = 21903,
  [SMALL_STATE(804)] = 21932,
  [SMALL_STATE(805)] = 21955,
  [SMALL_STATE(806)] = 21984,
  [SMALL_STATE(807)] = 22009,
  [SMALL_STATE(808)] = 22032,
  [SMALL_STATE(809)] = 22061,
  [SMALL_STATE(810)] = 22090,
  [SMALL_STATE(811)] = 22112,
  [SMALL_STATE(812)] = 22126,
  [SMALL_STATE(813)] = 22140,
  [SMALL_STATE(814)] = 22164,
  [SMALL_STATE(815)] = 22184,
  [SMALL_STATE(816)] = 22208,
  [SMALL_STATE(817)] = 22222,
  [SMALL_STATE(818)] = 22244,
  [SMALL_STATE(819)] = 22266,
  [SMALL_STATE(820)] = 22280,
  [SMALL_STATE(821)] = 22302,
  [SMALL_STATE(822)] = 22322,
  [SMALL_STATE(823)] = 22345,
  [SMALL_STATE(824)] = 22368,
  [SMALL_STATE(825)] = 22381,
  [SMALL_STATE(826)] = 22394,
  [SMALL_STATE(827)] = 22407,
  [SMALL_STATE(828)] = 22420,
  [SMALL_STATE(829)] = 22433,
  [SMALL_STATE(830)] = 22450,
  [SMALL_STATE(831)] = 22467,
  [SMALL_STATE(832)] = 22486,
  [SMALL_STATE(833)] = 22503,
  [SMALL_STATE(834)] = 22520,
  [SMALL_STATE(835)] = 22533,
  [SMALL_STATE(836)] = 22546,
  [SMALL_STATE(837)] = 22559,
  [SMALL_STATE(838)] = 22576,
  [SMALL_STATE(839)] = 22593,
  [SMALL_STATE(840)] = 22610,
  [SMALL_STATE(841)] = 22627,
  [SMALL_STATE(842)] = 22648,
  [SMALL_STATE(843)] = 22661,
  [SMALL_STATE(844)] = 22678,
  [SMALL_STATE(845)] = 22691,
  [SMALL_STATE(846)] = 22710,
  [SMALL_STATE(847)] = 22723,
  [SMALL_STATE(848)] = 22746,
  [SMALL_STATE(849)] = 22759,
  [SMALL_STATE(850)] = 22772,
  [SMALL_STATE(851)] = 22785,
  [SMALL_STATE(852)] = 22798,
  [SMALL_STATE(853)] = 22811,
  [SMALL_STATE(854)] = 22824,
  [SMALL_STATE(855)] = 22837,
  [SMALL_STATE(856)] = 22850,
  [SMALL_STATE(857)] = 22863,
  [SMALL_STATE(858)] = 22880,
  [SMALL_STATE(859)] = 22893,
  [SMALL_STATE(860)] = 22906,
  [SMALL_STATE(861)] = 22923,
  [SMALL_STATE(862)] = 22936,
  [SMALL_STATE(863)] = 22949,
  [SMALL_STATE(864)] = 22972,
  [SMALL_STATE(865)] = 22989,
  [SMALL_STATE(866)] = 23006,
  [SMALL_STATE(867)] = 23023,
  [SMALL_STATE(868)] = 23046,
  [SMALL_STATE(869)] = 23063,
  [SMALL_STATE(870)] = 23082,
  [SMALL_STATE(871)] = 23099,
  [SMALL_STATE(872)] = 23116,
  [SMALL_STATE(873)] = 23129,
  [SMALL_STATE(874)] = 23146,
  [SMALL_STATE(875)] = 23159,
  [SMALL_STATE(876)] = 23176,
  [SMALL_STATE(877)] = 23189,
  [SMALL_STATE(878)] = 23212,
  [SMALL_STATE(879)] = 23225,
  [SMALL_STATE(880)] = 23238,
  [SMALL_STATE(881)] = 23251,
  [SMALL_STATE(882)] = 23264,
  [SMALL_STATE(883)] = 23285,
  [SMALL_STATE(884)] = 23304,
  [SMALL_STATE(885)] = 23321,
  [SMALL_STATE(886)] = 23334,
  [SMALL_STATE(887)] = 23347,
  [SMALL_STATE(888)] = 23360,
  [SMALL_STATE(889)] = 23373,
  [SMALL_STATE(890)] = 23386,
  [SMALL_STATE(891)] = 23399,
  [SMALL_STATE(892)] = 23412,
  [SMALL_STATE(893)] = 23425,
  [SMALL_STATE(894)] = 23438,
  [SMALL_STATE(895)] = 23454,
  [SMALL_STATE(896)] = 23470,
  [SMALL_STATE(897)] = 23486,
  [SMALL_STATE(898)] = 23502,
  [SMALL_STATE(899)] = 23522,
  [SMALL_STATE(900)] = 23542,
  [SMALL_STATE(901)] = 23562,
  [SMALL_STATE(902)] = 23578,
  [SMALL_STATE(903)] = 23594,
  [SMALL_STATE(904)] = 23610,
  [SMALL_STATE(905)] = 23626,
  [SMALL_STATE(906)] = 23642,
  [SMALL_STATE(907)] = 23658,
  [SMALL_STATE(908)] = 23674,
  [SMALL_STATE(909)] = 23694,
  [SMALL_STATE(910)] = 23710,
  [SMALL_STATE(911)] = 23726,
  [SMALL_STATE(912)] = 23742,
  [SMALL_STATE(913)] = 23756,
  [SMALL_STATE(914)] = 23772,
  [SMALL_STATE(915)] = 23788,
  [SMALL_STATE(916)] = 23804,
  [SMALL_STATE(917)] = 23816,
  [SMALL_STATE(918)] = 23828,
  [SMALL_STATE(919)] = 23844,
  [SMALL_STATE(920)] = 23860,
  [SMALL_STATE(921)] = 23878,
  [SMALL_STATE(922)] = 23894,
  [SMALL_STATE(923)] = 23914,
  [SMALL_STATE(924)] = 23930,
  [SMALL_STATE(925)] = 23946,
  [SMALL_STATE(926)] = 23958,
  [SMALL_STATE(927)] = 23974,
  [SMALL_STATE(928)] = 23990,
  [SMALL_STATE(929)] = 24010,
  [SMALL_STATE(930)] = 24026,
  [SMALL_STATE(931)] = 24042,
  [SMALL_STATE(932)] = 24058,
  [SMALL_STATE(933)] = 24074,
  [SMALL_STATE(934)] = 24090,
  [SMALL_STATE(935)] = 24107,
  [SMALL_STATE(936)] = 24124,
  [SMALL_STATE(937)] = 24139,
  [SMALL_STATE(938)] = 24156,
  [SMALL_STATE(939)] = 24171,
  [SMALL_STATE(940)] = 24188,
  [SMALL_STATE(941)] = 24205,
  [SMALL_STATE(942)] = 24222,
  [SMALL_STATE(943)] = 24239,
  [SMALL_STATE(944)] = 24256,
  [SMALL_STATE(945)] = 24273,
  [SMALL_STATE(946)] = 24290,
  [SMALL_STATE(947)] = 24307,
  [SMALL_STATE(948)] = 24324,
  [SMALL_STATE(949)] = 24341,
  [SMALL_STATE(950)] = 24358,
  [SMALL_STATE(951)] = 24373,
  [SMALL_STATE(952)] = 24388,
  [SMALL_STATE(953)] = 24405,
  [SMALL_STATE(954)] = 24418,
  [SMALL_STATE(955)] = 24435,
  [SMALL_STATE(956)] = 24452,
  [SMALL_STATE(957)] = 24463,
  [SMALL_STATE(958)] = 24480,
  [SMALL_STATE(959)] = 24495,
  [SMALL_STATE(960)] = 24512,
  [SMALL_STATE(961)] = 24529,
  [SMALL_STATE(962)] = 24546,
  [SMALL_STATE(963)] = 24559,
  [SMALL_STATE(964)] = 24576,
  [SMALL_STATE(965)] = 24591,
  [SMALL_STATE(966)] = 24604,
  [SMALL_STATE(967)] = 24621,
  [SMALL_STATE(968)] = 24636,
  [SMALL_STATE(969)] = 24653,
  [SMALL_STATE(970)] = 24668,
  [SMALL_STATE(971)] = 24685,
  [SMALL_STATE(972)] = 24700,
  [SMALL_STATE(973)] = 24717,
  [SMALL_STATE(974)] = 24734,
  [SMALL_STATE(975)] = 24749,
  [SMALL_STATE(976)] = 24764,
  [SMALL_STATE(977)] = 24781,
  [SMALL_STATE(978)] = 24796,
  [SMALL_STATE(979)] = 24811,
  [SMALL_STATE(980)] = 24826,
  [SMALL_STATE(981)] = 24837,
  [SMALL_STATE(982)] = 24852,
  [SMALL_STATE(983)] = 24867,
  [SMALL_STATE(984)] = 24884,
  [SMALL_STATE(985)] = 24899,
  [SMALL_STATE(986)] = 24910,
  [SMALL_STATE(987)] = 24925,
  [SMALL_STATE(988)] = 24942,
  [SMALL_STATE(989)] = 24957,
  [SMALL_STATE(990)] = 24974,
  [SMALL_STATE(991)] = 24989,
  [SMALL_STATE(992)] = 25006,
  [SMALL_STATE(993)] = 25019,
  [SMALL_STATE(994)] = 25034,
  [SMALL_STATE(995)] = 25045,
  [SMALL_STATE(996)] = 25062,
  [SMALL_STATE(997)] = 25079,
  [SMALL_STATE(998)] = 25096,
  [SMALL_STATE(999)] = 25111,
  [SMALL_STATE(1000)] = 25122,
  [SMALL_STATE(1001)] = 25139,
  [SMALL_STATE(1002)] = 25156,
  [SMALL_STATE(1003)] = 25173,
  [SMALL_STATE(1004)] = 25188,
  [SMALL_STATE(1005)] = 25203,
  [SMALL_STATE(1006)] = 25217,
  [SMALL_STATE(1007)] = 25231,
  [SMALL_STATE(1008)] = 25245,
  [SMALL_STATE(1009)] = 25259,
  [SMALL_STATE(1010)] = 25273,
  [SMALL_STATE(1011)] = 25287,
  [SMALL_STATE(1012)] = 25301,
  [SMALL_STATE(1013)] = 25315,
  [SMALL_STATE(1014)] = 25329,
  [SMALL_STATE(1015)] = 25343,
  [SMALL_STATE(1016)] = 25357,
  [SMALL_STATE(1017)] = 25371,
  [SMALL_STATE(1018)] = 25385,
  [SMALL_STATE(1019)] = 25399,
  [SMALL_STATE(1020)] = 25413,
  [SMALL_STATE(1021)] = 25427,
  [SMALL_STATE(1022)] = 25441,
  [SMALL_STATE(1023)] = 25455,
  [SMALL_STATE(1024)] = 25469,
  [SMALL_STATE(1025)] = 25483,
  [SMALL_STATE(1026)] = 25497,
  [SMALL_STATE(1027)] = 25511,
  [SMALL_STATE(1028)] = 25525,
  [SMALL_STATE(1029)] = 25539,
  [SMALL_STATE(1030)] = 25553,
  [SMALL_STATE(1031)] = 25567,
  [SMALL_STATE(1032)] = 25581,
  [SMALL_STATE(1033)] = 25595,
  [SMALL_STATE(1034)] = 25609,
  [SMALL_STATE(1035)] = 25619,
  [SMALL_STATE(1036)] = 25633,
  [SMALL_STATE(1037)] = 25643,
  [SMALL_STATE(1038)] = 25657,
  [SMALL_STATE(1039)] = 25671,
  [SMALL_STATE(1040)] = 25685,
  [SMALL_STATE(1041)] = 25699,
  [SMALL_STATE(1042)] = 25713,
  [SMALL_STATE(1043)] = 25723,
  [SMALL_STATE(1044)] = 25735,
  [SMALL_STATE(1045)] = 25747,
  [SMALL_STATE(1046)] = 25757,
  [SMALL_STATE(1047)] = 25771,
  [SMALL_STATE(1048)] = 25785,
  [SMALL_STATE(1049)] = 25799,
  [SMALL_STATE(1050)] = 25813,
  [SMALL_STATE(1051)] = 25827,
  [SMALL_STATE(1052)] = 25841,
  [SMALL_STATE(1053)] = 25855,
  [SMALL_STATE(1054)] = 25869,
  [SMALL_STATE(1055)] = 25881,
  [SMALL_STATE(1056)] = 25893,
  [SMALL_STATE(1057)] = 25907,
  [SMALL_STATE(1058)] = 25921,
  [SMALL_STATE(1059)] = 25931,
  [SMALL_STATE(1060)] = 25941,
  [SMALL_STATE(1061)] = 25955,
  [SMALL_STATE(1062)] = 25965,
  [SMALL_STATE(1063)] = 25979,
  [SMALL_STATE(1064)] = 25993,
  [SMALL_STATE(1065)] = 26007,
  [SMALL_STATE(1066)] = 26021,
  [SMALL_STATE(1067)] = 26035,
  [SMALL_STATE(1068)] = 26049,
  [SMALL_STATE(1069)] = 26063,
  [SMALL_STATE(1070)] = 26077,
  [SMALL_STATE(1071)] = 26091,
  [SMALL_STATE(1072)] = 26105,
  [SMALL_STATE(1073)] = 26119,
  [SMALL_STATE(1074)] = 26133,
  [SMALL_STATE(1075)] = 26147,
  [SMALL_STATE(1076)] = 26161,
  [SMALL_STATE(1077)] = 26175,
  [SMALL_STATE(1078)] = 26189,
  [SMALL_STATE(1079)] = 26203,
  [SMALL_STATE(1080)] = 26217,
  [SMALL_STATE(1081)] = 26231,
  [SMALL_STATE(1082)] = 26245,
  [SMALL_STATE(1083)] = 26259,
  [SMALL_STATE(1084)] = 26273,
  [SMALL_STATE(1085)] = 26287,
  [SMALL_STATE(1086)] = 26301,
  [SMALL_STATE(1087)] = 26315,
  [SMALL_STATE(1088)] = 26329,
  [SMALL_STATE(1089)] = 26343,
  [SMALL_STATE(1090)] = 26353,
  [SMALL_STATE(1091)] = 26367,
  [SMALL_STATE(1092)] = 26381,
  [SMALL_STATE(1093)] = 26395,
  [SMALL_STATE(1094)] = 26409,
  [SMALL_STATE(1095)] = 26423,
  [SMALL_STATE(1096)] = 26437,
  [SMALL_STATE(1097)] = 26451,
  [SMALL_STATE(1098)] = 26461,
  [SMALL_STATE(1099)] = 26475,
  [SMALL_STATE(1100)] = 26489,
  [SMALL_STATE(1101)] = 26503,
  [SMALL_STATE(1102)] = 26517,
  [SMALL_STATE(1103)] = 26531,
  [SMALL_STATE(1104)] = 26545,
  [SMALL_STATE(1105)] = 26559,
  [SMALL_STATE(1106)] = 26573,
  [SMALL_STATE(1107)] = 26587,
  [SMALL_STATE(1108)] = 26601,
  [SMALL_STATE(1109)] = 26615,
  [SMALL_STATE(1110)] = 26629,
  [SMALL_STATE(1111)] = 26643,
  [SMALL_STATE(1112)] = 26653,
  [SMALL_STATE(1113)] = 26667,
  [SMALL_STATE(1114)] = 26677,
  [SMALL_STATE(1115)] = 26691,
  [SMALL_STATE(1116)] = 26705,
  [SMALL_STATE(1117)] = 26719,
  [SMALL_STATE(1118)] = 26730,
  [SMALL_STATE(1119)] = 26739,
  [SMALL_STATE(1120)] = 26750,
  [SMALL_STATE(1121)] = 26761,
  [SMALL_STATE(1122)] = 26772,
  [SMALL_STATE(1123)] = 26783,
  [SMALL_STATE(1124)] = 26792,
  [SMALL_STATE(1125)] = 26803,
  [SMALL_STATE(1126)] = 26812,
  [SMALL_STATE(1127)] = 26821,
  [SMALL_STATE(1128)] = 26830,
  [SMALL_STATE(1129)] = 26841,
  [SMALL_STATE(1130)] = 26850,
  [SMALL_STATE(1131)] = 26859,
  [SMALL_STATE(1132)] = 26870,
  [SMALL_STATE(1133)] = 26879,
  [SMALL_STATE(1134)] = 26890,
  [SMALL_STATE(1135)] = 26901,
  [SMALL_STATE(1136)] = 26912,
  [SMALL_STATE(1137)] = 26923,
  [SMALL_STATE(1138)] = 26934,
  [SMALL_STATE(1139)] = 26945,
  [SMALL_STATE(1140)] = 26956,
  [SMALL_STATE(1141)] = 26967,
  [SMALL_STATE(1142)] = 26978,
  [SMALL_STATE(1143)] = 26989,
  [SMALL_STATE(1144)] = 27000,
  [SMALL_STATE(1145)] = 27011,
  [SMALL_STATE(1146)] = 27022,
  [SMALL_STATE(1147)] = 27033,
  [SMALL_STATE(1148)] = 27042,
  [SMALL_STATE(1149)] = 27051,
  [SMALL_STATE(1150)] = 27062,
  [SMALL_STATE(1151)] = 27073,
  [SMALL_STATE(1152)] = 27082,
  [SMALL_STATE(1153)] = 27093,
  [SMALL_STATE(1154)] = 27104,
  [SMALL_STATE(1155)] = 27115,
  [SMALL_STATE(1156)] = 27124,
  [SMALL_STATE(1157)] = 27133,
  [SMALL_STATE(1158)] = 27142,
  [SMALL_STATE(1159)] = 27151,
  [SMALL_STATE(1160)] = 27162,
  [SMALL_STATE(1161)] = 27171,
  [SMALL_STATE(1162)] = 27182,
  [SMALL_STATE(1163)] = 27193,
  [SMALL_STATE(1164)] = 27202,
  [SMALL_STATE(1165)] = 27211,
  [SMALL_STATE(1166)] = 27222,
  [SMALL_STATE(1167)] = 27233,
  [SMALL_STATE(1168)] = 27244,
  [SMALL_STATE(1169)] = 27255,
  [SMALL_STATE(1170)] = 27266,
  [SMALL_STATE(1171)] = 27277,
  [SMALL_STATE(1172)] = 27288,
  [SMALL_STATE(1173)] = 27297,
  [SMALL_STATE(1174)] = 27308,
  [SMALL_STATE(1175)] = 27319,
  [SMALL_STATE(1176)] = 27328,
  [SMALL_STATE(1177)] = 27337,
  [SMALL_STATE(1178)] = 27348,
  [SMALL_STATE(1179)] = 27359,
  [SMALL_STATE(1180)] = 27368,
  [SMALL_STATE(1181)] = 27379,
  [SMALL_STATE(1182)] = 27390,
  [SMALL_STATE(1183)] = 27401,
  [SMALL_STATE(1184)] = 27412,
  [SMALL_STATE(1185)] = 27423,
  [SMALL_STATE(1186)] = 27434,
  [SMALL_STATE(1187)] = 27445,
  [SMALL_STATE(1188)] = 27456,
  [SMALL_STATE(1189)] = 27467,
  [SMALL_STATE(1190)] = 27478,
  [SMALL_STATE(1191)] = 27489,
  [SMALL_STATE(1192)] = 27500,
  [SMALL_STATE(1193)] = 27509,
  [SMALL_STATE(1194)] = 27520,
  [SMALL_STATE(1195)] = 27531,
  [SMALL_STATE(1196)] = 27542,
  [SMALL_STATE(1197)] = 27553,
  [SMALL_STATE(1198)] = 27564,
  [SMALL_STATE(1199)] = 27575,
  [SMALL_STATE(1200)] = 27586,
  [SMALL_STATE(1201)] = 27597,
  [SMALL_STATE(1202)] = 27608,
  [SMALL_STATE(1203)] = 27619,
  [SMALL_STATE(1204)] = 27628,
  [SMALL_STATE(1205)] = 27639,
  [SMALL_STATE(1206)] = 27650,
  [SMALL_STATE(1207)] = 27661,
  [SMALL_STATE(1208)] = 27672,
  [SMALL_STATE(1209)] = 27683,
  [SMALL_STATE(1210)] = 27694,
  [SMALL_STATE(1211)] = 27705,
  [SMALL_STATE(1212)] = 27714,
  [SMALL_STATE(1213)] = 27723,
  [SMALL_STATE(1214)] = 27734,
  [SMALL_STATE(1215)] = 27743,
  [SMALL_STATE(1216)] = 27754,
  [SMALL_STATE(1217)] = 27765,
  [SMALL_STATE(1218)] = 27774,
  [SMALL_STATE(1219)] = 27785,
  [SMALL_STATE(1220)] = 27796,
  [SMALL_STATE(1221)] = 27807,
  [SMALL_STATE(1222)] = 27818,
  [SMALL_STATE(1223)] = 27829,
  [SMALL_STATE(1224)] = 27840,
  [SMALL_STATE(1225)] = 27851,
  [SMALL_STATE(1226)] = 27862,
  [SMALL_STATE(1227)] = 27873,
  [SMALL_STATE(1228)] = 27884,
  [SMALL_STATE(1229)] = 27893,
  [SMALL_STATE(1230)] = 27904,
  [SMALL_STATE(1231)] = 27913,
  [SMALL_STATE(1232)] = 27922,
  [SMALL_STATE(1233)] = 27933,
  [SMALL_STATE(1234)] = 27944,
  [SMALL_STATE(1235)] = 27955,
  [SMALL_STATE(1236)] = 27963,
  [SMALL_STATE(1237)] = 27971,
  [SMALL_STATE(1238)] = 27979,
  [SMALL_STATE(1239)] = 27987,
  [SMALL_STATE(1240)] = 27995,
  [SMALL_STATE(1241)] = 28003,
  [SMALL_STATE(1242)] = 28011,
  [SMALL_STATE(1243)] = 28019,
  [SMALL_STATE(1244)] = 28027,
  [SMALL_STATE(1245)] = 28035,
  [SMALL_STATE(1246)] = 28043,
  [SMALL_STATE(1247)] = 28051,
  [SMALL_STATE(1248)] = 28059,
  [SMALL_STATE(1249)] = 28067,
  [SMALL_STATE(1250)] = 28075,
  [SMALL_STATE(1251)] = 28083,
  [SMALL_STATE(1252)] = 28091,
  [SMALL_STATE(1253)] = 28099,
  [SMALL_STATE(1254)] = 28107,
  [SMALL_STATE(1255)] = 28115,
  [SMALL_STATE(1256)] = 28123,
  [SMALL_STATE(1257)] = 28131,
  [SMALL_STATE(1258)] = 28139,
  [SMALL_STATE(1259)] = 28147,
  [SMALL_STATE(1260)] = 28155,
  [SMALL_STATE(1261)] = 28163,
  [SMALL_STATE(1262)] = 28171,
  [SMALL_STATE(1263)] = 28179,
  [SMALL_STATE(1264)] = 28187,
  [SMALL_STATE(1265)] = 28195,
  [SMALL_STATE(1266)] = 28203,
  [SMALL_STATE(1267)] = 28211,
  [SMALL_STATE(1268)] = 28219,
  [SMALL_STATE(1269)] = 28227,
  [SMALL_STATE(1270)] = 28235,
  [SMALL_STATE(1271)] = 28243,
  [SMALL_STATE(1272)] = 28251,
  [SMALL_STATE(1273)] = 28259,
  [SMALL_STATE(1274)] = 28267,
  [SMALL_STATE(1275)] = 28275,
  [SMALL_STATE(1276)] = 28283,
  [SMALL_STATE(1277)] = 28291,
  [SMALL_STATE(1278)] = 28299,
  [SMALL_STATE(1279)] = 28307,
  [SMALL_STATE(1280)] = 28315,
  [SMALL_STATE(1281)] = 28323,
  [SMALL_STATE(1282)] = 28331,
  [SMALL_STATE(1283)] = 28339,
  [SMALL_STATE(1284)] = 28347,
  [SMALL_STATE(1285)] = 28355,
  [SMALL_STATE(1286)] = 28363,
  [SMALL_STATE(1287)] = 28371,
  [SMALL_STATE(1288)] = 28379,
  [SMALL_STATE(1289)] = 28387,
  [SMALL_STATE(1290)] = 28395,
  [SMALL_STATE(1291)] = 28403,
  [SMALL_STATE(1292)] = 28411,
  [SMALL_STATE(1293)] = 28419,
  [SMALL_STATE(1294)] = 28427,
  [SMALL_STATE(1295)] = 28435,
  [SMALL_STATE(1296)] = 28443,
  [SMALL_STATE(1297)] = 28451,
  [SMALL_STATE(1298)] = 28459,
  [SMALL_STATE(1299)] = 28467,
  [SMALL_STATE(1300)] = 28475,
  [SMALL_STATE(1301)] = 28483,
  [SMALL_STATE(1302)] = 28491,
  [SMALL_STATE(1303)] = 28499,
  [SMALL_STATE(1304)] = 28507,
  [SMALL_STATE(1305)] = 28515,
  [SMALL_STATE(1306)] = 28523,
  [SMALL_STATE(1307)] = 28531,
  [SMALL_STATE(1308)] = 28539,
  [SMALL_STATE(1309)] = 28547,
  [SMALL_STATE(1310)] = 28555,
  [SMALL_STATE(1311)] = 28563,
  [SMALL_STATE(1312)] = 28571,
  [SMALL_STATE(1313)] = 28579,
  [SMALL_STATE(1314)] = 28587,
  [SMALL_STATE(1315)] = 28595,
  [SMALL_STATE(1316)] = 28603,
  [SMALL_STATE(1317)] = 28611,
  [SMALL_STATE(1318)] = 28619,
  [SMALL_STATE(1319)] = 28627,
  [SMALL_STATE(1320)] = 28635,
  [SMALL_STATE(1321)] = 28643,
  [SMALL_STATE(1322)] = 28651,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [91] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block_statement_group, 1),
  [93] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block_statement_group, 1),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(368),
  [108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(510),
  [111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(510),
  [114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(936),
  [117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(807),
  [120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(84),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(270),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(428),
  [129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(270),
  [132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(269),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(680),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1313),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1135),
  [144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(276),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(263),
  [155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1139),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1144),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1146),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(143),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(262),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(518),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(261),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(959),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1153),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1295),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(931),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(390),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(376),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(930),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(883),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1287),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(428),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(386),
  [212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1286),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1285),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(701),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(697),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(702),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(507),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1177),
  [233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block_statement_group, 2),
  [235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block_statement_group, 2),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 3, .production_id = 21),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 3, .production_id = 21),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1), REDUCE(sym_statement, 1),
  [320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1), REDUCE(sym_statement, 1),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 3, .production_id = 24),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 3, .production_id = 24),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 4, .production_id = 24),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 4, .production_id = 24),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 23),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 23),
  [365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1271),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 163),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 163),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 130),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 130),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_body, 2),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_body, 2),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, .production_id = 64),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, .production_id = 64),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 57),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 57),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 143),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 143),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 144),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 144),
  [488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_body, 2),
  [490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_body, 2),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 129),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 129),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 147),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 147),
  [500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 148),
  [502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 148),
  [504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 149),
  [506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 149),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 55),
  [518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 55),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 58),
  [522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 58),
  [524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 153),
  [534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 153),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 154),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 154),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 149),
  [542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 149),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 155),
  [546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 155),
  [548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 65),
  [550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 65),
  [552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 156),
  [554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 156),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 58),
  [558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 58),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 57),
  [562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 57),
  [564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 56),
  [566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 56),
  [568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 62),
  [578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 62),
  [580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 62),
  [582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 62),
  [584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_declaration, 4, .production_id = 62),
  [586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_declaration, 4, .production_id = 62),
  [588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 117),
  [590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 117),
  [592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 115),
  [594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 115),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 62),
  [598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 62),
  [600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 112),
  [602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 112),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 116),
  [606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 116),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 114),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 114),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 115),
  [614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 115),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 114),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 114),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 113),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 113),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 112),
  [626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 112),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 104),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 104),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 20),
  [634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 20),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 103),
  [638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 103),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 92),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 92),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_body, 3),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_body, 3),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 178),
  [658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 178),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 179),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 179),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 180),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 180),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 181),
  [670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 181),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 182),
  [674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 182),
  [676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_body, 3),
  [678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_body, 3),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 102),
  [682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 102),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 101),
  [686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 101),
  [688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 92),
  [702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 92),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 6),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 6),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 93),
  [710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 93),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 20),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 20),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_declaration, 3, .production_id = 20),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_declaration, 3, .production_id = 20),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 20),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 20),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 201),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 201),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6, .production_id = 63),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 6, .production_id = 63),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 5),
  [746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 5),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2),
  [752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2), SHIFT_REPEAT(167),
  [755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2), SHIFT_REPEAT(1132),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 5, .production_id = 24),
  [770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 5, .production_id = 24),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 97),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 97),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, .production_id = 30),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, .production_id = 30),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, .production_id = 20),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, .production_id = 20),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3, .production_id = 14),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3, .production_id = 14),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 231),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 231),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, .production_id = 14),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, .production_id = 14),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 230),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 230),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 229),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 229),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 169),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 169),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 168),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 168),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 165),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 165),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 170),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 170),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2),
  [832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 171),
  [836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 171),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 23),
  [840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 23),
  [842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11, .production_id = 236),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11, .production_id = 236),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 209),
  [848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 209),
  [850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enhanced_for_statement, 9, .production_id = 208),
  [852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enhanced_for_statement, 9, .production_id = 208),
  [854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 25),
  [856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 25),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 207),
  [862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 207),
  [864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 4),
  [866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 4),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 4, .production_id = 63),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 4, .production_id = 63),
  [872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 21),
  [874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 21),
  [876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 206),
  [882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 206),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_synchronized_statement, 3, .production_id = 22),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_synchronized_statement, 3, .production_id = 22),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 205),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 205),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 204),
  [914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 204),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 184),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 184),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 133),
  [926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 133),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 185),
  [930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 185),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, .production_id = 119),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, .production_id = 119),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4),
  [938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 134),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 134),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, .production_id = 63),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, .production_id = 63),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 3),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 3),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, .production_id = 14),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, .production_id = 14),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 203),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 203),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 186),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 186),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 187),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 187),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, .production_id = 118),
  [974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, .production_id = 118),
  [976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 188),
  [982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 188),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 3),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 96),
  [994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 96),
  [996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6),
  [998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 6),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 191),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 191),
  [1004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 190),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 190),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enhanced_for_statement, 8, .production_id = 189),
  [1014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enhanced_for_statement, 8, .production_id = 189),
  [1016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 2),
  [1018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 2),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 3, .production_id = 40),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 3, .production_id = 40),
  [1024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 4, .production_id = 73),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 4, .production_id = 73),
  [1028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 62),
  [1030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 62),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 61),
  [1034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 61),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 3, .production_id = 183),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 3, .production_id = 183),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 5, .production_id = 228),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 5, .production_id = 228),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 6, .production_id = 235),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 6, .production_id = 235),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 4, .production_id = 202),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 4, .production_id = 202),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition, 3),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition, 3),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body_declarations, 2),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body_declarations, 1),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(759),
  [1081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(814),
  [1084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(428),
  [1087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1313),
  [1090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(12),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2),
  [1095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(359),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(931),
  [1101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(501),
  [1104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1287),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(428),
  [1110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1268),
  [1113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1286),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1285),
  [1119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(701),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(697),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(702),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(695),
  [1149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(814),
  [1152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(428),
  [1155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1313),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2),
  [1160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(363),
  [1163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(931),
  [1166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1287),
  [1169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(428),
  [1172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1268),
  [1175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1286),
  [1178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1285),
  [1181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(701),
  [1184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(697),
  [1187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(702),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(605),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1214] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(864),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(1320),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [1225] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(864),
  [1229] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(1320),
  [1233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [1240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(695),
  [1243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(428),
  [1246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1313),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2),
  [1251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(931),
  [1254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1287),
  [1257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(428),
  [1260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1286),
  [1263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1285),
  [1266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(701),
  [1269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(697),
  [1272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(702),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 5, .production_id = 105),
  [1281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 5, .production_id = 105),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 5, .production_id = 106),
  [1285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 5, .production_id = 106),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .production_id = 32),
  [1289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .production_id = 32),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [1293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .production_id = 31),
  [1307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .production_id = 31),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(108),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 4, .production_id = 72),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 4, .production_id = 72),
  [1320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(1311),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_repeat1, 2),
  [1329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2),
  [1331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(1263),
  [1334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(907),
  [1337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions, 1),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions, 1),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(107),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 53),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 53),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 54),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 54),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotated_type, 2),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotated_type, 2),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 17),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 17),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 19),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 19),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 59),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 59),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 60),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 60),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat2, 2),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat2, 2),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat2, 2), SHIFT_REPEAT(236),
  [1393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat2, 2), SHIFT_REPEAT(907),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(582),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [1403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_repeat1, 3),
  [1405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 3),
  [1407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unannotated_type, 1),
  [1409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unannotated_type, 1),
  [1411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1), SHIFT(582),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 5),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 5),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 68),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 68),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 42),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 42),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 2),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 2),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10, .production_id = 2),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10, .production_id = 2),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 6),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 6),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [1450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 77),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 77),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 35),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 35),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integral_type, 1),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integral_type, 1),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, .production_id = 11),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, .production_id = 11),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_floating_point_type, 1),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_floating_point_type, 1),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifiers, 1),
  [1480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifiers, 1),
  [1482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 51),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 51),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 18),
  [1494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 18),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [1500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(433),
  [1503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(931),
  [1506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(433),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 52),
  [1511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 52),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 16),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 16),
  [1517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 3),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 3),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 27),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 27),
  [1525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 40),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 40),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 125),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 125),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, .production_id = 157),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, .production_id = 157),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 73),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 73),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 3),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 3),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 2, .production_id = 89),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 89),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 2, .production_id = 86),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 2, .production_id = 86),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compact_constructor_declaration, 3, .production_id = 20),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compact_constructor_declaration, 3, .production_id = 20),
  [1561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [1563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions_expr, 4),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions_expr, 4),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 3, .production_id = 36),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 3, .production_id = 36),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 120),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 120),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions_expr, 3),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions_expr, 3),
  [1585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [1587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 2),
  [1591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 2),
  [1593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 2, .production_id = 88),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 88),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [1599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 4, .production_id = 69),
  [1601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 4, .production_id = 69),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [1605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 26),
  [1607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 26),
  [1609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 4),
  [1611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 4),
  [1613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 2),
  [1615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 2),
  [1617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 3, .production_id = 122),
  [1619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 122),
  [1621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 3, .production_id = 121),
  [1623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 121),
  [1625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [1627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 4),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 4),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_initializer, 2),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_initializer, 2),
  [1637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compact_constructor_declaration, 2, .production_id = 84),
  [1639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compact_constructor_declaration, 2, .production_id = 84),
  [1641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 48),
  [1643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 48),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [1651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat1, 1), REDUCE(aux_sym_modifiers_repeat1, 1),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [1656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat1, 1),
  [1658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 51),
  [1662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 51),
  [1664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_literal, 3, .dynamic_precedence = 17),
  [1666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_literal, 3, .dynamic_precedence = 17),
  [1668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [1670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [1672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 3, .production_id = 40),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 3, .production_id = 40),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 6, .production_id = 145),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 6, .production_id = 145),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 7, .production_id = 176),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 7, .production_id = 176),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 7, .production_id = 175),
  [1686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 7, .production_id = 175),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, .production_id = 37),
  [1690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, .production_id = 37),
  [1692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 6, .production_id = 146),
  [1694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 6, .production_id = 146),
  [1696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 4, .production_id = 73),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 4, .production_id = 73),
  [1700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 82),
  [1702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 82),
  [1704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 1, .production_id = 3),
  [1706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 1, .production_id = 3),
  [1708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 3),
  [1710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 3),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 81),
  [1714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 81),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiline_string_literal, 3),
  [1718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiline_string_literal, 3),
  [1720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 3),
  [1722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 3),
  [1724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 80),
  [1726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 80),
  [1728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 52),
  [1730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 52),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 5, .production_id = 78),
  [1734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 5, .production_id = 78),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 16),
  [1742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 16),
  [1744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 79),
  [1746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 79),
  [1748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 5, .production_id = 108),
  [1750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 5, .production_id = 108),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 5),
  [1754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 5),
  [1756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 5, .production_id = 107),
  [1758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 5, .production_id = 107),
  [1760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1),
  [1762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1),
  [1764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 2, .production_id = 7),
  [1766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 2, .production_id = 7),
  [1768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 47),
  [1770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 47),
  [1772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_reference, 3),
  [1774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_reference, 3),
  [1776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 4),
  [1778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 4),
  [1780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 2, .production_id = 8),
  [1782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 2, .production_id = 8),
  [1784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 18),
  [1786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 18),
  [1788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 49),
  [1790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 49),
  [1792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [1794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [1796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 50),
  [1798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 50),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 4, .production_id = 66),
  [1802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 4, .production_id = 66),
  [1804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 2),
  [1806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 2),
  [1808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 4, .production_id = 67),
  [1810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 4, .production_id = 67),
  [1812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 2),
  [1814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 2),
  [1816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_reference, 4),
  [1818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_reference, 4),
  [1820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiline_string_literal, 2),
  [1822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiline_string_literal, 2),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 5, .production_id = 109),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 5, .production_id = 109),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 29),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 29),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 4, .production_id = 70),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 4, .production_id = 70),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 4, .production_id = 71),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 4, .production_id = 71),
  [1842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 233),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 233),
  [1846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 232),
  [1848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 232),
  [1850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 8, .production_id = 237),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 8, .production_id = 237),
  [1854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2),
  [1856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2),
  [1858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 227),
  [1860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 227),
  [1862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 5, .production_id = 110),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 5, .production_id = 110),
  [1866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 226),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 226),
  [1870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 224),
  [1872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 224),
  [1874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 5, .production_id = 200),
  [1876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 5, .production_id = 200),
  [1878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 234),
  [1880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 234),
  [1882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 33),
  [1884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 33),
  [1886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 34),
  [1888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 34),
  [1890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(549),
  [1927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(907),
  [1930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(549),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 111),
  [1939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 28),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [1943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 33),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(1300),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [1980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 2),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__element_value, 1),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 2),
  [2006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 2),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [2014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 3),
  [2016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 3),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 4),
  [2036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 4),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 76),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 5),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 5),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 98),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 4, .production_id = 131),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 1), REDUCE(aux_sym_modifiers_repeat1, 1),
  [2087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_initializer_repeat1, 2),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 166),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 5, .production_id = 162),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [2197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [2201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(929),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 1),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 1),
  [2252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1), SHIFT(866),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_type, 1),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [2267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 1, .production_id = 9),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_catch_type_repeat1, 2),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_catch_type_repeat1, 2),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 1, .production_id = 10),
  [2297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2),
  [2299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(796),
  [2302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(905),
  [2305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(909),
  [2308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(910),
  [2311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(911),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 2, .production_id = 126),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 2, .production_id = 85),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [2368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 2, .production_id = 138),
  [2378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 2, .production_id = 138), SHIFT_REPEAT(878),
  [2381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__multiline_string_literal_repeat1, 2),
  [2383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__multiline_string_literal_repeat1, 2), SHIFT_REPEAT(925),
  [2386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__multiline_string_literal_repeat1, 2), SHIFT_REPEAT(830),
  [2389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__multiline_string_literal_repeat1, 2), SHIFT_REPEAT(802),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 1, .production_id = 10),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [2424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(167),
  [2427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1132),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 6),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 4, .production_id = 172),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 4, .production_id = 173),
  [2452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 1, .production_id = 100),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_type, 2),
  [2456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiline_string_fragment, 1),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__multiline_string_fragment_repeat1, 2),
  [2462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__multiline_string_fragment_repeat1, 2), SHIFT_REPEAT(832),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 1),
  [2469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 3, .production_id = 136),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 3, .production_id = 137),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(907),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2),
  [2484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2), SHIFT_REPEAT(195),
  [2487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2), SHIFT_REPEAT(1132),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 3, .production_id = 139),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 3, .production_id = 140),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 3, .production_id = 139),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 3, .production_id = 140),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 192),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uses_module_directive, 3, .production_id = 141),
  [2504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uses_module_directive, 3, .production_id = 45),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 193),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 194),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 195),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 192),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 193),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 194),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 195),
  [2522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_type_repeat1, 2), SHIFT_REPEAT(729),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 196),
  [2527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 197),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiline_string_fragment, 2),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 198),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 199),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_modifier, 1),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 212),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 214),
  [2557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 215),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 223),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 222),
  [2571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 221),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 219),
  [2575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 216),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 215),
  [2579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 214),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 212),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 216),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 1),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 27),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 2, .production_id = 38),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 2, .production_id = 39),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [2677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 8),
  [2681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 2),
  [2683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(665),
  [2686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(677),
  [2717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 13),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 4),
  [2757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(163),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2),
  [2766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2), SHIFT_REPEAT(964),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [2773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 3),
  [2775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_bound_repeat1, 2), SHIFT_REPEAT(667),
  [2778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_bound_repeat1, 2),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 2),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 2),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 2, .production_id = 87),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 2),
  [2800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 3, .production_id = 124),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 2),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 3),
  [2808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 4, .production_id = 158),
  [2810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 83),
  [2812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throws, 3),
  [2814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(170),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 5),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throws, 2),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 3),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 1),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 167),
  [2847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 167), SHIFT_REPEAT(154),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 3, .production_id = 160),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 84),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 3, .production_id = 159),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 210),
  [2926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 211),
  [2928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2),
  [2930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 213), SHIFT_REPEAT(919),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 213),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_list, 2, .production_id = 41),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_argument_list_repeat1, 2),
  [2951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_argument_list_repeat1, 2), SHIFT_REPEAT(1191),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 217),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 218),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 220), SHIFT_REPEAT(906),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 220),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_rule, 3),
  [2971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_initializer_repeat1, 2), SHIFT_REPEAT(106),
  [2974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 142),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 99), SHIFT_REPEAT(179),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 99),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [2999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(821),
  [3002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2),
  [3004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2), SHIFT_REPEAT(965),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 75), SHIFT_REPEAT(845),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 75),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 46),
  [3038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 46), SHIFT_REPEAT(673),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_list, 1, .production_id = 12),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [3055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(406),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [3066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(630),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 4, .production_id = 174),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 20),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_resource_specification_repeat1, 2),
  [3077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_resource_specification_repeat1, 2), SHIFT_REPEAT(347),
  [3080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_element_value_array_initializer_repeat1, 2), SHIFT_REPEAT(102),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_element_value_array_initializer_repeat1, 2),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declarator, 3, .production_id = 123),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 2, .production_id = 15),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 74),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 1),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 83),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 3),
  [3113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 45),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 3, .production_id = 43),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 5, .production_id = 158),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 4),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2, .production_id = 14),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_bounds, 2),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 3),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [3157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 3, .production_id = 87),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [3167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 2),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_interfaces, 2),
  [3179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 4, .production_id = 124),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_interfaces, 2),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declarator, 2, .production_id = 85),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_pair, 3, .production_id = 135),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [3195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [3201] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [3221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_formal_parameter, 3, .production_id = 164),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_formal_parameter, 2, .production_id = 132),
  [3225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_permits, 2),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 5),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_value, 2, .production_id = 225),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [3261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asterisk, 1),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 4, .production_id = 14),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [3285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 4),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 3),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 3, .production_id = 14),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 3),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 4),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_java(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
